AllyBattleLayer = class("AllyBattleLayer")

--new
function AllyBattleLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function AllyBattleLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["AllyBattleLayer"] = self
	ccb["AllyBattleLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/AllyBattleLayer.ccbi", proxy, self)
	self.data = data

	-- set button onlick
	self.btnClose.owner = self
	self.btnBattle.owner = self

	self:initUI()
	return self
end

function AllyBattleLayer:initUI()
	self.lbTitle:setString(ZGMultiLan("title_hfqunp"))
	self.lbBattleState:setString(MultiLan("team_desc3"))
	self.btnBattle:setTitleForState(MultiLan("button_challenge"), cc.CONTROL_STATE_NORMAL)
	SetTouchEventForLayer(self.lySwallow, TouchSwallow)
	self:initScrollLayer()
end

function AllyBattleLayer:initScrollLayer()
	local cellSize = AllyBattleCell.getCellSize()
	local enemyInfoTeam = self.data.enemyInfo.team
	local maxY = math.max(#enemyInfoTeam * cellSize.height, self.lyScroll:getContentSize().height)
	for i = 1, #enemyInfoTeam do
		local abc = AllyBattleCell:new()
		abc:create({
			enemyInfo = enemyInfoTeam[i],
			isAlly = (i ~= 1),
			inspire = self.data.enemyInfo.inspire
		})
		abc.topNode:setPosition(0, maxY - i * cellSize.height)
		self.lyScroll:addChild(abc.topNode)
	end
end

function AllyBattleLayer:onCloseBtn()
	removeSelf(self.owner.topNode)
end

function AllyBattleLayer:onBattleBtn(  )
	cclog("onBattleBtn")
end