require "lua/Cocos2d"
require "lua/Cocos2dConstants"
require "lua/Localization"

AssetsUpdate = class("AssetsUpdate")
AssetsUpdate.__index = AssetsUpdate

AssetsUpdate.scene = nil
AssetsUpdate.percentLabel = nil
AssetsUpdate.packageNumberLabel = nil
AssetsUpdate.curVersionLabel = nil
AssetsUpdate.progressBar = nil
AssetsUpdate.downloadButton = nil
AssetsUpdate.retryButton = nil

function AssetsUpdate:AssetsUpdateSetPercent(percentNum)
	self.progressBar:setPercentage(percentNum)
	self.progressBar:getParent():setVisible(true)
	self:AssetsUpdateSetPercentString(MultiLan("AU_curProcess") .. percentNum .. "%")  
end

function AssetsUpdate:AssetsUpdateSetPercentString(percentString)
	-- print(percentString)
	self.percentLabel:setString(percentString)
end

function AssetsUpdate:AssetsUpdateSetPackageNumber(packageNum)
	self.packageNumberLabel:setString(MultiLan("AU_remindBag") .. packageNum)
end

function AssetsUpdate:AssetsUpdateSetCurVersion(versionStr1, versionStr2, versionStr3)
	self.curVersionLabel:setString(MultiLan("AU_curVersion") .. versionStr1 .. "." .. versionStr2 .. "." .. versionStr3)
end


function AssetsUpdate:AssetsUpdateEvent(eventId)	-- 0创建文件失败，1网络错误，2无更新版本，3解压错误，4正在解压，5需要更新app，6更新成功
	if eventId == 1 then
		self.retryButton:setVisible(true)
	else
		self.retryButton:setVisible(false)
	end

	if eventId == 0 then
		self:AssetsUpdateSetPercentString(MultiLan("AU_updateEvent_0"))
	elseif eventId == 1 then
		self:AssetsUpdateSetPercentString(MultiLan("AU_updateEvent_1"))
	elseif eventId == 2 then
		self:AssetsUpdateSetPercentString(MultiLan("AU_updateEvent_2"))
	elseif eventId == 3 then
		self:AssetsUpdateSetPercentString(MultiLan("AU_updateEvent_3"))
	elseif eventId == 4 then
		self:AssetsUpdateSetPercentString(MultiLan("AU_updateEvent_4"))
	elseif eventId == 5 then
		self:AssetsUpdateSetPercentString(MultiLan("AU_updateEvent_5"))
		self.downloadButton:setVisible(true)
	elseif eventId == 6 then
		self:AssetsUpdateSetPercentString(MultiLan("AU_updateEvent_6"))
	else
		self:AssetsUpdateSetPercentString(MultiLan("AU_updateEvent_7"))
	end
end

function AssetsUpdateDownloadApp()
	--local function goToDownload()
		AssetsUpdateLayer:getInstance():DownloadApp()
		AssetsUpdate.downloadButton:setEnabled(false)
		AssetsUpdate.downloadButton:setColor(cc.c3b(96,96,96))
		AssetsUpdate.downloadButton:setTitleForState(MultiLan("AU_isLoading"), cc.CONTROL_STATE_NORMAL)
		AssetsUpdate.downloadButton:setTitleForState(MultiLan("AU_isLoading"), cc.CONTROL_STATE_DISABLED)
	--end
	
	function lua_string_split(str, split_char)    
		local sub_str_tab = {};    
		if str ~= nil then
			while (true) do        
				local pos = string.find(str, split_char);        
				if (not pos) then            
					sub_str_tab[#sub_str_tab + 1] = str;            
					break;        
				end        
				local sub_str = string.sub(str, 1, pos - 1);        
				sub_str_tab[#sub_str_tab + 1] = sub_str;        
				str = string.sub(str, pos + 1, #str);    
			end   
		end
		return sub_str_tab;
	end
	--[[
	local deviceInfo = DevicePlatform:getInstance():getDeviceInfomation()
	local infoTable = lua_string_split(deviceInfo, ",")
	
	if  infoTable[3] ~=nil and infoTable[3] == "Wifi" then
		goToDownload()
	else
		local label = cc.Label:create(MultiLan("AU_not_wifi"), "Helvetica", 30)
		label:setDimensions(455, 80)
		--CreateSmallPopupWithCancel(nil, label, goToDownload)
	end
	]]
end

function onKeyReleased(keyCode, event)
	local scene = event:getCurrentTarget()
	if keyCode == cc.KeyCode.KEY_BACK then
		if DevicePlatform:getInstance():getSdkPlatform() == "SDK_UC_ANDROID" then
			DevicePlatform:getInstance():exitSdk()
		else
			CreateSmallPopupWithCancel(nil,CreateCommonLabel(MultiLan("AU_isExit"), nil,FontSize3), ExitGame)
		end
	elseif keyCode == cc.KeyCode.KEY_MENU  then
		--label:setString("MENU clicked!")
	end
end

function AssetsUpdate:AssetsUpdateEnter()
	-- print("AssetsUpdateEnter")
	self.scene = cc.Scene:create()
	self.scene:setAnchorPoint(cc.p(0.5, 0.5))
	self.scene:ignoreAnchorPointForPosition(false)
	self.scene:setContentSize(cc.size(640, 960))
	self.scene:setPosition(cc.p(cc.Director:getInstance():getWinSize().width / 2, cc.Director:getInstance():getWinSize().height / 2))
	local listener = cc.EventListenerKeyboard:create()
	listener:registerScriptHandler(onKeyReleased, cc.Handler.EVENT_KEYBOARD_RELEASED )
	local eventDispatcher = self.scene:getEventDispatcher()
	eventDispatcher:addEventListenerWithSceneGraphPriority(listener, self.scene)
	
	if cc.Director:getInstance():getRunningScene() ~= nil then
		cc.Director:getInstance():replaceScene(self.scene)
	else
		cc.Director:getInstance():runWithScene(self.scene)
	end

	cc.SpriteFrameCache:getInstance():removeSpriteFrames()
	cc.Director:getInstance():getTextureCache():removeAllTextures()
	--Localization:loadString()
	cc.SpriteFrameCache:getInstance():addSpriteFrames("ccb/ccbResources/AssetsUpdata.plist")

	local layer = cc.Layer:create()
	layer:ignoreAnchorPointForPosition(true)
	layer:setContentSize(cc.size(640, 960))
	self.scene:addChild(layer)
	-- print(2)
	local bgSprite = cc.Sprite:createWithSpriteFrameName("MainBack.png")
	bgSprite:setPosition(cc.p(layer:getContentSize().width / 2, layer:getContentSize().height / 2))
	layer:addChild(bgSprite)
	
	self.downloadButton = cc.ControlButton:create(cc.Label:create(MultiLan("AU_startDownload"), "Helvetica", 30), cc.Scale9Sprite:createWithSpriteFrameName("button_creatname.png"))
	self.downloadButton:setPreferredSize(cc.size(257, 79))
	self.downloadButton:registerControlEventHandler(AssetsUpdateDownloadApp, cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE)
	self.downloadButton:setVisible(false)
	self.downloadButton:setPosition(cc.p(320, 450))
	layer:addChild(self.downloadButton)
	
	self.retryButton = cc.ControlButton:create(cc.Label:create(MultiLan("button_retry"), "Helvetica", 30), cc.Scale9Sprite:createWithSpriteFrameName("button_creatname.png"))
	self.retryButton:setPreferredSize(cc.size(257, 79))
	self.retryButton:registerControlEventHandler(gameEntrance, cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE)
	self.retryButton:setVisible(false)
	self.retryButton:setPosition(cc.p(320, 450))
	layer:addChild(self.retryButton)

	self.packageNumberLabel = cc.Label:create("", "Helvetica", 22)
	self.packageNumberLabel:setPosition(cc.p(320, 400))
	layer:addChild(self.packageNumberLabel)
	
	self.percentLabel = cc.Label:create("", "Helvetica", 22)
	self.percentLabel:setPosition(cc.p(320, 350))
	layer:addChild(self.percentLabel)
	
	self.curVersionLabel = cc.Label:create("", "Helvetica", 22)
	self.curVersionLabel:setPosition(cc.p(320, 300))
	layer:addChild(self.curVersionLabel)
	
	local logoSprite = cc.Sprite:createWithSpriteFrameName("pic_logo.png")
	logoSprite:setPosition(cc.p(layer:getContentSize().width / 2, layer:getContentSize().height * 0.746))
	layer:addChild(logoSprite)
	
	local percentLayer = cc.Layer:create()
	percentLayer:setVisible(false)
	percentLayer:ignoreAnchorPointForPosition(false)
	percentLayer:setPosition(cc.p(320, 200))
	percentLayer:setContentSize(cc.size(600, 40))
	layer:addChild(percentLayer)
	
	local sprite1 = cc.Sprite:createWithSpriteFrameName("pic_enterloading01.png")
	sprite1:setPosition(cc.p(percentLayer:getContentSize().width / 2, percentLayer:getContentSize().height / 2))
	percentLayer:addChild(sprite1)
	print("---------")
	self.progressBar = cc.ProgressTimer:create(cc.Sprite:createWithSpriteFrameName("pic_enterloading02.png"))
	self.progressBar:setPosition(cc.p(percentLayer:getContentSize().width / 2, percentLayer:getContentSize().height / 2))
	self.progressBar:setType(cc.PROGRESS_TIMER_TYPE_BAR)
	self.progressBar:setMidpoint(cc.p(0, 0))
	self.progressBar:setBarChangeRate(cc.p(1, 0))
	percentLayer:addChild(self.progressBar)
	
	
	-- print(4)
end

function AssetsUpdate:AssetsUpdateUpdate()
end

function AssetsUpdate:AssetsUpdateExit()
end