require "lua/CommonFunction"
--require "lua/CommonDefine"
require "lua/AudioEngine"
require "lua/CommonPopup"
require "lua/TimeDown"
require "lua/GameGuide"
require "lua/UserDetailLayer"
require "lua/GameListLayer"
require "lua/GameHomeLayer"
require "lua/GameMapLayer"
require "lua/GameBattleLayer"
require "lua/EquipLayer"
require "lua/GameBagLayer"
require "lua/GameSkillLayer"
require "lua/GameHeroLayer"
require "lua/GameArenaLayer"
require "lua/GamePvpLayer"
require "lua/GameGroupLayer"
require "lua/GameTeamLayer"
require "lua/GameFamilyLayer"
require "lua/GameShopLayer"
require "lua/GameActLayer"
require "lua/GameMarketLayer"
require "lua/GameChatLayer"
require "lua/GamePlayerInfoLayer"
require "lua/GameEquipMeltLayer"
require "lua/GameEquipForgeLayer"
require "lua/GameMasterEquipEatLayer"
require "lua/GameMasterEquipInheritLayer"
require "lua/GameStoneUpGradeLayer"
require "lua/GameMailLayer"
require "lua/GameCompensateLayer"
require "lua/RankHomeLayer"
require "lua/RefineLayer"
require "lua/EquipBatchFilterLayer"
require "lua/SkillChangeLayer"
require "lua/SkillMasteryLayer"
require "lua/SkillMastery/Exchange"
require "lua/SkillMastery/Merge"
require "lua/SkillMastery/Buy"
require "lua/SkillUpLayer"
require "lua/cells/RankLayer"
require "lua/cells/Rankcell"
require "lua/cells/RankHomeCell"
require "lua/cells/skillChangeCell"
require "lua/cells/SkillUpCell"
require "lua/cells/skillHomeCell"
require "lua/cells/SkillExchangeCell"
require "lua/cells/FlashSaleCell"
require "lua/cells/EventsCell"
require "lua/cells/CompensateCell"
require "lua/cells/AwardCell"
require "lua/cells/GuildWarCell"
require "lua/cells/GuildWarListCell"
require "lua/cells/AwardLeijiCell"
require "lua/cells/PlaceAwardCell"
require "lua/AllyBattleLayer"
require "lua/cells/AllyBattleCell"
require "lua/AllyBattleReportLayer"
--弹窗
require "lua/Tan/FlashSaleTan"
require "lua/Tan/HeroAuraLayer"
require "lua/Tan/GuildWarTanLayer"
require "lua/Tan/GuildWarZhanTanLayer"
--活动页面
require "lua/Event/WishesLayer"
require "lua/Event/LostTreasureLayer"
require "lua/Event/FlashSaleLayer"
require "lua/Event/JewelManiaLayer"
require "lua/Event/LuckyDrawLayer"
require "lua/Event/EasyGemsLayer"
require "lua/Event/LifetimeCardLayer"
require "lua/Event/PrepaidGiftLayer"
require "lua/Event/PlaceAwardLayer"

--工会战
require "lua/family/GuildWarLayer"
require "lua/family/BattleListLayer"
require "lua/family/RewardListLayer"
--天羽
require "lua/wing/WingLayer"
require "lua/wing/WingRankCell"
require "lua/wing/HeroTokenLayer"
require "lua/wing/HeroTokenMergeLayer"
require "lua/wing/HeroTokenTaskLayer"
require "lua/wing/HeroTokenTaskCell"
require "lua/FeedbackLayer"

XiaLayer = XiaLayer or {}
ccb["XiaLayer"] = XiaLayer

XiaLayerOwner = XiaLayerOwner or {}
ccb["XiaLayerOwner"] = XiaLayerOwner

--玩家数据
VipData = nil


--根节点
UI_LAYER = nil
MAIN_LAYER = nil
POPUP_LAYER = nil
POPUP_LAYER_S = nil
NOTE_LAYER = nil

--UI_LAYER的子节点
MiddleBackground  = nil
BroadcastLayer    = nil
CommonBattleLayer = nil 
CommonTitleLayer  = nil

CommonHomeLayer   = nil
CommonMapLayer    = nil
CommonEquipLayer  = nil
CommonBagLayer    = nil
CommonSkillLayer  = nil
CommonHeroLayer   = nil
CommonArenaLayer  = nil
CommonPvpLayer    = nil
CommonGroupLayer  = nil
CommonTeamLayer   = nil
CommonFamilyLayer = nil
CommonShopLayer   = nil

GroupLayerTag = nil 
TeamLayerTag = nil
MarketLayerTag = nil

UiChildArr = nil
UiChildEnterArr = nil
UiChildExitArr  = nil
UiChildTitleArr  = nil

UniqueNoticeData = nil  --公告数据
ShopPayListData = nil

--解决充值后三倍
local PAY_POPUP_ROOT = nil

--tgame审核标识
TGAME_IN_EXAMINE = false

function IsTgamePlartform(plat_str)
	if plat_str == nil then
		plat_str = SDK_PLATFORM
	end

	if (plat_str == "SDK_TGAME_IOS" or plat_str == "SDK_TGAME_ANDROID" or
		plat_str == "SDK_TGAME_VN_IOS" or plat_str == "SDK_TGAME_VN_ANDROID" or
		plat_str == "SDK_TGAME_TH_IOS" or plat_str == "SDK_TGAME_TH_ANDROID" or
		plat_str == "SDK_TGAME_XMT_IOS" or plat_str == "SDK_TGAME_XMT_ANDROID" or
		plat_str == "SDK_JAGUAR_ANDROID" or plat_str == "SDK_JAGUAR_THIRD") then
		return true
	else
		return false
	end
end 

function IsInExamine( )
	return (TGAME_IN_EXAMINE == true and (IsTgamePlartform() or SDK_PLATFORM == "SDK_WEIBO_IOS"))
end
function EquipEnter()
	EquipLayer:EquipLayerEnter()
end

function EquipExit()
	EquipLayer:EquipLayerExit()
end

function BagEnter()
	BagLayer:BagLayerEnter()
end

function BagExit()
	BagLayer:BagLayerExit()
end

function SkillEnter()
	SkillLayer:SkillLayerEnter()
end

function SkillExit()
	SkillLayer:SkillLayerExit()
end

function refreshHeroInfoTable(  )
	if HeroInfoTable == nil or table.maxn(UserSelfInfo.hero_star) == 0 then
		--初始化护法数据
		local StaticData = GameData:getGameDataTable().hero
		HeroInfoTable = {}
		for i=1,table.maxn(StaticData) do
			if StaticData[i].htype == 2 then
				-- print("insert")
				table.insert(HeroInfoTable,{staticData = StaticData[i], dynamicData=UserInfo:getHero(StaticData[i].id), equip={},bChange=false,button=nil})
				if UserInfo:getUserInfo().data.equip["hero_"..StaticData[i].id] == nil then
					UserInfo:getUserInfo().data.equip["hero_"..StaticData[i].id] = {}
				end
				HeroInfoTable[table.maxn(HeroInfoTable)].equip = UserInfo:getUserInfo().data.equip["hero_"..StaticData[i].id]
				UserAttr:CalHeroFinalAttr(StaticData[i].id)
			end
		end
	end
end

function ShowNew(node, second, three, four)
	local tag = tolua.cast(node, "cc.Node"):getTag()
	-- print("ShowNew", tag, UiChildArr[tag], UiChildArr[tag]:isVisible(),second,three,four)
	if UiChildArr[tag] ~= nil and UiChildArr[tag]:isVisible() and tag ~= 2 then
		cclog("return")
		return
	end
	
	if UiChildCheckArr[tag] ~= nil then
		if UiChildCheckArr[tag]() == false then
			if UiChildNoteArr[tag] ~= nil then
				UiChildNoteArr[tag]()
			end
			return
		end
	end

	for i=1,table.maxn(UiChildArr) do
		if i ~= tag then
			if UiChildExitArr[i] ~= nil and UiChildArr[i]:isVisible() then
				UiChildExitArr[i]()
			end
			UiChildArr[i]:setVisible(false)  
		else
			UiChildArr[i]:setVisible(true)
			if UiChildTitleArr[i] ~= nil then
				CommonTitleLayer:setVisible(true)
				-- XiaLayerOwner["mBigTitleSprite"]:setSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame("title_"..UiChildTitleArr[i]..".png"))
				XiaLayerOwner["mTitleBigTitle"]:setString(ZGMultiLan("title_subTitle_" .. UiChildTitleArr[i]))
			else
				CommonTitleLayer:setVisible(false)
			end
			print("11",UiChildEnterArr[i])
			if UiChildEnterArr[i] ~= nil then
				UiChildEnterArr[i]()
			end
		end
	end
	
	if tag > 0 and tag < 7 then
		for i=1, 6 do
			if XiaLayerOwner["mMainButton"..i]:getChildByTag(1) ~= nil then
				XiaLayerOwner["mMainButton"..i]:removeChildByTag(1)
			end
		end
		local sprite = CreateCommonSprite("eff_btn_zhuye.png", Pos(XiaLayerOwner["mMainButton"..tag]:getContentSize(), 0.50, 0.50))
		--sprite:runAction(cc.Sequence:create(cc.ScaleTo:create(1,0.9), cc.ScaleTo:create(1,1.1)))
		XiaLayerOwner["mMainButton"..tag]:addChild(sprite, 1, 1)
		-- local btn = XiaLayerOwner["mMainButton" .. tag]
		-- local sprite = CreateCommonSprite("effect_selected01.png", cc.p())	
	end
	
	XiaLayerOwner["mHelpIcon"]:setVisible(UiChildNeedHelp[tag])
end

function DelayTimeCallfunc(tmpLayer, tmpTime, callfunc)
	if tmpLayer ~= nil and callfunc ~= nil then
		tmpLayer:runAction(cc.Sequence:create(cc.DelayTime:create(tmpTime), cc.CallFunc:create(callfunc)))
	end
end

function GameBagInfoInit()
	local function delayInitBag()
		BagLayer:BagLayerEnter()
	end
	GameEnteringLayer.percent = GameEnteringLayer.GENERATE_BAG_INFO
	DelayTimeCallfunc(scene, 0.01, delayInitBag)
end

function InitGameUi()
	if ZG_DEBUG_TEST_NET_REQUEST == true then
		local testcb = function ( retData )
			ccdump(retData, "test interface cb")
		end
		HttpSend("equip/lock", {"id=6931"}, testcb)
		return
	end

	if false then
		for i = 1, 500 do
			local nameXing = NameMultiLan("rnd_first_name_" .. (math.random(os.clock()*10^6)%MAX_XING + 1))
			local nameMing = ""
			if i % 3 == 0 or i % 3 == 2 then
				nameMing = NameMultiLan("rnd_last_name_woman_" .. (math.random(os.clock()*10^6)%MAX_MING_WOMAN + 1))
			else
				nameMing = NameMultiLan("rnd_last_name_man_" .. (math.random(os.clock()*10^6)%MAX_MING_MAN + 1))
			end
			local name = nameXing..nameMing
			cclog(name)
		end
	end

	if GameConfig:GetIsRelease() then
		print = function() end
	end


	--加载资源
	--SpriteFrameCache:getInstance():addSpriteFramesWithFile("ccb/ccbResources/Whatever.plist")
	DelayTimeCallfunc(scene, 0.01, GameBagInfoInit)
	
	--大层
	UI_LAYER = CCBReaderLoad("ccb/XiaLayer.ccbi",cc.CCBProxy:create(),XiaLayerOwner)
	UI_LAYER:setVisible(false)
	printNode(scene, "sceneSize")
	-- print(WinSize.width, WinSize.height)
	scene:addChild(UI_LAYER)
	POPUP_LAYER = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
	scene:addChild(POPUP_LAYER, POPUP_TAG, POPUP_TAG)
	POPUP_LAYER_S = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
	scene:addChild(POPUP_LAYER_S, POPUP_S_TAG, POPUP_S_TAG)
	NOTE_LAYER = CreateLayer(CommonSize ,1, Pos(CommonSize))
	scene:addChild(NOTE_LAYER, NOTE_TAG, NOTE_TAG)

	AddCloudForBackground(XiaLayerOwner["mBackLayer"], 1)
	--特殊界面
	MAIN_LAYER = XiaLayerOwner["mMainLayer"]      --UI_Layer中显示在最上面
	BroadcastLayer = XiaLayerOwner["mBroadcastLayer"]  --UI_Layer中显示在最上面
	MiddleBackground = XiaLayerOwner["mMainLayer"]
	CommonTitleLayer = XiaLayerOwner["mBigTitleLayer"]
	
	--平行界面
	CommonHomeLayer   = XiaLayerOwner["mHomeLayer"]
	CommonMapLayer    = XiaLayerOwner["mMapLayer"]
	CommonBattleLayer = XiaLayerOwner["mBattleLayer"]
	CommonEquipLayer  = XiaLayerOwner["mEquipLayer"]  
	CommonBagLayer    = XiaLayerOwner["mBagLayer"]
	CommonSkillLayer  = XiaLayerOwner["mSkillLayer"]
	CommonHeroLayer   = XiaLayerOwner["mHeroLayer"]  
	CommonArenaLayer  = XiaLayerOwner["mArenaLayer"]
	CommonPvpLayer    = XiaLayerOwner["mPvpLayer"]
	CommonGroupLayer  = XiaLayerOwner["mGroupLayer"]
	CommonTeamLayer   = XiaLayerOwner["mTeamLayer"]
	CommonFamilyLayer = XiaLayerOwner["mFamilyLayer"]
	CommonShopLayer   = XiaLayerOwner["mShopLayer"]
	CommonActLayer   = XiaLayerOwner["mActLayer"]
	CommonMarketLayer = XiaLayerOwner["mMarketLayer"]

	XiaLayerOwner["mCommonMoneyLayer"]:setVisible(false)
	

	--多语言
	XiaLayerOwner["lb_menu_main"]:setString(ZGMultiLan("lb_menu_main"))
	XiaLayerOwner["lb_menu_battle"]:setString(ZGMultiLan("lb_menu_battle"))
	XiaLayerOwner["lb_menu_equip"]:setString(ZGMultiLan("lb_menu_equip"))
	XiaLayerOwner["lb_menu_bag"]:setString(ZGMultiLan("lb_menu_bag"))
	XiaLayerOwner["lb_menu_skill"]:setString(ZGMultiLan("lb_menu_skill"))
	XiaLayerOwner["lb_menu_keeper"]:setString(ZGMultiLan("lb_menu_keeper"))
	XiaLayerOwner["lbActShopTitle"]:setString(ZGMultiLan("lbActShopTitle"))
	XiaLayerOwner["lbActZhuanTitle"]:setString(ZGMultiLan("lbActZhuanTitle"))
	XiaLayerOwner["lbActLevelTitle"]:setString(ZGMultiLan("lbActLevelTitle"))
	XiaLayerOwner["lbActLevelSubTitle"]:setString(ZGMultiLan("lbActLevelSubTitle"))
	XiaLayerOwner["lbActExcTitle"]:setString(ZGMultiLan("lbActExcTitle"))
	-- XiaLayerOwner["lbActExcDesc"]:setString(ZGMultiLan("lbActExcDesc"))
	-- XiaLayerOwner["lbActPayTitle"]:setString(ZGMultiLan("lbActPayTitle"))
	-- XiaLayerOwner["lbActPayDesc1"]:setString(ZGMultiLan("lbActPayDesc1"))
	-- XiaLayerOwner["lbActPayDesc2"]:setString(ZGMultiLan("lbActPayDesc2"))
	XiaLayerOwner["lbActConTitle"]:setString(ZGMultiLan("lbActConTitle"))
	XiaLayerOwner["lbActNewTitle"]:setString(ZGMultiLan("lbActNewTitle"))
	XiaLayerOwner["lbActNewDesc"]:setString(ZGMultiLan("lbActNewDesc"))
	XiaLayerOwner["lbLiveMainTitle"]:setString(ZGMultiLan("lbLiveMainTitle"))
	XiaLayerOwner["lbPvpMainTitle"]:setString(ZGMultiLan("lbPvpMainTitle"))
	XiaLayerOwner["lbBtnTiaoZhan1"]:setString(ZGMultiLan("lbBtnTiaoZhan"))
	XiaLayerOwner["lbBtnTiaoZhan2"]:setString(ZGMultiLan("lbBtnTiaoZhan"))
	XiaLayerOwner["lbBtnTiaoZhan3"]:setString(ZGMultiLan("lbBtnTiaoZhan"))


	
	-- XiaLayerOwner["lbBasePropertiesTitle"]:setString(ZGMultiLan("lbBasePropertiesTitle"))
	XiaLayerOwner["mEquipBattleValueTitle"]:setString(ZGMultiLan("equip_battle_value_title"))
	XiaLayerOwner["mMainBattleValueTitle"]:setString(ZGMultiLan("equip_battle_value_title"))

	XiaLayerOwner["lbMainBtnGiftTtitle"]:setString(ZGMultiLan("lbMainBtnGiftTtitle"))
	XiaLayerOwner["lbMainBtnHeroTokenTtitle"]:setString(MultiLan("hero_token_title"))
	XiaLayerOwner["lbMainBtnMailTtitle"]:setString(ZGMultiLan("lbMainBtnMailTtitle"))
	XiaLayerOwner["lbMainBtnRankTtitle"]:setString(ZGMultiLan("lbMainBtnRankTtitle"))
	XiaLayerOwner["lbMainBtnChatTtitle"]:setString(ZGMultiLan("lbMainBtnChatTtitle"))
	XiaLayerOwner["lbMainBtnMoreTtitle"]:setString(ZGMultiLan("lbMainBtnMoreTtitle"))
	XiaLayerOwner["lbMainBtnArenaTtitle"]:setString(ZGMultiLan("lbMainBtnArenaTtitle"))
	XiaLayerOwner["lbMainBtnFamilyTtitle"]:setString(ZGMultiLan("lbMainBtnFamilyTtitle"))
	XiaLayerOwner["lbMainBtnGroupTtitle"]:setString(ZGMultiLan("lbMainBtnGroupTtitle"))
	XiaLayerOwner["lbMainBtnShopTtitle"]:setString(ZGMultiLan("lbMainBtnShopTtitle"))
	XiaLayerOwner["lbMainBtnMeltTtitle"]:setString(ZGMultiLan("lbMainBtnMeltTtitle"))
	XiaLayerOwner["lbMainBtnMarketTtitle"]:setString(ZGMultiLan("lbMainBtnMarketTtitle"))
	XiaLayerOwner["lbMainBtnActTtitle"]:setString(ZGMultiLan("lbMainBtnActTtitle"))
	XiaLayerOwner["lbMainBtnPayTtitle"]:setString(ZGMultiLan("lbMainBtnPayTtitle"))
	-- XiaLayerOwner["lbTitleGuildWarTeamManage"]:setString(ZGMultiLan("lbTitleTeamSettting"))
	-- XiaLayerOwner["lbTitleGuildWarGroup"]:setString(ZGMultiLan("lbTitleTeamSettting"))
	-- XiaLayerOwner["lbTitleGuildWarReport"]:setString(ZGMultiLan("lbTitleGuildWarReport"))
	-- XiaLayerOwner["lbTitleGuildWar"]:setString(ZGMultiLan("lbTitleGuildWar"))
	XiaLayerOwner["lbBtnGuildSign"]:setString(ZGMultiLan("lbBtnGuildSign"))
	XiaLayerOwner["lbBtnGuildExchange"]:setString(ZGMultiLan("lbBtnGuildExchange"))
	XiaLayerOwner["lbBtnGuildMember"]:setString(ZGMultiLan("lbBtnGuildMember"))
	XiaLayerOwner["lbBtnGuildRank"]:setString(ZGMultiLan("lbBtnGuildRank"))
	XiaLayerOwner["lbBtnGuildRefresh"]:setString(ZGMultiLan("lbBtnGuildRefresh"))
	XiaLayerOwner["lbBtnGuildSearch"]:setString(ZGMultiLan("lbBtnGuildSearch"))
	XiaLayerOwner["lbBtnGuildCreate"]:setString(ZGMultiLan("lbBtnGuildCreate"))
	XiaLayerOwner["lbBtnGuildList"]:setString(ZGMultiLan("lbBtnGuildList"))
	XiaLayerOwner["lbBtnGuildWar"]:setString(ZGMultiLan("lbBtnGuildWar"))
	XiaLayerOwner["lbBtnGuildAct2"]:setString(ZGMultiLan("lbBtnGuildActNotOpen"))
	XiaLayerOwner["lbBtnGuildAct3"]:setString(ZGMultiLan("lbBtnGuildActNotOpen"))
	XiaLayerOwner["lbInfoGuildWarTitle"]:setString(ZGMultiLan("lbInfoGuildWarTitle"))
	XiaLayerOwner["lbTitleBattleFilghtData"]:setString(ZGMultiLan("title_subTitle_tongji"))

	XiaLayerOwner["lb_guild_go_boss"]:setString(ZGMultiLan("guild_lb_go_boss"))
	XiaLayerOwner["lbMainCompensateTtitle"]:setString(ZGMultiLan("lbMainCompensateTtitle"))
	XiaLayerOwner["mHomeLayerServeTimeDesc"]:setString(MultiLan("mHomeLayerServeTimeDesc"))
	-- UpdateServeTime(XiaLayerOwner["mHomeLayerServeTimeNum"])
	XiaLayerOwner["lb_guild_home_Guildwar"]:setString(ZGMultiLan("lbTitleGuildWar"))
	XiaLayerOwner["lb_guild_home_guildwar_desc"]:setString(MultiLan("lb_guild_home_guildwar_desc"))
--描边
	XiaLayerOwner["lb_guild_go_boss"]:enableOutline(cc.c3b(0,0,0),1)

	if GameConfig:IsMarketClosed() then
		XiaLayerOwner["lyHomeMarketBtn"]:removeFromParent()
	end
	-- cclog("UserInfo:getUserInfo().needIndemnity "..UserInfo:getUserInfo().data.needIndemnity)
	-- ccdump(UserInfo:getUserInfo(),"UserInfo:getUserInfo()")
	GameGuide:setButtonNote(XiaLayerOwner["lyHomeCompensateBtn"], true, Pos(cc.size(100,100), 0.74,0.76), 1)
	if UserInfo:getUserInfo().data.needIndemnity == 0 or UserInfo:getUserInfo().data.needIndemnity == nil then
		XiaLayerOwner["lyHomeCompensateBtn"]:removeFromParent()
	end

	GroupLayerTag = 12 
	TeamLayerTag = 13
	MarketLayerTag = 14
	
	UiChildCheckArr = {nil            , nil            ,nil              ,nil           , CheckSkill      , CheckHero      , CheckArena      , nil                 , CheckFamily       , nil            , nil            , CheckGroup      , CheckTeam      , CheckMarket       }
	UiChildNoteArr  = {nil            , nil            ,nil              ,nil           , SkillNotOpen    , HeroNotOpen    , ArenaNotOpen    , nil                 , FamilyNotOpen     , nil            , nil            , GroupNotOpen    , TeamNotOpen    , MarketNotOpen		}
	UiChildArr =      {CommonHomeLayer, CommonMapLayer, CommonEquipLayer, CommonBagLayer, CommonSkillLayer, CommonHeroLayer, CommonArenaLayer, CommonPvpLayer      , CommonFamilyLayer , CommonShopLayer, CommonActLayer , CommonGroupLayer, CommonTeamLayer, CommonMarketLayer }
	UiChildEnterArr = {HomeEnter      , MapEnter      , EquipEnter      , BagEnter      , SkillEnter      , HeroEnter      , ArenaEnter      , PvpEnter            , FamilyEnter       , ShopEnter      , ActEnter       , GroupEnter      , TeamEnter      , MarketEnter		}
	UiChildExitArr  = {HomeExit       , nil           , EquipExit       , nil           , nil             , nil            , nil             , PvpExit             , FamilyExit        , ShopExit       , ActExit        , GroupExit       , TeamExit       , MarketExit		}
	UiChildTitleArr = {nil            , "map"         , "equip"         , "bag"         , "skillall"      , "mercenary"    , "pvp"           , nil                 , "guild"           , "shopall"      , nil            , "teamduobao"    , "hfqunp"       , "marketbig"		}
	UiChildNeedHelp = {false          ,false          ,false            ,false          ,true             ,false           , false           , false               ,true               ,true            , false          , true            , true           , true 				} 
	 
	for i=1,table.maxn(UiChildArr) do
		UiChildArr[i]:setVisible(false)
	end 
	
	UserSelfInfo = UserInfo:getUserInfo().data.info
	UserActiveInfo = UserInfo:getUserInfo().data.activity
	InitActArr()

	--默认主页
	local node = cc.Node:create()
	node:setTag(1)
	ShowNew(node)
	GameGuide:initGuide() 
	GameGuide:initHandGuide()
	
	BattleEnter()
	
	ChatLayer:ChatLayerEnter()
	ChatLayer:ChatLayerExit()
	
	
	GameGuide:SetBagFullEffect()
	--文字描边
	XiaLayerOwner["lb_menu_main"]:enableOutline(cc.c3b(25,14,8),1)
	XiaLayerOwner["lb_menu_battle"]:enableOutline(cc.c3b(25,14,8),1)
	XiaLayerOwner["lb_menu_equip"]:enableOutline(cc.c3b(25,14,8),1)
	XiaLayerOwner["lb_menu_bag"]:enableOutline(cc.c3b(25,14,8),1)
	XiaLayerOwner["lb_menu_skill"]:enableOutline(cc.c3b(25,14,8),1)
	XiaLayerOwner["lb_menu_keeper"]:enableOutline(cc.c3b(25,14,8),1)

	XiaLayerOwner["lbMainBtnRankTtitle"]:enableOutline(cc.c3b(25,14,8),1)
	XiaLayerOwner["lbMainBtnChatTtitle"]:enableOutline(cc.c3b(25,14,8),1)
	XiaLayerOwner["lbMainBtnActTtitle"]:enableOutline(cc.c3b(25,14,8),1)
	XiaLayerOwner["lbMainBtnMoreTtitle"]:enableOutline(cc.c3b(25,14,8),1)
	XiaLayerOwner["lbMainCompensateTtitle"]:enableOutline(cc.c3b(25,14,8),1)
	XiaLayerOwner["lbMainBtnGiftTtitle"]:enableOutline(cc.c3b(25,14,8),1)
	XiaLayerOwner["lbMainBtnHeroTokenTtitle"]:enableOutline(cc.c3b(25,14,8),1)
	XiaLayerOwner["lbMainBtnMailTtitle"]:enableOutline(cc.c3b(25,14,8),1)


	-- 移动label和button
	-- CommonMoveLabelUnderBtn(XiaLayerOwner["mHomeMarketButton"], XiaLayerOwner["lbMainBtnMarketTtitle"])
	-- CommonMoveLabelUnderBtn(XiaLayerOwner["mHomeGiftButton"], XiaLayerOwner["lbMainBtnGiftTtitle"])
	-- CommonMoveLabelUnderBtn(XiaLayerOwner["mHomeMailButton"], XiaLayerOwner["lbMainBtnMailTtitle"])
	-- CommonMoveLabelUnderBtn(XiaLayerOwner["mHomeRankButton"], XiaLayerOwner["lbMainBtnRankTtitle"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mMainButton1"], XiaLayerOwner["lb_menu_main"],3)
	CommonMoveLabelUnderBtn(XiaLayerOwner["mMainButton2"], XiaLayerOwner["lb_menu_battle"],3)
	CommonMoveLabelUnderBtn(XiaLayerOwner["mMainButton3"], XiaLayerOwner["lb_menu_equip"],3)
	CommonMoveLabelUnderBtn(XiaLayerOwner["mMainButton4"], XiaLayerOwner["lb_menu_bag"],3)
	CommonMoveLabelUnderBtn(XiaLayerOwner["mMainButton5"], XiaLayerOwner["lb_menu_skill"],3)
	CommonMoveLabelUnderBtn(XiaLayerOwner["mMainButton6"], XiaLayerOwner["lb_menu_keeper"],3)
	CommonMoveLabelUnderBtn(XiaLayerOwner["mMainButton1"], XiaLayerOwner["mMainicon1"],2)
	CommonMoveLabelUnderBtn(XiaLayerOwner["mMainButton2"], XiaLayerOwner["mMainicon2"],2)
	CommonMoveLabelUnderBtn(XiaLayerOwner["mMainButton3"], XiaLayerOwner["mMainicon3"],2)
	CommonMoveLabelUnderBtn(XiaLayerOwner["mMainButton4"], XiaLayerOwner["mMainicon4"],2)
	CommonMoveLabelUnderBtn(XiaLayerOwner["mMainButton5"], XiaLayerOwner["mMainicon5"],2)
	CommonMoveLabelUnderBtn(XiaLayerOwner["mMainButton6"], XiaLayerOwner["mMainicon6"],2)

	CommonMoveLabelUnderBtn(XiaLayerOwner["mHomeHeroTokenButton"], XiaLayerOwner["lbMainBtnHeroTokenTtitle"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mHomeGiftButton"], XiaLayerOwner["lbMainBtnGiftTtitle"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mHomeMailButton"], XiaLayerOwner["lbMainBtnMailTtitle"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mHomeRankButton"], XiaLayerOwner["lbMainBtnRankTtitle"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mHomeTalkButton"], XiaLayerOwner["lbMainBtnChatTtitle"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mHomeMoreButton"], XiaLayerOwner["lbMainBtnMoreTtitle"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mArenaButton"], XiaLayerOwner["lbMainBtnArenaTtitle"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mHomeFamilyButton"], XiaLayerOwner["lbMainBtnFamilyTtitle"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mHomeGroupButton"], XiaLayerOwner["lbMainBtnGroupTtitle"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mHomeMeltButton"], XiaLayerOwner["lbMainBtnMeltTtitle"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mHomeMarketButton"], XiaLayerOwner["lbMainBtnMarketTtitle"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mHomeShopButton"], XiaLayerOwner["lbMainBtnShopTtitle"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mHomeActButton"], XiaLayerOwner["lbMainBtnActTtitle"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mHomePayButton"], XiaLayerOwner["lbMainBtnPayTtitle"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mHomeCompensateButton"], XiaLayerOwner["lbMainCompensateTtitle"])

	CommonMoveLabelUnderBtn(XiaLayerOwner["btnActLevelMore"], XiaLayerOwner["lbActLevelMore"])
	XiaLayerOwner["lbActLevelMore"]:setString(ZGMultiLan("lbMainBtnMoreTtitle"))

	CommonMoveLabelUnderBtn(XiaLayerOwner["mFamilyButton5"], XiaLayerOwner["lbBtnGuildSign"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mFamilyButton6"], XiaLayerOwner["lbBtnGuildExchange"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mFamilyButton7"], XiaLayerOwner["lbBtnGuildMember"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mFamilyButton8"], XiaLayerOwner["lbBtnGuildRank"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mFamilyButton1"], XiaLayerOwner["lbBtnGuildRefresh"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mFamilyButton2"], XiaLayerOwner["lbBtnGuildSearch"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mFamilyButton3"], XiaLayerOwner["lbBtnGuildCreate"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mFamilyButton4"], XiaLayerOwner["lbBtnGuildList"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mBtnGuildAct1"], XiaLayerOwner["lbBtnGuildWar"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mBtnGuildAct2"], XiaLayerOwner["lbBtnGuildAct2"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mBtnGuildAct3"], XiaLayerOwner["lbBtnGuildAct3"])

	--市集暂未开放
	local back = CreateCommonSprite("board_skill01.png", cc.p(0,0))
	local waitLabel = CreateCommonLabel(MultiLan("GAL_pleaseWait"), nil,FontSize3)
	local showLayer = CreateLayer(waitLabel:getContentSize(),1,Pos(XiaLayerOwner["mHomeMarketButton"]:getContentSize(),0.5,0.7))
	back:setScaleX(waitLabel:getContentSize().width/ back:getContentSize().width+0.2)
	back:setScaleY(waitLabel:getContentSize().height/ back:getContentSize().height+0.2)
	back:setPosition(Pos(showLayer:getContentSize()))
	showLayer:addChild(back)
	waitLabel:setPosition(Pos(showLayer:getContentSize()))
	waitLabel:setColor(COLOR_YELLOW)
	showLayer:addChild(waitLabel)
	showLayer:setVisible(false)
	XiaLayerOwner["mHomeMarketButton"]:addChild(showLayer)
	showLayer:setAnchorPoint(cc.p(0.5,-1.3))
	showLayer:setScale(0.3)
	local function showFunc()
		showLayer:stopAllActions()
		showLayer:setVisible(true)
		showLayer:setScale(1.4)
		--showLayer:runAction(cc.ScaleTo:create(0.3*(2-showLayer:getScale())/2, 1.5))
		--CommonNote(MultiLan("GAL_pleaseWait"))
	end
	local function hideFunc()
		showLayer:stopAllActions()
		showLayer:runAction(cc.Sequence:create(cc.ScaleTo:create(0.3*(showLayer:getScale())/2, 0), cc.CallFunc:create(HideSelf)))
	end

	--XiaLayerOwner["mHomeMarketButton"]:registerControlEventHandler(showFunc, cc.CONTROL_EVENTTYPE_TOUCH_DOWN)
	--XiaLayerOwner["mHomeMarketButton"]:registerControlEventHandler(hideFunc, cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE)
	--XiaLayerOwner["mHomeMarketButton"]:registerControlEventHandler(hideFunc, cc.CONTROL_EVENTTYPE_TOUCH_CANCEL)
	--XiaLayerOwner["mHomeMarketButton"]:registerControlEventHandler(hideFunc, cc.CONTROL_EVENTTYPE_DRAG_OUTSIDE)
	
	--世界广播
	InitBroadcastStr()
	
	--tgame特殊要求
	if not TGAME_IN_EXAMINE and IsTgamePlartform() then
		local function onTgameUserCenter()
			DevicePlatform:getInstance():showCenter()
		end
		
		CommonHomeLayer:addChild(CreateCommonButton("button_chuangguan.png", Pos(CommonHomeLayer:getContentSize(), 0.19, 0.77), cc.size(144,50), onTgameUserCenter, {str=MultiLan("tgame_showCenter"), size = FontSize1}))
	end
	
	--平台收集用户信息
	-- print("SDK_PLATFORM",SDK_PLATFORM)
	if SDK_PLATFORM == "SDK_UC_ANDROID" then
		-- print("LOGIN_SERVER_NAME", LOGIN_SERVER_NAME)
		local jsonData = "{\"roleId\":\"".. tostring(UserSelfInfo.uid).."\",".. 
						  "\"roleName\":\"".. UserSelfInfo.name .."\","..
						  "\"roleLevel\":\"".. tostring(UserSelfInfo.level) .."\","..
						  "\"zoneId\":\"".. tostring(LOGIN_SERVER_ID).."\","..
						  "\"zoneName\":\"".. LOGIN_SERVER_NAME.."\""..
						  "}"
						

	
		local tmpTable = {
						loginGameRole = "loginGameRole",
						str = jsonData
					}
					
		DevicePlatform:getInstance():sdkExtraFunction(tmpTable)
	elseif  SDK_PLATFORM == "SDK_OPPO_ANDROID" then
		local tmpTable = {
						gameid = "2916",
						service = LOGIN_SERVER_NAME,
						roleName = UserSelfInfo.name,
						roleLevel = tostring(UserSelfInfo.level),
					}
					
		DevicePlatform:getInstance():sdkExtraFunction(tmpTable)
	elseif 	SDK_PLATFORM == "SDK_TGAME_ANDROID" or SDK_PLATFORM == "SDK_TGAME_IOS" then
		local tmpTable = {
						eventType = tostring(0),
						roleId = tostring(UserSelfInfo.uid),
						roleName = UserSelfInfo.name,
						serverId = tostring(LOGIN_SERVER_ID),
						serverName = LOGIN_SERVER_NAME,
                        gameName = "全民剑侠",
						gameVersion = IHelper:getInstance():getFinalVersion()
					}
					
		DevicePlatform:getInstance():sdkExtraFunction(tmpTable)
	end
    local eventDispatcher  = cc.Director:getInstance():getEventDispatcher()
    local eventName = "NotificationDelayEnter"
    local listener = cc.EventListenerCustom:create(eventName, gameEntranceDelay)
    eventDispatcher.addEventListenerWithFixedPriority(eventDispatcher,listener, 1)
	
	-- 初始化google pay
	DevicePlatform:getInstance():initGooglePay()
	local appStoreEventName = "NotificationGooglePayBuyFinish"
	local appStoreListener = cc.EventListenerCustom:create(appStoreEventName, googlePlayRefreshDiamond)
	eventDispatcher.addEventListenerWithFixedPriority(eventDispatcher,appStoreListener, 1)
	-- print("initGooglePay")

	-- 测试
	if ZG_DEBUG_TEST_SINGLE_LAYER == true then
		require "lua/test/TestAnim"
		local tl = TestAnim:new()
		tl:create()
		local node = tl.topNode
		if POPUP_LAYER == nil then
			POPUP_LAYER = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
		end
		POPUP_LAYER:addChild(node)
	end
end

function GameNoticeShow()
	-- if TGAME_IN_EXAMINE and IsTgamePlartform() then
	-- 	return
	-- end
	if IsInExamine() then return end

	local xhr = cc.XMLHttpRequest:new()
	xhr.responseType = cc.XMLHTTPREQUEST_RESPONSE_STRING
	-- print("getNoticeUrl: " .. IHelper:getInstance():getNoticeUrl() .. "NOTICE_"..NOTICE_ID..".json")
	xhr:open("GET", IHelper:getInstance():getNoticeUrl() .. "NOTICE_"..NOTICE_ID..".json")
	-- xhr:open("GET", "http://45.32.71.122/NOTICE_1.json")
	local function requestNoticeCallback()
		-- print("Notice", NOTICE_ID)
		-- print(xhr.response)
		--xhr.response = "[{\"t\":1,\"d\":\"新服开启\"},{\"t\":2,\"d\":\"2014年11月7号\"}]"
		UniqueNoticeData = (require "cjson").decode(xhr.response)
		NewsPopup(UniqueNoticeData)
	end
	xhr:registerScriptHandler(requestNoticeCallback)
	xhr:send()
end

local localIndex = 1
local showedLocalStr = {}

local showedBroadStr = {}
local strX = nil
function UpdateBroadcast()
	-- print("UpdateBroadcast", table.maxn(showedBroadStr))
	local broadback = CreateLayer(cc.size(1280,30), 1, Pos(BroadcastLayer:getContentSize(),1,0.5), cc.p(0,0.5))
	local richtextArr = {}
	local wrong = false
	if table.maxn(showedBroadStr) == 0 then
		-- print(table.maxn(showedBroadStr))

		local sourceTable = GameData:getGameDataTable().notice[localIndex]
		local typeColor = {COLOR_WHITE, COLOR_RED, COLOR_GREEN}
		for i=1,table.maxn(sourceTable) do
			table.insert(richtextArr, {str = MultiLan(sourceTable[i].d), size=20, color=typeColor[sourceTable[i].t]})
		end

		localIndex = localIndex + 1
		if localIndex > table.maxn(showedLocalStr) then
			localIndex = 1
		end
	else
		for i=1, table.maxn(showedBroadStr) do
			if 300 < showedBroadStr[i].id and showedBroadStr[i].id < 306 then
				if showedBroadStr[i].id == 301 then
					richtextArr = {
									{str=showedBroadStr[i].name.." ",size=20, color=COLOR_GREEN},
									{str=" "..MultiLan("notice_server_7_1").." ",size=20, color=COLOR_WHITE},
									{str=MultiLan("notice_server_7_2"),size=20, color=COLOR_GREEN}
								  }
				elseif showedBroadStr[i].id == 302 then
					richtextArr = {
									{str=showedBroadStr[i].name.." ",size=20, color=COLOR_GREEN},
									{str=" "..MultiLan("notice_server_1_1").." ",size=20, color=COLOR_WHITE},
									{str=showedBroadStr[i].union_id,size=20, color=COLOR_GREEN},
									{str=" "..MultiLan("notice_server_1_2").." ",size=20, color=COLOR_WHITE},
									{str=showedBroadStr[i].union_name,size=20, color=COLOR_GREEN},
									{str=" "..MultiLan("notice_server_1_3"),size=20, color=COLOR_WHITE}
								  }
				elseif showedBroadStr[i].id == 303 then
					richtextArr = {
									{str=showedBroadStr[i].name.." ", size=20, color=COLOR_GREEN},
									{str=" "..MultiLan("notice_server_5_1").." ", size=20, color=COLOR_WHITE},
									{str=MultiLan("notice_server_5_2"), size=20, color=COLOR_GREEN},
									{str=" "..MultiLan("notice_server_5_3"), size=20, color=COLOR_WHITE}
								  }
				elseif showedBroadStr[i].id == 304 then
					if showedBroadStr[i].rank == 1 then
						richtextArr = {
										{str=showedBroadStr[i].name.." ", size=20, color=COLOR_GREEN},
										{str=" "..MultiLan("notice_server_2_1").." ", size=20, color=COLOR_WHITE},
										{str=MultiLan("notice_server_2_2"), size=20, color=COLOR_GREEN}
									  }
					elseif showedBroadStr[i].rank == 2 then
						richtextArr = {
										{str=showedBroadStr[i].name.." ", size=20, color=COLOR_GREEN},
										{str=" "..MultiLan("notice_server_3_1").." ", size=20, color=COLOR_WHITE},
										{str=MultiLan("notice_server_3_2"), size=20, color=COLOR_GREEN}
									  }
					elseif showedBroadStr[i].rank == 3 then
						richtextArr = {
										{str=showedBroadStr[i].name.." ", size=20, color=COLOR_GREEN},
										{str=" "..MultiLan("notice_server_4_1").." ", size=20, color=COLOR_WHITE},
										{str=MultiLan("notice_server_4_2"), size=20, color=COLOR_GREEN}
									  }
					end
				elseif showedBroadStr[i].id == 305 then
					richtextArr = {
									{str=showedBroadStr[i].name.." ", size=20, color=COLOR_GREEN},
									{str=" "..MultiLan("notice_server_6_1").." ", size=20, color=COLOR_WHITE},
									{str=MultiLan("notice_server_6_2"), size=20, color=COLOR_GREEN}
								  }
				end
				
				table.remove(showedBroadStr, i)
				break
			else
				table.remove(showedBroadStr, i)
				UpdateBroadcast()
				return
			end
		end
	end
	
	CreateRichtextByFather(broadback,richtextArr)
	AddBroadcastStr(broadback)
end

function InitBroadcastStr()
	EnergyTimeSchedulerEntry = scheduler:scheduleScriptFunc(UpdateBroadcast, 20, false)
	--随机生成本地广播序列
	local count = table.maxn(GameData:getGameDataTable().notice)
	local temp = {}
	for i=1, count do temp[i] = i end
	for i=1,count do
		local randomIndex = math.random(os.clock()*10^6)%(count+1-i) + 1
		showedLocalStr[i] = temp[randomIndex]
		table.remove(temp, randomIndex)
	end
	
	UpdateBroadcast()
end

--服务器端广播
function AddServerBoardcast(rcvTable)
	table.insert(showedBroadStr, rcvTable)
	for k,v in pairs(showedBroadStr[table.maxn(showedBroadStr)]) do
		--CommonNote(k.." "..v)
	end
end

function AddBroadcastStr(broadNode)
	-- print("AddBroadcastStr")
	BroadcastLayer:addChild(broadNode)
	broadNode:runAction(cc.Sequence:create(cc.MoveBy:create(8,cc.p(-580,0)), cc.DelayTime:create(4), cc.MoveBy:create(8, cc.p(-1280,0)), cc.CallFunc:create(removeSelf)))
	--BroadcastLayer
end

function onMainMelt()
	EquipMeltLayer:EquipMeltLayerEnter()
end

local function setVipNeedInfo(fatherLayer)
	local vipData = GameData:getGameDataTable().vip
	--说明
	local ruleBack = CreateCommonSprite("board_skill01.png", Pos(POPUP_SIZE_MAX,0.5,0.91))
	ruleBack:setScaleX(1.6)
	fatherLayer:addChild(ruleBack)
	if UserVipInfo.level == VIP_LEVEL_MAX then
		fatherLayer:addChild(CreateCommonLabel(MultiLan("CL_vipIsfull"), Pos(POPUP_SIZE_MAX,0.5,0.91), FontSize4))
		-- 左边 当前lv
		fatherLayer:addChild(CreateCommonSprite("vip.png", Pos(POPUP_SIZE_MAX,0.1,0.86)))
		local vipLevel = cc.LabelBMFont:create(UserSelfInfo.vip, "ccb/ccbResources/bmfont_vip.fnt")
		vipLevel:setPosition(Pos(POPUP_SIZE_MAX,0.17,0.857))
		fatherLayer:addChild(vipLevel)
		-- 右边 max
		-- fatherLayer:addChild(CreateCommonSprite("vip.png", Pos(POPUP_SIZE_MAX,0.85,0.86)))
		-- vipLevel = CreateCommonFntLabel("MAX", FntTypeUserTitle)
		vipLevel = CreateCommonLabel("MAX", Pos(POPUP_SIZE_MAX, 0.85, 0.86), FontSize4, COLOR_FNT_UserTilte)
		fatherLayer:addChild(vipLevel)
	else
		local richText = ccui.RichText:create()
		richText:ignoreContentAdaptWithSize(false)
		richText:setContentSize(cc.size(ruleBack:getContentSize().width*ruleBack:getScaleX(),ruleBack:getContentSize().height))
		richText:setPosition(cc.p(ruleBack:getPositionX()+100, ruleBack:getPositionY() - 5))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CL_vipLvlUpNeedGold_1"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_YELLOW, 255, (vipData[UserSelfInfo.vip+2].count- UserSelfInfo.pay_cash_count).. " " .. MultiLan("prop_name_100001"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CL_vipLvlUpNeedGold_2"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, EQUIP_COLOR_ARR[4], 255 ,"VIP"..(UserSelfInfo.vip+1),DefaultFontName, FontSize4))
		fatherLayer:addChild(richText)
		
		fatherLayer:addChild(CreateCommonSprite("vip.png", Pos(POPUP_SIZE_MAX,0.1,0.86)))
		local vipLevel = cc.LabelBMFont:create(UserSelfInfo.vip, "ccb/ccbResources/bmfont_vip.fnt")
		vipLevel:setPosition(Pos(POPUP_SIZE_MAX,0.17,0.857))
		fatherLayer:addChild(vipLevel)
		fatherLayer:addChild(CreateCommonSprite("vip.png", Pos(POPUP_SIZE_MAX,0.85,0.86)))
		vipLevel = cc.LabelBMFont:create(UserSelfInfo.vip+1, "ccb/ccbResources/bmfont_vip.fnt")
		vipLevel:setPosition(Pos(POPUP_SIZE_MAX, 0.92, 0.857))
		fatherLayer:addChild(vipLevel)
	end

	local barBack = CreateCommonSprite("pic_equiptiao01.png", Pos(POPUP_SIZE_MAX,0.5,0.86))
	barBack:setScale(0.7)
	fatherLayer:addChild(barBack)

	local bar = CreateCommonBar("pic_equiptiao02.png", Pos(POPUP_SIZE_MAX,0.5,0.86))
	bar:setScale(0.7)
	if UserVipInfo.level == VIP_LEVEL_MAX then
		bar:setPercentage(100)
	else
		bar:setPercentage((UserSelfInfo.pay_cash_count - vipData[UserSelfInfo.vip+1].count)*100/(vipData[UserSelfInfo.vip+2].count - vipData[UserSelfInfo.vip+1].count))
	end
	fatherLayer:addChild(bar)
end

function onVipClick()
	--内容
	local layer = cc.Layer:create()
	local vip = UserSelfInfo.vip
	local popupContent = CreateLayer(POPUP_SIZE_MAX, 1, Pos(POPUP_SIZE_MAX, 0.5, 0.48))
	local scrollLayer  = CreateLayer(cc.size(600,640), 1, Pos(POPUP_SIZE_MAX,0.5,0.505))--nil,nil,cc.c4b(0,255,0,255))
	setVipNeedInfo(popupContent)
	
	--内容
	popupContent:addChild(CreateCommonSprite("board_equip.png",Pos(POPUP_SIZE_MAX,0.5,0.47), 0.9))
	
	local vipDesc = CreateLayer(cc.size(410,480),1,Pos(POPUP_SIZE_MAX,0.5,0.45))
	popupContent:addChild(vipDesc)
	local vipData = GameData:getGameDataTable().vip

	local function setVipDesc()
		vipDesc:removeAllChildren(true)
		vipDesc:addChild(CreateCommonSprite("board_guildlevel.png",Pos(vipDesc:getContentSize(),0.5,1.1), 0.93))
		vipDesc:addChild(CreateCommonLabel(string.format(MultiLan("CL_vipPrivilege_1"), tostring(vip)), Pos(vipDesc:getContentSize(),0.5, 1.12), FontSize4, COLOR_FNT_UserTilte))
		-- vipDesc:addChild(CreateCommonFntLabel(string.format(MultiLan("CL_vipPrivilege_1"), tostring(vip)), FntTypeCommonYellow, Pos(vipDesc:getContentSize(), 0.5, 1.11)))
		
		local richText = ccui.RichText:create()
		richText:ignoreContentAdaptWithSize(false)
		richText:setContentSize(vipDesc:getContentSize())
		richText:setPosition(Pos(vipDesc:getContentSize(),0.5,0.5))
		
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CL_vipPrivilege_2"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_YELLOW, 255 , vipData[vip+1].count.. " " .. MultiLan("prop_name_100001"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CL_vipPrivilege_3"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementNewLine:create())
		if vipData[vip+1].fast_fight > 0 then
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CL_vipPrivilege_4"),DefaultFontName, FontSize4))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 , vipData[vip+1].fast_fight,DefaultFontName, FontSize4))
			--richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ," 次",DefaultFontName, FontSize4))
			richText:pushBackElement(ccui.RichElementNewLine:create())
		end
		
		if vipData[vip+1].boss > 0 then
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CL_vipPrivilege_5"),DefaultFontName, FontSize4))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 , vipData[vip+1].boss,DefaultFontName, FontSize4))
			--richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ," 次",DefaultFontName, FontSize4))
			richText:pushBackElement(ccui.RichElementNewLine:create())
		end
		
		if vipData[vip+1].shop_slot > 0 then
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CL_vipPrivilege_6"),DefaultFontName, FontSize4))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 , vipData[vip+1].shop_slot,DefaultFontName, FontSize4))
			--richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ," 次",DefaultFontName, FontSize4))
			richText:pushBackElement(ccui.RichElementNewLine:create())
		end
		
		buttonTitle = {MultiLan("CL_train_1"), MultiLan("CL_train_2"), MultiLan("CL_train_3"), MultiLan("CL_train_4")}
		if vipData[vip+1].hire_train > 0 then
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CL_vipPrivilege_7"),DefaultFontName, FontSize4))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 , buttonTitle[vipData[vip+1].hire_train],DefaultFontName, FontSize4))
			--richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ," 次",DefaultFontName, FontSize4))
			richText:pushBackElement(ccui.RichElementNewLine:create())
		end
		
		--护法升星
		if vipData[vip+1].hire_star > 0 then
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 , MultiLan("CL_vipPrivilege_13"),DefaultFontName, FontSize4))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 , " "..vipData[vip+1].hire_star,DefaultFontName, FontSize4))
			--richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ," 次",DefaultFontName, FontSize4))
			richText:pushBackElement(ccui.RichElementNewLine:create())
		end
		
		--护法群战
		if vip >= 6 then
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CL_vipPrivilege_14"),DefaultFontName, FontSize4))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 ," "..MultiLan("CL_vipPrivilege_15"),DefaultFontName, FontSize4))
			richText:pushBackElement(ccui.RichElementNewLine:create())
		end
		
		--市集寄售
		if not GameConfig:IsMarketClosed() then
			if vipData[vip+1].market_slot > 0 then
				richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 , MultiLan("CL_vipPrivilege_16"),DefaultFontName, FontSize4))
				richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 , " "..vipData[vip+1].market_slot,DefaultFontName, FontSize4))
				richText:pushBackElement(ccui.RichElementNewLine:create())
			end
		end
		--vip共有描述
		if vip > 0 then
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CL_vipPrivilege_8"),DefaultFontName, FontSize4))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 ,MultiLan("CL_vipPrivilege_9"),DefaultFontName, FontSize4))
			richText:pushBackElement(ccui.RichElementNewLine:create())
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CL_vipPrivilege_10"),DefaultFontName, FontSize4))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 ,MultiLan("CL_vipPrivilege_11"),DefaultFontName, FontSize4))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CL_vipPrivilege_12"),DefaultFontName, FontSize4))
		end
		
		vipDesc:addChild(richText)
	end
	setVipDesc()
	--左右按钮
	local function leftVip()
		if vip > 0  then
			vip = vip-1
			setVipDesc()
		end
		return true
	end
	
	local function rightVip()
		if vip < VIP_LEVEL_MAX then
			vip = vip + 1
			setVipDesc()
		end
		return true
	end
	local leftLayer = CreateLayer(cc.size(80,500),1,Pos(POPUP_SIZE_MAX,0.12,0.5), nil, leftVip)
	leftLayer:addChild(CreateCommonSprite("title_rechargeway.png", cc.p(40,250), nil, nil,nil,true))
	leftLayer:setScale(0.6)
	popupContent:addChild(leftLayer)
	local rightLayer = CreateLayer(cc.size(80,500),1,Pos(POPUP_SIZE_MAX,0.88,0.5), nil, rightVip)
	rightLayer:addChild(CreateCommonSprite("title_rechargeway.png", cc.p(40,250)))
	rightLayer:setScale(0.6)
	popupContent:addChild(rightLayer)
	
	local popupRoot = CommonCreatePopupMax("vip", popupContent)
	--关闭
	local function closeFunc()
		removeSelf(popupRoot)
	end
	popupContent:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_MAX,0.3,0.07), cc.size(144,50), closeFunc, {str=MultiLan("button_close"), size = FontSize6}))
	
	--VIP
	local function gotoPay()
		removeSelf(popupRoot)
		onMainPay()
	end
	popupContent:addChild(CreateCommonButton("button_blue.png", Pos(POPUP_SIZE_MAX,0.7,0.07), cc.size(144,50), gotoPay, {str=MultiLan("button_charge"), size = FontSize6}))
end

function sendRefreshCash()
	local resendMax = 5
	local resendCount = 0
	local resendTime = 20

	--刷新钻石回调
	local function refreshCashCallback(retData)
		-- ccdump(retData,"retData")
		if retData.ret == 0 then
			if UserSelfInfo.cash == retData.data.cash then
				resendCount = resendCount + 1
				if resendCount <= resendMax then
					local function delaySend()
						HttpSend("user/payinfo",{},refreshCashCallback)
					end
					--CommonNote("重发"..resendCount.."次")
					if resendCount == 1 then
						NOTE_LAYER:runAction(cc.Sequence:create(cc.DelayTime:create(5), cc.CallFunc:create(delaySend)))
					else
						NOTE_LAYER:runAction(cc.Sequence:create(cc.DelayTime:create(resendTime), cc.CallFunc:create(delaySend)))
					end
				end
			elseif UserSelfInfo.cash < retData.data.cash then
				--同步前后端充值数据
				local noteArr = {MultiLan("CL_ChargeSucceed_1"),MultiLan("CL_ChargeSucceed_2")..(retData.data.cash-UserSelfInfo.cash)}
				local colorArr = {COLOR_GREEN, COLOR_YELLOW}
				
				UserSelfInfo.cash = retData.data.cash
				UserSelfInfo.pay_cash_count = retData.data.pay_cash_count
				
				if retData.data.vip > UserSelfInfo.vip then
					table.insert(noteArr, MultiLan("CL_ChargeSucceed_3")..retData.data.vip)
					table.insert(colorArr , COLOR_YELLOW)
					UserSelfInfo.vip  = retData.data.vip
				end
				if not GameConfig:IsMarketClosed() and retData.data.coupon ~= nil and retData.data.coupon ~= UserSelfInfo.coupon then
					table.insert(noteArr, MultiLan("lan_get").." "..MultiLan("prop_name_"..PROP_ID_COUPON).."*"..(retData.data.coupon-UserSelfInfo.coupon))
					table.insert(colorArr , COLOR_YELLOW)
					UserSelfInfo.coupon  = retData.data.coupon
				end
                CommonNote(noteArr, colorArr)
				UserVipInfo = GameData:getGameDataTable().vip[UserSelfInfo.vip+1]
				
				--月卡天数
				UserSelfInfo.vipcard_days = retData.data.vipcard_days
				UserSelfInfo.firstpay = retData.data.firstpay
				setQuestByType(QUEST_TYPE_FIRST)
				setQuestByType(QUEST_TYPE_PAY)
				
				--连续充值活动
				if retData.data.conpay_days ~= nil then
					UserSelfInfo.conpay_days = retData.data.conpay_days
					UserSelfInfo.actconpay_days = retData.data.actconpay_days

					--更新活动提示
					if ACT_TYPE_CONPAY ~= 0 and Activity_ActArr[ACT_TYPE_CONPAY] ~= nil then
						Activity_ActArr[ACT_TYPE_CONPAY].canReward = IsConpayCanReward(Activity_ActArr[ACT_TYPE_CONPAY].info)
						-- print("Activity_ActArr[ACT_TYPE_CONPAY].canReward",Activity_ActArr[ACT_TYPE_CONPAY].canReward)
						if Activity_ActArr[ACT_TYPE_CONPAY].layer:isVisible() then
							setConAct()
						end
					end
					
					if ACT_TYPE_CONPAY_TEMP ~= 0 and Activity_ActArr[ACT_TYPE_CONPAY_TEMP] ~= nil then
						Activity_ActArr[ACT_TYPE_CONPAY_TEMP].canReward = IsTempConpayCanReward(Activity_ActArr[ACT_TYPE_CONPAY_TEMP].info)
						if Activity_ActArr[ACT_TYPE_CONPAY_TEMP].layer:isVisible() then
							setTempConAct()
						end
					end
					
				end
				--更新活动提示
				if ACT_TYPE_VIP_FREE ~= 0 and Activity_ActArr[ACT_TYPE_VIP_FREE] ~= nil then
					Activity_ActArr[ACT_TYPE_VIP_FREE].canReward = IsActVipCanReward()
				end
				if IsShouchong() then
					Activity_ActArr[ACT_TYPE_FIRST].canReward = IsShouchongCanReward()
				end
				
				--新服累计充值
				if retData.data.newserver_pay ~= nil and ACT_TYPE_PAY ~= 0 and Activity_ActArr[ACT_TYPE_PAY] ~= nil then
					--Activity_ActArr[ACT_TYPE_PAY].info = retData.data.newserver_pay
					for k,v in pairs(retData.data.newserver_pay) do
						UserActiveInfo.newserver_pay[k] = v
					end
					TimeDown:setTimeInfo(Activity_ActArr[ACT_TYPE_PAY].timerId, Activity_ActArr[ACT_TYPE_PAY].info.countdown)
					if Activity_ActArr[ACT_TYPE_PAY].layer:isVisible() then
						setPayAct()
					end
				end
				
				--临时累计冲值
				if retData.data.accpay ~= nil and ACT_TYPE_PAY_TEMP ~= 0 and Activity_ActArr[ACT_TYPE_PAY_TEMP] ~= nil then
					Activity_ActArr[ACT_TYPE_PAY_TEMP].info.accpay = retData.data.accpay
					if Activity_ActArr[ACT_TYPE_PAY_TEMP].layer:isVisible() then
						setPayTempAct()
					end
				end
				
				
				--转盘充值
				if retData.data.daily_lottery ~= nil and ACT_TYPE_ZHUAN ~= 0 and Activity_ActArr[ACT_TYPE_ZHUAN] ~= nil then
					Activity_ActArr[ACT_TYPE_ZHUAN].info.left = retData.data.daily_lottery.left
					Activity_ActArr[ACT_TYPE_ZHUAN].canReward = IsZhuanCanReward(Activity_ActArr[ACT_TYPE_ZHUAN].info)
					if CommonActLayer:isVisible() and GameActShowTag == ACT_TYPE_ZHUAN then
						setZhuanAct()
					end
				end
				if Activity_ActArr[ACT_TYPE_LIFETIME].layer:isVisible() then
					setLifeTime()
				end
				if IsShouchong() then
					if Activity_ActArr[ACT_TYPE_FIRST].layer:isVisible() then
						setFirstAct()
					end
				end
				
				--刷新界面
				XiaLayer:SetHomeUserInfo()
				if PAY_POPUP_ROOT ~= nil then
					removeSelf(PAY_POPUP_ROOT)
					PAY_POPUP_ROOT = nil
					showPayShop(ShopPayListData,activity)
				end

				--刷新主页提示
				if CommonHomeLayer:isVisible() then
					GameGuide:setActButtonNote()
				end
			end
		
		end
	end
	--CommonNote("第一次")
    HttpSend("user/payinfo",{},refreshCashCallback)
end

--充值回掉
function useQhRefreshDiamond(event)
   cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("NotificationRefreshDiamond")
   sendRefreshCash()
end

-- 服务器加完元宝
function buyResultCallback(retData)
	if retData.ret == 0 then
		-- 加成功了
		sendRefreshCash()
		DevicePlatform:getInstance():serverCheckFinished(retData.itemid)
		-- ShopPayListData
		-- for index = 1,table.maxn(ShopPayListData) do
		-- 	if ShopPayListData[index].id == itemId then

		-- 	end
		-- end
	end
end
AppStoreReceipt = ""
AppStoreBuyOrderid = ""
function googleBuySuccess(data)
	cclog("googleBuySuccess:" .. data)
	if data == "third" then
		sendRefreshCash()
	else
		AppStoreReceipt = data
	end
end

--苹果充值
function appStoreRefreshDiamond(event)
   cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("NotificationAppStoreBuyFinish") 
   cclog("app store receipt " .. tostring(AppStoreReceipt))
   cclog("app store rorder:"..AppStoreBuyOrderid)
   HttpSend("game/appstorepaycall",{"receipt-data="..AppStoreReceipt,"order_id="..AppStoreBuyOrderid},buyResultCallback)
   AppStoreReceipt = ""
   AppStoreBuyOrderid = ""

end

function googlePlayRefreshDiamond(event)
   -- cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("NotificationGooglePayBuyFinish") 
   cclog("googlePlay receipt " .. tostring(AppStoreReceipt))
   cclog("googlePlay rorder:"..AppStoreBuyOrderid)
   HttpSend("game/googleplaypaycall",{"inapp_purchase_data="..AppStoreReceipt,"inapp_data_signature="..AppStoreBuyOrderid},buyResultCallback)
   AppStoreReceipt = ""
   AppStoreBuyOrderid = ""
end

local function shopBuyDiamondQH(ordersData)
    local ordersid = ordersData.order_id
    local itemid = ordersData.item_id
    local itemPrice = ordersData.price
    if not canBuy() then return end
    if ShopPayListData ~= nil then
       for index = 1,table.maxn(ShopPayListData) do
          if ShopPayListData[index].id == itemid then

            local eventDispatcher  = cc.Director:getInstance():getEventDispatcher()
            local eventName = "NotificationRefreshDiamond"
            local listener = cc.EventListenerCustom:create(eventName, useQhRefreshDiamond)
                            eventDispatcher.addEventListenerWithFixedPriority(eventDispatcher,listener, 1)

			local productName = nil
			if itemid == 100 then
                productName = MultiLan("lan_monthCard")
			else
                productName = MultiLan("prop_name_100001")
			end
			local tmpTable = {}
			if SDK_PLATFORM == "SDK_QH_ANDROID" then
				tmpTable = {
	                          islandscape = 0, 
	                          moneyamount = itemPrice*100,
							  exchangerate = ShopPayListData[index].cash/itemPrice,
	                          quUserId = QH_360_USERID,
	                          productname = productName,
							  productId = itemid,
							  notifurl = "http://119.29.4.185/game/qhpaycall",
							  appusername = UserInfo.UserInfoTable.data.info.name,
							  userId = UserInfo.UserInfoTable.data.info.uid,
							  appsorderId = ordersid
							  }
            elseif SDK_PLATFORM == "SDK_TGAME_IOS" or SDK_PLATFORM == "SDK_TGAME_ANDROID" then
				local changeTable = {0, 6000, 2400, 1200, 600, 360, 120}
				
				local finalItemId = itemid
				if SDK_PLATFORM == "SDK_TGAME_IOS" then
					finalItemId = "com.tplay.qmjxft.item"..changeTable[itemid-100+1]
				else
					finalItemId = "com.qmjxgtw.gp"..changeTable[itemid-100+1]
				end
			
				if itemid == 100 then
					productName = "全民劍俠月卡"
				else
					productName = ShopPayListData[index].cash.."元寶禮包"
				end
			
                tmpTable = {
                              productId = finalItemId,
                              buyNum = 1,
                              realPrice = tostring(itemPrice),
                              productname = productName,
                              extInfo =  UserSelfInfo.uid.."_"..ordersid.."_"..tostring(itemPrice).."_"..finalItemId,
                              notifyUrl = "http://119.28.3.238/game/tgpaycall"
                            }
            elseif SDK_PLATFORM == "SDK_JAGUAR_ANDROID" then
            	local changeTable = {"000100_yk", "006000", "002400", "001200", "000600", "000360", "000120"}
				finalItemId = "jx_"..changeTable[itemid-100+1].."_0"
				 local appStoreEventName = "NotificationGooglePayBuyFinish"
                local appStoreListener = cc.EventListenerCustom:create(appStoreEventName, googlePlayRefreshDiamond)
                eventDispatcher.addEventListenerWithFixedPriority(eventDispatcher,appStoreListener, 1)
				if itemid == 100 then
					productName = "全民劍俠月卡"
				else
					productName = ShopPayListData[index].cash.."元寶禮包"
				end
			
                tmpTable = {
                              productId = finalItemId,
                              buyNum = 1,
                              realPrice = tostring(itemPrice),
                              productname = productName,
                              extInfo =  UserSelfInfo.uid.."_"..ordersid.."_"..tostring(itemPrice).."_"..finalItemId,
                              notifyUrl = tostring(LOGIN_SERVER_ID)
                            }
            elseif SDK_PLATFORM == "SDK_WEIBO_IOS" then
                local appStoreEventName = "NotificationAppStoreBuyFinish"
                local appStoreListener = cc.EventListenerCustom:create(appStoreEventName, appStoreRefreshDiamond)
                eventDispatcher.addEventListenerWithFixedPriority(eventDispatcher,appStoreListener, 1)

                local iosChangeTable = {0, 6480,3280, 1980, 980, 500, 300,120, 60}
                tmpTable = {
                                productId = "com.hardtime.qmjx.cn1." .. iosChangeTable[itemid-100+1],
                                extInfo = ordersid,
                            }
            elseif SDK_PLATFORM == "SDK_TGAME_VN_IOS" or SDK_PLATFORM == "SDK_TGAME_VN_ANDROID" then
				local changeTable = {0, 5180, 3080, 1080, 500, 60}
				
				local finalItemId = itemid
				if SDK_PLATFORM == "SDK_TGAME_VN_IOS" then
					finalItemId = "com.tplay.qmjxvn.item"..changeTable[itemid-100+1]
				else
					finalItemId = "com.tplay.qmjxvn.gp"..changeTable[itemid-100+1]
				end
			
				if itemid == 100 then
					productName = "Kiếm Hiệp Auto thẻ tháng"
				else
					productName = "Lễ bao "..ShopPayListData[index].cash.." nguyên bảo"
				end
			
                tmpTable = {
                              productId = finalItemId,
                              buyNum = 1,
                              realPrice = tostring(itemPrice),
                              productname = productName,
                              extInfo = UserSelfInfo.uid.."_"..ordersid,
                              notifyUrl = "http://119.28.5.92/game/tgpaycall"
                            }
               elseif SDK_PLATFORM == "SDK_TGAME_TH_IOS" or SDK_PLATFORM == "SDK_TGAME_TH_ANDROID" then
				local changeTable = {0, 6000, 2400, 1200, 600, 360, 120}
				
				local finalItemId = itemid
				if SDK_PLATFORM == "SDK_TGAME_TH_IOS" then
					finalItemId = "com.qmpublishing.qmjxtl.item"..changeTable[itemid-100+1]
				else
					finalItemId = "com.qmjxtl2.gp"..changeTable[itemid-100+1]
				end
			
				if itemid == 100 then
					productName = "การ์ดเดือน"
				else
					productName = "ก้อนทอง"..ShopPayListData[index].cash
				end
			
                tmpTable = {
                              productId = finalItemId,
                              buyNum = 1,
                              realPrice = tostring(itemPrice),
                              productname = productName,
                              extInfo = UserSelfInfo.uid.."_"..ordersid,
                              notifyUrl = "http://119.28.5.92:8090/game/tgpaycall"
                            }
            elseif SDK_PLATFORM == "SDK_TGAME_XMT_IOS" or SDK_PLATFORM == "SDK_TGAME_XMT_ANDROID" then
				local changeTable = {0, 6000, 2400, 1200, 600, 360, 120}
				
				local finalItemId = itemid
				if SDK_PLATFORM == "SDK_TGAME_XMT_IOS" then
					finalItemId = "com.qmautogame.qmxm.item"..changeTable[itemid-100+1]
				else
					finalItemId = "com.qmautogame.qmxm.gp"..changeTable[itemid-100+1]
				end
			
				if itemid == 100 then
					productName = "月卡"
				else
					productName = ShopPayListData[index].cash.."元宝礼包"
				end
			
                tmpTable = {
                              productId = finalItemId,
                              buyNum = 1,
                              realPrice = tostring(itemPrice),
                              productname = productName,
                              extInfo = UserSelfInfo.uid.."_"..ordersid,
                              notifyUrl = "http://119.28.3.238:8090/game/tgpaycall"
                            }

			elseif SDK_PLATFORM == "SDK_HUAWEI_ANDROID" then
				local count = ShopPayListData[index].cash
				if itemid == 100 then
					count = 1
				end
				tmpTable = {
								realPrice = string.format("%.2f", itemPrice),
								productname = count..productName,
								appsorderId = ordersid,
								productdesc = productName,
								uid         = UserSelfInfo.uid
							}
			elseif SDK_PLATFORM == "SDK_XY_IOS" then
				tmpTable = {
	                          islandscape = 0, 
	                          moneyamount = tostring(itemPrice),
							  extra = UserSelfInfo.uid.."_"..ordersid,
							  serverId = tostring(LOGIN_SERVER_ID)
							}
            elseif SDK_PLATFORM == "SDK_XM_ANDROID" then
            	local extrenData = UserSelfInfo.cash..","..UserSelfInfo.vip..","..UserSelfInfo.level..",".."guild"..","..UserSelfInfo.name..","..UserSelfInfo.uid..","..LOGIN_SERVER_NAME
				tmpTable = {
							  productId = itemid,
							  appsorderId = ordersid,
							  moneyamount = tostring(itemPrice),
							  extrenData = extrenData,
							}
			elseif SDK_PLATFORM == "SDK_ANZHI_ANDROID" then
            	local extrenData = UserSelfInfo.cash..","..UserSelfInfo.vip..","..UserSelfInfo.level..",".."guild"..","..UserSelfInfo.name..","..UserSelfInfo.uid..","..LOGIN_SERVER_NAME
				tmpTable = {
							  appsorderId = ordersid,
							  moneyamount = tostring(itemPrice),
							  productName = productName
							}
			elseif SDK_PLATFORM == "SDK_COOLPAD_ANDROID" then

				local coolTable = {[100]=1, [101]=2, [102]=3, [103]=4, [104]=5, [105]=6, [999]=7}
				tmpTable = {
							  productId = coolTable[itemid],
							  orderId = ordersid,
							  price = tostring(itemPrice),
							  goodscount = count,
							  uid = UserSelfInfo.uid,
							  openId = QH_360_USERID,
							  accessToken = ACCESS_TOKEN
							}
			elseif SDK_PLATFORM == "SDK_BAIDU_ANDROID" then
					local count = ShopPayListData[index].cash
					if itemid == 100 then
						count = 1
					end
					tmpTable = {
							  productId = itemid,
							  appsorderId = ordersid,
							  productName = count..productName,
							  moneyamount = itemPrice*100,
							  uid         = UserSelfInfo.uid
					}
			elseif SDK_PLATFORM == "SDK_OPPO_ANDROID" then
					local count = ShopPayListData[index].cash
					if itemid == 100 then
						count = 1
					end
					tmpTable = {
							  productId = itemid,
							  appsorderId = ordersid,
							  productName = productName,
							  moneyamount = itemPrice*100,
							  notifurl = "http://119.29.4.185/game/oppopaycall",
							  goodscount = count,
							  uid         = UserSelfInfo.uid
					}
			elseif SDK_PLATFORM == "SDK_WDJ_ANDROID" then
					if itemid == 100 then
						productName = MultiLan("lan_monthCard").."*1"
					else
						productName = MultiLan("prop_name_100001").."*"..ShopPayListData[index].cash
					end
					tmpTable = {
						      productname = productName,
							  appsorderId = ordersid,
							  moneyamount = itemPrice*100
					}
			elseif SDK_PLATFORM == "SDK_UC_ANDROID" then
					local count = ShopPayListData[index].cash
					tmpTable = {
							  cpid = ordersid,
							  roleName = UserSelfInfo.name,
							  roleId = UserSelfInfo.uid,
							  realPrice = itemPrice,
							  notifurl = "http://119.29.4.185/game/ucpaycall",
					}
			elseif SDK_PLATFORM == "SDK_LOVEU_ANDROID" then
				local appStoreEventName = "NotificationGooglePayBuyFinish"
                local appStoreListener = cc.EventListenerCustom:create(appStoreEventName, googlePlayRefreshDiamond)
                eventDispatcher.addEventListenerWithFixedPriority(eventDispatcher,appStoreListener, 1)
				local finalItemId = itemid
				tmpTable = {
					productId = finalItemId,
					buyNum = 1,
					realPrice = tostring(itemPrice),
					extInfo = UserSelfInfo.uid.."_"..ordersid,
				}
			end
			
			--local function delayBuy()
				DevicePlatform:getInstance():buy(tmpTable)
				--print("-------------------",DevicePlatform:getInstance():getDeviceInfomation())
			--end
              --UI_LAYER:runAction(cc.Sequence:create(cc.DelayTime:create(0.1), cc.CallFunc:create(delayBuy)))
              break
          end
      end
    end
end

function getOrderIdCallback(retData)
	cclog("retData.ret" .. retData.ret)
	if retData.ret == 0 then
		-- print("getOrderIdCallback", SDK_PLATFORM)
	   if SDK_PLATFORM ~= "SDK_NONE" then 
		  shopBuyDiamondQH(retData.data)
	   else
		  sendRefreshCash()
	   end

	   -- print("orderid", retData.data.order_id)
	   -- print("itemid", retData.data.item_id)
	end
end

--充值商店列表
function showPayShop(payListData)
	local popupContent = CreateLayer(POPUP_SIZE_MAX, 1, Pos(POPUP_SIZE_MAX, 0.5, 0.48))
	local scrollLayer  = CreateLayer(cc.size(600,600), 1, Pos(POPUP_SIZE_MAX, POS_CONFIGS.store_scroll_layer.xp, POS_CONFIGS.store_scroll_layer.yp))
	popupContent:addChild(scrollLayer)


	
	local function thirdRefreshDiamond( event )
		-- body	
		sendRefreshCash()
	end

	local function onPayBuyClicked(node)
		-- cclog("onPayBuyClicked", payListData[node:getTag()].id, payListData[node:getTag()].price)
		if SDK_PLATFORM == "SDK_JAGUAR_THIRD" then
               local  tmpTable = {
                              productId = finalItemId,
                              buyNum = 1,
                              realPrice = "",
                              productname = "",
                              extInfo = "",
                              notifyUrl = tostring(LOGIN_SERVER_ID)
                            }
                DevicePlatform:getInstance():buy(tmpTable)
        else
			HttpSend("pay/order",{"item_id="..payListData[node:getTag()].id,"price="..payListData[node:getTag()].price,"sid="..LOGIN_SERVER_ID,"platform="..SDK_PLATFORM},getOrderIdCallback)
		end
	end

	local setTable = {
						{cash=0,  color=2, pic="pic_recharge01.png"},
						{cash=500,  color=3, pic="pic_recharge02.png"},
						{cash=1000,  color=4, pic="pic_recharge03.png"},
						{cash=2000,  color=5, pic="pic_recharge04.png"},
						{cash=5000,  color=5, pic="pic_recharge05.png"}
					 }
	--根据元宝数量决定图片和外框
	local function getSetInfoByCash(cashValue)
		for i=1,table.maxn(setTable) do
			if cashValue >= setTable[i].cash and (i == table.maxn(setTable) or cashValue < setTable[i+1].cash) then
				return setTable[i]
			end
		end
		
		return setTable[1]
	end

	local layer = cc.Layer:create()
	local layerTable = {}
	local backSize = cc.size(200,300)
	local sanbeiTag = UserSelfInfo.firstpay
	--sanbeiTag = 1
	--CommonNote("sanbeiTag", sanbeiTag)
	local supportLargePay = false --是否支持大额充值
	for i = 1, table.maxn(payListData) do
		local itemInfo = payListData[i]
		if itemInfo.id ~= 999 then
			local back = CreateLayer(backSize)
			local setInfo = getSetInfoByCash(payListData[i].cash)
			table.insert(layerTable, back)
			back:addChild(CreateCommonSprite("board_pvpgoods.png", Pos(backSize, 0.5,0.6)))
			if itemInfo.id == 100 then
				back:addChild(CreateCommonSprite("pic_rechargecard.png", Pos(backSize, 0.5,0.7)))
			else
				back:addChild(CreateCommonSprite(setInfo.pic, Pos(backSize, 0.5,0.7)))
			end
			back:addChild(CreateCommonSprite(FRAME_ICON_ARR[setInfo.color], Pos(backSize, 0.5,0.7)))
			
			--三倍
			local bit = 1
			if i ~= 1 then
				bit = sanbeiTag%2
				sanbeiTag = math.floor(sanbeiTag/2)
			end 

			if bit == 0 then
				back:addChild(CreateCommonSprite("pic_discount01.png", Pos(backSize, 0.32,0.77)))
				local saleLabel= CreateCommonLabel(MultiLan("CL_FirstCharge"), Pos(backSize, 0.275, 0.805), FontSize1)
				saleLabel:setRotation(-45)
				back:addChild(saleLabel)
			end
			
			--数量
			if itemInfo.id == 100 then
				back:addChild(CreateCommonLabel(MultiLan("lan_monthCard"), Pos(backSize, 0.5,0.47), FontSize2, COLOR_YELLOW))
				back:addChild(CreateCommonSprite("pic_yuekasm.png", Pos(backSize, 1.46, 0.94)))
				back:addChild(CreateCommonLabel(MultiLan("CL_monthcard"), Pos(backSize, 0.15, 0.955), FontSize1, COLOR_YELLOW, cc.p(0,0.5)))
			else
				back:addChild(CreateCommonSprite("icon_gold.png", Pos(backSize, 0.3,0.47),0.85))
				back:addChild(CreateCommonLabel(itemInfo.cash, Pos(backSize, 0.45,0.47), FontSize2,COLOR_YELLOW,cc.p(0,0.5)))
			end
			back:addChild(CreateCommonLabel(MultiLan("CL_RMB")..itemInfo.price, Pos(backSize, 0.5,0.37), FontSize2))
			
			--银票
			if not GameConfig:IsMarketClosed() then
				local getCouponLabel = CreateCommonLabel(MultiLan("CL_get_coupon")..math.ceil(itemInfo.cash/2), Pos(backSize, 0.5,0.24), FontSize2, COLOR_GREEN)
				back:addChild(CreateLayerBackSprite("board_skill01.png", cc.size(8+getCouponLabel:getContentSize().width,35), Pos(backSize, 0.5,0.24), 200))
				back:addChild(getCouponLabel)
			end

			--充值
			local btnPos = nil
			if  GameConfig:IsMarketClosed() then
				local payButton = CreateCommonButton("MainButton12.png", Pos(backSize, 0.5, 0.22), cc.size(144, 50), onPayBuyClicked, {str = MultiLan("button_buy"),size=FontSize6})
				payButton:setScale(0.82)
				payButton:setSwallowTouch(false)
				back:addChild(payButton,0, i)
			else
				local payButton = CreateCommonButton("MainButton12.png", Pos(backSize, POS_CONFIGS.store_pay_button.xp, POS_CONFIGS.store_pay_button.yp), cc.size(144, 50), onPayBuyClicked, {str = MultiLan("button_buy"),size=FontSize6})
				payButton:setScale(0.82)
				payButton:setSwallowTouch(false)
				back:addChild(payButton,0, i)
			end
			
			
 
		else
			supportLargePay = true
		end
	end
    if SDK_PLATFORM == "SDK_WEIBO_IOS" then
        local iosChangeTable = {0, 6480,3280, 1980, 980, 500, 300,120, 60}
        local tmpValue = ""
        for i = 1, table.maxn(iosChangeTable) do
            tmpValue = tmpValue .. "com.hardtime.qmjx.cn1." .. iosChangeTable[i] .. ";"
        end
        local productsList = {tmpKey = tmpValue}
        DevicePlatform:getInstance():sdkExtraFunction(productsList)
    end
	
	CreateMxN(layer, 3, 1, layerTable)
	-- print("111", layer:getContentSize().height, scrollLayer:getContentSize().height)
	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, scrollLayer:getContentSize().height - layer:getContentSize().height), kScrollViewDirectionVertical)
	if layer:getContentSize().height < scrollLayer:getContentSize().height then
		scrolView:setTouchEnabled(false)
	end

	--说明
	setVipNeedInfo(popupContent)

	--标题
	local spTitle = CreateCommonSprite("title_charge.png", Pos(POPUP_SIZE_MAX, 0.5, 1))
	-- local lbTitle = CreateCommonFntLabel(ZGMultiLan("title_recharge"), FntTypeCommonYellow, Pos(spTitle:getContentSize(), 0.5, 0.4))
	local lbTitle = CreateCommonLabel(ZGMultiLan("title_recharge"), Pos(spTitle:getContentSize(), 0.5, 0.4), FontSize4, COLOR_FNT_CommonYellow)
	spTitle:addChild(lbTitle)
	popupContent:addChild(spTitle)
	
	-- local popupRoot = CommonCreatePopupMax("recharge", popupContent)
	local popupRoot = CommonCreatePopupMax(nil, popupContent)
	PAY_POPUP_ROOT = popupRoot
	--关闭
	local function closeFunc()
		if XiaLayerOwner["mActLayer"]:isVisible() then
			resetActLayer()
		end
		removeSelf(popupRoot)
		PAY_POPUP_ROOT = nil
	end
	local closeButton = CreateCommonButton("button_red.png", Pos(POPUP_SIZE_MAX,0.3,0.07), cc.size(144,50), closeFunc, {str=MultiLan("button_close"), size = FontSize6})
	popupContent:addChild(closeButton)
	
	--VIP
	local function gotoVip()
		removeSelf(popupRoot)
		PAY_POPUP_ROOT = nil
		onVipClick() 
	end
	local vipButton = CreateCommonButton("button_blue.png", Pos(POPUP_SIZE_MAX,0.7,0.07), cc.size(144,50), gotoVip, {str=MultiLan("CL_vipPrivilege"), size = FontSize6})
	popupContent:addChild(vipButton)
	
	--大额充值
	local function onBigPayClick()
		local popupContet = CreateLayer(POPUP_SIZE_SML, 1, Pos(POPUP_SIZE_SML))
		local popupRoot = CommonCreatePopupSmall("hugegold", popupContet)
		local payEditBox = nil
		local function sendBigPay()
			 local singature = tostring(payEditBox:getText())
			 local payValue = tonumber(singature)

			 if payValue == nil then
				CommonNote(MultiLan("CL_typeCorreValue"))
				return
			 end
			 if payValue < 2000 then
				CommonNote(MultiLan("CL_massiveCharge_1"))
				return
			 end
			--CommonNote(""..payValue)
			HttpSend("pay/order",{"item_id=999","price="..payValue,"sid="..LOGIN_SERVER_ID,"platform="..SDK_PLATFORM},getOrderIdCallback)
			removeSelf(popupRoot)
		end
		
		local descBack = CreateCommonSprite("board_skill01.png", Pos(POPUP_SIZE_SML, 0.5,0.7))
		descBack:setScaleX(1.4)
		popupContet:addChild(descBack)
		popupContet:addChild(CreateCommonLabel(MultiLan("CL_massiveCharge_2"), Pos(POPUP_SIZE_SML, 0.5,0.7),FontSize4, COLOR_GREEN))
		
		popupContet:addChild(CreateCommonSprite("board_creatname.png", Pos(POPUP_SIZE_SML)))
        payEditBox = cc.EditBox:create(cc.size(269*0.85, 54*0.85), cc.Scale9Sprite:createWithSpriteFrameName("pic_suiyiaaa.png"))
	    popupContet:addChild(payEditBox)
		payEditBox:setReturnType(cc.KEYBOARD_RETURNTYPE_SEND)
		payEditBox:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
	    payEditBox:setPlaceHolder(MultiLan("CL_massiveCharge_3"))
	    payEditBox:setPosition(Pos(POPUP_SIZE_SML,0.49,0.5))
		
		local function closeFunc() 
			removeSelf(popupRoot)
		end
		popupContet:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_SML, 0.3, 0.22), cc.size(144,50), closeFunc, {str=MultiLan("button_cancel"), size = FontSize6}))
		popupContet:addChild(CreateCommonButton("button_yellow.png", Pos(POPUP_SIZE_SML, 0.7, 0.22), cc.size(144,50), sendBigPay, {str=MultiLan("button_charge"), size = FontSize6}))
	end
	
	if UserSelfInfo.vip >= 7 and supportLargePay then
		closeButton:setPosition(Pos(POPUP_SIZE_MAX,0.2,0.05))
		vipButton:setPosition(Pos(POPUP_SIZE_MAX,0.8,0.05))
	
		popupContent:addChild(CreateCommonButton("button_yellow.png", Pos(POPUP_SIZE_MAX,0.5,0.05), cc.size(144,50), onBigPayClick, {str=MultiLan("CL_massiveCharge_4"), size = FontSize6}))
	end
	
						--Activity_ActArr[ACT_TYPE_PAY].info = {id=3,count=1000,countdown=10000}
					--TimeDown:setTimeInfo(Activity_ActArr[ACT_TYPE_PAY].timerId, Activity_ActArr[ACT_TYPE_PAY].info.countdown)
end

function onMainPay()
	-- print("onMainPay",NetWorkLock)
	local function getPayListCallback(retData)
		if retData.ret == 0 then
			if PAY_POPUP_ROOT ~= nil then
				removeSelf(PAY_POPUP_ROOT)
				PAY_POPUP_ROOT = nil
			end
			ShopPayListData = retData.data
			showPayShop(ShopPayListData)
		end
	end
	
	HttpSend("pay/items",{},getPayListCallback)
end

function onMainHelp()
	if SDK_PLATFORM == "SDK_JAGUAR_ANDROID" or SDK_PLATFORM == "SDK_JAGUAR_THIRD" then
		local tmpTable = {
							eventType = tostring(2),
							roleId = tostring(UserSelfInfo.uid),
							roleName = tostring(UserSelfInfo.name),
							serverId = tostring(LOGIN_SERVER_ID),
							}
		DevicePlatform:getInstance():sdkExtraFunction(tmpTable)
	else
		HelpPopup("gamehelp")
	end
end
	
function onMainNotice()
	NewsPopup(UniqueNoticeData)
end

function onMainMail()
    local function mailInfoCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			return 
		end
		setMailNote(false)
		UserMailInfo = jsonDataTable.data
		GameMailLayer:GameMailLayerEnter(UserMailInfo)
	end

	HttpSend("mail/info", {}, mailInfoCallback)
	local function testCallback()
		CommonNote("111")
	end
	
	--HttpSend("game/test", {"num=1"}, testCallback)
end

function onArenaClick()
	local function arenaInfoCallback(jsonDataTable)
		-- print("arenaInfoCallback")
		if jsonDataTable.ret ~= 0 then
			cclog("arenaInfoCallback failed %d", jsonDataTable.ret)
			return 
		end
		UserArenaInfo = jsonDataTable.data
		
		local node = cc.Node:create()
		node:setTag(7)
		ShowNew(node)
	end
	
	if CheckArena() then
		HttpSend("arena/info", {}, arenaInfoCallback)
	else
		ArenaNotOpen()
	end
end

--商店
function onShopClick()
	local function shopInfoCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("shopInfoCallback failed %d", jsonDataTable.ret)
			return 
		end
		UserShopInfo = jsonDataTable.data
		table.sort(UserShopInfo.info.list,SortTableById)
		
		local node = cc.Node:create()
		node:setTag(10)
		ShowNew(node)
	end
	
	HttpSend("shop/info", {"id=3"}, shopInfoCallback)
end

--帮会
function onFamilyClick()
	local function familyInfoCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("familyInfoCallback failed %d", jsonDataTable.ret)
			return 
		end
		UserFamilyInfo = jsonDataTable.data
		if UserFamilyInfo.info == nil then
			-- print("bUserHasFamily false")
			bUserHasFamily = false
		else
			-- print("bUserHasFamily true")
			bUserHasFamily = true
		end
		
		local node = cc.Node:create()
		node:setTag(9)
		ShowNew(node)
	end
	
	HttpSend("union/info", {"id=3"}, familyInfoCallback)
end

local function onUpHelpClick()
	if CommonSkillLayer:isVisible() then
		HelpPopup("skill")
	elseif CommonFamilyLayer:isVisible() then
		HelpPopup("family")
	elseif CommonShopLayer:isVisible() then
		HelpPopup("luckyshop")
	elseif CommonGroupLayer:isVisible() then
		HelpPopup("group")
	elseif CommonTeamLayer:isVisible() then
		HelpPopup("group_heroTeam")
	elseif CommonMarketLayer:isVisible() then
		HelpPopup("market")
	end
end



--主页
XiaLayer["ShowNew"]        = ShowNew
XiaLayer["onMainMelt"]     = onMainMelt
XiaLayer["onMainPay"]      = onMainPay
XiaLayer["onVipClick"]     = onVipClick
XiaLayer["onMainHelp"]     = onMainHelp
XiaLayer["onMainNotice"]   = onMainNotice
XiaLayer["onMainMail"]     = onMainMail
XiaLayer["onUpHelpClick"] = onUpHelpClick
--战斗
XiaLayer["onBattleMap"]        = onBattleMap
XiaLayer["onBattleCount"]      = onBattleCount
XiaLayer["onBattleSetting"]    = onBattleSetting
XiaLayer["onBattleQuick"]      = onBattleQuick

--
XiaLayer["onArenaClick"]      = onArenaClick
XiaLayer["onShopClick"]       = onShopClick
XiaLayer["onFamilyClick"]     = onFamilyClick

XiaLayer["onHomeCompensateClick"]     = onHomeCompensateClick
