
function removeFather(button)
	local node = tolua.cast(button, "cc.Node")
	removeSelf(node:getParent():getParent())
end

function CommonCreatePopup(content, callback)
	local popupLayer = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
	
	local function TouchWithCallback()
		callback()
		return true
	end
	
	if callback ~= nil then
		SetTouchEventForLayer(popupLayer, TouchWithCallback)
	else
		SetTouchEventForLayer(popupLayer, TouchSwallow)
	end
	
	local swallowLayer = cc.LayerColor:create(cc.c4b(0,0,0,COMMON_SWALLOW_OPACITY))
	-- print("WinSize",WinSize.width,WinSize.height,swallowLayer:getPositionX(),swallowLayer:getPositionY())
	swallowLayer:ignoreAnchorPointForPosition(false) 
	swallowLayer:setContentSize(WinSize)
	swallowLayer:setPosition(Pos(CommonSize))
	popupLayer:addChild(swallowLayer)
	
	content:setAnchorPoint(cc.p(0.5, 0.5))
	content:ignoreAnchorPointForPosition(false)
	content:setPosition(Pos(CommonSize))
	popupLayer:addChild(content)

	if POPUP_LAYER == nil then
		POPUP_LAYER = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
		scene:addChild(POPUP_LAYER, POPUP_TAG, POPUP_TAG)
	end
	POPUP_LAYER:addChild(popupLayer)

	return popupLayer
end

function CommonCreateScale9Backgroud( size, pos )
	local sp = cc.Scale9Sprite:createWithSpriteFrameName("ease.png")
	sp:setInsetLeft(7)
	sp:setInsetRight(7)
	sp:setInsetTop(7)
	sp:setInsetBottom(7)
	sp:setContentSize(size)
	if pos ~= nil then
		sp:setPosition(pos)
	end
	return sp
end

--最大弹窗
function CommonCreatePopupMax(title, content, closeCallback, helpCallback, addBackSp) 
	-- print("CommonCreatePopupMax", title)
	local bigPopup = cc.Layer:create()
	bigPopup:ignoreAnchorPointForPosition(false) 
	bigPopup:setContentSize(POPUP_SIZE_MAX)

	-- local back = CreateCommonSprite("board_big.png", Pos(POPUP_SIZE_MAX))
	-- back:setScaleX(POPUP_SIZE_MAX.width/ POPUP_SIZE_BIG.width)
	-- bigPopup:addChild(back)
	-- bigPopup:addChild(content,1)

	local back = cc.Scale9Sprite:createWithSpriteFrameName("board_big.png")
	back:setContentSize(cc.size(POPUP_SIZE_MAX.width, POPUP_SIZE_BIG.height))
	back:setPosition(Pos(POPUP_SIZE_MAX))
	bigPopup:addChild(back)
	bigPopup:addChild(content, 1)

	-- add bg sprite
	local spBgSecond = cc.Scale9Sprite:createWithSpriteFrameName("ease.png")
	spBgSecond:setInsetLeft(7)
	spBgSecond:setInsetRight(7)
	spBgSecond:setInsetTop(7)
	spBgSecond:setInsetBottom(7)
	-- spBgSecond:setContentSize(cc.size(POPUP_SIZE_MAX.width * 0.9, POPUP_SIZE_MAX.height * 0.85))
	spBgSecond:setContentSize(cc.size(580, 700))
	spBgSecond:setPosition(Pos(POPUP_SIZE_MAX, 0.5, 0.505))
	bigPopup:addChild(spBgSecond)

	if title ~= nil and title ~= "phblist" then
		bigPopup:addChild(CreateCommonSprite("title_boardall.png", Pos(POPUP_SIZE_MAX,0.5,1)), 2)
	end
	if title ~= nil then
		-- bigPopup:addChild(CreateCommonFntLabel(ZGMultiLan("title_" .. title), FntTypeUserTitle, Pos(POPUP_SIZE_MAX, 0.5, 1)), 2)
		bigPopup:addChild(CreateCommonLabel(ZGMultiLan("title_" .. title), Pos(POPUP_SIZE_MAX, 0.5, 1), FontSize5, COLOR_FNT_UserTilte), 2)
	end
	
	local function closeFunc()
		if closeCallback ~= true and closeCallback ~= nil then
			closeCallback()
		end
		removeSelf(bigPopup:getParent())
	end

	if closeCallback ~= nil then
		bigPopup:addChild(CreateCommonButton("icon_close.png", cc.p(POPUP_SIZE_MAX.width-38, POPUP_SIZE_MAX.height-36), cc.size(50, 50), closeFunc))
	end

	if helpCallback ~= nil then
		bigPopup:addChild(CreateCommonButton("icon_help.png", cc.p(38, POPUP_SIZE_MAX.height-36), cc.size(50, 50), helpCallback))
	end

	return CommonCreatePopup(bigPopup)
end

--大弹窗
function CommonCreatePopupBig(title, content, bNeedClose, helpCallback, withOutBg) 
	local bigPopup = cc.Layer:create()
	bigPopup:ignoreAnchorPointForPosition(false) 
	bigPopup:setContentSize(POPUP_SIZE_BIG)
	
	local back = CreateCommonSprite("board_big.png", Pos(POPUP_SIZE_BIG))

	--back:setScale(content:getScale())
	bigPopup:addChild(back)

	-- add bg sprite
	if not (withOutBg == true) then
		local spBgSecond = cc.Scale9Sprite:createWithSpriteFrameName("ease.png")
		spBgSecond:setInsetLeft(7)
		spBgSecond:setInsetRight(7)
		spBgSecond:setInsetTop(7)
		spBgSecond:setInsetBottom(7)
		-- spBgSecond:setContentSize(cc.size(POPUP_SIZE_BIG.width * 0.9, POPUP_SIZE_BIG.height * 0.82))
		spBgSecond:setContentSize(cc.size(520.0, 700))
		spBgSecond:setPosition(Pos(POPUP_SIZE_BIG, 0.5, 0.505))
		bigPopup:addChild(spBgSecond)
	end

	bigPopup:addChild(content,1)

	if title ~= nil then
		bigPopup:addChild(CreateCommonSprite("title_boardall.png", cc.p(280,830)), 2)
		-- bigPopup:addChild(CreateCommonSprite("title_"..title..".png", cc.p(280,830)), 2)
		bigPopup:addChild(CreateCommonLabel(ZGMultiLan("title_" .. title), Pos(cc.size(560, 830), 0.5, 1), FontSize5, COLOR_FNT_UserTilte, cc.p(0.5, 0.5)), 2)
		-- bigPopup:addChild(CreateCommonFntLabel(ZGMultiLan("title_" .. title), FntTypeUserTitle, Pos(cc.size(560, 830), 0.5, 1)), 2)
	end
	
	if bNeedClose then
		bigPopup:addChild(CreateCommonButton("icon_close.png", cc.p(POPUP_SIZE_BIG.width-37.5, POPUP_SIZE_BIG.height-32.5), cc.size(50, 50), removeFather))
	end
	
	if helpCallback ~= nil then
		bigPopup:addChild(CreateCommonButton("icon_help.png", cc.p(37.5, POPUP_SIZE_BIG.height-32.5), cc.size(50, 50), helpCallback))
	end

	return CommonCreatePopup(bigPopup)
end

function CommonCreatePopupBigWithoutBg( title, content, bNeedClose, helpCallback )
	return CommonCreatePopupBig(title, content, bNeedClose, helpCallback, true)
end

--中弹窗
function CommonCreatePopupMid(title, content, closeCallback, helpCallback) 
	local midPopup = cc.Layer:create()
	midPopup:ignoreAnchorPointForPosition(false) 
	midPopup:setContentSize(POPUP_SIZE_MID)
	midPopup:addChild(CreateCommonSprite("board_middle.png", Pos(POPUP_SIZE_MID)))

	-- add bg sprite
	local spBgSecond = cc.Scale9Sprite:createWithSpriteFrameName("ease.png")
	spBgSecond:setInsetLeft(7)
	spBgSecond:setInsetRight(7)
	spBgSecond:setInsetTop(7)
	spBgSecond:setInsetBottom(7)
	spBgSecond:setContentSize(cc.size(POPUP_SIZE_MID.width * 0.9, POPUP_SIZE_MID.height * 0.77))
	spBgSecond:setPosition(Pos(POPUP_SIZE_MID, 0.5, 0.505))
	midPopup:addChild(spBgSecond)

	midPopup:addChild(content, 1)

	if title ~= nil then
		midPopup:addChild(CreateCommonSprite("title_boardall.png", cc.p(280,POPUP_SIZE_MID.height)), 2)
		-- midPopup:addChild(CreateCommonSprite("title_"..title..".png", cc.p(280,POPUP_SIZE_MID.height)), 2)
		midPopup:addChild(CreateCommonLabel(ZGMultiLan("title_" .. title), Pos(POPUP_SIZE_MID, 0.5, 1), FontSize5, COLOR_FNT_UserTilte, cc.p(0.5, 0.5)), 2)
		-- midPopup:addChild(CreateCommonFntLabel(ZGMultiLan("title_" .. title), FntTypeUserTitle, Pos(POPUP_SIZE_MID, 0.5, 1)), 2)
	end
	
	local function closeFunc()
		if closeCallback ~= true and closeCallback ~= nil then
			closeCallback()
		end
		removeSelf(midPopup:getParent())
	end

	if closeCallback ~= nil then
		midPopup:addChild(CreateCommonButton("icon_close.png", cc.p(POPUP_SIZE_MID.width-38, POPUP_SIZE_MID.height-33), cc.size(50, 50), closeFunc))
	end
	
	if helpCallback ~= nil then
		midPopup:addChild(CreateCommonButton("icon_help.png", cc.p(38, POPUP_SIZE_MID.height-33), cc.size(50, 50), helpCallback))
	end
	
	return CommonCreatePopup(midPopup)
end

--小弹窗
function CommonCreatePopupSmall(title, content, bNeedClose) 
	local smlPopup = cc.Layer:create()
	smlPopup:ignoreAnchorPointForPosition(false) 
	smlPopup:setContentSize(POPUP_SIZE_SML)
	smlPopup:addChild(CreateCommonSprite("board_small.png", Pos(POPUP_SIZE_SML)))
	content:setPosition(Pos(POPUP_SIZE_SML))

	-- add bg sprite
	local spBgSecond = cc.Scale9Sprite:createWithSpriteFrameName("ease.png")
	spBgSecond:setInsetLeft(7)
	spBgSecond:setInsetRight(7)
	spBgSecond:setInsetTop(7)
	spBgSecond:setInsetBottom(7)
	-- spBgSecond:setContentSize(cc.size(POPUP_SIZE_SML.width * 0.9, POPUP_SIZE_SML.height * 0.85))
	spBgSecond:setContentSize(cc.size(520, 200))
	spBgSecond:setPosition(Pos(POPUP_SIZE_SML, 0.5, 0.52))
	smlPopup:addChild(spBgSecond)

	smlPopup:addChild(content)


	if title ~= nil then
		smlPopup:addChild(CreateCommonSprite("title_boardall.png", cc.p(280,POPUP_SIZE_SML.height)), 2)
		-- smlPopup:addChild(CreateCommonSprite("title_"..title..".png", cc.p(280,POPUP_SIZE_SML.height)), 2)
		smlPopup:addChild(CreateCommonLabel(ZGMultiLan("title_" .. title), Pos(POPUP_SIZE_SML, 0.5, 1), FontSize5, COLOR_FNT_UserTilte, cc.p(0.5, 0.5)), 2)
		-- smlPopup:addChild(CreateCommonFntLabel(ZGMultiLan("title_" .. title), FntTypeUserTitle, Pos(POPUP_SIZE_SML, 0.5, 1)), 2)
	end
	
	if bNeedClose then
		smlPopup:addChild(CreateCommonButton("icon_close.png", cc.p(POPUP_SIZE_SML.width-38, POPUP_SIZE_SML.height-37), cc.size(50, 50), removeFather))
	end

	return CommonCreatePopup(smlPopup)
end

--只有一个确定按钮并能够响应回调
function CommonCreatePopupSmallWithOneButtonCallback(title, content, buttonText, callback)
	local popupContet = CreateLayer(POPUP_SIZE_SML, 1, Pos(POPUP_SIZE_SML))
	content:setPosition(Pos(POPUP_SIZE_SML,0.5,0.58))
	popupContet:addChild(content)
	
	local popupRoot = CommonCreatePopupSmall(title, popupContet)

	local function sureFunc()
		removeSelf(popupRoot)
		callback()
	end

	popupContet:addChild(CreateCommonButton("button_green.png", Pos(POPUP_SIZE_SML, 0.5, 0.14), cc.size(144,50), sureFunc, {str=buttonText, size = FontSize6}))

	return popupRoot
end

--带确定取消的小弹窗
function CreateSmallPopupWithCancel(title, content, callback, zgMoreHeight)
	if zgMoreHeight == nil then
		zgMoreHeight = 0
	end
	local popupContetSize = cc.size(POPUP_SIZE_SML.width, POPUP_SIZE_SML.height + zgMoreHeight)
	local popupContet = CreateLayer(popupContetSize, 1, Pos(popupContetSize))
	content:setPosition(Pos(popupContetSize,0.5,0.58))
	popupContet:addChild(content)
	
	local popupRoot = CommonCreatePopupSmall(title, popupContet)
	
	local function closeFunc()
		removeSelf(popupRoot)
		showFailedPopup = false
	end

	local function sureFunc()
		callback()
		removeSelf(popupRoot)
	end

	if callback ~= nil then
		popupContet:addChild(CreateCommonButton("button_red.png", Pos(popupContetSize, 0.3, 0.14), cc.size(144,50), closeFunc, {str=MultiLan("button_cancel"), size = FontSize6}))
		popupContet:addChild(CreateCommonButton("button_green.png", Pos(popupContetSize, 0.7, 0.14), cc.size(144,50), sureFunc, {str=MultiLan("button_ok"), size = FontSize6}))
	else
		popupContet:addChild(CreateCommonButton("button_green.png", Pos(popupContetSize, 0.5, 0.14), cc.size(144,50), closeFunc, {str=MultiLan("button_ok"), size = FontSize6}))
	end

	return popupRoot
end

--重试
function CreateSmallPopupWithTryAgain(title, content, callback) 
	local popupContet = CreateLayer(POPUP_SIZE_SML, 1, Pos(POPUP_SIZE_SML))
	content:setPosition(Pos(POPUP_SIZE_SML,0.5,0.58))
	popupContet:addChild(content)
	
	local popupRoot = CommonCreatePopupSmall(title, popupContet)
	
	local function closeFunc()
		removeSelf(popupRoot)
	end

	local function sureFunc()
		callback()
		removeSelf(popupRoot)
	end
	
	if callback ~= nil then
		popupContet:addChild(CreateCommonButton("button_yellow.png", Pos(POPUP_SIZE_SML, 0.5, 0.14), cc.size(144,50), sureFunc, {str=MultiLan("button_retry"), size = FontSize6}))
	else
		popupContet:addChild(CreateCommonButton("button_blue.png", Pos(POPUP_SIZE_SML, 0.5, 0.14), cc.size(144,50), closeFunc, {str=MultiLan("button_ok"), size = FontSize6}))
	end

	return popupRoot
end

--取消和充值的小弹窗
function CreateSmallPopupWithPay(title, content)
	-- print("CommonCreatePopupSmall")
	local popupContet = CreateLayer(POPUP_SIZE_SML, 1, Pos(POPUP_SIZE_SML))
	content:setPosition(Pos(POPUP_SIZE_SML,0.5,0.58))
	popupContet:addChild(content)
	
	local popupRoot = CommonCreatePopupSmall(title, popupContet)
	
	local function closeFunc()
		removeSelf(popupRoot)
	end

	local function payFunc()
		removeSelf(popupRoot)
		onMainPay()
	end

	popupContet:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_SML, 0.3, 0.14), cc.size(144,50), closeFunc, {str=MultiLan("button_cancel"), size = FontSize6}))
	popupContet:addChild(CreateCommonButton("button_blue.png", Pos(POPUP_SIZE_SML, 0.7, 0.14), cc.size(144,50), payFunc, {str=MultiLan("button_charge"), size = FontSize6}))
	return popupRoot
end

local function shopItemNotEnough()
	CommonNote(MultiLan("CP_UnionItemIsNotEnough"))
end

--兑换商店 
SHOP_TYPE_ARENA = 2
SHOP_TYPE_FAMILY = 4
CommonShopInfo = nil
function CommonCreateShopPopup(shopType)
	-- print("CommonCreateShopPopup", shopType)
	local myFamilyInfo = nil
	if shopType == SHOP_TYPE_FAMILY then
		myFamilyInfo = getMyMemberInfo()
	end
	
	local titleArr = {nil,"pvpexchange", nil,"gxexchange"}
	local descArr  = {nil,MultiLan("CP_honorValue"),nil,MultiLan("CP_contributionNowAndTotal")}
	local coinArr  = {nil," ".. MultiLan("prop_name_110001"),nil,MultiLan("CP_contribution")}
	
	--排序 
	table.sort(CommonShopInfo.info.list,SortTableById)
	
	--内容
	local popupContent = CreateLayer(POPUP_SIZE_MAX, 1, Pos(POPUP_SIZE_MAX))
	local scrollLayer  = CreateLayer(cc.size(600,640), 1, Pos(POPUP_SIZE_MAX,0.5,0.48))
	scrollLayer:setScale(0.98)
	popupContent:addChild(scrollLayer)
	local ruleBack = CreateCommonSprite("board_skill01.png", Pos(POPUP_SIZE_MAX,0.5,0.89))
	ruleBack:setScaleX(1.6)
	popupContent:addChild(ruleBack)
	popupContent:addChild(CreateCommonLabel(descArr[shopType],Pos(POPUP_SIZE_MAX,0.6,0.89), 23, nil, cc.p(1,0.5)))
	local valueLabel = CreateCommonLabel("", Pos(POPUP_SIZE_MAX,0.6,0.89), FontSize3, nil, cc.p(0,0.5))
	valueLabel:setColor(COLOR_GREEN)
	popupContent:addChild(valueLabel)
	-- print(2)
	local function refreshShop(layer)
		-- print("refreshShop")
		local layer = cc.Layer:create()
		local line = math.ceil(table.maxn(CommonShopInfo.info.list)/3)
		
		--购买
		function onItemClicked(node)
			local tag = tolua.cast(node, "cc.Node"):getTag()
			local iteminfo = nil
			for i=1,table.maxn(CommonShopInfo.info.list) do
				if CommonShopInfo.info.list[i].id == tag then
					iteminfo = CommonShopInfo.info.list[i]
				end
			end
			if iteminfo == nil then
				return
			end
			local function shopBuyCallback(jsonDataTable)
				if jsonDataTable.ret == 0 then
					if jsonDataTable.data.state == 1 then
						shopItemNotEnough()
					else
						--增加
						UserInfo:addProp(jsonDataTable.data.item)
						
						--飘字
						for i=1, table.maxn(jsonDataTable.data.item) do
							CommonNote(MultiLan("CP_exchangeSucceed")..MultiLan("lan_get")..MultiLan(GameData:getPropDataTable(jsonDataTable.data.item[i].prop_id).name).."*"..jsonDataTable.data.item[i].num)
						end
						
						--消耗
						for i=1,table.maxn(jsonDataTable.data.use) do
							if jsonDataTable.data.use[i].use_type == "contribution" then
								myFamilyInfo.contribution = myFamilyInfo.contribution - jsonDataTable.data.use[i].use_num
							else
								UserSelfInfo[jsonDataTable.data.use[i].use_type] = UserSelfInfo[jsonDataTable.data.use[i].use_type] - jsonDataTable.data.use[i].use_num
								if jsonDataTable.data.use[i].use_type == "cash" then
									UseCash(jsonDataTable.data.use[i].use_num)
								end
								
							end
						end

						--刷新
						if jsonDataTable.data.newinfo ~= nil then
							CommonShopInfo.info.list = jsonDataTable.data.newinfo.list
							table.sort(CommonShopInfo.info.list,SortTableById)
						else --删除已购买商品
							for i=1, table.maxn(jsonDataTable.data.buy) do
								for j=1,table.maxn(CommonShopInfo.info.list) do
									if CommonShopInfo.info.list[j].id == jsonDataTable.data.buy[i] then
										if shopType ~= SHOP_TYPE_FAMILY then
											table.remove(CommonShopInfo.info.list, j)
										end
										break
									end
								end
							end
						end
					end
					if shopType == SHOP_TYPE_FAMILY then
						for i=1,table.maxn(CommonShopInfo.info.list) do
							for j=1,table.maxn(jsonDataTable.data.left) do
								if jsonDataTable.data.left[j].id == CommonShopInfo.info.list[i].id then
									CommonShopInfo.info.list[i].left = jsonDataTable.data.left[j].left
								end
							end
						end
					end
					
					refreshShop()
				end
			end
	
			if shopType == SHOP_TYPE_ARENA and  UserSelfInfo.honor < iteminfo.cost  then
				CommonHonorNeed(iteminfo.cost)
				return
			elseif shopType == SHOP_TYPE_FAMILY then
				if myFamilyInfo.contribution < iteminfo.cost then
					CommonContributionNeed(iteminfo.cost)
					return
				end
				
				if iteminfo.left <= 0 then
					shopItemNotEnough()
					return
				end
			end
			HttpSend("shop/buy", {"id="..shopType, "itemid="..tag}, shopBuyCallback)
		end
		
		local y = 260 * line - 140
		for i=1,line do
			for j=1,3 do
				local x = 200*j-100
				local itemInfo = CommonShopInfo.info.list[(i-1)*3+j]
				if itemInfo ~= nil then
					layer:addChild(CreateCommonSprite("board_pvpgoods.png", cc.p(x, y+30)))
					local buyButton = CreateCommonButton("MainButton12.png", cc.p(x, y-90), cc.size(137, 53), onItemClicked, {str = MultiLan("button_buy"),size=FontSize6})
					buyButton:setSwallowTouch(false)
					layer:addChild(buyButton,0, itemInfo.id)
					
					local propInfo = GameData:getPropDataTable(itemInfo.prop_id)
					local itemObj = CreateBagItem()
					if itemInfo.attr ~= nil and itemInfo.attr ~= CJSON_NULL then
						itemObj:setItemType(BAG_ITEM_TYPE_HERO_EQUIP)
						itemObj:setItemInfoTable(itemInfo)
						itemObj:setCanTouch(false)
					else
						itemObj:setItemType(BAG_ITEM_TYPE_THING_SHOP)
						itemObj:setItemInfoTable(itemInfo)
						itemObj:setItemName("")
					end
					itemObj:setPosition(cc.p(x,y+60))
					layer:addChild(itemObj)
					
					if shopType == SHOP_TYPE_ARENA then
						layer:addChild(CreateCommonLabel(MultiLan(propInfo.name), cc.p(x, y-8), FontSize2, cc.c3b(210, 0, 255)))
					elseif shopType == SHOP_TYPE_FAMILY then
						layer:addChild(CreateCommonLabel(MultiLan(propInfo.name).."*"..itemInfo.amount, cc.p(x, y-8), FontSize2, cc.c3b(210, 0, 255)))
						itemObj:setItemLeft(MultiLan("CP_left")..itemInfo.left)
						itemObj:setItemCount(0)
					end
					layer:addChild(CreateCommonLabel(itemInfo.cost..""..coinArr[shopType], cc.p(x, y-40), FontSize4))
				end
			end
		
			y = y- 260
		end

		layer:setContentSize(cc.size(600, math.max(640, 260*line-20)))
		local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, 640-(260*line-20)), kScrollViewDirectionVertical)
		if 260  * line - 20 < 640 then
			scrolView:setTouchEnabled(false)
		end
		
		--说明
		if shopType == SHOP_TYPE_ARENA then
			valueLabel:setString(UserSelfInfo.honor)
		elseif shopType == SHOP_TYPE_FAMILY then
			valueLabel:setString(myFamilyInfo.contribution.."/"..myFamilyInfo.total_contribution)
		end
	end
	refreshShop()
	-- print(1)
	local popupRoot = nil
	if shopType == SHOP_TYPE_ARENA then
		local function arenaShopHelp()
			HelpPopup("arenashop")
		end
		cclog("titleArr[shopType] 1" .. titleArr[shopType])
		popupRoot = CommonCreatePopupMax(titleArr[shopType], popupContent, true, arenaShopHelp)
	else
		cclog("titleArr[shopType] 2" .. titleArr[shopType])
		popupRoot = CommonCreatePopupMax(titleArr[shopType], popupContent, true)
	end
	--关闭
	local function closeFunc()
		removeSelf(popupRoot)
	end
	
	-- print(2)
	--刷新
	local function refreshFunc()
		local function commonRefreshCallback(jsonDataTable)
			if jsonDataTable.ret == 0 then
				UserSelfInfo[jsonDataTable.data.use_type] = UserSelfInfo[jsonDataTable.data.use_type] - jsonDataTable.data.use_num
				CommonShopInfo.info.list = jsonDataTable.data.info.list
				CommonShopInfo.refresh_num = jsonDataTable.data.refresh_num
				table.sort(CommonShopInfo.info.list,SortTableById)
				refreshShop()
				CommonNote(MultiLan("CP_refreshSucceed"))
			end
		end
		
		local function sendShopRefresh()
			if shopType == SHOP_TYPE_ARENA and UserSelfInfo.honor < GameData:getGameDataTable().consume[CommonShopInfo.refresh_num + 1].honor_shop then
				CommonHonorNeed(GameData:getGameDataTable().consume[CommonShopInfo.refresh_num + 1].honor_shop)
				return
			end
			
			HttpSend("shop/refresh", {"id="..shopType},  commonRefreshCallback)
		end
		
		local needCost = 0
		if shopType == SHOP_TYPE_ARENA then
			if GameData:getGameDataTable().consume[CommonShopInfo.refresh_num + 1] == nil then
				CommonTodayLimit()
			else
				needCost = GameData:getGameDataTable().consume[CommonShopInfo.refresh_num + 1].honor_shop
				CreateSmallPopupWithCancel("surere", CreateCommonLabel(string.format(MultiLan("CP_refreshHonorShop"),tostring(needCost)), nil, FontSize3), sendShopRefresh)
			end
		end
	end
	
	if shopType == SHOP_TYPE_FAMILY then
		popupContent:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_MAX,0.5,0.05), cc.size(144,50), closeFunc, {str=MultiLan("button_close"), size = FontSize6}))
	else
		popupContent:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_MAX,0.3,0.05), cc.size(144,50), closeFunc, {str=MultiLan("button_close"), size = FontSize6}))
		popupContent:addChild(CreateCommonButton("button_blue.png", Pos(POPUP_SIZE_MAX,0.7,0.05), cc.size(144,50), refreshFunc, {str=MultiLan("button_refresh"), size = FontSize6}))
	end
end

--离线挂机弹窗
function OutlinePopup(title, outlineInfo,passId)
	if outlineInfo == nil then
		return
	end
	-- print("OutlinePopup")
	--内容
	local layer = cc.Layer:create()
	local descAreaSize = cc.size(480, 490)
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setContentSize(descAreaSize)
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CP_isCalResult"),DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementNewLine:create())

	local secend = outlineInfo.time
	local minute = math.floor(secend/60)
	local hour = math.floor(minute/60)
	minute = minute - 60 * hour
	secend = secend - 3600 * hour - 60 * minute
	local timeStr = ""
	if hour > 0 then
		timeStr = timeStr..hour.." "..MultiLan("lan_hour")
	end
	if minute > 0 then
		timeStr = timeStr.." "..minute.." "..MultiLan("lan_minute")
	end
	if secend > 0 then
		timeStr = timeStr.." "..secend.." "..MultiLan("lan_second")
	end

	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CP_offlineReport_1"),DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 , timeStr,     DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CP_offlineReport_2"),        DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CP_offlineReport_3"),DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 , MultiLan(GameData:getPass(passId).name),     DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CP_offlineReport_4"),        DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 , outlineInfo.wnum + outlineInfo.lnum,     DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CP_offlineReport_5"),        DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 , MultiLan("CP_offlineReport_6"),     DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 , outlineInfo.wnum, DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 , MultiLan("CP_offlineReport_7"),     DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 , outlineInfo.lnum, DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 , MultiLan("CP_offlineReport_8"),     DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 , outlineInfo.exp, DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementNewLine:create())

	if outlineInfo.expinfo.levelup > 0 then
		richText:pushBackElement(ccui.RichElementText:create(16, COLOR_ORANGE, 255 , MultiLan("CP_offlineReport_9"), DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(17, COLOR_GREEN, 255 , outlineInfo.expinfo.level - outlineInfo.expinfo.levelup, DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(18, COLOR_ORANGE, 255 , MultiLan("CP_offlineReport_10"), DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(19, COLOR_GREEN, 255 , outlineInfo.expinfo.level, DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementNewLine:create())
	end
	
	--银两
	richText:pushBackElement(ccui.RichElementText:create(20, COLOR_WHITE, 255 , MultiLan("CP_offlineReport_11"),     DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(21, COLOR_GREEN, 255 , outlineInfo.gold, DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementNewLine:create())

	--道具
	if outlineInfo.items ~= nil then
		for i=1,table.maxn(outlineInfo.items) do
			if outlineInfo.items[i].prop_id ~= PROP_ID_GOLD then
				local propData = GameData:getPropDataTable(outlineInfo.items[i].prop_id)
				if propData.ptype == 13 then
					richText:pushBackElement(ccui.RichElementText:create(1, EQUIP_COLOR_ARR[propData.color], 255 ,MultiLan("lan_get")..MultiLan(propData.name)..": "..outlineInfo.items[i].num,DefaultFontName,FontSize4))
					richText:pushBackElement(ccui.RichElementNewLine:create())
				end
			end
		end
	end
	
	--装备
	for i=1, table.maxn(outlineInfo.equip_num) do
		local totle = outlineInfo.equip_num[i] + outlineInfo.sell[i]
		if totle > 0 then
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 , MultiLan("CP_offlineReport_12"),     DefaultFontName, FontSize4))
			if outlineInfo.sell[i] > 0 then
				richText:pushBackElement(ccui.RichElementText:create(1, EQUIP_COLOR_ARR[i], 255 , EQUIP_NAME_ARR[i].."*"..totle..string.format(MultiLan("CP_offlineReport_13"),tostring(outlineInfo.sell[i])), DefaultFontName, FontSize4))
			else
				richText:pushBackElement(ccui.RichElementText:create(1, EQUIP_COLOR_ARR[i], 255 , EQUIP_NAME_ARR[i].."*"..totle, DefaultFontName, FontSize4))
			end
			richText:pushBackElement(ccui.RichElementNewLine:create())
		end
	end

	BattleAddBoxDesc(outlineInfo, richText, FontSize4)
	
	local height = richText:getTextMaxHeight()
	local popupContent = CreateLayer(POPUP_SIZE_MID, 1, Pos(POPUP_SIZE_MID, 0.5, 0.48))
	local scrollLayer  = CreateLayer(descAreaSize, 1, Pos(POPUP_SIZE_MID, 0.5, 0.52))
	popupContent:addChild(scrollLayer)
	richText:setPosition(cc.p(240, math.max(descAreaSize.height, height) - descAreaSize.height / 2))
	layer:addChild(richText)
	layer:setContentSize(cc.size(descAreaSize.width, math.max(descAreaSize.height, height)))
	
	local scrollView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, math.min(0, descAreaSize.height - height)), kScrollViewDirectionVertical)
	if height < descAreaSize.height then
		scrollView:setTouchEnabled(false)
	end

	local popupRoot = CommonCreatePopupMid(title, popupContent)
	
	local function doneFunc() 
		removeSelf(popupRoot) 
	end
	popupContent:addChild(CreateCommonButton("button_green.png",Pos(POPUP_SIZE_MID,0.5,0.10), cc.size(144,50), doneFunc, {str=MultiLan("button_ok"),size=FontSize6}))
end

--更多属性
function MorepertyPopup(attr,fightNum,name,level,role)
	local popupContent = CreateLayer(POPUP_SIZE_BIG, 1, Pos(POPUP_SIZE_BIG))
	local descAreaSize = cc.size(500, 660)
	local descArea = CreateLayer(descAreaSize, 1, Pos(POPUP_SIZE_BIG,0.5,0.51))
	popupContent:addChild(descArea)
	local color1 = cc.c3b(190,170,190)
	local color2 = COLOR_GREEN
	
	local layer = cc.Layer:create()
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setAnchorPoint(cc.p(0.5, 0.5))
	richText:setContentSize(descAreaSize)
	layer:addChild(richText)
	--等级
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_CYAN, 255 ,"Lv."..level.." "..name,DefaultFontName, FontSize3))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	
	--职业
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_ORANGE, 255 ,MultiLan("CP_moreProperty_1")..MultiLan("role_career_"..role) ,DefaultFontName, FontSize3))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	
	--主属性
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 ,MultiLan("CP_moreProperty_2")..MAIN_ATTR_DESC[role], DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,"["..MultiLan("ui_more_attr_main_attr").."]",DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	
	--战力
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_ORANGE, 255 ,MultiLan("CP_moreProperty_3")..fightNum,DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_4"),DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ," ",DefaultFontName, FontSize3))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	
	--基础属性
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CP_moreProperty_5"),DefaultFontName, FontSize3))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	--MASTER_ATTR_DESC   ATTR_DESC  {str="力量", agi="敏捷", int="智力", sta="耐力", hp="生命值", mp="魔法值"
	--力量
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,ATTR_DESC.str.."：",DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,attr.str,DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,"["..ATTR_DESC.pr,DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,"+"..attr.str,DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ," "..ATTR_DESC.hit,DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,"+"..(attr.str*0.6),DefaultFontName, FontSize2))
	if role == 1 then
		richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_6"),DefaultFontName, FontSize2))
		richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,"+"..math.floor(attr.str/2),DefaultFontName, FontSize2))
		richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_7"),DefaultFontName, FontSize2))
		richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,"+"..attr.str,DefaultFontName, FontSize2))
	end
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,"]",DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
		--智力
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,ATTR_DESC.int.."：",DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,attr.int,DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,"["..ATTR_DESC.mr,DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,"+"..attr.int,DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_8"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,"+"..math.ceil(math.sqrt(attr.int)),DefaultFontName, FontSize2))
	if role == 2 then
		richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_6"),DefaultFontName, FontSize2))
		richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,"+"..math.floor(attr.int/2),DefaultFontName, FontSize2))
		richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_7"),DefaultFontName, FontSize2))
		richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,"+"..attr.int,DefaultFontName, FontSize2))
	end
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,"]",DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	--敏捷
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,ATTR_DESC.agi.."：",DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,attr.agi,DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,"["..ATTR_DESC.crit,DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,"+"..attr.agi,DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ," "..ATTR_DESC.dodge,DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,"+"..(attr.agi*0.2),DefaultFontName, FontSize2))
	if role == 3 then
		richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_6"),DefaultFontName, FontSize2))
		richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,"+"..math.floor(attr.agi/2),DefaultFontName, FontSize2))
		richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_7"),DefaultFontName, FontSize2))
		richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,"+"..attr.agi,DefaultFontName, FontSize2))
	end
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,"]",DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	--耐力
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,ATTR_DESC.sta.."：",DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,attr.sta,DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,"["..ATTR_DESC.hp,DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,"+"..(attr.sta*10),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ," "..ATTR_DESC.tough,DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,"+"..attr.sta,DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,"]",DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	--生命 
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,ATTR_DESC.hp.."：",DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,attr.hp,DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	--内力
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,ATTR_DESC.mp.."：",DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,attr.mp,DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	
	--战斗属性
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ," ",DefaultFontName, FontSize3))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CP_moreProperty_9"),DefaultFontName, FontSize3))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_10"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,level,DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_11"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	--最小伤害
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_6"),DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,math.ceil(attr.damage/2),DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	--最大伤害
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_7"),DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,attr.damage,DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	--护甲 
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,ATTR_DESC.armor.."：",DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,attr.armor,DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_12"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,string.format("%.1f",attr.armor*100/(attr.armor+3*level*level+3*level+50)).."%",DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_13"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	--物抗
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,ATTR_DESC.pr.."：",DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,attr.pr,DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_12"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,string.format("%.1f",attr.pr*100/(attr.pr+50*level+50)).."%",DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_14"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	--魔抗
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,ATTR_DESC.mr.."：",DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,attr.mr,DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_12"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,string.format("%.1f",attr.mr*100/(attr.mr+50*level+50)).."%",DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_15"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	--暴击
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,ATTR_DESC.crit.."：",DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,attr.crit,DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_16"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,string.format("%.1f",attr.crit*100/(attr.crit+3*level*level+3*level+50)).."%",DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_17"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,string.format("%.1f",180+attr.masterAttr.critdamage*100).."%",DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_18"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	--命中
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,ATTR_DESC.hit.."：",DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,attr.hit,DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_19"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	--闪避
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,ATTR_DESC.dodge.."：",DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,attr.dodge,DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_20"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	--韧性
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,ATTR_DESC.tough.."：",DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,attr.tough,DefaultFontName, FontSize4))
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_21"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	
	--神器属性
	richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ," ",DefaultFontName, FontSize3))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CP_moreProperty_22"),DefaultFontName, FontSize3))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	local color3 = COLOR_RED
	local color4 = COLOR_CYAN
	for k,v in pairs(MASTER_ATTR_DESC) do
		if attr.masterAttr[k] ~= 0 then
			richText:pushBackElement(ccui.RichElementText:create(1, color3, 255 ,v.."：",DefaultFontName, FontSize4))
			if k == "arp" or  k == "prp" or  k == "mrp" then
				richText:pushBackElement(ccui.RichElementText:create(1, color4, 255 ,attr.masterAttr[k],DefaultFontName, FontSize4))
				richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,MultiLan("CP_moreProperty_23"),DefaultFontName, FontSize2))
				richText:pushBackElement(ccui.RichElementText:create(1, color2, 255 ,string.format("%.1f",0.4*attr.masterAttr[k]+ 5.28 -0.0006*attr.masterAttr[k]*attr.masterAttr[k]).."%",DefaultFontName, FontSize2))
				if k == "arp" then
					richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,ATTR_DESC.armor.."]",DefaultFontName, FontSize2))
				elseif k == "prp" then
					richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,ATTR_DESC.pr.."]",DefaultFontName, FontSize2))
				elseif k == "mrp" then
					richText:pushBackElement(ccui.RichElementText:create(1, color1, 255 ,ATTR_DESC.mr.."]",DefaultFontName, FontSize2))
				end
			else
				richText:pushBackElement(ccui.RichElementText:create(1, color4, 255 ,string.format("%.1f",100*attr.masterAttr[k]).."%",DefaultFontName, FontSize4))
			end
			
			richText:pushBackElement(ccui.RichElementNewLine:create())
		end
	end
	
	
	local realHeight = richText:getTextMaxHeight()
	-- print("realHeight",realHeight)
	richText:setPosition(cc.p(250, realHeight - descAreaSize.height / 2))
	layer:setContentSize(cc.size(500, math.max(descAreaSize.height,realHeight)))
	local scrollView = CreateScrollViewByFather(descArea, layer, cc.p(0, math.min(0,descAreaSize.height-realHeight)), kScrollViewDirectionVertical)
	if realHeight < descAreaSize.height then
		scrolView:setTouchEnabled(false)
	end
	
	local popupRoot = CommonCreatePopupBig("moreattribute",popupContent)
	local function closeFunc() removeSelf(popupRoot) end
	popupContent:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_BIG,0.5,0.05), cc.size(144,50), closeFunc, {str=MultiLan("button_close"), size = FontSize6}))
end

--游戏帮助
function HelpPopup(typeStr)
	print(i, getStrengthPercent({strengthen=10,grade=1}))
	for i=1, 10 do
		--print(i, getStrengthPercent({strengthen=i,grade=1}))
	end
	-- print("HelpPopup",typeStr)
	if GameData:getGameDataTable().help == nil then
		return 
	end
	
	local t = GameData:getGameDataTable().help[typeStr]
	if t == nil then
		return
	end

	local popupContent = CreateLayer(POPUP_SIZE_BIG, 1, Pos(POPUP_SIZE_BIG))
	local descAreaSize = cc.size(480, 660)
	local descArea = CreateLayer(descAreaSize, 1, Pos(POPUP_SIZE_BIG,0.5,0.51))
	popupContent:addChild(descArea)
	local color = {COLOR_GREEN, COLOR_WHITE, COLOR_CYAN, COLOR_RED}
	-- local color = {COLOR_GREEN, COLOR_BLACK, COLOR_CYAN, COLOR_RED}
	local size  = {FontSize3,FontSize4,FontSize3}
	
	local layer = cc.Layer:create()
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setAnchorPoint(cc.p(0.5, 0.5))
	richText:setContentSize(descAreaSize)
	layer:addChild(richText)
	local bFirst = true
	for i=1,table.maxn(t) do
		if t[i].t == 1 or t[i].t == 3 then
			if bFirst == true then
				bFirst = false
			else
				richText:pushBackElement(ccui.RichElementText:create(1,color[t[i].t], 255," ",DefaultFontName,FontSize3))
				richText:pushBackElement(ccui.RichElementNewLine:create())
			end
		end
		richText:pushBackElement(ccui.RichElementText:create(1, color[t[i].t], 255 ,MultiLan(t[i].d),DefaultFontName, size[t[i].t]))
		richText:pushBackElement(ccui.RichElementNewLine:create())
	end
	
	local realHeight = richText:getTextMaxHeight()
	-- print("help help", realHeight)
	richText:setPosition(cc.p(descAreaSize.width / 2, descAreaSize.height / 2 +math.max(0,realHeight-descAreaSize.height)))
	layer:setContentSize(cc.size(descAreaSize.width, math.max(descAreaSize.height,realHeight)))
	local scrollView = CreateScrollViewByFather(descArea, layer, cc.p(0, math.min(0,descAreaSize.height-realHeight)), kScrollViewDirectionVertical)
	if realHeight < descAreaSize.height then
		scrollView:setTouchEnabled(false)
	end
	
	local popupRoot = CommonCreatePopupBig("gamehelp",popupContent)
	local function closeFunc() removeSelf(popupRoot) end
	popupContent:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_BIG,0.5,0.05), cc.size(144,50), closeFunc, {str=MultiLan("button_close"), size = FontSize6}))
end

--公告弹窗
function NewsPopup(t)
	if t == nil or t == CJSON_NULL then
		return
	end

	local popupContent = CreateLayer(POPUP_SIZE_BIG, 1, Pos(POPUP_SIZE_BIG))
	-- local descAreaSize = cc.size(500, 680)
	local descAreaSize = cc.size(480, 670)
	local descArea = CreateLayer(descAreaSize, 1, Pos(POPUP_SIZE_BIG,0.5,0.505))
	popupContent:addChild(descArea)
	local color = {COLOR_GREEN, COLOR_RED, COLOR_WHITE}
	-- local color = {COLOR_GREEN, COLOR_RED, COLOR_BLACK}
	local size  = {FontSize3,FontSize4,FontSize4}
	
	local layer = cc.Layer:create()
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setAnchorPoint(cc.p(0.5, 0.5))
	richText:setContentSize(descAreaSize)
	layer:addChild(richText)
	local bFirst = true
	for i=1,table.maxn(t) do
		if t[i].t == 1 then
			if bFirst == true then
				bFirst = false
			else
				-- print(i,"here")
				richText:pushBackElement(ccui.RichElementNewLine:create())
				richText:pushBackElement(ccui.RichElementText:create(1,color[t[i].t], 255," ",DefaultFontName,FontSize2))
				richText:pushBackElement(ccui.RichElementNewLine:create())
			end
		end
		
		if t[i].t == 1 then
			richText:pushBackElement(ccui.RichElementText:create(1, color[t[i].t], 255 ,t[i].d,DefaultFontName, size[t[i].t]))
			richText:pushBackElement(ccui.RichElementNewLine:create())
		elseif 	t[i].t == 4 then
			richText:pushBackElement(ccui.RichElementNewLine:create())
		else
			richText:pushBackElement(ccui.RichElementText:create(1,color[t[i].t], 255,t[i].d,DefaultFontName,size[t[i].t]))
		end
	end
	
	local realHeight = richText:getTextMaxHeight()
	richText:setPosition(cc.p(descAreaSize.width / 2,descAreaSize.height / 2+math.max(0,realHeight - descAreaSize.height)))
	layer:setContentSize(cc.size(descAreaSize.width, math.max(descAreaSize.height,realHeight)))
	local scrollView = CreateScrollViewByFather(descArea, layer, cc.p(0, math.min(0,descAreaSize.height-realHeight)), kScrollViewDirectionVertical)
	if realHeight < descAreaSize.height then
		scrollView:setTouchEnabled(false)
	end
	
	local popupRoot = CommonCreatePopupBig("news",popupContent)
	local function closeFunc() removeSelf(popupRoot) end
	popupContent:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_BIG,0.5,0.05), cc.size(144,50), closeFunc, {str=MultiLan("button_close"), size = FontSize6}))
end
