EquipBatchFilterLayer = class("EquipBatchFilterLayer")

--new
function EquipBatchFilterLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function EquipBatchFilterLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["EquipBatchFilterLayer"] = self
	ccb["EquipBatchFilterLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/EquipBatchFilterLayer.ccbi", proxy, self)
	self.data = data

	-- set button onlick
	self.btClose.owner = self
	self.btClose1.owner = self
	self.btn_type_white.owner = self
	self.btn_type_green.owner = self
	self.btn_type_blue.owner = self
	self.btn_type_purpe.owner = self
	self.btn_type_orange.owner = self
	self:initUI()
	return self
end
function EquipBatchFilterLayer:initUI()
	SetTouchEventForLayer(self.swallowLayerSmall, TouchSwallow)
	self:Refresh()
	self.btn_type_white:setTitleForState(MultiLan("melt_melt"),1) 
	self.btn_type_green:setTitleForState(MultiLan("melt_melt"),1) 
	self.btn_type_blue:setTitleForState(MultiLan("melt_melt"),1) 
	self.btn_type_purpe:setTitleForState(MultiLan("melt_melt"),1) 
	self.btn_type_orange:setTitleForState(MultiLan("melt_melt"),1) 
	self.btClose1:setTitleForState(MultiLan("button_close"),1) 
	self.mTitleAutoSell:setString(ZGMultiLan("title_piliang"))
end
function EquipBatchFilterLayer:onCloseEquipMeltBtnClick( sender )
	removeSelf(self.owner.topNode)
end
function EquipBatchFilterLayer:onCloseEquipMeltBtnClick1( sender )
	removeSelf(self.owner.topNode)
end
function EquipBatchFilterLayer:onWhiteBtn( sender )
	if table_is_empty(self.owner.equipTable.white) then
	   CommonNote(MultiLan("GEML_selectMeltEquip"))
       return
	end
	self.owner:onClickBtn(self.owner.equipTable, "white" )
end
function EquipBatchFilterLayer:onGreenBtn( sender )
	if table_is_empty(self.owner.equipTable.green) then
	   CommonNote(MultiLan("GEML_selectMeltEquip"))
       return
	end
	self.owner:onClickBtn(self.owner.equipTable, "green")
end
function EquipBatchFilterLayer:onBlueBtn( sender )
	if table_is_empty(self.owner.equipTable.blue) then
	   CommonNote(MultiLan("GEML_selectMeltEquip"))
       return
	end
	self.owner:onClickBtn(self.owner.equipTable, "blue")
end
function EquipBatchFilterLayer:onPurpeBtn( sender )
	if table_is_empty(self.owner.equipTable.purpe) then
	   CommonNote(MultiLan("GEML_selectMeltEquip"))
       return
	end
	self.owner:onClickBtn(self.owner.equipTable, "purpe" )
end
function EquipBatchFilterLayer:onOrangeBtn( sender )
	if table_is_empty(self.owner.equipTable.orange) then
	   CommonNote(MultiLan("GEML_selectMeltEquip"))
       return
	end
	self.owner:onClickBtn(self.owner.equipTable, "orange")
end
function EquipBatchFilterLayer:onClickBtn( infotable, subscript)
	local function equipMeltCallback(jsonDataTable)
        if  jsonDataTable == CJSON_NULL then
            return
        end
		if jsonDataTable.ret ~= 0 then
			-- cclog("take on equip failed %d", jsonDataTable.ret)
			return 
		end
		
		if jsonDataTable.data.fusion_ids ~= nil then
			for i=1,table.maxn(jsonDataTable.data.fusion_ids) do
				 UserInfo:removeEquipByIdAndObj(jsonDataTable.data.fusion_ids[i],0)
			end
		end

		local fusion = jsonDataTable.data.fusion
		if fusion > 0 then
			CommonNote(string.format(MultiLan("GEML_getFusion"),tostring(fusion)))
		end
        UserInfo:addMeltFusion(fusion)

		UserInfo:addProp(jsonDataTable.data.items)
		local noteArr = {}
		local colorArr = {}
        local propdetailInfo = nil
		local propDetailName = ""
        if jsonDataTable.data.items ~= CJSON_NULL then
            for i=1,table.maxn(jsonDataTable.data.items) do
                propdetailInfo = GameData:getPropDataTable(jsonDataTable.data.items[i].prop_id)
				propDetailName = MultiLan(propdetailInfo.name)
                if propdetailInfo.level > 0 then
					if EquipHelper:isRedEquip(jsonDataTable.data.items[i].obj) then 
						table.insert(noteArr, MultiLan("GEML_getNewArtifact")..propdetailInfo.level.."  ".. propDetailName)
						table.insert(colorArr, COLOR_RED)
					else
						table.insert(noteArr, MultiLan("GEML_getNewEquip")..propdetailInfo.level.."  ".. propDetailName)
						local color,grade = EquipHelper:getEquipColor(jsonDataTable.data.items[i].obj)
						table.insert(colorArr, color)
					end
                else
					table.insert(noteArr, MultiLan("GEML_return")..jsonDataTable.data.items[i].num.."  ".. propDetailName)
					table.insert(colorArr, COLOR_YELLOW)
                end
            end
        end
		CommonNote(noteArr, colorArr)
        EquipMeltLayer:EquipMeltLayerClearItem()
	    EquipMeltLayer:refreshEquipMeltValue()
	    self:Refresh()
	end
	local msgString = "ids="
	local bFirst = true
	for i=1,table.maxn(infotable[subscript]) do 
		if bFirst then
			bFirst = false
		else
			msgString  = msgString .. ","
		end
		msgString  = msgString  .. infotable[subscript][i].id
		UserAttr:compareAaEquipScore(infotable[subscript][i].id)
	end
	HttpSend("equip/fusion", {msgString}, equipMeltCallback)
end
function EquipBatchFilterLayer:Refresh()
	self.equipTable = {
						white = {},
					    green = {},
					    blue = {},
					    purpe = {},
					    orange = {},
						}
	local bagEquipListOring = UserInfo:getBagEquip()
	local color = nil
	local equipQualitys = 0 
	for i = 1, table.maxn(bagEquipListOring) do
		color,equipQualitys  = EquipHelper:getEquipColor(bagEquipListOring[i])
		if bagEquipListOring[i].stone == CJSON_NULL or table.maxn(bagEquipListOring[i].stone) == 0 then
			if not EquipHelper:isMaster(bagEquipListOring[i]) and not EquipHelper:isGlyph(bagEquipListOring[i]) and bagEquipListOring[i].locked == 0 then 
				if equipQualitys == 1 then
					table.insert(self.equipTable.white,bagEquipListOring[i])
				elseif equipQualitys == 2 then
					table.insert(self.equipTable.green,bagEquipListOring[i])
				elseif equipQualitys == 3 then
					table.insert(self.equipTable.blue,bagEquipListOring[i])
				elseif equipQualitys == 4 then
					table.insert(self.equipTable.purpe,bagEquipListOring[i])
				elseif equipQualitys == 5 then
					table.insert(self.equipTable.orange,bagEquipListOring[i])
				end
			end
		end
	end
	self.lb_type_white:setString(MultiLan("CD_equipColor_1").." * "..table.maxn(self.equipTable.white))
	self.lb_type_green:setString(MultiLan("CD_equipColor_2").." * "..table.maxn(self.equipTable.green))
	self.lb_type_blue:setString(MultiLan("CD_equipColor_3").." * "..table.maxn(self.equipTable.blue))
	self.lb_type_purpe:setString(MultiLan("CD_equipColor_4").." * "..table.maxn(self.equipTable.purpe))
	self.lb_type_orange:setString(MultiLan("CD_equipColor_5").." * "..table.maxn(self.equipTable.orange))
end



