EquipFilterChange = class("EquipFilterChange")
EquipFilterChange.__index = EquipFilterChange

EquipFilterChange.isCreated = false
EquipFilterChange.topNode = nil
EquipFilterChange.itemInfo = nil
EquipFilterChange.role = 0
EquipFilterChange.equipedLayer = nil	--上面那个层
EquipFilterChange.filterLayer = nil	
EquipFilterChange.filterScroll = nil	--下面的滚动层
EquipFilterChange.label = nil	--没有装备时显示的label

function EquipFilterChange:EquipFilterChangeCreate()
	self.filterScroll = cc.ScrollView:create()
	self.filterLayer:addChild(self.filterScroll)
	self.filterScroll:setViewSize(cc.size(self.filterLayer:getContentSize().width, self.filterLayer:getContentSize().height))
	self.filterScroll:setPosition(cc.p(0,-10))
	self.filterScroll:ignoreAnchorPointForPosition(true)
	self.filterScroll:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
	self.filterScroll:setClippingToBounds(true)
	self.filterScroll:setBounceable(true)
	self.filterScroll:setDelegate()
	self.filterScroll:setVisible(true)
end

function EquipFilterChange:EquipFilterChangeRefresh()
	if self.equipedLayer ~= nil then
		self.equipedLayer:removeFromParent()
		self.equipedLayer = nil
	end
	self.equipedLayer = cc.Layer:create()
	self.equipedLayer:ignoreAnchorPointForPosition(false)
	self.equipedLayer:setAnchorPoint(cc.p(0, 1))
	self.equipedLayer:setPosition(cc.p(0, self.filterLayer:getContentSize().height-20))
	
	local equipedItemBgSprite = cc.Sprite:createWithSpriteFrameName("board_equipchoose.png")
	equipedItemBgSprite:setAnchorPoint(cc.p(0, 0))
	self.equipedLayer:addChild(equipedItemBgSprite)

	local pBackgroundButton = cc.Scale9Sprite:createWithSpriteFrameName("pic_suiyiaaa.png")
	pBackgroundButton:setContentSize(cc.size(100,100))
	pBackgroundButton:setAnchorPoint(cc.p(0, 0))
	pBackgroundButton:setPosition(cc.p(0,-10))
	self.filterLayer:addChild(pBackgroundButton)


	
	local equipedRichInfo = EquipHelper:createItemInfoRichtext(self.itemInfo,nil,true)
	equipedRichInfo:setContentSize(cc.size(270, 500))
	equipedRichInfo:formatText()
	equipedRichInfo:ignoreAnchorPointForPosition(true)
	equipedRichInfo:setPosition(cc.p(115, equipedRichInfo:getTextMaxHeight()-500 + 30/2))
	self.equipedLayer:setContentSize(496, equipedRichInfo:getTextMaxHeight() + 30)
	self.equipedLayer:addChild(equipedRichInfo)
	
	EquipHelper:setEquipPlaceNameLabel(self.equipedLayer, self.itemInfo)
	
	local equipedItem = CreateBagItem()
	equipedItem:setItemType(BAG_ITEM_TYPE_EQUIP)
	equipedItem:setCanTouch(false)
	equipedItem:setItemInfoTable(self.itemInfo)
	equipedItem:setPosition(cc.p(50, self.equipedLayer:getContentSize().height - 60))
	self.equipedLayer:addChild(equipedItem)
	
	equipedItemBgSprite:setScaleY(self.equipedLayer:getContentSize().height / equipedItemBgSprite:getSpriteFrame():getRect().height)
	
	self.filterLayer:addChild(self.equipedLayer)
end

function EquipFilterChange:scrollRefresh()
	local scrollLayer = cc.Layer:create()
	scrollLayer:ignoreAnchorPointForPosition(true)
	self.filterScroll:setViewSize(cc.size(self.filterLayer:getContentSize().width, self.filterLayer:getContentSize().height - self.equipedLayer:getContentSize().height))
	self.filterScroll:setContainer(scrollLayer)
	local scrollWorldPos = self.filterScroll:getParent():convertToWorldSpace(cc.p(self.filterScroll:getPosition()))
	local scrollViewSize = self.filterScroll:getViewSize()
	local curPosY = 0
	local tmpFlag = false

	local selfEquipData = EquipHelper:getStaticData(self.itemInfo)
	local bagEquipList = UserInfo:sortBagEquipByScore(selfEquipData.place, self.role) 
    
	local i = table.maxn(bagEquipList)
	while i >= 1 do
		-- cclog("equip type %d", selfEquipData.place)
		tmpFlag = true
		local itemLayer = cc.Layer:create()
		itemLayer:ignoreAnchorPointForPosition(true)
		
		local itemBgSprite = cc.Sprite:createWithSpriteFrameName("board_equipchoose.png")
		itemBgSprite:setAnchorPoint(cc.p(0, 0))
		itemLayer:addChild(itemBgSprite)
		
		local itemRichInfo = EquipHelper:createItemInfoRichtext(bagEquipList[i])
		itemRichInfo:setContentSize(cc.size(270, 500))
		itemRichInfo:formatText()
		--itemRichInfo:setContentSize(cc.size(270, itemRichInfo:getTextMaxHeight()))
		itemRichInfo:ignoreAnchorPointForPosition(true)
		itemRichInfo:setPosition(cc.p(115, itemRichInfo:getTextMaxHeight()-500 + 30/2))
		itemLayer:setContentSize(496, itemRichInfo:getTextMaxHeight() + 30)
		itemLayer:addChild(itemRichInfo)
		itemLayer:setPosition(cc.p(0, curPosY))
		curPosY = curPosY + itemLayer:getContentSize().height
		
		EquipHelper:setEquipPlaceNameLabel(itemLayer,bagEquipList[i])
		
		-- cclog("rich text height %.2f", itemRichInfo:getTextMaxHeight())
		
		itemBgSprite:setScaleY(itemLayer:getContentSize().height / itemBgSprite:getSpriteFrame():getRect().height)
		
		local bagItem = CreateBagItem()
		bagItem:setCanTouch(false)
		bagItem:setItemType(BAG_ITEM_TYPE_EQUIP)
		bagItem:setItemInfoTable(bagEquipList[i])
		bagItem:setPosition(cc.p(55, itemLayer:getContentSize().height - 60))
		itemLayer:addChild(bagItem)
		
		local function changeEquipmentEquipmentCallback(jsonDataTable)
			if jsonDataTable.ret ~= 0 then
				-- cclog("change equip failed %d", jsonDataTable.ret)
				return 
			end
			-- ccdump(jsonDataTable,"jsonDataTable")
			local equipedId = jsonDataTable.data.id
			local bagId = jsonDataTable.data.obj_id
			local takeonEquipTable = UserInfo:removeEquipByIdAndObj(bagId,0)
			UserInfo:addEquipByObj(takeonEquipTable, jsonDataTable.data.obj)
			UserAttr:compareAaEquipScore(bagId)
			local takeoffEquipTable = UserInfo:removeEquipByIdAndObj(equipedId, jsonDataTable.data.obj)
			UserInfo:addEquipByObj(takeoffEquipTable, 0)
			UserAttr:equipAttrChange(jsonDataTable.data.obj, true)
			if jsonDataTable.data.obj == 1 then
				UserAttr:compareAllyEquipScore(takeoffEquipTable)
			else
				UserAttr:compareEquipScore(takeoffEquipTable)
				UserAttr:compareAllyEquipScore(takeoffEquipTable,jsonDataTable.data.obj)
			end
		end
		
		local function changeEquipment(node)
			-- cclog("equip/swap?" .. "id=" .. self.itemInfo.id .. "&obj_id=" .. node:getTag())
			if EquipHelper:getStaticData(FindFirstByKey(UserInfo:getUserInfo().data.bag_equip,"id", node:getTag())).level - UserSelfInfo.level > 10 then
				CommonNote(MultiLan("EFC_note1"))
				return
			end
			
			HttpSend("equip/swap", {"id=" .. self.itemInfo.id, "obj_id=" .. node:getTag()}, changeEquipmentEquipmentCallback)
			
			EquipFilterChangeClose()
		end
		local pBackgroundButton = cc.Scale9Sprite:createWithSpriteFrameName("button_blue.png")
		local pTitle = cc.Label:create(MultiLan("lan_equip"), DefaultFontName, FontSize3)
		local takeonButton = cc.ControlButton:create(pTitle, pBackgroundButton)
		takeonButton:setTag(bagEquipList[i].id)
		takeonButton:registerControlEventHandler(changeEquipment,cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE)
		takeonButton:setPosition(cc.p(420, itemLayer:getContentSize().height * 0.4))
		takeonButton:setPreferredSize(cc.size(144, 50))
		takeonButton:setScale(0.8)
		takeonButton:setScrollViewRect(cc.rect(scrollWorldPos.x, scrollWorldPos.y, scrollViewSize.width, scrollViewSize.height))
		itemLayer:addChild(takeonButton)
		
		scrollLayer:addChild(itemLayer)

		i = i-1
	end
	if tmpFlag then
		self.label:setVisible(false)
	else
		self.label:setVisible(true)
	end
	if scrollLayer:getContentSize().height <= self.filterLayer:getContentSize().height then
		scrollLayer:setContentSize(cc.size(self.filterLayer:getContentSize().width, self.filterLayer:getContentSize().height))
		self.filterScroll:setContentOffset(cc.p(0, 0), false)
	else
		scrollLayer:setContentSize(cc.size(self.filterLayer:getContentSize().width, curPosY))
		self.filterScroll:setContentOffset(cc.p(0, -scrollLayer:getContentSize().height + self.filterScroll:getViewSize().height), false)
	end
	self.filterScroll:updateInset()
end

function EquipFilterChange:EquipFilterChangeEnter(infoTable)
	if self.isCreated then
		self.topNode:setVisible(true)
	else
		self.isCreated = true
		local tmpLayer = createEquipPopupBoard(1)
		self.topNode = CommonCreatePopup(tmpLayer)
		
		self.filterLayer = tolua.cast(tmpLayer:getChildByTag(1):getChildByTag(2), "cc.Layer")
		local closeButton = tolua.cast(tmpLayer:getChildByTag(1):getChildByTag(3), "cc.ControlButton")
		closeButton:registerControlEventHandler(EquipFilterChangeClose,cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE)
		
		self.label = cc.Label:create(MultiLan("EFC_noFitEquip"), DefaultFontName, FontSize4)
		self.label:setPosition(self.filterLayer:getContentSize().width / 2, self.filterLayer:getContentSize().height / 2)
		self.label:setColor(COLOR_RED)
		self.filterLayer:addChild(self.label)
		
		self:EquipFilterChangeCreate()
	end
	--这里根据obj来查找穿戴者的role类型
	if infoTable.obj == 0 then
		self.role = 0
	elseif infoTable.obj == 1 then
		self.role = UserInfo:getUserInfo().data.info.role	--获得主角类型
	else
		self.role = GameData:getHeroRoleData(infoTable.obj).role	--获得主角类型
	end

	self.itemInfo = infoTable
	self:EquipFilterChangeRefresh()
	self:scrollRefresh()
end

function EquipFilterChange:EquipFilterChangeExit()
	self.topNode:setVisible(false)
end

function EquipFilterChangeClose()
	EquipFilterChange:EquipFilterChangeExit()
end
