EquipLayer = class("EquipLayer")
EquipLayer.__index = EquipLayer

EquipLayer.isCreated = false
EquipLayer.topNode = nil
EquipLayer.itemTable = {}
EquipLayer.notePlaceTable = {}

ccb["EquipLayer"] = EquipLayer
EquipLayerOwner = EquipLayerOwner or {}
ccb["EquipLayerOwner"] = EquipLayerOwner

EQUIP_MAX = 10

function EquipLayer:EquipLayerCreateItem()
	for i = 1, EQUIP_MAX do
		self.itemTable[i] = CreateBagItem()
		self.itemTable[i]:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
		self.itemTable[i]:setTag(i)
		tolua.cast(EquipLayerOwner["mEquipItemLayer" .. i], "cc.Node"):addChild(self.itemTable[i])
	end
	
	--初始化
	--local attrTable = {"力量：","敏捷：","智力：","耐力：","伤害：","护甲：","魔抗：","命中：","暴击：","闪避：","韧性："}
    local attrTable = {"str","int","agi","sta","damage","armor","mr","hit","crit","dodge","tough"}

	for i=1, 11 do
		tolua.cast(EquipLayerOwner["mEquipProperty"..i], "cc.Label"):setString(MultiLan( "attr_role_"..attrTable[i])..":")
		-- tolua.cast(EquipLayerOwner["mEquipProperty"..i], "cc.Label"):setColor(COLOR_ORANGE)
	end
	-- EquipLayerOwner["mEquipValue5"]:setColor(COLOR_GREEN)
	-- tolua.cast(EquipLayerOwner["mEquipBattleValue"], "cc.Label"):setColor(COLOR_ORANGE)
end

function EquipLayer:EquipLayerRefreshItem()
	-- print("EquipLayerRefreshItem")
    if self.isCreated == false and CommonEquipLayer:isVisible() == false then
       return
    end
    --self.notePlaceTable = {}
    for i = 1, EQUIP_MAX do
		self.itemTable[i]:setItemType(BAG_ITEM_TYPE_EMPTY_EQUIP)
		self.itemTable[i]:setItemInfoTable({place=i})
		if findValueFromTable(self.notePlaceTable, i) then
			self.itemTable[i]:setItemNoteEffect(true)
		else
			self.itemTable[i]:setItemNoteEffect(false)
		end
        -- self.itemTable[i]:setEmptyBgByPlace(i)
        self.itemTable[i]:setItemSprite("user_equip_"..i..".png")
	end
	if UserInfo:getUserInfo().data.equip.hero_1 ~= nil and UserInfo:getUserInfo().data.equip.hero_1 ~= CJSON_NULL then
		for i = 1, table.maxn(UserInfo:getUserInfo().data.equip.hero_1) do
			local propId = UserInfo:getUserInfo().data.equip.hero_1[i].prop_id
			local propInfoTable = GameData:getPropDataTable(propId)
			-- cclog("place is %d", propInfoTable.place)
			self.itemTable[propInfoTable.place]:setItemType(BAG_ITEM_TYPE_EQUIP)
			self.itemTable[propInfoTable.place]:setItemInfoTable(UserInfo:getUserInfo().data.equip.hero_1[i])
		end
	end
	self:PropertyLabelRefresh()
	--小手引导
	GameGuide:setHandGuide(12, self.itemTable[1])
end

function EquipLayer:playSpineAnimation( role ,sex ,level)

	local seetag = role * 2 - sex + 1

	local spineFileNameArr = SPINE_CONFIGS.userFiles
	local s_pPathSpineBoyJson = "spine/" .. spineFileNameArr[seetag] .. ".json"
	local s_pPathSpineBoyAtlas = "spine/" .. spineFileNameArr[seetag] .. ".atlas"
	local spineboy = sp.SkeletonAnimation:create(s_pPathSpineBoyJson, s_pPathSpineBoyAtlas, 1)
	EquipLayerOwner["lyUserBg"]:addChild(spineboy)
	spineboy:setPosition(Pos(EquipLayerOwner["lyUserBg"]:getContentSize(), 0.5, 0.05))

  	-- local boneNode = spineboy:findBone("Bone79")
  	-- boneNode:setVisible(false)

  	spineboy:setScale(SPINE_CONFIGS.userFilesScale[seetag])
	spineboy:setDebugBones(false)
	spineboy:setAnimation(0, "animation", true)
	if level >= 40 then
		spineboy:setAnimation(0, "wind", true)
	end
end

function EquipLayer:setupBodyBg( role ,sex)
	-- 播放CCB动画
	if GameConfig:GetProjectType() == "HY" then
		EquipLayer["mAnimationManager"]:setRootNode(EquipLayerOwner["ly_anim"])
		EquipLayerOwner["ly_anim_fire"]:removeAllChildren()
		if role == 1 then
			local p = cc.ParticleSystemQuad:create("ccbResources/particals/bodybg_1/fire.plist")
			p:setPosition(Pos(EquipLayerOwner["ly_anim_fire"]:getContentSize()))
			p:setScale(0.25)
			EquipLayerOwner["ly_anim_fire"]:addChild(p)
			EquipLayer["mAnimationManager"]:runAnimationsForSequenceNamed("fire")
		end
	end
	if GameConfig:GetProjectType() == "WOW" then
		EquipLayer["mAnimationManager"]:setRootNode(EquipLayerOwner["ly_anim"])
		EquipLayerOwner["ly_anim_fire"]:removeAllChildren()
		if role == 2 and sex == 2 then
			local p = cc.ParticleSystemQuad:create("ccbResources/particals/bodybg_2/fire.plist")
			p:setPosition(Pos(EquipLayerOwner["ly_anim_fire"]:getContentSize()))
			p:setScale(0.25)
			EquipLayerOwner["ly_anim_fire"]:addChild(p)
			EquipLayer["mAnimationManager"]:runAnimationsForSequenceNamed("fire")
		end
	end

	-- 设置需要显示的背景
	for i = 1, 3 do
		EquipLayerOwner["lyBodyPartical_" .. i]:setVisible((i == role))
	end
	EquipLayerOwner["im_class_icon"]:setSpriteFrame("school_icon_"..role..".png")
	-- 添加粒子动画

	if role == 1 then
		for i = 1, #PARTICLE_CONFIGS.user.fire do
			local sp = EquipLayerOwner["lyBodyPartical_1"]:getChildByTag(i)
			local p = cc.ParticleSystemQuad:create("ccbResources/particals/bodybg_1/" .. PARTICLE_CONFIGS.user.fire[i] .. ".plist")
			local x, y = sp:getPosition()
			p:setPosition(cc.p(x, y))
			p:setScale(sp:getScale())
			sp:getParent():addChild(p)
			sp:removeFromParent()	
		end
	end
	if role == 2 then
		for i = 1, #PARTICLE_CONFIGS.user.water do
			local sp = EquipLayerOwner["lyBodyPartical_2"]:getChildByTag(i)
			local p = cc.ParticleSystemQuad:create("ccbResources/particals/bodybg_2/" .. PARTICLE_CONFIGS.user.water[i] .. ".plist")
			local x, y = sp:getPosition()
			p:setPosition(cc.p(x, y))
			p:setScale(sp:getScale())
			sp:getParent():addChild(p)
			sp:removeFromParent()	
		end
	end
	if role == 3 then
		for i = 1, #PARTICLE_CONFIGS.user.wind do
			local sp = EquipLayerOwner["lyBodyPartical_3"]:getChildByTag(i)
			local p = cc.ParticleSystemQuad:create("ccbResources/particals/bodybg_3/" .. PARTICLE_CONFIGS.user.wind[i] .. ".plist")
			local x, y = sp:getPosition()
			p:setPosition(cc.p(x, y))
			p:setScale(sp:getScale())
			sp:getParent():addChild(p)
			sp:removeFromParent()	
		end
	end
end

function EquipLayer:PropertyLabelRefresh()
	tolua.cast(EquipLayerOwner["mEquipActorName"], "cc.Label"):setString("Lv." .. UserInfo:getUserInfo().data.info.level .. " " .. UserInfo:getUserInfo().data.info.name)
	-- tolua.cast(EquipLayerOwner["mEquipBattleValue"], "cc.Label"):setString(UserAttr:getFightNum())
	-- tolua.cast(EquipLayerOwner["mEquipBattleValue"], "cc.Label"):setColor(COLOR_WHITE)
	EquipLayerOwner["mEquipValuePower"]:setString(UserAttr:getFightNum())
	--UserSelfInfo.title = 100+ (math.random(os.clock()*10^6)%9 + 1)
	if UserSelfInfo.title == 0 then
		-- EquipLayerOwner["mEquipUserTitle"]:setVisible(false)
		EquipLayerOwner["mEquipHonor"]:setVisible(false)
	else
		-- EquipLayerOwner["mEquipUserTitle"]:setVisible(true)
		-- tolua.cast(EquipLayerOwner["mEquipUserTitle"], "cc.Sprite"):setSpriteFrame("honor_"..UserSelfInfo.title..".png")
		EquipLayerOwner["mEquipHonor"]:setString(ZGMultiLan("honor_" .. UserSelfInfo.title))
	end
	
	local userAttr = UserAttr:getAttrTable()
	tolua.cast(EquipLayerOwner["mEquipValue1"], "cc.Label"):setString(userAttr.str)
	tolua.cast(EquipLayerOwner["mEquipValue2"], "cc.Label"):setString(userAttr.int)
	tolua.cast(EquipLayerOwner["mEquipValue3"], "cc.Label"):setString(userAttr.agi)
	tolua.cast(EquipLayerOwner["mEquipValue4"], "cc.Label"):setString(userAttr.sta)
	tolua.cast(EquipLayerOwner["mEquipValue5"], "cc.Label"):setString(math.ceil(userAttr.damage/2).." - "..userAttr.damage)
	tolua.cast(EquipLayerOwner["mEquipValue6"], "cc.Label"):setString(userAttr.armor)
	tolua.cast(EquipLayerOwner["mEquipValue7"], "cc.Label"):setString(userAttr.mr)
	tolua.cast(EquipLayerOwner["mEquipValue8"], "cc.Label"):setString(userAttr.hit)
	tolua.cast(EquipLayerOwner["mEquipValue9"], "cc.Label"):setString(userAttr.crit)
	tolua.cast(EquipLayerOwner["mEquipValue10"], "cc.Label"):setString(userAttr.dodge)
	tolua.cast(EquipLayerOwner["mEquipValue11"], "cc.Label"):setString(userAttr.tough)
	
	-- EquipLayerOwner["mEquipLayerHp"]:setString(userAttr.hp)
	-- EquipLayerOwner["mEquipLayerMp"]:setString(userAttr.mp)

	EquipLayerOwner["mEquipPropertyHP"]:setString(MultiLan("attr_role_hp")..":")
	EquipLayerOwner["mEquipPropertyMP"]:setString(MultiLan("attr_role_mp")..":")
	EquipLayerOwner["mEquipValueHP"]:setString(userAttr.hp)
	EquipLayerOwner["mEquipValueMP"]:setString(userAttr.mp)

	-- EquipLayerOwner["mEquipLayerBody"]:setSpriteFrame("body_icon_"..UserSelfInfo.role..".png")
end

function EquipLayer:EquipLayerEnter()
	-- print("EquipLayer:EquipLayerEnter")
	GameGuide:resetHandGuide()
	GameGuide:handStepClick(11, XiaLayerOwner["mMainButton3"])
	if self.isCreated then
		-- print("isCreated")
		self:EquipLayerRefreshItem()
		self.topNode:setVisible(true)
		EquipLayerOwner["layerWing"]:setVisible(false)
		EquipLayerOwner["layerWing"]:removeAllChildren()
	else
		self.isCreated = true
		
		local proxy = cc.CCBProxy:create()
		self.topNode = CCBReaderLoad("ccb/EquipLayer.ccbi", proxy, EquipLayerOwner)
		CommonEquipLayer:addChild(self.topNode)
		
		self:EquipLayerCreateItem()
		self:EquipLayerRefreshItem()
		CommonMoveLabelUnderBtn(EquipLayerOwner["mEquipMoreProperty"], EquipLayerOwner["lbEquipMoreProperty"])
		EquipLayerOwner["lbEquipMoreProperty"]:setString(ZGMultiLan("btn_equip_more_proporties"))
		EquipLayerOwner["lbEquipWingProperty"]:setString(MultiLan("btn_equip_wing_proporties"))
		EquipLayerOwner["layerWing"]:setVisible(false)
		EquipLayerOwner["layerWing"]:removeAllChildren()
		-- EquipLayerOwner["mEquipBattleValueTitle"]:setString(ZGMultiLan("equip_battle_value_title"))
		-- EquipLayerOwner["mEquipMoreProperty"]:setTitleForState(ZGMultiLan("btn_equip_more_proporties"), 1)
		EquipLayerOwner["mEquipPropertyPower"]:setString(ZGMultiLan("equip_battle_value_title").. ":")
		-- EquipLayerOwner["lbBasePropertiesTitle"]:setString(ZGMultiLan("lbBasePropertiesTitle") .. ":")
		self:playSpineAnimation(UserSelfInfo.role , UserSelfInfo.sex, UserSelfInfo.level)
		self:setupBodyBg(UserSelfInfo.role,UserSelfInfo.sex)
	end

end

function EquipLayer:addNotePlace(place)
	-- print("EquipLayer:addNotePlace",place)
	if false == findValueFromTable(self.notePlaceTable,place) then
		table.insert(self.notePlaceTable, place)
		GameGuide:newEquipGuide(self.notePlaceTable)
		if CommonEquipLayer:isVisible() then
			self:EquipLayerRefreshItem()
		end
	end
end

function EquipLayer:deleteNotePlace(place)
	-- print("EquipLayer:deleteNotePlace",place)
	if findValueFromTable(self.notePlaceTable,place) then
		removeFromTable(self.notePlaceTable, place)
		GameGuide:newEquipGuide(self.notePlaceTable)
		-- print(CommonEquipLayer:isVisible())
		if CommonEquipLayer:isVisible() then
			self:EquipLayerRefreshItem()
		end
	end
end

function EquipLayer:EquipLayerExit()
	self.topNode:setVisible(false)
	EquipLayerOwner["layerWing"]:removeAllChildren(true)
end

local function onEquipButtonMore()
	-- print("Equip  我我我我万千瓦为去去ore property click")
	MorepertyPopup(UserAttr:getAttrTable(),UserAttr:getFightNum(),UserSelfInfo.name,UserSelfInfo.level,UserSelfInfo.role)
end
local function onEquipButtonWing()
	-- cclog("onEquipButtonWing")
	if UserSelfInfo.level < 40 then
		CommonNote(MultiLan("lb_wing_tishi"))
		return
	end
	EquipLayerOwner["layerWing"]:setVisible(true)
	local winglayer = WingLayer:new()
	winglayer:create()
	local layerNode = winglayer.topNode
	EquipLayerOwner["layerWing"]:addChild(layerNode) 
	
end


EquipLayer["onEquipButtonMore"] = onEquipButtonMore
EquipLayer["onEquipButtonWing"] = onEquipButtonWing


