EquipStrengthen = class("EquipStrengthen")
EquipStrengthen.__index = EquipStrengthen

EquipStrengthen.isCreated = false
EquipStrengthen.topNode = nil
EquipStrengthen.itemIcon = nil
EquipStrengthen.itemRichtext = nil
EquipStrengthen.itemInfo = nil
EquipStrengthen.strengthenType = 0
EquipStrengthen.strengJin = 0
EQUIP_STRENGTHEN = 0
EQUIP_REFINE = 1

ccb["EquipStrengthen"] = EquipStrengthen
EquipStrengthenOwner = EquipStrengthenOwner or {}
ccb["EquipStrengthenOwner"] = EquipStrengthenOwner


function EquipStrengthen:RefreshEquipStrengthenInfo(infoTable, pType)
	-- print("RefreshEquipStrengthenInfo", pType)
	if pType == EQUIP_STRENGTHEN then
		EquipStrengthenOwner["mEquipStrengthenBtn"]:setVisible(true)
		-- EquipStrengthenOwner["mEquipStrengthenTitle"]:setVisible(true)
        EquipStrengthenOwner["mTitleEquipStrengthen"]:setVisible(true)
        -- EquipStrengthenOwner["mEquipRefineTitle"]:setVisible(false)
        EquipStrengthenOwner["mTitleEquipRefine"]:setVisible(false)
		EquipStrengthenOwner["mEquipRefine"]:setVisible(false)
		EquipStrengthenOwner["mEquipHighRefine"]:setVisible(false)

        local propDataTable = GameData:getPropDataTable(infoTable.prop_id)
        local equipLevel = propDataTable.level
        local color, equipColor = EquipHelper:getEquipColor(infoTable)  
        local strengthValue = (1+math.ceil((1+infoTable.strengthen)/5))* equipColor 

        tolua.cast(EquipStrengthenOwner["mEquipStrengthenPercent"], "cc.Label"):
               setString(MultiLan("ES_nextLvlAdd")..strengthValue.."%")

        local strengLevel = infoTable.strengthen
        local nextLevel = strengLevel + 1
        local strengBase = propDataTable.strprop
        EquipStrengthen.strengJin = math.ceil((0.8 * math.ceil(nextLevel/5)*nextLevel - (math.ceil(nextLevel/5)*4 - 4)) * strengBase * equipColor)

        local haveStrengJin = 0
        local bagProp = UserInfo:getUserInfo().data.bag_prop
        for i = 1,table.maxn(bagProp) do
            if bagProp[i].prop_id == 100003 then
               haveStrengJin = haveStrengJin + bagProp[i].amount
            end
        end
        local needGold =  EquipStrengthen.strengJin * 2000

        EquipStrengthenOwner["mEquipStrengthenDesc1"]:setString(MultiLan("ES_propNeeded_1")..EquipStrengthen.strengJin..MultiLan("ES_propNeeded_2")..haveStrengJin..")")
        if EquipStrengthen.strengJin > haveStrengJin then
			EquipStrengthenOwner["mEquipStrengthenDesc1"]:setColor(COLOR_RED)
		else
			EquipStrengthenOwner["mEquipStrengthenDesc1"]:setColor(COLOR_WHITE)
		end
		EquipStrengthenOwner["mEquipStrengthenDesc2"]:setString(MultiLan("ES_propNeeded_3")..needGold.."\r\n"..MultiLan("ES_propNeeded_2")..UserSelfInfo.gold..MultiLan("ES_propNeeded_4"))
        if needGold > UserSelfInfo.gold then
			EquipStrengthenOwner["mEquipStrengthenDesc2"]:setColor(COLOR_RED)
		else
			EquipStrengthenOwner["mEquipStrengthenDesc2"]:setColor(COLOR_WHITE)
		end
		
		
	elseif pType == EQUIP_REFINE then
		-- print("222")
		EquipStrengthenOwner["mEquipStrengthenBtn"]:setVisible(false)
        -- EquipStrengthenOwner["mEquipStrengthenTitle"]:setVisible(false)
        EquipStrengthenOwner["mTitleEquipStrengthen"]:setVisible(false)
        -- EquipStrengthenOwner["mEquipRefineTitle"]:setVisible(true)
        EquipStrengthenOwner["mTitleEquipRefine"]:setVisible(true)
		EquipStrengthenOwner["mEquipRefine"]:setVisible(true)
		EquipStrengthenOwner["mEquipHighRefine"]:setVisible(false)

        tolua.cast(EquipStrengthenOwner["mEquipStrengthenPercent"], "cc.Label"):
               setString(MultiLan("ES_washNeeded_1"))

        local equipLevel = GameData:getPropDataTable(infoTable.prop_id).level
        local needGold = 4500 + 500 * equipLevel
        EquipStrengthenOwner["mEquipStrengthenDesc1"]:setString(MultiLan("ES_washNeeded_2")..needGold.."\r\n"..MultiLan("ES_propNeeded_2")..UserSelfInfo.gold..MultiLan("ES_propNeeded_4"))
        if needGold > UserSelfInfo.gold then
			EquipStrengthenOwner["mEquipStrengthenDesc1"]:setColor(COLOR_RED)
		else
			EquipStrengthenOwner["mEquipStrengthenDesc1"]:setColor(COLOR_WHITE)
		end
		EquipStrengthenOwner["mEquipStrengthenDesc2"]:setString("")
	end

	self.itemIcon:setItemType(BAG_ITEM_TYPE_EQUIP)	
	self.itemIcon:setItemInfoTable(infoTable)
    self.itemIcon:setCanTouch(false)

	if self.itemRichtext ~= nil then
		self.itemRichtext:removeFromParent()
	end
	self.itemRichtext = EquipHelper:createItemInfoRichtext(infoTable,nil,true)
	self.itemRichtext:setPosition(cc.p(300, 400))
	EquipStrengthenOwner["mEquipStrengthenLayer"]:addChild(self.itemRichtext)

end

function EquipStrengthen:EquipStrengthenEnter(infoTable, pType)
	if self.isCreated then
		self.topNode:setVisible(true)
	else
		self.isCreated = true
		
		local proxy = cc.CCBProxy:create()
		self.topNode = CommonCreatePopup(CCBReaderLoad("ccb/EquipStrengthen.ccbi",proxy,EquipStrengthenOwner))
		
		--ccb多语言
		EquipStrengthenOwner["mEquipStrengthenBtn"]:setTitleForState(MultiLan("button_strengthen"), 1)
		EquipStrengthenOwner["mEquipRefine"]:setTitleForState(MultiLan("button_refine"), 1)
		EquipStrengthenOwner["mTitleEquipStrengthen"]:setString(ZGMultiLan("equip_strengthen_title"))
		EquipStrengthenOwner["mTitleEquipRefine"]:setString(ZGMultiLan("equip_refine_title"))
		
		self.itemIcon = CreateBagItem()
		self.itemIcon:setPosition(cc.p(100, 600))
		EquipStrengthenOwner["mEquipStrengthenLayer"]:addChild(self.itemIcon)
	end
	self.strengthenType = pType
	self.itemInfo = infoTable
    EquipStrengthen:RefreshEquipStrengthenInfo(infoTable, pType)

end

function EquipStrengthen:EquipStrengthenExit()
	self.topNode:setVisible(false)
end

local function onEquipStrengthenClose()
	EquipStrengthen:EquipStrengthenExit()
end

local function onEquipStrengthen()
	local function equipStrengthenCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			-- cclog("strengthen equip failed %d", jsonDataTable.ret)
			return 
		end
		UserInfo:setGold(UserInfo:getGold() - jsonDataTable.data.gold)

		UserInfo:removepropByPropId(jsonDataTable.data.prop_id,jsonDataTable.data.prop_num)

		local equipInfo = UserInfo:getEquipByIdAndObj(jsonDataTable.data.idx, jsonDataTable.data.obj)
		if equipInfo ~= nil then
			equipInfo.strengthen = equipInfo.strengthen + 1
			BagLayer:UpdateItem(equipInfo)
			UserAttr:setEquipGradeAndScore(equipInfo)
			EquipStrengthen:EquipStrengthenEnter(equipInfo, EQUIP_STRENGTHEN)
		end
		UserAttr:equipAttrChange(jsonDataTable.data.obj, true)
		BagLayer:setDirty(true)
		EquipLayer:EquipLayerRefreshItem()
	end


    local haveStrengJin = 0
    local bagProp = UserInfo:getUserInfo().data.bag_prop
    for i = 1,table.maxn(bagProp) do
        if bagProp[i].prop_id == 100003 then
             haveStrengJin = haveStrengJin + bagProp[i].amount
         end
    end
	
	if EquipStrengthen.itemInfo.strengthen >= EQUIP_STRENGTHEN_MAX then
        CommonNote(MultiLan("ES_strenthFail_3"))
        return
	end

    if haveStrengJin < EquipStrengthen.strengJin then
        CommonNote(MultiLan("ES_strenthFail_1"))
        return
    end

    if UserInfo:getUserInfo().data.info.gold < EquipStrengthen.strengJin * 2000 then
        CommonNote(MultiLan("ES_strenthFail_2"))
        return
    end
	HttpSend("equip/strengthen", {"id=" .. EquipStrengthen.itemInfo.id}, equipStrengthenCallback)
	--onEquipStrengthenClose()
end

function onEquipRefine()
	local equipLevel = EquipHelper:getStaticData(EquipStrengthen.itemInfo).level
	local needGold = 4500 + 500 * equipLevel
	local function equipRefineCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			-- cclog("refine equip failed %d", jsonDataTable.ret)
			return 
		end
		UserInfo:setGold(UserInfo:getGold() - needGold)
		local equipInfo = UserInfo:setEquipByIdAndObj(jsonDataTable.data)
		-- print("equipRefineCallback",equipInfo )
		if equipInfo ~= nil then
			UserAttr:setEquipGradeAndScore(equipInfo)
			EquipStrengthen:EquipStrengthenEnter(equipInfo, EQUIP_REFINE)
		end

		UserAttr:equipAttrChange(jsonDataTable.data.obj)
	end

    if UserInfo:getUserInfo().data.info.gold < needGold then
        CommonNote(MultiLan("ES_washFail"))
        return
    end
	HttpSend("equip/refine", {"id=" .. EquipStrengthen.itemInfo.id}, equipRefineCallback)
end

function onEquipHighRefine()

end

local function onEquipStrengthenHelp()
	if EquipStrengthen.strengthenType  == EQUIP_STRENGTHEN then
		HelpPopup("equipstrengthen")
	elseif EquipStrengthen.strengthenType == EQUIP_REFINE then
		HelpPopup("equiprefine")
	end
end

EquipStrengthen["onEquipStrengthen"] = onEquipStrengthen
EquipStrengthen["onEquipRefine"] = onEquipRefine
EquipStrengthen["onEquipHighRefine"] = onEquipHighRefine
EquipStrengthen["onEquipStrengthenClose"] = onEquipStrengthenClose
EquipStrengthen["onEquipStrengthenHelp"] = onEquipStrengthenHelp