JewelManiaLayer = class("JewelManiaLayer")

--new
function JewelManiaLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function JewelManiaLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["JewelManiaLayer"] = self
	ccb["JewelManiaLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/Event/JewelManiaLayer.ccbi", proxy, self)
	self.data = data
   
	-- set button onlick
	self.mActHelpBtn.owner = self
	self.mActPayBack.owner = self
	self.btCraft.owner = self
	self.btChose.owner = self
	self.btChoseRed.owner = self
	self.btChoseYellow.owner = self
	self.btChoseGreen.owner = self
	self.btChoseBlue.owner = self
	self.btCancel.owner = self
	self.JewelTable = {["Original"] = {},
						["Cailiao"] = {},
					}
	self.CailiaoTable = {
						["red"] = {},
						["blue"] = {},
						["yellow"] = {},
						["green"] = {},
					}
	self:initUI()
	return self
end
function JewelManiaLayer:initUI(  )
	self.tanLayer:setVisible(false)
	SetTouchEventForLayer(self.swallowLayerSmall, TouchSwallow)
	self.lbActjewelmanialTitle:setString(ZGMultiLan("act_title_jewelmania"))
	self.lbTimeDesc:setString(MultiLan("GAL_jewelmania_desc1"))
	self.lbTimeDesc2:setString(MultiLan("GAL_jewelmania_desc2"))
	self.lbTimeName:setString(MultiLan("GAL_jewelmania_desc8"))
	self.lbupgradeName:setString(MultiLan("GAL_jewelmania_desc3"))
	self.lbDireDesc1:setString(MultiLan("GAL_jewelmania_desc4"))
	self.lbDireDesc2:setString(MultiLan("GAL_jewelmania_desc4"))
	self.lbDireDesc3:setString(MultiLan("GAL_jewelmania_desc4"))
	self.lbCost:setString(MultiLan("GAL_jewelmania_desc7"))
	self.lbMaterials:setString(MultiLan("GAL_jewelmania_desc6"))
	self.btCraft:setTitleForState(MultiLan("GAL_jewelmania_button"),1)
	self.btCancel:setTitleForState(MultiLan("button_cancel"),1)
	self.lbTitle02:setString(ZGMultiLan("title_jewelchoose"))

end
function JewelManiaLayer:onActPayBack(sender)
	self.owner.data.resetActLayer()
	self.owner.topNode:setVisible(false)
end
function JewelManiaLayer:onActHelpClick(sender)
	HelpPopup("actijewelmania")
end
function JewelManiaLayer:onClickBtChose(sender)
	local rubynum = 0
	for i = 1, table.maxn(UserInfo:getUserInfo().data.bag_prop) do
		local propId = UserInfo:getUserInfo().data.bag_prop[i].prop_id
		local propInfoTable = GameData:getPropDataTable(propId)
		if propInfoTable.ptype == PROP_TYPE_GEM then
			if propInfoTable.level >= 4 then
				rubynum = rubynum + 1
			end
		end
	end
	local LINE_MAX = 4
	local lineCount =  math.ceil(rubynum/LINE_MAX)

	local scrollLayer = self.owner.scrollLayer
    local layer = cc.Layer:create()
    local y = lineCount * 120
    layer:setContentSize(cc.size(scrollLayer:getContentSize().width, y))
	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, scrollLayer:getContentSize().height - y), kScrollViewDirectionVertical)
	
	local index = 1
	for i = 1, table.maxn(UserInfo:getUserInfo().data.bag_prop) do
		local propId = UserInfo:getUserInfo().data.bag_prop[i].prop_id
		local propInfoTable = GameData:getPropDataTable(propId)
		if propInfoTable.ptype == PROP_TYPE_GEM then
			if propInfoTable.level >= 4 and propInfoTable.level < 10 then
				local bagItem = CreateBagItem()
				bagItem:setItemType(BAG_ITEM_TYPE_JEWEL_MANIA)
				bagItem:setItemInfoTable(UserInfo:getUserInfo().data.bag_prop[i])
				local tmp = math.mod((index-1), LINE_MAX)
				local tmp2 = math.floor((index-1) / LINE_MAX) + 1
				bagItem:setPosition(cc.p(layer:getContentSize().width * (0.1 + 0.25 * tmp), layer:getContentSize().height - tmp2 * 120 + 120 * 0.5))
				layer:addChild(bagItem)
				index = index + 1
			end
		end
	end
    self.owner.tanLayer:setVisible(true)
	-- cclog("onClickBtChose")
end
function JewelManiaLayer:onClickBtCraft(sender)
	if table_is_empty(self.owner.JewelTable.Original) then
		CommonNote(MultiLan("GAL_jewelmania_desc10"))
		return
	end
	if table_is_empty(self.owner.JewelTable.Cailiao) then
		CommonNote(MultiLan("GAL_jewelmania_desc9"))
		return
	end
	local function CraftCallBack(jsonDataTable)
		ccdump(jsonDataTable,"jsonDataTable")
		if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
			self.owner.imRedFrame:setVisible(false)
			self.owner.imYellowFrame:setVisible(false)
			self.owner.imGreenFrame:setVisible(false)
			self.owner.imBlueFrame:setVisible(false)
			self.owner.imOriginalFrame:setVisible(false)
			self.owner.imCailiaoFrame:setVisible(false)
			self.owner.imShengchengFrame:setVisible(false)

			UserInfo:addProp(jsonDataTable.data.newStone)
			UserInfo:addPropNote(jsonDataTable.data.newStone)
			UserSelfInfo.cash = UserSelfInfo.cash - jsonDataTable.data.cost_cash
			UserInfo:removepropByPropId(self.owner.JewelTable.Original.prop_id, 1)
			UserInfo:removepropByPropId(self.owner.JewelTable.Cailiao.prop_id, 1)
			self.owner.lbUserCash:setString(tostring(UserSelfInfo.cash))
			self.owner.lbcostnum:setString("0")
			self.owner.CailiaoTable.red = {}
			self.owner.CailiaoTable.blue = {}
			self.owner.CailiaoTable.yellow = {}
			self.owner.CailiaoTable.green = {}
			self.owner.JewelTable.Original = {}
			self.owner.JewelTable.Cailiao = {}
		end
	end
	HttpSend("activity/makeStone", {"fromPropId="..self.owner.JewelTable.Original.prop_id,"toPropId="..self.owner.JewelTable.Cailiao.prop_id}, CraftCallBack)
end
function JewelManiaLayer:onClickBtChoseRed(sender)
	self.owner.JewelTable.Cailiao = self.owner.CailiaoTable.red
	if table_is_empty(self.owner.JewelTable.Cailiao) then
		self.owner.imCailiaoFrame:setVisible(false)
		self.owner.lbcostnum:setString("0")
		return
	end
	if self.owner.JewelTable.Original.sData.place == 2 then
		self.owner.lbcostnum:setString(tostring(UserActiveInfo.stone_maker.config[tostring(self.owner.JewelTable.Original.sData.level)].s))
	else
		self.owner.lbcostnum:setString(tostring(UserActiveInfo.stone_maker.config[tostring(self.owner.JewelTable.Original.sData.level)].ns))
	end
	self.owner.imCailiaoFrame:setVisible(true)
	if self.owner.JewelTable.Cailiao.sData.place == 1 then
		tolua.cast(self.owner.imCailiaoFrame, "cc.Sprite"):setSpriteFrame("frame_green.png")
	elseif self.owner.JewelTable.Cailiao.sData.place == 2 then
		tolua.cast(self.owner.imCailiaoFrame, "cc.Sprite"):setSpriteFrame("frame_violet.png")
	elseif self.owner.JewelTable.Cailiao.sData.place == 3 then
		tolua.cast(self.owner.imCailiaoFrame, "cc.Sprite"):setSpriteFrame("frame_blue.png")
	elseif self.owner.JewelTable.Cailiao.sData.place == 4 then
		tolua.cast(self.owner.imCailiaoFrame, "cc.Sprite"):setSpriteFrame("frame_yellow.png")
	end
	tolua.cast(self.owner.imCailiaoJewel, "cc.Sprite"):setSpriteFrame("prop_"..self.owner.JewelTable.Cailiao.sData.id..".png")
	self.owner.lbCailiaoJewel:setString("Lv"..self.owner.JewelTable.Cailiao.sData.level)
end
function JewelManiaLayer:onClickBtChoseYellow(sender)
	self.owner.JewelTable.Cailiao = self.owner.CailiaoTable.yellow
	if table_is_empty(self.owner.JewelTable.Cailiao) then
		self.owner.imCailiaoFrame:setVisible(false)
		self.owner.lbcostnum:setString("0")
		return
	end
	-- ccdump(UserActiveInfo.stone_maker.config,"UserActiveInfo.stone_makerconfid")
	-- ccdump(self.owner.JewelTable.Original.sData.level,"self.owner.JewelTable.Original.sData.level")
	-- ccdump(UserActiveInfo.stone_maker.config["4"],"hahaha")
	if self.owner.JewelTable.Original.sData.place == 4 then
		self.owner.lbcostnum:setString(tostring(UserActiveInfo.stone_maker.config[tostring(self.owner.JewelTable.Original.sData.level)].s))
	else
		self.owner.lbcostnum:setString(tostring(UserActiveInfo.stone_maker.config[tostring(self.owner.JewelTable.Original.sData.level)].ns))
	end
	self.owner.imCailiaoFrame:setVisible(true)
	if self.owner.JewelTable.Cailiao.sData.place == 1 then
		tolua.cast(self.owner.imCailiaoFrame, "cc.Sprite"):setSpriteFrame("frame_green.png")
	elseif self.owner.JewelTable.Cailiao.sData.place == 2 then
		tolua.cast(self.owner.imCailiaoFrame, "cc.Sprite"):setSpriteFrame("frame_violet.png")
	elseif self.owner.JewelTable.Cailiao.sData.place == 3 then
		tolua.cast(self.owner.imCailiaoFrame, "cc.Sprite"):setSpriteFrame("frame_blue.png")
	elseif self.owner.JewelTable.Cailiao.sData.place == 4 then
		tolua.cast(self.owner.imCailiaoFrame, "cc.Sprite"):setSpriteFrame("frame_yellow.png")
	end
	tolua.cast(self.owner.imCailiaoJewel, "cc.Sprite"):setSpriteFrame("prop_"..self.owner.JewelTable.Cailiao.sData.id..".png")
	self.owner.lbCailiaoJewel:setString("Lv"..self.owner.JewelTable.Cailiao.sData.level)
end
function JewelManiaLayer:onClickBtChoseGreen(sender)
	self.owner.JewelTable.Cailiao = self.owner.CailiaoTable.green
	if table_is_empty(self.owner.JewelTable.Cailiao) then
		self.owner.imCailiaoFrame:setVisible(false)
		self.owner.lbcostnum:setString("0")
		return
	end
	if self.owner.JewelTable.Original.sData.place == 1 then
		self.owner.lbcostnum:setString(tostring(UserActiveInfo.stone_maker.config[tostring(self.owner.JewelTable.Original.sData.level)].s))
	else
		self.owner.lbcostnum:setString(tostring(UserActiveInfo.stone_maker.config[tostring(self.owner.JewelTable.Original.sData.level)].ns))
	end
	self.owner.imCailiaoFrame:setVisible(true)
	if self.owner.JewelTable.Cailiao.sData.place == 1 then
		tolua.cast(self.owner.imCailiaoFrame, "cc.Sprite"):setSpriteFrame("frame_green.png")
	elseif self.owner.JewelTable.Cailiao.sData.place == 2 then
		tolua.cast(self.owner.imCailiaoFrame, "cc.Sprite"):setSpriteFrame("frame_violet.png")
	elseif self.owner.JewelTable.Cailiao.sData.place == 3 then
		tolua.cast(self.owner.imCailiaoFrame, "cc.Sprite"):setSpriteFrame("frame_blue.png")
	elseif self.owner.JewelTable.Cailiao.sData.place == 4 then
		tolua.cast(self.owner.imCailiaoFrame, "cc.Sprite"):setSpriteFrame("frame_yellow.png")
	end
	tolua.cast(self.owner.imCailiaoJewel, "cc.Sprite"):setSpriteFrame("prop_"..self.owner.JewelTable.Cailiao.sData.id..".png")
	self.owner.lbCailiaoJewel:setString("Lv"..self.owner.JewelTable.Cailiao.sData.level)
end
function JewelManiaLayer:onClickBtChoseBlue(sender)
	self.owner.JewelTable.Cailiao = self.owner.CailiaoTable.blue
	if table_is_empty(self.owner.JewelTable.Cailiao) then
		self.owner.imCailiaoFrame:setVisible(false)
		self.owner.lbcostnum:setString("0")
		return
	end
	if self.owner.JewelTable.Original.sData.place == 3 then
		self.owner.lbcostnum:setString(tostring(UserActiveInfo.stone_maker.config[tostring(self.owner.JewelTable.Original.sData.level)].s))
	else
		self.owner.lbcostnum:setString(tostring(UserActiveInfo.stone_maker.config[tostring(self.owner.JewelTable.Original.sData.level)].ns))
	end
	self.owner.imCailiaoFrame:setVisible(true)
	if self.owner.JewelTable.Cailiao.sData.place == 1 then
		tolua.cast(self.owner.imCailiaoFrame, "cc.Sprite"):setSpriteFrame("frame_green.png")
	elseif self.owner.JewelTable.Cailiao.sData.place == 2 then
		tolua.cast(self.owner.imCailiaoFrame, "cc.Sprite"):setSpriteFrame("frame_violet.png")
	elseif self.owner.JewelTable.Cailiao.sData.place == 3 then
		tolua.cast(self.owner.imCailiaoFrame, "cc.Sprite"):setSpriteFrame("frame_blue.png")
	elseif self.owner.JewelTable.Cailiao.sData.place == 4 then
		tolua.cast(self.owner.imCailiaoFrame, "cc.Sprite"):setSpriteFrame("frame_yellow.png")
	end
	tolua.cast(self.owner.imCailiaoJewel, "cc.Sprite"):setSpriteFrame("prop_"..self.owner.JewelTable.Cailiao.sData.id..".png")
	self.owner.lbCailiaoJewel:setString("Lv"..self.owner.JewelTable.Cailiao.sData.level)
end
function JewelManiaLayer:onClickCancel(sender)
	cclog("onClickBtChoseBlue")
	self.owner.tanLayer:setVisible(false)
end
function JewelManiaLayer:onClickChoseJewel(itemInfoTable)
	-- cclog("onClickChoseJewel")
	-- ccdump(itemInfoTable,"itemInfoTable")
	-- ccdump(self,"self")
	self.imRedFrame:setVisible(false)
	self.imYellowFrame:setVisible(false)
	self.imGreenFrame:setVisible(false)
	self.imBlueFrame:setVisible(false)
	self.imOriginalFrame:setVisible(false)
	self.imCailiaoFrame:setVisible(false)
	self.imShengchengFrame:setVisible(false)
	self.lbcostnum:setString("0")

	self.JewelTable.Original = itemInfoTable
	self.CailiaoTable.red = {}
	self.CailiaoTable.blue = {}
	self.CailiaoTable.yellow = {}
	self.CailiaoTable.green = {}
	for i = 1, table.maxn(UserInfo:getUserInfo().data.bag_prop) do
		local propId = UserInfo:getUserInfo().data.bag_prop[i].prop_id
		local propInfoTable = GameData:getPropDataTable(propId)
		if propInfoTable.ptype == PROP_TYPE_GEM then
			if propInfoTable.level == itemInfoTable.sData.level then
				--green 绿色
				if propInfoTable.place == 1 then
					self.CailiaoTable.green = UserInfo:getUserInfo().data.bag_prop[i]
					tolua.cast(self.imGreenJewel, "cc.Sprite"):setSpriteFrame("prop_"..self.CailiaoTable.green.prop_id..".png")
					if propInfoTable.place == itemInfoTable.sData.place then
						self.lbGreenNum:setString("x"..self.CailiaoTable.green.amount-1)
						if self.CailiaoTable.green.amount-1 == 0 then
							self.CailiaoTable.green = {}
						end
					else
						self.lbGreenNum:setString("x"..self.CailiaoTable.green.amount)
					end
					self.imGreenFrame:setVisible(true)
				--red
				elseif propInfoTable.place == 2 then
					self.CailiaoTable.red = UserInfo:getUserInfo().data.bag_prop[i]
					tolua.cast(self.imRedJewel, "cc.Sprite"):setSpriteFrame("prop_"..self.CailiaoTable.red.prop_id..".png")
					if propInfoTable.place == itemInfoTable.sData.place then
						self.lbRedNum:setString("x"..self.CailiaoTable.red.amount-1)
						if self.CailiaoTable.red.amount-1 == 0 then
							self.CailiaoTable.red = {}
						end
					else
						self.lbRedNum:setString("x"..self.CailiaoTable.red.amount)
					end
					self.imRedFrame:setVisible(true)
				-- blue
				elseif propInfoTable.place == 3 then
					self.CailiaoTable.blue = UserInfo:getUserInfo().data.bag_prop[i]
					tolua.cast(self.imBlueJewel, "cc.Sprite"):setSpriteFrame("prop_"..self.CailiaoTable.blue.prop_id..".png")
					if propInfoTable.place == itemInfoTable.sData.place then
						self.lbBlueNum:setString("x"..self.CailiaoTable.blue.amount-1)
						if self.CailiaoTable.blue.amount-1 == 0 then
							self.CailiaoTable.blue = {}
						end
					else
						self.lbBlueNum:setString("x"..self.CailiaoTable.blue.amount)
					end
					self.imBlueFrame:setVisible(true)
				--yellow
				elseif propInfoTable.place == 4 then
					self.CailiaoTable.yellow = UserInfo:getUserInfo().data.bag_prop[i]
					tolua.cast(self.imYellowJewel, "cc.Sprite"):setSpriteFrame("prop_"..self.CailiaoTable.yellow.prop_id..".png")
					if propInfoTable.place == itemInfoTable.sData.place then
						self.lbYellowNum:setString("x"..self.CailiaoTable.yellow.amount-1)
						if self.CailiaoTable.yellow.amount-1 == 0 then
							self.CailiaoTable.yellow = {}
						end
					else
						self.lbYellowNum:setString("x"..self.CailiaoTable.yellow.amount)
					end
					self.imYellowFrame:setVisible(true)
				end
			end
		end
	end
	if table_is_empty(self.CailiaoTable.green) then
		local info = GameData:getPropDataTableByLevel(1,6,itemInfoTable.sData.level)
		tolua.cast(self.imGreenJewel, "cc.Sprite"):setSpriteFrame("prop_"..info.id..".png")
		self.lbGreenNum:setString("x0")
		self.imGreenFrame:setVisible(true)
	end
	if table_is_empty(self.CailiaoTable.red)  then
		local info = GameData:getPropDataTableByLevel(2,6,itemInfoTable.sData.level)
		tolua.cast(self.imRedJewel, "cc.Sprite"):setSpriteFrame("prop_"..info.id..".png")
		self.lbRedNum:setString("x0")
		self.imRedFrame:setVisible(true)
	end

	if table_is_empty(self.CailiaoTable.blue)  then
		local info = GameData:getPropDataTableByLevel(3,6,itemInfoTable.sData.level)
		tolua.cast(self.imBlueJewel, "cc.Sprite"):setSpriteFrame("prop_"..info.id..".png")
		self.lbBlueNum:setString("x0")
		self.imBlueFrame:setVisible(true)
	end
	if table_is_empty(self.CailiaoTable.yellow) then
		local info = GameData:getPropDataTableByLevel(4,6,itemInfoTable.sData.level)
		tolua.cast(self.imYellowJewel, "cc.Sprite"):setSpriteFrame("prop_"..info.id..".png")
		self.lbYellowNum:setString("x0")
		self.imYellowFrame:setVisible(true)
	end
	self.imOriginalFrame:setVisible(true)
	self.imShengchengFrame:setVisible(true)
	if itemInfoTable.sData.place == 1 then
		tolua.cast(self.imOriginalFrame, "cc.Sprite"):setSpriteFrame("frame_green.png")
		tolua.cast(self.imShengchengFrame, "cc.Sprite"):setSpriteFrame("frame_green.png")
	elseif itemInfoTable.sData.place == 2 then
		tolua.cast(self.imOriginalFrame, "cc.Sprite"):setSpriteFrame("frame_violet.png")
		tolua.cast(self.imShengchengFrame, "cc.Sprite"):setSpriteFrame("frame_violet.png")
	elseif itemInfoTable.sData.place == 3 then
		tolua.cast(self.imOriginalFrame, "cc.Sprite"):setSpriteFrame("frame_blue.png")
		tolua.cast(self.imShengchengFrame, "cc.Sprite"):setSpriteFrame("frame_blue.png")
	elseif itemInfoTable.sData.place == 4 then
		tolua.cast(self.imOriginalFrame, "cc.Sprite"):setSpriteFrame("frame_yellow.png")
		tolua.cast(self.imShengchengFrame, "cc.Sprite"):setSpriteFrame("frame_yellow.png")
	end
	local ShengchengJewel = GameData:getPropDataTableByLevel(itemInfoTable.sData.place,6,itemInfoTable.sData.level + 1)
	tolua.cast(self.imOriginalJewel, "cc.Sprite"):setSpriteFrame("prop_"..itemInfoTable.sData.id..".png")
	self.lbOriginalJewel:setString("Lv"..itemInfoTable.sData.level)
	tolua.cast(self.imShengchengJewel, "cc.Sprite"):setSpriteFrame("prop_"..ShengchengJewel.id..".png")
	-- ccdump(itemInfoTable,"itemInfoTable")
	self.lbShengchengJewel:setString("Lv"..( itemInfoTable.sData.level + 1 ))
	self.tanLayer:setVisible(false)
end







