LifetimeCardLayer = class("LifetimeCardLayer")

--new
function LifetimeCardLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function LifetimeCardLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["LifetimeCardLayer"] = self
	ccb["LifetimeCardLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/Event/LifetimeCardLayer.ccbi", proxy, self)
	self.data = data
	self.mActPayBack.owner = self
	self.btPay.owner = self
	self.btMackCard.owner = self
	self.bt_life_card_fan.owner = self
	self.btGetGold.owner = self
	self.cardflag = 1
	self:initUI()
	return self
end
function LifetimeCardLayer:initUI(  )
	self.lbCardDescZheng1:setString(MultiLan("lbCardDescZheng1"))
	self.lbCardDescZheng1:enableOutline(cc.c3b(231,246,255),1)
	self.lbLifeCardDesc1:setString(MultiLan("lbLifeCardDesc1"))
	self.lbLifeCardDesc2:setString(MultiLan("lbLifeCardDesc2"))
	self.lbCardDescTettle:setString(MultiLan("lbCardDescTettle"))
	self.lbCardDescTettle:enableOutline(cc.c3b(231,246,255),1)
	self.lbCardDesc1:setString(MultiLan("lbCardDesc1"))
	self.lbCardDesc1:enableOutline(cc.c3b(231,246,255),1)
	self.lbLifetimeTitle:setString(ZGMultiLan("title_lifetime"))
	self.btPay:setTitleForState(MultiLan("lifetime_button1"),1)
	self.btGetGold:setTitleForState(MultiLan("lifetime_button2"),1)
	self.btMackCard:setTitleForState(MultiLan("lifetime_button3"),1)
	self:ReCard()
end
function LifetimeCardLayer:onActPayBack(sender)
	self.owner.data.resetActLayer()
	self.owner.topNode:setVisible(false)
end
function LifetimeCardLayer:onActHelpClick(sender)
	HelpPopup("actilifetime")
end
function LifetimeCardLayer:onClickPay( sender )
-- cclog("onClickPay")
	onMainPay("lifetimecard")
end
function LifetimeCardLayer:onClickMackCard( sender )
	local function MackCardCallback( jsonDataTable )
		if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
			UserInfo:setCash(UserInfo:getCash() - 888)
			self.owner.btMackCard:setVisible(false)
			self.owner.btPay:setVisible(false)
			self.owner.btGetGold:setVisible(true)
			UserActiveInfo.has_life_vip_card = 1
			Activity_ActArr[ACT_TYPE_LIFETIME].canReward = IsLifeCardCanReward()
		end
	end

	HttpSend("activity/activeLifeVipCard", {}, MackCardCallback)
	
end
function LifetimeCardLayer:onClickGetGold( sender )
	-- cclog("btGetGold")
	local function GetGoldCallback( jsonDataTable )
		if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
			self.owner.btGetGold:setEnabled(false)
			CommonNote(MultiLan("CL_ChargeSucceed_2")..jsonDataTable.data.cash)
			UserInfo:setCash(UserInfo:getCash() + jsonDataTable.data.cash)
			UserActiveInfo.life_vip_card = 1
			Activity_ActArr[ACT_TYPE_LIFETIME].canReward = IsLifeCardCanReward()
			if Activity_ActArr[ACT_TYPE_LIFETIME].canReward == false and Activity_ActArr[ACT_TYPE_LIFETIME].noteNode ~= nil then
				removeSelf(Activity_ActArr[ACT_TYPE_LIFETIME].noteNode)
			end
		end
	end
	HttpSend("activity/rewardLifeVipCard", {}, GetGoldCallback)
end
function LifetimeCardLayer:onClickLifecard( sender )
	-- cclog("onClickLifecard")
	if self.owner.cardflag == 1 then 
		self.owner.cardflag = 0
	else
		self.owner.cardflag = 1
	end
	self.owner:ReCard()
end
function LifetimeCardLayer:ReCard(  )
	if self.cardflag == 1 then
		self.life_card_zheng:setVisible(true)
		self.life_card_fan:setVisible(false)
	else
		self.life_card_zheng:setVisible(false)
		self.life_card_fan:setVisible(true)
	end
end




