LostTreasureLayer = class("LostTreasureLayer")

--new
function LostTreasureLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function LostTreasureLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["LostTreasureLayer"] = self
	ccb["LostTreasureLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/Event/FindTreasureLayer.ccbi", proxy, self)
	self.data = data
   
	-- set button onlick
	self.mActHelpBtn.owner = self
	self.mActPayBack.owner = self
	self.btPreview.owner = self
	self.btHunt1.owner = self
	self.btHunt10.owner = self
	self.button1.owner = self
	self.button2.owner = self
	self.button3.owner = self
	self.btTanOk.owner = self
	self.btTanCancel.owner = self
	self.buyIndianaJonesInfo = nil
	self.IndianaJonesInfo = nil
    self.free_per_day = 0
    self.max_per_day = 0
    self.saleComLayer = {
	{["saleComLayer"] = self.saleComLayer1, ["imIco"] = self.imIco1 , ["lbNum"] = self.lbNum1 , ["lbName"] = self.lbName1,},
	{["saleComLayer"] = self.saleComLayer2, ["imIco"] = self.imIco2 , ["lbNum"] = self.lbNum2 , ["lbName"] = self.lbName2,},
	{["saleComLayer"] = self.saleComLayer3, ["imIco"] = self.imIco3 , ["lbNum"] = self.lbNum3 , ["lbName"] = self.lbName3,},
}
	self:initUI()
	return self
end
function LostTreasureLayer:initUI(  )
	self.tanLayer:setVisible(false)
	SetTouchEventForLayer(self.swallowLayerSmall, TouchSwallow)
	self.lbActFindTitle:setString(ZGMultiLan("act_title_find"))
	self.lbTimeDesc1:setString(MultiLan("GAL_find_desc1"))
	self.lbTimeDesc2:setString(MultiLan("GAL_find_desc2"))
	self.lbTimeName:setString(MultiLan("GAL_find_desc3"))
	self.lbDireName:setString(MultiLan("GAL_find_desc4"))
	self.lbFindCost:setString(MultiLan("GAL_find_desc5"))
	self.lbFind10Cost:setString(MultiLan("GAL_find_desc6"))
	self.lbFreeTime:setString(MultiLan("GAL_find_desc7"))
	self.lbTimes:setString(MultiLan("GAL_find_desc8"))
	self.btPreview:setTitleForState(MultiLan("GAL_find_button1"),1)
	self.btHunt1:setTitleForState(MultiLan("GAL_find_button2"),1)
	self.btHunt10:setTitleForState(MultiLan("GAL_find_button3"),1)
	self.btTanOk:setTitleForState(MultiLan("button_ok"),1)
	
end
function LostTreasureLayer:onActPayBack(sender)
	self.owner.data.resetActLayer()
	self.owner.topNode:setVisible(false)
end
function LostTreasureLayer:onActHelpClick(sender)
	HelpPopup("actilosttre")
end
function LostTreasureLayer:onClickBtPreview(sender)
	--
	cclog("onClickBtPreview")
	self.owner.btTanOk:setVisible(false)
	self.owner.btTanCancel:setVisible(true)
	self.owner.tanLayer:setVisible(true)
end
function LostTreasureLayer:onClickBtHunt1(sender)
	-- ccdump(self.owner.IndianaJonesInfo,"self.owner.IndianaJonesInfo")
	if self.owner.max_per_day - self.owner.IndianaJonesInfo.data.today_used <= 0 then
		CommonNote(MultiLan("GAL_find_desc10"))
		return
	end
	if self.owner.free_per_day - self.owner.IndianaJonesInfo.data.free_used_today <= 0 and UserSelfInfo.cash < self.owner.IndianaJonesInfo.data.info.price_one then
		CommonCashNeed()
		return
	end
	local function buyIndianaJonesCallback(jsonDataTable)
		-- ccdump(jsonDataTable,"1jsonDataTable")
		if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
			local that = self.owner
			
			-- self.owner.treasureBox
			self.owner.buyIndianaJonesInfo = jsonDataTable
			UserSelfInfo.cash = UserSelfInfo.cash - jsonDataTable.data.cost_cash
			self.owner.lbCashNum:setString(tostring(UserSelfInfo.cash))
			if jsonDataTable.data.got_adv_id ~= 0 then
				self.owner.btTanOk:setVisible(true)
				self.owner.btTanCancel:setVisible(false)
				self.owner.tanLayer:setVisible(true)
			else
				UserInfo:addProp(jsonDataTable.data.normal_items)
				UserInfo:addPropNote(jsonDataTable.data.normal_items)
				local that = self.owner
				self.owner.treasureBox:runAction(cc.Sequence:create(cc.ScaleTo:create(0.15, 1), cc.DelayTime:create(2), cc.CallFunc:create(function ()
																																		tolua.cast(that.treasureBox, "cc.Sprite"):setSpriteFrame("duobao_closebox.png")																											end)))
			end
			self.owner.IndianaJonesInfo.data.today_used = self.owner.IndianaJonesInfo.data.today_used + 1
			self.owner.lbremTimeNum:setString(string.format(MultiLan("GAL_find_desc9"),tostring(self.owner.max_per_day - self.owner.IndianaJonesInfo.data.today_used)))
			self.owner.IndianaJonesInfo.data.free_used_today = jsonDataTable.data.free_used_today
			if self.owner.free_per_day - jsonDataTable.data.free_used_today > 0 then
				self.owner.lbFreeTimeNum:setString(string.format(MultiLan("GAL_find_desc9"),tostring(self.owner.free_per_day - jsonDataTable.data.free_used_today)))
			else
				self.owner.lbFreeTimeNum:setString(string.format(MultiLan("GAL_find_desc9"),tostring(0)))
				Activity_ActArr[ACT_TYPE_FIND].canReward = false
			end
			if Activity_ActArr[ACT_TYPE_FIND].canReward == false and Activity_ActArr[ACT_TYPE_FIND].noteNode ~= nil then
				removeSelf(Activity_ActArr[ACT_TYPE_FIND].noteNode)
				Activity_ActArr[ACT_TYPE_FIND].noteNode = nil
			end	
		end
	end
	tolua.cast(self.owner.treasureBox, "cc.Sprite"):setSpriteFrame("duobao_fullbox.png")
	self.owner.treasureBox:runAction(cc.Sequence:create(cc.ScaleTo:create(0.15, 1), cc.DelayTime:create(0.5), cc.CallFunc:create(function ()
																															HttpSend("activity/buyIndianaJones", {"times=1"}, buyIndianaJonesCallback)			
																														end)))
	
end
function LostTreasureLayer:onClickBtHunt10(sender)
	if self.owner.max_per_day - self.owner.IndianaJonesInfo.data.today_used < 10 then
		CommonNote(MultiLan("GAL_find_desc10"))
		return
	end
	if UserSelfInfo.cash < self.owner.IndianaJonesInfo.data.info.price_ten then
		CommonCashNeed()
		return
	end
	local function buyIndianaJonesCallback(jsonDataTable)
		-- ccdump(jsonDataTable,"10jsonDataTable")
		if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
			local that = self.owner
			self.owner.buyIndianaJonesInfo = jsonDataTable
			UserInfo:addProp(jsonDataTable.data.normal_items)
			UserInfo:addPropNote(jsonDataTable.data.normal_items)
			UserSelfInfo.cash = UserSelfInfo.cash - jsonDataTable.data.cost_cash
			self.owner.lbCashNum:setString(tostring(UserSelfInfo.cash))
			
			self.owner.btTanOk:setVisible(true)
			self.owner.btTanCancel:setVisible(false)
			self.owner.tanLayer:setVisible(true)
			self.owner.IndianaJonesInfo.data.today_used = self.owner.IndianaJonesInfo.data.today_used + 10
			self.owner.lbremTimeNum:setString(string.format(MultiLan("GAL_find_desc9"),tostring(self.owner.max_per_day - self.owner.IndianaJonesInfo.data.today_used)))
			
			if self.owner.free_per_day - jsonDataTable.data.free_used_today > 0 then
				self.owner.lbFreeTimeNum:setString(string.format(MultiLan("GAL_find_desc9"),tostring(self.owner.free_per_day - jsonDataTable.data.free_used_today)))
			else
				self.owner.lbFreeTimeNum:setString(string.format(MultiLan("GAL_find_desc9"),tostring(0)))
			end
		end
	end
	tolua.cast(self.owner.treasureBox, "cc.Sprite"):setSpriteFrame("duobao_fullbox.png")
	self.owner.treasureBox:runAction(cc.Sequence:create(cc.ScaleTo:create(0.15, 1), cc.DelayTime:create(0.5), cc.CallFunc:create(function ()
																															HttpSend("activity/buyIndianaJones", {"times=10"}, buyIndianaJonesCallback)			
																														end)))
	
end
function LostTreasureLayer:onclickButton1( sender )
-- ccdump(self.owner.IndianaJonesInfo,"---IndianaJonesInfo---")
	local items = self.owner.IndianaJonesInfo.data.info.adv_items[self.owner.IndianaJonesInfo.data.aim_adv_id].items
	-- ccdump(items,"items")
	local itemInfoTable = GameData:getPropDataTable(items[1].prop_id)
	if itemInfoTable.ptype == 7 then
		return
	end
	PropDetail:PropDetailEnter(items[1], true)
	
end
function LostTreasureLayer:onclickButton2( sender )
	local items = self.owner.IndianaJonesInfo.data.info.adv_items[self.owner.IndianaJonesInfo.data.aim_adv_id].items
	local itemInfoTable = GameData:getPropDataTable(items[2].prop_id)
	if itemInfoTable.ptype == 7 then
		return
	end
	PropDetail:PropDetailEnter(items[2], true)
	
end
function LostTreasureLayer:onclickButton3( sender )
	local items = self.owner.IndianaJonesInfo.data.info.adv_items[self.owner.IndianaJonesInfo.data.aim_adv_id].items
	local itemInfoTable = GameData:getPropDataTable(items[3].prop_id)
	if itemInfoTable.ptype == 7 then
		return
	end
	PropDetail:PropDetailEnter(items[3], true)
	
end
function LostTreasureLayer:onClickBtTanOk( sender )
	self.owner.IndianaJonesInfo.data.aim_adv_id = self.owner.buyIndianaJonesInfo.data.new_adv_id
	-- ccdump(self.owner.IndianaJonesInfo,"---IndianaJonesInfo---")
	UserInfo:addProp(self.owner.buyIndianaJonesInfo.data.adv_items)
	UserInfo:addPropNote(self.owner.buyIndianaJonesInfo.data.adv_items)
	self.owner.tanLayer:setVisible(false)
	local info = self.owner.IndianaJonesInfo.data.info.adv_items[self.owner.IndianaJonesInfo.data.aim_adv_id]
	local that = self.owner
	self.owner.treasureBox:runAction(cc.Sequence:create(cc.ScaleTo:create(0.15, 1), cc.DelayTime:create(2), cc.CallFunc:create(function ()
																																	tolua.cast(that.treasureBox, "cc.Sprite"):setSpriteFrame("duobao_closebox.png")
																														end)))
	-- tolua.cast(self.owner.treasureBox, "cc.Sprite"):setSpriteFrame("duobao_closebox.png")
	for i=1,3 do
		self.owner.saleComLayer[i].lbNum:setString("x"..info.items[i].num)
		self.owner.saleComLayer[i].lbName:setString(MultiLan("prop_name_"..info.items[i].prop_id))
		tolua.cast(self.owner.saleComLayer[i].imIco, "cc.Sprite"):setSpriteFrame("prop_"..info.items[i].prop_id..".png")
	end
	
end
function LostTreasureLayer:onClickBtTanCancel( sender )
	cclog("onClickBtTanCancel")
	self.owner.tanLayer:setVisible(false)
end




