PlaceAwardLayer = class("PlaceAwardLayer")

--new
function PlaceAwardLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function PlaceAwardLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["PlaceAwardLayer"] = self
	ccb["PlaceAwardLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/Event/paimingxianli.ccbi", proxy, self)
	self.data = data
	self.bt_rank_jingji.owner = self
	self.bt_rank_zhanshi.owner = self
	self.bt_rank_fashi.owner = self
	self.bt_rank_lieren.owner = self
	self.mActPayBack.owner = self
	self:initUI()
	return self
end
function PlaceAwardLayer:initUI(  )
	self.lbdesc:setString(MultiLan("paimingdesc")) 
	self.lbActPaimingiTitle:setString(ZGMultiLan"title_paiming")
	self.bt_rank_jingji:setTitleForState(MultiLan("placeaward_button1"),1)
	self.bt_rank_zhanshi:setTitleForState(MultiLan("placeaward_button2"),1)
	self.bt_rank_fashi:setTitleForState(MultiLan("placeaward_button3"),1)
	self.bt_rank_lieren:setTitleForState(MultiLan("placeaward_button4"),1)
end
function PlaceAwardLayer:onActPayBack(sender)
	self.owner.data.resetActLayer()
	self.owner.topNode:setVisible(false)
end
function PlaceAwardLayer:setScrollLayer( tag )
	local scrollLayer = self.scrollLayer
	local layer = cc.Layer:create()
	local awardInfo = {}
	local listInfo = {}
	local function ListRanking( listInfo )
		for k, v in pairs(listInfo) do
			-- cclog(" v name is "..v.name.."\nUserSelfInfo name is "..UserSelfInfo.name)
			if v.name == UserSelfInfo.name then
				self.lbpaimingnum:setString(string.format(MultiLan("placeaward_desc2"),tostring(k)))
				break
			else
				self.lbpaimingnum:setString(MultiLan("placeaward_desc1"))
			end
		end
	end
	if tag == 1 then
		awardInfo = Activity_List.power_config
		listInfo = Activity_List.rankList[4]
		ListRanking( listInfo )
	elseif tag == 2 then
		awardInfo = Activity_List.arena_config
		listInfo = Activity_List.rankList[1]
		ListRanking( listInfo )
	elseif tag == 3 then
		awardInfo = Activity_List.arena_config
		listInfo = Activity_List.rankList[2]
		ListRanking( listInfo )
	elseif tag == 4 then
		awardInfo = Activity_List.arena_config
		listInfo = Activity_List.rankList[3]
		ListRanking( listInfo )
	end
	local count = 6
	local cellSize = AwardCell.getCellSize()
	local y = count * cellSize.height
	layer:setContentSize(cc.size(cellSize.width, y))
	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, scrollLayer:getContentSize().height - y), kScrollViewDirectionVertical)
	for i = 1 ,count do
		local placeawardcell = PlaceAwardCell:new()
		placeawardcell:create({awardInfo = awardInfo,
			listInfo = listInfo,
			tag = i,})
		local cellNode = placeawardcell.topNode
		cellNode:setPositionY(y - i * cellSize.height)
		layer:addChild(cellNode)
	end
end
function PlaceAwardLayer:onClickBtRankJingji(sender)
	-- cclog("onClickBtRankJingji")
	self.owner:setScrollLayer( 1 )
	self.owner:setEffect( 1 )
end
function PlaceAwardLayer:onClickBtRankZhanshi(sender)
	-- cclog("onClickBtRankZhanshi")
	self.owner:setScrollLayer( 2 )
	self.owner:setEffect( 2 )
end
function PlaceAwardLayer:onClickBtRankFashi(sender)
	-- cclog("onClickBtRankFashi")
	self.owner:setScrollLayer( 3 )
	self.owner:setEffect( 3 )
end
function PlaceAwardLayer:onClickBtRankLieren(sender)
	-- cclog("onClickBtRankLieren")
	self.owner:setScrollLayer( 4 )
	self.owner:setEffect( 4 )
end
function PlaceAwardLayer:setEffect(tag)

	local bttable = {self.bt_rank_jingji,self.bt_rank_zhanshi,self.bt_rank_fashi,self.bt_rank_lieren}
	for i = 1,4 do
		if bttable[i]:getChildByTag(1) ~= nil then
			bttable[i]:removeChildByTag(1)
		end
	end
	local Sprite = cc.Sprite:createWithSpriteFrameName("Event_btn_eff.png")
	Sprite:setPosition(cc.p(72,25))
	bttable[tag]:addChild(Sprite,1,1)
end





