local bArenaInited = false
UserArenaInfo = nil

local rewardTable = {
						{1,1,310,1000,1000},{2,2,290,700,700},{3,3,270,500,500},{4,4,250,400,400},
						{5,5,230,350,350},{6,10,210,300,300},{11,20,190,250,250},{21,30,170,200,200},
						{31,40,150,180,180},{41,50,130,160,160},{51,70,110,150,150},{71,100,100,140,140},
						{101,200,90,130,130},{201,300,80,120,120},{301,400,70,110,110},{401,500,60,100,100},
						{501,700,55,90,90},{701,1000,55,80,80},{1001,2000,50,70,70},{2001,3000,50,60,60},
						{501,700,55,90,90},{701,1000,55,80,80},{1001,2000,50,70,70},{2001,3000,50,60,60},
						{3001,4000,50,50,50},{4001,5000,50,40,40},{5001,7000,45,30,30},{7001,10000,45,20,20},
						{10001,50000,40,10,10}
						}

function setUserHead(node, role ,sex)
	--tolua.cast(node, "cc.Sprite"):setSpriteFrame("Lv."..level)
	local head = SetMyHead( role ,sex ,2)
	tolua.cast(node, "cc.Sprite"):setSpriteFrame(head)
end

function GetHeadByRole(role,position)
	return CreateCommonSprite("actor_icon_"..role..".png",position)
end

function GetLevelLabel(level, position,size)
	return CreateCommonLabel("Lv"..level, position, size)
end

function GetSchoolIconByRole(role, position)
	return CreateCommonSprite("school_icon_"..role..".png", position)
end

function setUserRoleIcon(node, role)
	tolua.cast(node, "cc.Sprite"):setSpriteFrame("school_icon_"..role..".png")
end

function setLevel(node, level)
	tolua.cast(node, "cc.Node"):setString("Lv."..level)
end



--设置名字和家族
function setNameAndFamily(father, name ,family)
	father:removeAllChildren(true)
	local size = father:getContentSize()
	local nameLabel = CreateCommonLabel(name,cc.p(5,size.height/2),FontSize4,nil,cc.p(0,0.5))
	father:addChild(nameLabel)
	if family ~= nil and family ~= "" then
		father:addChild(CreateCommonLabel("["..family.."]",cc.p(7+nameLabel:getContentSize().width,size.height/2),FontSize4,cc.c3b(210,0 ,255),cc.p(0,0.5)))
	end
end

--设置排名信息  排名 战力 签名
function setListAndMark(father, num , fightNum, desc)
	father:removeAllChildren(true)
	
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setContentSize(father:getContentSize())
	richText:setPosition(Pos(father:getContentSize(),0.51,0.5))

	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GALa_rank_1"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(2, COLOR_GREEN, 255 , num,     DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(3, COLOR_WHITE, 255 ,"    "..MultiLan("GALa_rank_2"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(4, COLOR_GREEN, 255 ,fightNum,        DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	richText:pushBackElement(ccui.RichElementText:create(5, cc.c3b(210,0 ,255), 255 , desc, DefaultFontName, FontSize2))
	
	father:addChild(richText)
end

--设置排名信息  排名 积分 帮主
function setListAndMaster(father, num ,score, desc)
	father:removeAllChildren(true)
	
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setContentSize(father:getContentSize())
	richText:setPosition(Pos(father:getContentSize(),0.51,0.5))

	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GALa_rank_1"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(2, COLOR_GREEN, 255 , num,     DefaultFontName, FontSize2))
	--richText:pushBackElement(ccui.RichElementText:create(3, COLOR_WHITE, 255 ,"    "..MultiLan("GALa_rank_2"),DefaultFontName, FontSize2))
	--richText:pushBackElement(ccui.RichElementText:create(4, COLOR_GREEN, 255 ,fightNum,        DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(4, COLOR_WHITE, 255 , "    "..MultiLan("union_battle_13"),     DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(4, COLOR_WHITE, 255 , score,     DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("union_battle_12"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(2, cc.c3b(210,0 ,255), 255 , desc, DefaultFontName, FontSize2))
	
	father:addChild(richText)
end

--设置名字和家族
function setFamilyAndScore(father, name ,score)
	father:removeAllChildren(true)
	
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setContentSize(father:getContentSize())
	richText:setPosition(Pos(father:getContentSize(),0.51,0.5))

	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,name,DefaultFontName, FontSize2))
	father:addChild(richText)
	--richText:pushBackElement(ccui.RichElementText:create(3, COLOR_WHITE, 255 ,"    "..MultiLan("GALa_rank_2"),DefaultFontName, FontSize2))
	--richText:pushBackElement(ccui.RichElementText:create(4, COLOR_GREEN, 255 ,fightNum,        DefaultFontName, FontSize2))
end
--设置排名信息  排名 战力 排名奖励
local function setListAndReward(father, num ,fightNum)
	father:removeAllChildren(true)
	
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setContentSize(father:getContentSize())
	richText:setPosition(Pos(father:getContentSize(), 0.52, 0.49))

	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GALa_rank_1"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(2, COLOR_GREEN, 255 , num,     DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(3, COLOR_WHITE, 255 ,"    "..MultiLan("GALa_rank_2"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(4, COLOR_GREEN, 255 ,fightNum,        DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	richText:pushBackElement(ccui.RichElementText:create(5, COLOR_WHITE, 255 ,MultiLan("GALa_rank_3"),DefaultFontName, FontSize2))
	local function getRewardByRank(rank)
		for i=1,table.maxn(rewardTable) do
			if rank>= rewardTable[i][1] and rank <= rewardTable[i][2] then
				return rewardTable[i]
			end
		end
		return nil
	end
	local reward = getRewardByRank(num)
	if reward ~= nil then
	richText:pushBackElement(ccui.RichElementText:create(5, COLOR_CYAN, 255 ,MultiLan("GALa_rank_4"),DefaultFontName, FontSize1))
	richText:pushBackElement(ccui.RichElementText:create(5, COLOR_GREEN, 255 ,reward[3],DefaultFontName, FontSize1))
	richText:pushBackElement(ccui.RichElementText:create(5, COLOR_CYAN, 255 ,MultiLan("GALa_rank_5"),DefaultFontName, FontSize1))
	richText:pushBackElement(ccui.RichElementText:create(5, COLOR_GREEN, 255 ,reward[4],DefaultFontName, FontSize1))
	richText:pushBackElement(ccui.RichElementText:create(5, COLOR_CYAN, 255 ,MultiLan("GALa_rank_6"),DefaultFontName, FontSize1))
	richText:pushBackElement(ccui.RichElementText:create(5, COLOR_GREEN, 255 ,reward[5],DefaultFontName, FontSize1))
	end
	
	
	father:addChild(richText)
end

--刷新玩家的信息
local function arenaUpdateSelf()
	setNameAndFamily(XiaLayerOwner["mMyNameLayer"], UserSelfInfo.name, UserArenaInfo.self.union_name)
	setListAndReward(XiaLayerOwner["mMyInfoLayer"], UserArenaInfo.self.idx, UserAttr:getFightNum())
	setUserHead(XiaLayerOwner["mMyHead"], UserSelfInfo.role,UserSelfInfo.sex)
	setUserRoleIcon(XiaLayerOwner["mMyType"], UserSelfInfo.role)
	setLevel(XiaLayerOwner["mMyLevel"], UserSelfInfo.level)
end

--刷新敌人的信息
local function arenaUpdateEnemy()
	for i=1,3 do
		if UserArenaInfo.player[i] ~= nil then
			XiaLayerOwner["mArenaEnemyLayer"..i]:setVisible(true)
			setNameAndFamily(XiaLayerOwner["mEnemyNameLayer"..i], UserArenaInfo.player[i].name, UserArenaInfo.player[i].union_name)
			setListAndReward(XiaLayerOwner["mEnemyInfoLayer"..i],UserArenaInfo.player[i].idx, UserArenaInfo.player[i].power)
			local head = SetMyHead(UserArenaInfo.player[i].role,UserArenaInfo.player[i].sex,2)
			SetCommonButtonSprite(XiaLayerOwner["mArnemyHead"..i], head)
			setUserRoleIcon(XiaLayerOwner["mArnemyType"..i], UserArenaInfo.player[i].role)
			setLevel(XiaLayerOwner["mEnemyLevel"..i],  UserArenaInfo.player[i].level)
		else
			XiaLayerOwner["mArenaEnemyLayer"..i]:setVisible(false)
		end
	end
end

local function ArenaLayerInit()
	-- print("ArenaLayerInit")
	arenaUpdateSelf()
	arenaUpdateEnemy()
	XiaLayerOwner["mArenaDesc2"]:setString(UserArenaInfo.num)

	if bArenaInited then
		return
	end
	bArenaInited = true

	--文字
	XiaLayerOwner["mArenaDesc1"]:setString(MultiLan("GALa_enemyInfo_1"))
	XiaLayerOwner["mArenaDesc2"]:setColor(COLOR_GREEN)

	XiaLayerOwner["mArenaButtonList"]:setTitleForState(MultiLan("GALa_enemyInfo_2"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mArenaButtonShop"]:setTitleForState(MultiLan("GALa_enemyInfo_3"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mArenaButtonBuy"]:setTitleForState(MultiLan("GALa_enemyInfo_4"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mArenaButtonChange"]:setTitleForState(MultiLan("GALa_enemyInfo_5"), cc.CONTROL_STATE_NORMAL)
end

function ArenaEnter()
	GameGuide:handStepClick(31, XiaLayerOwner["mArenaButton"])
	ArenaLayerInit()
	GameGuide:setHandGuide(32, XiaLayerOwner["mTiaozhanButton"])
	GameGuide:GuideEnter(GUIDE_TYPE_ARENA)
end

--排行榜
function showArenaList(pvpListInfo)
	local ranklayer = RankLayer:new()
    ranklayer:create({roleType = 6})
    local layerNode = ranklayer.topNode 
    if POPUP_LAYER == nil then
		POPUP_LAYER = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
		scene:addChild(POPUP_LAYER, POPUP_TAG, POPUP_TAG)
	end
	POPUP_LAYER:addChild(layerNode)
	--内容
    local scrollLayer = ranklayer.scrollLayer
    local layer = cc.Layer:create()
    local count = table.maxn(pvpListInfo)
    local cellSize = Rankcell.getCellSize()
    local y = count * cellSize.height
    layer:setContentSize(cc.size(cellSize.width, y))
	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, scrollLayer:getContentSize().height - y), kScrollViewDirectionVertical)
    for i = 1, count do
    		local rankcell = Rankcell:new()
            rankcell:create({
            	rank = i,
            	name=pvpListInfo[i].name, 
            	family=pvpListInfo[i].union_name,
            	ranks=pvpListInfo[i].idx,
            	power=pvpListInfo[i].power,
            	sign=pvpListInfo[i].sign,
                head=pvpListInfo[i].role,
                sex = pvpListInfo[i].sex,
                leavel=pvpListInfo[i].level,
                uid = pvpListInfo[i].uid,
            	})
            local cellNode = rankcell.topNode 
            cellNode:setPositionY(y - i * cellSize.height)   
	        layer:addChild(cellNode)
    end
end
function onArenaList()
	local function rankInfoCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			-- cclog("arenaInfoCallback failed %d", jsonDataTable.ret)
			return 
		end
		showArenaList(jsonDataTable.data)
	end

	HttpSend("arena/rank", {}, rankInfoCallback)
end

--荣誉兑换
local function onArenaShop()
	local function arenaShopCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			-- cclog("arenaInfoCallback failed %d", jsonDataTable.ret)
			return 
		end
		CommonShopInfo = jsonDataTable.data
		CommonCreateShopPopup(SHOP_TYPE_ARENA)
	end

	HttpSend("shop/info", {"id="..SHOP_TYPE_ARENA}, arenaShopCallback)
end

--购买次数
function onArenaBuy()
	local function arenaBuyCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			-- cclog("arenaInfoCallback failed %d", jsonDataTable.ret)
			return 
		end
		
		UserArenaInfo.num = jsonDataTable.data.count
		UserSelfInfo.cash = UserSelfInfo.cash - 50
		UseCash(50)
		XiaLayerOwner["mArenaDesc2"]:setString(UserArenaInfo.num)
		CommonNote(MultiLan("GALa_buySucceed"))
	end
	
	local function sendArenaBuy()
		if UserArenaInfo.num >= 5 then
			CommonNote(MultiLan("GALa_challCount_1"))
		else
			HttpSend("arena/buy", {}, arenaBuyCallback)
		end
	end

	if UserSelfInfo.cash < 50 then
		CommonCashNeed()
	else
		CreateSmallPopupWithCancel("buytimes", CreateCommonLabel(MultiLan("GALa_challCount_2"), nil, FontSize3), sendArenaBuy)
	end
end

--换一批
local function onArenaChange()
	local function arenaRefreshCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			-- cclog("arenaInfoCallback failed %d", jsonDataTable.ret)
			return 
		end
		UserArenaInfo.player = jsonDataTable.data
		arenaUpdateEnemy()
	end

	HttpSend("arena/refresh", {}, arenaRefreshCallback)
end

--挑战
local function onArenaEnemyClicked(node)
	if UserArenaInfo.num <= 0 then
		onArenaBuy()
		return
	end
	
	GameGuide:handStepClick(32, XiaLayerOwner["mTiaozhanButton"])

	local tag = tolua.cast(node, "cc.Node"):getTag()
	ArnerFightId = UserArenaInfo.player[tag].uid
	ArnerFightRank = UserArenaInfo.player[tag].idx
	bFightWithBoss = 0
	NextFightLabel:setString(MultiLan("GALa_challNext").." "..UserArenaInfo.player[tag].name.." ...")
	NextFightLabel:setVisible(true)
	
	local node = cc.Node:create()
	node:setTag(2)
	ShowNew(node)
end

--查看详细信息
local function onArnemyHeadClick(node)
	if UserArenaInfo.player[node:getTag()] ~= nil then
		HttpSend("user/equip", {"fuid="..UserArenaInfo.player[node:getTag()].uid}, userDetailCallback)
	end
end

XiaLayer["onArenaList"]         = onArenaList
XiaLayer["onArenaShop"]         = onArenaShop
XiaLayer["onArenaBuy"]          = onArenaBuy
XiaLayer["onArenaChange"]       = onArenaChange
XiaLayer["onArnemyHeadClick"]   = onArnemyHeadClick
XiaLayer["onArenaEnemyClicked"] = onArenaEnemyClicked