BagLayer = class("BagLayer")
BagLayer.__index = BagLayer

BagLayer.isCreated = false
BagLayer.topNode = nil
BagLayer.isDirty = true  --装备有增加，删除，位置变动时设为true
BagLayer.selectedEquip = true
BagLayer.bagViewLayer = nil

BagLayer.equipFilterCount = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17}	
BagLayer.equipNameList = {MultiLan("CD_equipColor_1"),MultiLan("CD_equipColor_2"),MultiLan("CD_equipColor_3"),MultiLan("CD_equipColor_4"),MultiLan("CD_equipColor_5"),MultiLan("lan_artifact"),MultiLan("GBL_allEquip")}

--装备
BagLayer.bagEquipScroll = nil	--装备scroll
BagLayer.oldEquipCount = nil
BagLayer.equipLayer = nil	--装备scroll
BagLayer.equipList = {}


--道具
BagLayer.bagItemScroll = nil	--物品scroll
BagLayer.oldPropCount = nil
BagLayer.propLayer = nil	--装备scroll

local LINE_MAX = 5	--一行几个格子
local GRID_WIDTH = 110	--每个格子宽
local GRID_HEIGHT = 125	--每个格子高
BagLayer.autoSellCount = {1,2,3,4}
BagLayer.equipFilterSelectFlag = 17
BagLayer.selectEquipCount = 0
ccb["BagLayer"] = BagLayer
BagLayerOwner = BagLayerOwner or {}
ccb["BagLayerOwner"] = BagLayerOwner

--刷新位置
local function refreshPosition(container, scrollview, itemList)
	-- print("refreshPosition", table.maxn(itemList))
	local scrollLayer = BagLayerOwner["mBagScrollLayer"]
	local linecount = math.ceil(table.maxn(itemList)/ LINE_MAX)
	local viewSizeHeight = scrollLayer:getContentSize().height
	for i=1, table.maxn(itemList) do
		local tmp1 = math.mod((i-1),LINE_MAX) + 1
		local tmp2 = math.floor((i-1)/LINE_MAX) + 1
		-- print(i, tmp1,tmp2,(tmp1-0.5)*GRID_WIDTH, (linecount -tmp2+0.5)*GRID_HEIGHT)
		itemList[i].bagBtn:setPosition(cc.p((tmp1-0.5)*GRID_WIDTH, (linecount -tmp2+0.5)*GRID_HEIGHT))
	end
	
	container:setContentSize(cc.size(scrollLayer:getContentSize().width, math.max(viewSizeHeight, GRID_HEIGHT*linecount)))
	--scrollview:setContentOffset(cc.p(0,math.min(viewSizeHeight - GRID_HEIGHT*linecount)))
	scrollview:setTouchEnabled(GRID_HEIGHT*linecount > viewSizeHeight)
	scrollview:updateInset()
end

--切换当前页签
function setTagButtonState(isSelectEquip)
	BagLayer.selectedEquip = isSelectEquip
    tolua.cast(BagLayerOwner["mBagLayerEquipBtn"], "cc.ControlButton"):setHighlighted(isSelectEquip)
    tolua.cast(BagLayerOwner["mEquipLayerThing"], "cc.ControlButton"):setHighlighted(not isSelectEquip)
end

--刷新装备数量显示
function refrehBagCapCapbility()
    tolua.cast(BagLayerOwner["mBagLayerCapbility"], "cc.Label"):
        setString(BagLayer.selectEquipCount.."/"..UserInfo.UserInfoTable.data.info.bagslots)
end

function BagLayer:BagLayerEnter()
	GameGuide:resetHandGuide()
	-- print("BagLayer:BagLayerEnter", self.isCreated)
	if self.isCreated then
		self.topNode:setVisible(true)
	else
		self.isCreated = true
		--GameEnteringFinish()
		DelayTimeCallfunc(scene, 0.01, GameEnteringFinish)
		local proxy = cc.CCBProxy:create()
		self.topNode = CCBReaderLoad("ccb/BagLayer.ccbi",proxy,BagLayerOwner)
		CommonBagLayer:addChild(self.topNode)
		self:CreateBagScrollLayer()
		BagLayerOwner["mBagAutosellDesc"]:setString(MultiLan("GBL_sellEquipGet"))
		GRID_WIDTH = BagLayerOwner["mBagScrollLayer"]:getContentSize().width/LINE_MAX
		self.bagViewLayer = BagLayerOwner["mBagScrollLayer"]
		local bagPopLayer = tolua.cast(BagLayerOwner["mBagPopLayer"], "cc.Node")
		bagPopLayer:setVisible(false)
		bagPopLayer:retain()
		bagPopLayer:removeFromParent(false)
		POPUP_LAYER:addChild(bagPopLayer)
		bagPopLayer:release()
		SetTouchEventForLayer(bagPopLayer, TouchSwallow)
		
		--ccb多语言
		BagLayerOwner["mBagLayerEquipName"]:setString(MultiLan("bag_desc1"))
		BagLayerOwner["mBagLayerFilterClose"]:setTitleForState(MultiLan("button_close"), 1)
		BagLayerOwner["mBagLayerSellClose"]:setTitleForState(MultiLan("button_close"), 1)
		BagLayerOwner["mBagLayerSellButton1"]:setTitleForState(MultiLan("button_sell"), 1)
		BagLayerOwner["mBagLayerSellButton2"]:setTitleForState(MultiLan("button_sell"), 1)
		BagLayerOwner["mBagLayerSellButton3"]:setTitleForState(MultiLan("button_sell"), 1)
		BagLayerOwner["mBagLayerSellButton4"]:setTitleForState(MultiLan("button_sell"), 1)
		BagLayerOwner["mBagLayerEquipBtn"]:setTitleForState(MultiLan("lan_equip"), cc.CONTROL_STATE_NORMAL)
		BagLayerOwner["mBagLayerEquipBtn"]:setTitleForState(MultiLan("lan_equip"), cc.CONTROL_STATE_DISABLED)
		BagLayerOwner["mBagLayerEquipBtn"]:setTitleForState(MultiLan("lan_equip"), cc.CONTROL_STATE_HIGH_LIGHTED)
		BagLayerOwner["mEquipLayerThing"]:setTitleForState(MultiLan("lan_item"), cc.CONTROL_STATE_NORMAL)
		BagLayerOwner["mEquipLayerThing"]:setTitleForState(MultiLan("lan_item"), cc.CONTROL_STATE_DISABLED)
		BagLayerOwner["mEquipLayerThing"]:setTitleForState(MultiLan("lan_item"), cc.CONTROL_STATE_HIGH_LIGHTED)
		BagLayerOwner["mBagEnlargeBt"]:setTitleForState(MultiLan("bag_desc2"), 1)
		
		BagLayerOwner["mBagLayerBatchSell"]:setTitleForState(MultiLan("bag_button_1"), 1)
		BagLayerOwner["mBagLayerEquipFilter"]:setTitleForState(MultiLan("bag_button_2"), 1)

		BagLayerOwner["mTitleFilterLabel"]:setString(ZGMultiLan("equip_title_filter"))
		BagLayerOwner["mTitleAutoSell"]:setString(ZGMultiLan("equip_title_autoSell"))
	end
	
	
	--装备scroll刷新
	self.oldEquipCount = nil
	self:refreshEquipList()
	self:refreshEquipLayer()
	
	--物品scroll刷新
	self.oldPropCount = nil
	self:refreshPropLayer()


end

function BagLayer:BagLayerExit()
	self.topNode:setVisible(false)
end

function BagLayer:setDirty(dirty)
	self.isDirty = dirty
end

function BagLayer:CreateBagScrollLayer()
	local bagScrollLayer = BagLayerOwner["mBagScrollLayer"]
	
	self.equipLayer = cc.Layer:create()
	self.equipLayer:setContentSize(bagScrollLayer:getContentSize())
	self.bagEquipScroll = CreateScrollViewByFather(bagScrollLayer, self.equipLayer, cc.p(0, 0), cc.SCROLLVIEW_DIRECTION_VERTICAL)
	
	local equipScrollWorldPos = self.bagEquipScroll:getParent():convertToWorldSpace(cc.p(self.bagEquipScroll:getPosition()))
	local equipScrollViewSize = self.bagEquipScroll:getViewSize()
	local bagEquipList = UserInfo:getBagEquip()
	for i = 1, table.maxn(bagEquipList) do
		local bagItem = CreateBagItem()
		bagItem:setItemType(BAG_ITEM_TYPE_EQUIP)
		bagItem:setItemInfoTable(bagEquipList[i])
		bagItem:setScrollViewRect(cc.rect(equipScrollWorldPos.x, equipScrollWorldPos.y, equipScrollViewSize.width, equipScrollViewSize.height))
		
		bagEquipList[i].bagBtn = bagItem
		self.equipLayer:addChild(bagItem)
	end
	
	--self:refreshEquipList()
	
	--道具
	self.propLayer = cc.Layer:create()
	self.propLayer:ignoreAnchorPointForPosition(true)
	self.bagItemScroll = CreateScrollViewByFather(bagScrollLayer, self.propLayer, cc.p(0, 0), cc.SCROLLVIEW_DIRECTION_VERTICAL, nil, true)
	self.bagItemScroll:setVisible(false)
	local propScrollWorldPos = self.bagEquipScroll:getParent():convertToWorldSpace(cc.p(self.bagEquipScroll:getPosition()))
	local propScrollViewSize = self.bagEquipScroll:getViewSize()
	
	local bagPropListOring = UserInfo:getUserInfo().data.bag_prop
	for i = 1, table.maxn(bagPropListOring) do
		local bagItem = CreateBagItem()
		bagItem:setItemType(BAG_ITEM_TYPE_THING)
		bagItem:setItemInfoTable(bagPropListOring[i])
		bagItem:setScrollViewRect(cc.rect(propScrollWorldPos.x, propScrollWorldPos.y, propScrollViewSize.width, propScrollViewSize.height))
		bagPropListOring[i].bagBtn = bagItem
		self.propLayer:addChild(bagItem)
	end
	-- ccdump(bagPropListOring[1],"aaaaaaa")
    setTagButtonState(true)
end

--刷新道具显示
function BagLayer:refreshPropLayer()
	local bagPropListOring = UserInfo:sortPropById()
	refreshPosition(self.propLayer, self.bagItemScroll, bagPropListOring)
	
	if self.oldPropCount ~= nil then
		local oldLinecount = math.ceil(self.oldPropCount/ LINE_MAX) 
		local newLinecount = math.ceil(table.maxn(bagPropListOring)/ LINE_MAX)
		local oldOffset = math.min(self.bagViewLayer:getContentSize().height - GRID_HEIGHT*oldLinecount)
		local newOffset = math.min(self.bagViewLayer:getContentSize().height - GRID_HEIGHT*newLinecount)
		if oldOffset ~= newOffset then
			self.bagItemScroll:setContentOffset(cc.p(0, self.bagItemScroll:getContentOffset().y + newOffset - oldOffset))
			self.oldPropCount = table.maxn(bagPropListOring)
		end
	else
		self.oldPropCount = table.maxn(bagPropListOring)
		local linecount = math.ceil(self.oldPropCount/ LINE_MAX) 
		self.bagItemScroll:setContentOffset(cc.p(0,math.min(self.bagViewLayer:getContentSize().height - GRID_HEIGHT*linecount)))
	end
	
end

--刷新装备显示
function BagLayer:refreshEquipLayer()
	refreshPosition(self.equipLayer, self.bagEquipScroll, self.equipList)
	if self.oldEquipCount ~= nil then
		local oldLinecount = math.ceil(self.oldEquipCount/ LINE_MAX) 
		local newLinecount = math.ceil(table.maxn(self.equipList)/ LINE_MAX)
		local oldOffset = math.min(self.bagViewLayer:getContentSize().height - GRID_HEIGHT*oldLinecount)
		local newOffset = math.min(self.bagViewLayer:getContentSize().height - GRID_HEIGHT*newLinecount)
		if oldOffset ~= newOffset then
			self.bagEquipScroll:setContentOffset(cc.p(0, self.bagEquipScroll:getContentOffset().y + newOffset - oldOffset))
			self.oldEquipCount = table.maxn(self.equipList)
		end
	else
		self.oldEquipCount = table.maxn(self.equipList)
		local linecount = math.ceil(self.oldEquipCount/ LINE_MAX) 
		self.bagEquipScroll:setContentOffset(cc.p(0,math.min(self.bagViewLayer:getContentSize().height - GRID_HEIGHT*linecount)))
	end
end

function BagLayer:RefreshBagScrollLayer()
	if self.isCreated == false and CommonBagLayer:isVisible() == false then
		return
	end
	
	--装备scroll刷新
	if self.selectedEquip then
		self:refreshEquipList()
		self:refreshEquipLayer()
	else
		--物品scroll刷新
		self:refreshPropLayer()
	end
end

function BagLayer:refreshEquipList(tag)
	if tag ~= nil and (tag < 1 or tag > 17) then
		return
	end
	if tag ~= nil then
		self.equipFilterSelectFlag = tag
	end

	local bagScrollLayer = BagLayerOwner["mBagScrollLayer"]
	local bagEquipList ={}
	local bagEquipListOring = UserInfo:getBagEquip()
	
	--筛选
    if self.equipFilterSelectFlag < 11 then
		for i=1,table.maxn(bagEquipListOring) do
			local propInfoTable =  EquipHelper:getStaticData(bagEquipListOring[i])
			if propInfoTable.place == self.equipFilterSelectFlag  then
				table.insert(bagEquipList,bagEquipListOring[i]) 
				bagEquipListOring[i].bagBtn:setVisible(true)
			else
				bagEquipListOring[i].bagBtn:setVisible(false)
			end
		end
    elseif self.equipFilterSelectFlag < 16 then
        local equipDataInfo = {}
        local colorValue =  self.equipFilterSelectFlag - 10
        for i=1,table.maxn(bagEquipListOring) do
            equipDataInfo = bagEquipListOring[i]
		    local color, equipGrader = EquipHelper:getEquipColor(equipDataInfo) 
            if  not EquipHelper:isRedEquip(equipDataInfo)  and equipGrader == colorValue then
                table.insert(bagEquipList,bagEquipListOring[i]) 
			    bagEquipListOring[i].bagBtn:setVisible(true)
            else
				bagEquipListOring[i].bagBtn:setVisible(false)
			end
        end
	elseif self.equipFilterSelectFlag == 16 then
		local equipDataInfo = {}
        for i=1,table.maxn(bagEquipListOring) do
            equipDataInfo = bagEquipListOring[i]
            if EquipHelper:isRedEquip(equipDataInfo) then
                table.insert(bagEquipList,bagEquipListOring[i]) 
			    bagEquipListOring[i].bagBtn:setVisible(true)
            else
				bagEquipListOring[i].bagBtn:setVisible(false)
			end
        end
		
    elseif self.equipFilterSelectFlag == 17 then
        for i=1,table.maxn(bagEquipListOring) do
			-- print(i)
            bagEquipListOring[i].bagBtn:setVisible(true)
        end
		bagEquipList = bagEquipListOring
    else
        for i=1,table.maxn(bagEquipListOring) do
            bagEquipListOring[i].bagBtn:setVisible(false)
        end
        bagEquipList = bagEquipListOring
    end
	table.sort(bagEquipList, sortForBag)
	self.equipList = bagEquipList
    self.selectEquipCount = table.maxn(bagEquipList)
	refrehBagCapCapbility()
end

--删除背包道具
function BagLayer:removePropFromBag(Id, count)
    -- print("removePropFromBag", Id, count, table.maxn(UserInfo:getUserInfo().data.bag_prop))
	local bagProp = UserInfo:getUserInfo().data.bag_prop
	for i = 1, table.maxn(bagProp) do
		-- print(i,Id,UserInfo:getUserInfo().data.bag_prop[i].id)
		if Id == bagProp[i].id then
			local findProp = bagProp[i]
			bagProp[i].amount = bagProp[i].amount - count
			-- print("find")
			if bagProp[i].amount <= 0 then
				self:RemoveItem(bagProp[i])
				table.remove(bagProp, i)
			else
				self:UpdateItem(bagProp[i])
			end
			return findProp
		end
	end
end

function BagLayer:RemoveItem(itemInfo)
	if itemInfo == nil or self.isCreated == false then
		return 
	end
	-- print("RemoveItem")
	if itemInfo.attr == nil or itemInfo.attr == CJSON_NULL or itemInfo.obj == 0 then
		if itemInfo.bagBtn ~= nil then
			removeSelf(itemInfo.bagBtn)
		end
	end
end

function BagLayer:AddNewItem(itemInfo)
	-- print("AddNewItem")
	if itemInfo == nil or self.isCreated == false then
		return 
	end
	
	if itemInfo.attr == nil or itemInfo.attr == CJSON_NULL then
		local bagItem = CreateBagItem()
		bagItem:setItemType(BAG_ITEM_TYPE_THING)
		bagItem:setItemInfoTable(itemInfo)
		itemInfo.bagBtn = bagItem
		bagItem:setPositionX(-100)
		self.propLayer:addChild(bagItem)
	elseif itemInfo.obj == 0 then
		local bagItem = CreateBagItem()
		bagItem:setItemType(BAG_ITEM_TYPE_EQUIP)
		bagItem:setItemInfoTable(itemInfo)
		itemInfo.bagBtn = bagItem
		bagItem:setPositionX(-100)
		self.equipLayer:addChild(bagItem)
	end
end

function BagLayer:UpdateItem(itemInfo)
	-- print("UpdateItem", itemInfo.prop_id)
	if itemInfo == nil or self.isCreated == false or itemInfo.bagBtn == nil then 
		return 
	end
	

	if itemInfo.attr == nil or itemInfo.attr == CJSON_NULL then
		local x,y = itemInfo.bagBtn:getPositionX(),itemInfo.bagBtn:getPositionY()
		removeSelf(itemInfo.bagBtn)
	
		local bagItem = CreateBagItem()
		bagItem:setItemType(BAG_ITEM_TYPE_THING)
		bagItem:setItemInfoTable(itemInfo)
		itemInfo.bagBtn = bagItem
		self.propLayer:addChild(bagItem)
		bagItem:setPosition(cc.p(x,y))
	elseif itemInfo.obj == 0 then
		local x,y = itemInfo.bagBtn:getPositionX(),itemInfo.bagBtn:getPositionY()
		removeSelf(itemInfo.bagBtn)
	
		local bagItem = CreateBagItem()
		bagItem:setItemType(BAG_ITEM_TYPE_EQUIP)
		bagItem:setItemInfoTable(itemInfo)
		itemInfo.bagBtn = bagItem
		self.equipLayer:addChild(bagItem)
		bagItem:setPosition(cc.p(x,y))
	end
end


local function onBagLayerEquipBtnClick()
	BagLayer.bagEquipScroll:setVisible(true)
	BagLayer.bagItemScroll:setVisible(false)

    setTagButtonState(true)

    BagLayerOwner["mBagLayerEquipFilter"]:setVisible(true)
    BagLayerOwner["mBagLayerBatchSell"]:setVisible(true)
    BagLayerOwner["mBagLayerEquipName"]:setVisible(true)
    BagLayerOwner["mBagLayerCapbility"]:setVisible(true)
    BagLayerOwner["mBagEnlargeBt"]:setVisible(true)
    BagLayerOwner["mboardCapacityBg"]:setVisible(true)
	
	--装备scroll刷新
	BagLayer:refreshEquipList()
	BagLayer:refreshEquipLayer()
end

local function onBagLayerThingBtnClick()
	BagLayer.bagEquipScroll:setVisible(false)
	BagLayer.bagItemScroll:setVisible(true)

    setTagButtonState(false)

    BagLayerOwner["mBagLayerEquipFilter"]:setVisible(false)
    BagLayerOwner["mBagLayerBatchSell"]:setVisible(false)
    BagLayerOwner["mBagLayerEquipName"]:setVisible(false)
    BagLayerOwner["mBagLayerCapbility"]:setVisible(false)
    BagLayerOwner["mBagEnlargeBt"]:setVisible(false)
    BagLayerOwner["mboardCapacityBg"]:setVisible(false)
	
	--物品scroll刷新
	BagLayer:refreshPropLayer()
end

local function onBagLayerEnlargeBtnClick()

    local function bagEnlargeCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
            local enlargeCount = 15 - (UserInfo.UserInfoTable.data.info.bagslots - 50)/10
            if enlargeCount <= 0 then
                CommonNote(MultiLan("GBL_externBag_1"))
            end
			return 
		end
        CommonNote(MultiLan("GBL_externBag_2"))
        UserInfo:setCash(UserInfo:getCash() - 100)
        UserInfo.UserInfoTable.data.info.bagslots = UserInfo.UserInfoTable.data.info.bagslots + 10
        refrehBagCapCapbility()
		GameGuide:SetBagFullEffect()
	end
	
	local function sendBagEnlarge()
        if UserInfo.UserInfoTable.data.info.bagslots >= 200 then
            CommonNote(MultiLan("GBL_externBag_1"))
        else
           HttpSend("shop/bagslot", {}, bagEnlargeCallback)
        end
	end

	if UserInfo.UserInfoTable.data.info.cash < 100 then
		CommonCashNeed()
	else
        local enlargeCount = 15 - (UserInfo.UserInfoTable.data.info.bagslots - 50)/10
        local content = cc.Label:create(MultiLan("GBL_externBag_3")..enlargeCount..MultiLan("CP_offlineReport_5"),
                 DefaultFontName, FontSize3,cc.size(460,160),0,1)

	    CreateSmallPopupWithCancel("expandbag",content, sendBagEnlarge)

	end
end

local function onBagLayerBatchSell()
	BagLayerOwner["mBagPopLayer"]:setVisible(true)
	BagLayerOwner["mBagBatchSellLayer"]:setVisible(true)
	BagLayerOwner["mBagFilterLayer"]:setVisible(false)
    local equipQualitys = 0 
    local equipDataInfo = {}
    local whiteCount = 0
    local greenCount = 0
    local blueCount = 0
    local pregeCount = 0
	local bagEquipListOring = UserInfo:getBagEquip()
	local color = nil
    for k=1,table.maxn(bagEquipListOring) do
      equipDataInfo = bagEquipListOring[k]
      if  not EquipHelper:isRedEquip(equipDataInfo)  then
          color,equipQualitys  = EquipHelper:getEquipColor(equipDataInfo) 
          if equipQualitys == 1  then
				whiteCount = whiteCount + 1
		  elseif equipQualitys == 2 then
				greenCount = greenCount + 1
		  elseif equipQualitys == 3 then
				blueCount = blueCount + 1
		  elseif equipQualitys == 4 then
				pregeCount = pregeCount + 1
		  end
      end
   end

   BagLayer.autoSellCount[1] = whiteCount
   BagLayer.autoSellCount[2] = greenCount
   BagLayer.autoSellCount[3] = blueCount
   BagLayer.autoSellCount[4] = pregeCount
   tolua.cast(BagLayerOwner["mBatchSellWhite"], "cc.Label"):setString(MultiLan("CD_equipColor_1").."*"..BagLayer.autoSellCount[1])
   tolua.cast(BagLayerOwner["mBatchSellGreen"], "cc.Label"):setString(MultiLan("CD_equipColor_2").."*"..BagLayer.autoSellCount[2])
   tolua.cast(BagLayerOwner["mBatchSellBlue"], "cc.Label"):setString(MultiLan("CD_equipColor_3").."*"..BagLayer.autoSellCount[3])
   tolua.cast(BagLayerOwner["mBatchSellPerge"], "cc.Label"):setString(MultiLan("CD_equipColor_4").."*"..BagLayer.autoSellCount[4])
end

local function onBagLayerEquipFilter()
	BagLayerOwner["mBagPopLayer"]:setVisible(true)
	BagLayerOwner["mBagBatchSellLayer"]:setVisible(false)
	BagLayerOwner["mBagFilterLayer"]:setVisible(true)


    local propInfoTable = {}
    local place1Count = 0
    local place2Count = 0
    local place3Count = 0
    local place4Count = 0
    local place5Count = 0
    local place6Count = 0
    local place7Count = 0
    local place8Count = 0
    local place9Count = 0
    local place10Count = 0

    local equipQualitys = 0 
    local whiteCount = 0
    local greenCount = 0
    local blueCount = 0
    local pregeCount = 0
    local orangeCount = 0
    local redCount = 0

    local bagEquipListOring = UserInfo:getBagEquip()
    for k=1,table.maxn(bagEquipListOring) do
      equipDataInfo = bagEquipListOring[k]
      propInfoTable = GameData:getPropDataTable(equipDataInfo.prop_id)

        if propInfoTable.place == 1  then
		    place1Count = place1Count + 1
	    elseif propInfoTable.place == 2 then
		     place2Count = place2Count + 1
	    elseif propInfoTable.place == 3 then
		    place3Count = place3Count + 1
        elseif propInfoTable.place == 4 then
		   place4Count = place4Count + 1
        elseif propInfoTable.place == 5 then
		   place5Count = place5Count + 1
        elseif propInfoTable.place == 6 then
		   place6Count = place6Count + 1
	    elseif propInfoTable.place == 7 then
		   place7Count = place7Count + 1
	    elseif propInfoTable.place == 8 then
		   place8Count = place8Count + 1
	    elseif propInfoTable.place == 9 then
		   place9Count = place9Count + 1
        elseif propInfoTable.place == 10 then
		   place10Count = place10Count + 1
        end 
        
		local color = nil
        if not EquipHelper:isRedEquip(equipDataInfo)  then
		  color,equipQualitys  = EquipHelper:getEquipColor(equipDataInfo) 
          if equipQualitys == 1  then
				whiteCount = whiteCount + 1
		  elseif equipQualitys == 2 then
				greenCount = greenCount + 1
		  elseif equipQualitys == 3 then
				blueCount = blueCount + 1
		  elseif equipQualitys == 4 then
				pregeCount = pregeCount + 1
          elseif equipQualitys == 5 then
				orangeCount = orangeCount + 1
		  end
        else
          redCount = redCount + 1
      end
   end

   BagLayer.equipFilterCount[1] = place1Count 
   BagLayer.equipFilterCount[2] = place2Count
   BagLayer.equipFilterCount[3] = place3Count
   BagLayer.equipFilterCount[4] = place4Count
   BagLayer.equipFilterCount[5] = place5Count
   BagLayer.equipFilterCount[6] = place6Count
   BagLayer.equipFilterCount[7] = place7Count
   BagLayer.equipFilterCount[8] = place8Count
   BagLayer.equipFilterCount[9] = place9Count
   BagLayer.equipFilterCount[10] = place10Count

   BagLayer.equipFilterCount[11] = whiteCount
   BagLayer.equipFilterCount[12] = greenCount
   BagLayer.equipFilterCount[13] = blueCount
   BagLayer.equipFilterCount[14] = pregeCount
   BagLayer.equipFilterCount[15] = orangeCount
   BagLayer.equipFilterCount[16] = redCount
   BagLayer.equipFilterCount[17] = table.maxn(UserInfo:getUserInfo().data.bag_equip)

   tolua.cast(BagLayerOwner["mBagEquipFilterOption1"], "cc.ControlButton"):
   setTitleForState(MultiLan( "equip_place_1").." * "..BagLayer.equipFilterCount[1],1)
   tolua.cast(BagLayerOwner["mBagEquipFilterOption2"], "cc.ControlButton"):
   setTitleForState(MultiLan( "equip_place_2").." * "..BagLayer.equipFilterCount[2],1)
   tolua.cast(BagLayerOwner["mBagEquipFilterOption3"], "cc.ControlButton"):
   setTitleForState(MultiLan( "equip_place_3").." * "..BagLayer.equipFilterCount[3],1)
   tolua.cast(BagLayerOwner["mBagEquipFilterOption4"], "cc.ControlButton"):
   setTitleForState(MultiLan( "equip_place_4").." * "..BagLayer.equipFilterCount[4],1)
   tolua.cast(BagLayerOwner["mBagEquipFilterOption5"], "cc.ControlButton"):
   setTitleForState(MultiLan( "equip_place_5").." * "..BagLayer.equipFilterCount[5],1)
   tolua.cast(BagLayerOwner["mBagEquipFilterOption6"], "cc.ControlButton"):
   setTitleForState(MultiLan( "equip_place_6").." * "..BagLayer.equipFilterCount[6],1)
   tolua.cast(BagLayerOwner["mBagEquipFilterOption7"], "cc.ControlButton"):
   setTitleForState(MultiLan( "equip_place_7").." * "..BagLayer.equipFilterCount[7],1)
   tolua.cast(BagLayerOwner["mBagEquipFilterOption8"], "cc.ControlButton"):
   setTitleForState(MultiLan( "equip_place_8").." * "..BagLayer.equipFilterCount[8],1)
   tolua.cast(BagLayerOwner["mBagEquipFilterOption9"], "cc.ControlButton"):
   setTitleForState(MultiLan( "equip_place_9").." * "..BagLayer.equipFilterCount[9],1)
   tolua.cast(BagLayerOwner["mBagEquipFilterOption10"], "cc.ControlButton"):
   setTitleForState(MultiLan( "equip_place_10").." * "..BagLayer.equipFilterCount[10],1)

   tolua.cast(BagLayerOwner["mBagEquipFilterColor1"], "cc.ControlButton"):setTitleForState(MultiLan("CD_equipColor_1").." * "..BagLayer.equipFilterCount[11],1)
   tolua.cast(BagLayerOwner["mBagEquipFilterColor2"], "cc.ControlButton"):setTitleForState(MultiLan("CD_equipColor_2").." * "..BagLayer.equipFilterCount[12],1)
   tolua.cast(BagLayerOwner["mBagEquipFilterColor3"], "cc.ControlButton"):setTitleForState(MultiLan("CD_equipColor_3").." * "..BagLayer.equipFilterCount[13],1)
   tolua.cast(BagLayerOwner["mBagEquipFilterColor4"], "cc.ControlButton"):setTitleForState(MultiLan("CD_equipColor_4").." * "..BagLayer.equipFilterCount[14],1)
   tolua.cast(BagLayerOwner["mBagEquipFilterColor5"], "cc.ControlButton"):setTitleForState(MultiLan("CD_equipColor_5").." * "..BagLayer.equipFilterCount[15],1)
   tolua.cast(BagLayerOwner["mBagEquipFilterColor6"], "cc.ControlButton"):setTitleForState(MultiLan("lan_artifact").." * "..BagLayer.equipFilterCount[16],1)
   tolua.cast(BagLayerOwner["mBagEquipFilterAll"], "cc.ControlButton"):setTitleForState(MultiLan("GBL_allEquip").." * "..BagLayer.equipFilterCount[17],1)
end

local function onBagEquipSell(button)

    local equipQuality =  tolua.cast(button, "cc.Node"):getTag()

    if  BagLayer.autoSellCount[equipQuality] < 1 then
	   CommonNote(MultiLan("GBL_sellEquip_1"))
       return
	end
	
	--判断是否全部镶嵌宝石
	local bagEquip = UserInfo:getBagEquip()
	local bAllHaveStone = true
	for i=1,table.maxn(bagEquip) do
		if EquipHelper:getEquipGrade(bagEquip[i]) == equipQuality and
		   (bagEquip[i].stone == CJSON_NULL or table.maxn(bagEquip[i].stone) == 0) then
			bAllHaveStone = false
			break
		end
	end
	if bAllHaveStone then
		CommonNote(MultiLan("GBL_sellEquip_2"))
		return
	end
	--判断是否全部锁定
	local bAllLocked = true
	for i=1,table.maxn(bagEquip) do
		if EquipHelper:getEquipGrade(bagEquip[i]) == equipQuality and
		   bagEquip[i].locked == 0 then
			bAllLocked = false
			break
		end
	end
	if bAllLocked then
		CommonNote(MultiLan("GBL_sellEquip_lock"))
		return
	end

	local function equipAutoSellCallback(jsonDataTable)
        if  jsonDataTable == CJSON_NULL  or jsonDataTable.ret ~= 0 then
            return
        end

        if jsonDataTable.data ~= CJSON_NULL then
            UserInfo:addProp(jsonDataTable.data.prop, true)

            if jsonDataTable.data.prop ~= CJSON_NULL then
                for i=1,table.maxn(jsonDataTable.data.prop) do
                    if jsonDataTable.data.prop[i].prop_id == 100003 then
                        CommonNote(MultiLan("GEML_return")..jsonDataTable.data.prop[i].num.." "..MultiLan("prop_name_"..jsonDataTable.data.prop[i].prop_id),COLOR_YELLOW)
                    end
                end
            end

			for k=1,table.maxn(jsonDataTable.data.sell) do
				UserInfo:removeEquipByIdAndObj(jsonDataTable.data.sell[k],0)
				-- cclog("jsonDataTable.data.sell[k] is "..jsonDataTable.data.sell[k])
				UserAttr:compareAaEquipScore(jsonDataTable.data.sell[k])
			end
        end
        
        BagLayerOwner["mBagPopLayer"]:setVisible(false)
	    BagLayerOwner["mBagBatchSellLayer"]:setVisible(false)
		BagLayer.oldEquipCount = nil
        BagLayer:RefreshBagScrollLayer()
	end

    if equipQuality > 0  and equipQuality < 5 then
        equipQuality = equipQuality-1
	    HttpSend("item/autosell", {"quality=" .. equipQuality}, equipAutoSellCallback)
    end
end

local function onBagBatchSellClose()
	BagLayerOwner["mBagPopLayer"]:setVisible(false)
end

local function onBagFilterClose()
	BagLayerOwner["mBagPopLayer"]:setVisible(false)
end

local function onBagFilterOptionClick(button)
	-- cclog("onBagFilterOptionClick %d", tolua.cast(button, "cc.Node"):getTag())
	BagLayer:refreshEquipList(tolua.cast(button, "cc.Node"):getTag())

    BagLayer:refreshEquipLayer()
    onBagFilterClose()
end

local function onBagFilterColorClick(button)
	-- cclog("onBagFilterColorClick %d", tolua.cast(button, "cc.Node"):getTag())
	BagLayer:refreshEquipList(tolua.cast(button, "cc.Node"):getTag() + 10)

    BagLayer:refreshEquipLayer()
    onBagFilterClose()
end

local function onBagFilterAll()
	-- cclog("onBagFilterAll")
	BagLayer:refreshEquipList(17)
    BagLayer:refreshEquipLayer()
    onBagFilterClose()
end

BagLayer["onBagLayerEquipBtnClick"] = onBagLayerEquipBtnClick
BagLayer["onBagLayerThingBtnClick"] = onBagLayerThingBtnClick
BagLayer["onBagLayerEnlargeBtnClick"] = onBagLayerEnlargeBtnClick
BagLayer["onBagLayerBatchSell"] = onBagLayerBatchSell
BagLayer["onBagLayerEquipFilter"] = onBagLayerEquipFilter
BagLayer["onBagEquipSell"] = onBagEquipSell
BagLayer["onBagBatchSellClose"] = onBagBatchSellClose
BagLayer["onBagFilterOptionClick"] = onBagFilterOptionClick
BagLayer["onBagFilterColorClick"] = onBagFilterColorClick
BagLayer["onBagFilterAll"] = onBagFilterAll
BagLayer["onBagFilterClose"] = onBagFilterClose