NextPvepassId = nil  --下一场战斗的id
bFightWithBoss = 0
ArnerFightId = 0
ArnerFightRank = 0
BattleMapTitle = nil
NextFightLabel = nil
BattleTalkButton = nil
ExpPerHour = nil
local battleInited = false
local FightLayer = nil
local ShowedFightData = {nil,nil,nil,nil,nil,nil}
local fightRound = 0
local roundTag   = 0
local LeftActor = {}
local RightActor = {}
local POS_FIGHT_MIDDLE = cc.p(320, 110)
local POS_FIGHT_DOWN   = cc.p(320, 60)
local FightStepData = nil
local battleRequestData = nil
local fightType = 1  --1为pve 2为pvp
local battleRequestBack = true

local RESET_FIGHT_WAIT = 3
local BACK_TO_LOGIN_WAIT = 3600

--战斗状态
BATTLE_NONE  = 0   --等待激活状态
BATTLE_FIGHT = 1   --播放战报
BATTLE_REST  = 2   --休息中
BATTLE_QUEST = 3   --请求战报
BattleState = nil
BattleCountdown = 0 --倒计时计数  BATTLE_FIGHT

--倒计时
TimeBegin = nil
CountdownTimerArr = {}

--文本区
local ShowedRichTex = {}
BattleDescLayer        = nil
BattleDescScrollView   = nil
CurrentPosition        = nil

--创建战斗角色
function CreateBattleActor(typeStr, actortype)
	return require("lua/BattleActor").new(typeStr, actortype)
end

--初始化战斗界面
function InitFightLayer()
	-- print("InitFightLayer")
	FightLayer:removeAllChildren(true)
	FightActor = {{},{}}

	--切换地图
	local gameflag = FightStepData.a[2][1].t
	if gameflag == 2 then
		--pve
		-- cclog("--------pve----------")
		XiaLayerOwner["fight_map"]:setSpriteFrame("map_pve.png")
	elseif gameflag == 4 and GameData:getMonster(FightStepData.a[2][1].i).pass_id ~= 0 then
		--普通图
		-- cclog("--------pvp----------")
		XiaLayerOwner["fight_map"]:setSpriteFrame("map_pvp.png")
	elseif gameflag == 4 and GameData:getMonster(FightStepData.a[2][1].i).pass_id == 0 then
		--boss
		-- cclog("--------pvp_boss----------")
		XiaLayerOwner["fight_map"]:setSpriteFrame("map_pvp_boss.png")
	end


	for i=1, 2 do
		local height = 230
		for j=1,table.maxn(FightStepData.a[i]) do
			local actorInfo = FightStepData.a[i][j]
			local actor = nil
			if i==1 then
				actor = CreateBattleActor("left", actorInfo.t)
				actor:setAnchorPoint(cc.p(0,1))
				if actorInfo.t == 3 or (actorInfo.t == 4 and GameData:getMonster(actorInfo.i).pass_id ~= 0) then
					actor:setScale(0.7)
					actor:setPosition(cc.p(50, height))
					height = height - 70
				else
					actor:setPosition(cc.p(60, height))
					height = height - 90
				end
			else
				actor = CreateBattleActor("right", actorInfo.t)
				-- cclog("------------------------actorInfo.t is "..actorInfo.t)
				actor:setAnchorPoint(cc.p(1,1))
				-- print(actorInfo.t, actorInfo.i)
				if actorInfo.t == 3 or (actorInfo.t == 4 and GameData:getMonster(actorInfo.i).pass_id ~= 0)then
					actor:setScale(0.7)
					actor:setPosition(cc.p(640-50, height))
					height = height - 70
				else
					if actorInfo.t == 4 then
						actor:setActorBoss()
					end
					actor:setPosition(cc.p(640-60, height))
					height = height - 90
				end
			end
			
			
			actor:setMaxHp(actorInfo.h)
			actor:setMaxSp(actorInfo.m)
			if actorInfo.t == 1 or actorInfo.t == 2 then
				local head = SetMyHead(actorInfo.i,actorInfo.s,1)
				actor:setHead(head)
				actor:setLevelAndName(actorInfo.l, actorInfo.n)
			elseif actorInfo.t == 3 then
				actor:setHead("hero_circle_icon_"..GameData:getHeroRoleData(actorInfo.i).role..".png")
				actor:setLevelAndName(actorInfo.l, MultiLan(actorInfo.n))
			elseif actorInfo.t == 4 then
				actor:setHead("monster_"..actorInfo.i..".png")
				actor:setLevelAndName(actorInfo.l, MultiLan(actorInfo.n))
			end
			
			
			FightLayer:addChild(actor)
			table.insert(FightActor[i], actor)
		end
	end

	
	
	--遭遇敌人描述
	local richText = createBattleRichText()
	for i=1, table.maxn(FightStepData.a[2]) do
		richText:pushBackElement(ccui.RichElementText:create(3*i-2, COLOR_WHITE,255 , MultiLan("GBLa_findEnemy")..FightStepData.a[2][i].l.." ",DefaultFontName,FontSize2))
		if FightStepData.a[2][i].t == 2 then
			richText:pushBackElement(ccui.RichElementText:create(3*i-1, COLOR_BLUE ,255 ,FightStepData.a[2][i].n,DefaultFontName,FontSize2))
		else
			richText:pushBackElement(ccui.RichElementText:create(3*i-1, COLOR_BLUE ,255 ,MultiLan(FightStepData.a[2][i].n),DefaultFontName,FontSize2))
		end
		richText:pushBackElement(ccui.RichElementText:create(3*i, COLOR_WHITE ,255 ,"(HP:"..FightStepData.a[2][i].h..")",DefaultFontName,FontSize2))
		richText:pushBackElement(ccui.RichElementNewLine:create())
	end
	AddDescContent(richText, richText:getTextMaxHeight())
	--AddDescContent(richText, table.maxn(FightStepData.a[2])*richText:getContentSize().height)

	--初始化战斗数据
	fightRound = 1
	roundTag = 1
end

--注册一个倒计时
function registTimer(lTime, label, callback, bKuohao)
	table.insert(CountdownTimerArr, {leftTime = lTime, timeLabel = label, timeupCallBack = callback, extra = bKuohao})
end

--通用战斗描述
local function AddAttackDesc(round, actor1, color1, actor2, color2, skill, skillColor, attackType, value, extra)
	--1伤害 2回血 3回蓝 4技能吸血 5眩晕 6冰冻 7对自己使用
	local richText = createBattleRichText()
	
	local width = 0
	local battleFontSize = FontSize3
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE,255 ,"["..round.."]",DefaultFontName, battleFontSize))
	width = width + GetWidth("["..round.."]", battleFontSize)
	richText:pushBackElement(ccui.RichElementText:create(2, color1     ,255 ,actor1     ,DefaultFontName, battleFontSize))
	width = width + GetWidth(actor1, battleFontSize)
	if attackType < 4 then
		richText:pushBackElement(ccui.RichElementText:create(3, COLOR_BLACK ,255 ,MultiLan("GBLa_battleDesc_1")     ,DefaultFontName, battleFontSize))
		width = width + GetWidth(MultiLan("GBLa_battleDesc_1"), battleFontSize)
		richText:pushBackElement(ccui.RichElementText:create(4, skillColor  ,255 ,skill      ,DefaultFontName, battleFontSize))
		width = width + GetWidth(skill, battleFontSize)
		if attackType == 1 then
			richText:pushBackElement(ccui.RichElementText:create(5, COLOR_BLACK  ,255 ,MultiLan("GBLa_battleDesc_2")      ,DefaultFontName, battleFontSize))
			width = width + GetWidth(MultiLan("GBLa_battleDesc_2"), battleFontSize)
		else
			richText:pushBackElement(ccui.RichElementText:create(5, COLOR_BLACK  ,255 ,MultiLan("GBLa_battleDesc_3")      ,DefaultFontName, battleFontSize))
			width = width + GetWidth(MultiLan("GBLa_battleDesc_3"), battleFontSize)
		end
		richText:pushBackElement(ccui.RichElementText:create(6, color2      ,255 ,actor2     ,DefaultFontName, battleFontSize))
		width = width + GetWidth(actor2, battleFontSize)
		if attackType == 1 then
			richText:pushBackElement(ccui.RichElementText:create(7, COLOR_BLACK  ,255 ,MultiLan("GBLa_battleDesc_4")    ,DefaultFontName, battleFontSize))
			width = width + GetWidth(MultiLan("GBLa_battleDesc_4"), battleFontSize)
		else
			richText:pushBackElement(ccui.RichElementText:create(7, COLOR_BLACK  ,255 ,MultiLan("GBLa_battleDesc_5")    ,DefaultFontName, battleFontSize))
			width = width + GetWidth(MultiLan("GBLa_battleDesc_5"), battleFontSize)
		end
		richText:pushBackElement(ccui.RichElementText:create(8, COLOR_RED  ,255 ,math.abs(value)     ,DefaultFontName, battleFontSize))
		width = width + GetWidth(math.abs(value), battleFontSize)

		if attackType == 1 then
			richText:pushBackElement(ccui.RichElementText:create(9, COLOR_BLACK  ,255 ,MultiLan("GBLa_battleDesc_6")    ,DefaultFontName, battleFontSize))
			width = width + GetWidth(MultiLan("GBLa_battleDesc_6"), battleFontSize)
		elseif attackType == 2 then
			richText:pushBackElement(ccui.RichElementText:create(9, COLOR_BLACK  ,255 ,MultiLan("GBLa_battleDesc_7")    ,DefaultFontName, battleFontSize))
			width = width + GetWidth(MultiLan("GBLa_battleDesc_7"), battleFontSize)
		elseif attackType == 3 then
			richText:pushBackElement(ccui.RichElementText:create(9, COLOR_BLACK  ,255 ,MultiLan("GBLa_battleDesc_8")    ,DefaultFontName, battleFontSize))
			width = width + GetWidth(MultiLan("GBLa_battleDesc_8"), battleFontSize)
		end
	elseif attackType == 4 then
		richText:pushBackElement(ccui.RichElementText:create(3, COLOR_BLACK  ,255 ,MultiLan("GBLa_battleDesc_9")    ,DefaultFontName, battleFontSize))
		richText:pushBackElement(ccui.RichElementText:create(4, COLOR_RED  ,255 , math.abs(value)     ,DefaultFontName, battleFontSize))
		richText:pushBackElement(ccui.RichElementText:create(5, COLOR_BLACK  ,255 ,MultiLan("GBLa_battleDesc_7")    ,DefaultFontName, battleFontSize))
	elseif attackType == 7 then
		richText:pushBackElement(ccui.RichElementText:create(3, COLOR_BLACK  ,255 ,MultiLan("GBLa_battleDesc_10")    ,DefaultFontName, battleFontSize))
		richText:pushBackElement(ccui.RichElementText:create(4, COLOR_BLACK  ,255 ,MultiLan("GBLa_battleDesc_11")    ,DefaultFontName, battleFontSize))
	elseif attackType == 8 then
		richText:pushBackElement(ccui.RichElementText:create(3, COLOR_BLACK  ,255 ,MultiLan("GBLa_battleDesc_10")    ,DefaultFontName, battleFontSize))
		richText:pushBackElement(ccui.RichElementText:create(4, COLOR_BLACK  ,255 ,MultiLan("GBLa_battleDesc_12")    ,DefaultFontName, battleFontSize))
	elseif attackType == 5 then
		richText:pushBackElement(ccui.RichElementText:create(3, COLOR_BLACK  ,255 ,MultiLan("GBLa_battleDesc_2")      ,DefaultFontName, battleFontSize))
		richText:pushBackElement(ccui.RichElementText:create(4, color2      ,255 ,actor2     ,DefaultFontName, battleFontSize))
		richText:pushBackElement(ccui.RichElementText:create(5, COLOR_BLACK ,255 ,MultiLan("GBLa_battleDesc_1")     ,DefaultFontName, battleFontSize))
		richText:pushBackElement(ccui.RichElementText:create(6, skillColor  ,255 ,skill      ,DefaultFontName, battleFontSize))
	elseif attackType == 6 then
		richText:pushBackElement(ccui.RichElementText:create(3, COLOR_BLACK  ,255 ,MultiLan("GBLa_battleDesc_14")      ,DefaultFontName, battleFontSize))
	end
		
	if extra ~= nil then
		richText:pushBackElement(ccui.RichElementText:create(10, COLOR_BLACK  ,255 ,extra   ,DefaultFontName, battleFontSize))
		width = width + GetWidth(extra, battleFontSize)
	end

	AddDescContent(richText, richText:getTextMaxHeight())
	--[[
	if width > 570 then
		AddDescContent(richText, 2*richText:getContentSize().height)
	else
		AddDescContent(richText, richText:getContentSize().height)
	end
	]]
end

function FightEnd()
	-- print("FightEnd", battleRequestData.w)
	if battleRequestData.win == 1 then
		--胜利
		-- local sprite = CreateCommonSprite("battle_win.png", POS_FIGHT_MIDDLE)
		-- local sprite = CreateCommonFntLabel(ZGMultiLan("battle_value_win"), FntTypeUserTitle, POS_FIGHT_MIDDLE)
		local sprite = CreateCommonLabel(ZGMultiLan("battle_value_win"), POS_FIGHT_MIDDLE, FontSize4, COLOR_FNT_UserTilte)
		sprite:runAction(cc.Sequence:create(cc.ScaleTo:create(0.5,1.2), cc.DelayTime:create(0.5),cc.CallFunc:create(removeSelf)))
		FightLayer:addChild(sprite)
	elseif battleRequestData.win == 0 then
		--失败
		
		local sprite = CreateCommonLabel(ZGMultiLan("battle_value_dead"), POS_FIGHT_MIDDLE, FontSize4, COLOR_FNT_CommonDisableGray)
		sprite:runAction(cc.Sequence:create(cc.ScaleTo:create(0.5,1.2), cc.DelayTime:create(0.5),cc.CallFunc:create(removeSelf)))
		FightLayer:addChild(sprite)
	end

	BattleState = BATTLE_REST
end

--战斗步进   战斗动画和文字描述
local function FightStep()
	if table.maxn(FightStepData.b) == 0 then
		BattleState = BATTLE_REST
		return
	end
	-- print("FightStep",roundTag, fightRound,battleRequestData)
	if roundTag > table.maxn(FightStepData.b[fightRound]) then
		roundTag = 1
		fightRound = fightRound + 1
		if fightRound > table.maxn(FightStepData.b) then
			FightEnd()
		end
		return
	end
	
	local fightInfo = FightStepData.b[fightRound][roundTag]
	--print("FightStep", "fightRound",fightRound,"roundTag",roundTag,"r=",fightInfo.r,"m=",fightInfo.m,"h=",fightInfo.h,"k=",fightInfo.k,"i=",fightInfo.i,"n=",fightInfo.n,"o=",fightInfo.o,
			--"s=",fightInfo.s,"e=",fightInfo.e,"t=",fightInfo.t,"v=",fightInfo.v,"x=",fightInfo.x,"f=",fightInfo.f)

	local bNeedDesc = false
	local descType = 1 --1伤害 2回血 3回蓝 4技能吸血 ５纯ｂｕｆｆ　6跳过 7眩晕 8 冰冻   9-4
	local actor1 = FightActor[fightInfo.k+1][fightInfo.i]

	local actor2 = nil
	if fightInfo.n ~= nil and fightInfo.o ~= nil then
		actor2 = FightActor[fightInfo.n+1][fightInfo.o]
	end

	local color1 = nil
	local color2 = nil
	if fightInfo.k + 1 == 1 then
		color1 = cc.c3b(0 ,100 ,192)
		color2 = cc.c3b(210,0 ,255)
	else
		color1 = cc.c3b(210,0 ,255)--COLOR_PURPLE
		color2 = cc.c3b(0 ,100 ,192)
	end
	local skill  = MultiLan("GBLa_battleNorAtk")
	local skillColor = COLOR_BLACK
	local attackType = 1
	local extra = ""
	local value = 0
--[[
				k:0					//队伍编号
				i:1					//队员编号
				r:-20					//optional buff掉血
				h:50					//optional 回合前回复生命值
				m:20				//optional 回合前回复魔法值
				t:1					//1普通攻击  4暴击
				n:1					//目标队伍编号
				o:1					//目标队员的编号
				z:{w , b ,c}                //自己
				v:100				//攻击的伤害值
				y:                  // 技能吸血量 
				b:1					//optional buff类型
				c:3					//optional buff回合
				f:-50					//optional 当对手有反伤时，掉的血量
				x:30					//optional 当有吸血属性时，吸取的血量
				d:1					//optional 是否死亡

	]]
	if fightInfo.r ~= nil then
		actor1:hpChange(fightInfo.r[1].v)

		
		--更新buff
		actor1:deleteState(fightInfo.r[1].i)
		table.remove(fightInfo.r, 1)
		
		if table.maxn(fightInfo.r) == 0 then
			fightInfo.r = nil
		end
	elseif fightInfo.h ~= nil then
		actor1:hpChange(fightInfo.h)
		fightInfo.h = nil
	elseif fightInfo.m ~= nil then
		-- print("fightInfo.m",fightInfo.m)
		actor1:spChange(fightInfo.m)
		fightInfo.m = nil
	elseif fightInfo.s ~= nil or fightInfo.t ~= nil then
		bNeedDesc = true
		
		--技能
		value = fightInfo.v
		if fightInfo.s ~= nil then
			local skillInfo = GameData:getSkill(fightInfo.s)
			skill = " "..MultiLan(skillInfo.name).." " 
			skillColor = cc.c3b(7,152,0)--cc.c3b(255,252,0)
			descType = fightInfo.e
			if fightInfo.e == 4 then
				descType = 1
				fightInfo.e = 9
			else
				if fightInfo.e == 9 then
					value = fightInfo.y
					actor1:hpChange(fightInfo.y)
					descType = 4
				end
				
				if fightInfo.p ~= nil then
					actor1:useSkill(fightInfo.p)
					fightInfo.p = nil
				end
				fightInfo.s = nil
			end
		end
		
		if fightInfo.t ~= nil then
			actor1:ReduceRound(fightRound)
			if fightInfo.b ~= nil then
				actor2:AddState(fightInfo.b, fightInfo.c)
				actor2:updateState()
			end
			
			if fightInfo.z ~= nil then
				for i=1,table.maxn(fightInfo.z) do
					if fightInfo.z[i].w == 1 then
						actor1:AddState(fightInfo.z[i].b, fightInfo.z[i].c)
						actor1:updateState()
					else
						actor2:AddState(fightInfo.z[i].b, fightInfo.z[i].c)
						actor2:updateState()
					end
				end
			end
		end
		
		
		if fightInfo.t == 2 then
			extra = "("..MultiLan("lan_dodge")..")"
		elseif fightInfo.t == 3 then
			extra =  "("..MultiLan("lan_critical")..")"
		elseif fightInfo.t == 4 then
			descType = 7
		elseif fightInfo.t == 5 then
			descType = 8
		elseif fightInfo.t == 6 then
			descType = 6
		end
		
		if descType == 3 then
			actor2:spChange(fightInfo.v)
		elseif descType == 1 or descType == 2 then
			local damage = fightInfo.v
			if fightInfo.l ~= nil and descType == 1 then
				damage = fightInfo.v + fightInfo.l
				extra = extra..MultiLan("GBLa_battleDesc_13")..fightInfo.l..MultiLan("GBLa_battleDesc_6")
				fightInfo.l = nil
				if fightInfo.u ~= nil then
					actor2:spChange(0-fightInfo.u)
					fightInfo.u = nil
				end
			end
			
			if fightInfo.t == 3 then
				actor2:hpChange(damage, true)
			elseif fightInfo.t == 2 then
				actor2:noteMiss()
			else
				actor2:hpChange(damage)
			end
		end
		
		fightInfo.t = nil
	elseif fightInfo.x ~= nil then
		actor1:hpChange(fightInfo.x)
		fightInfo.x = nil
	elseif fightInfo.f ~= nil then
		actor1:hpChange(fightInfo.f)
		fightInfo.f = nil
	end

	if bNeedDesc then
		if actor2 == nil then
			AddAttackDesc(fightRound, actor1.name, color1, "", color2, skill, skillColor, descType, value, extra)
		else
			AddAttackDesc(fightRound, actor1.name, color1, actor2.name, color2, skill, skillColor, descType, value, extra)
		end
	end
	
	if fightInfo.s == nil and fightInfo.t == nil and fightInfo.x == nil and fightInfo.f == nil then
		roundTag = roundTag + 1
	end
end

--休息
local function BattleRest()
	-- print("BattleRest", BattleCountdown)
	if BattleCountdown <=0 or BattleCountdown == nil then
		BattleCountdown = 1
	end
	
	--中间
	FightRest(BattleCountdown)
	
	local battleFontSize = FontSize3
	--战斗结算文字
	local richText = createBattleRichText()
	
	local expColor = cc.c3b(210,64,0)
	local goldColor = cc.c3b(210,64,0)
	if battleRequestData.expinfo ~= nil and battleRequestData.expinfo.levelup > 0 then
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_BLACK, 255 ,MultiLan("GBLa_battleResult_1")..battleRequestData.expinfo.level,DefaultFontName,battleFontSize))
		richText:pushBackElement(ccui.RichElementNewLine:create())
	end
	
	if battleRequestData.win == 0 then
		if FightStepData.s == 1 then
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_BLACK, 255 ,MultiLan("GBLa_battleResult_2"),DefaultFontName,battleFontSize))
		else
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_BLACK, 255 ,MultiLan("GBLa_battleResult_3"),DefaultFontName,battleFontSize))
		end
		richText:pushBackElement(ccui.RichElementNewLine:create())
		
		if fightType == 1 then
			GameGuide:pveFailedPopup()
		end
	else
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_BLACK, 255 ,MultiLan("GBLa_battleResult_4"),DefaultFontName,battleFontSize))
		richText:pushBackElement(ccui.RichElementNewLine:create())
	
		if battleRequestData.exp ~= nil then
			richText:pushBackElement(ccui.RichElementText:create(1, expColor, 255 ,MultiLan("CP_offlineReport_8")..battleRequestData.exp,DefaultFontName,battleFontSize))
			richText:pushBackElement(ccui.RichElementNewLine:create())
		end
		
		if battleRequestData.gold ~= nil then
			richText:pushBackElement(ccui.RichElementText:create(1, goldColor, 255 ,MultiLan("CP_offlineReport_11")..battleRequestData.gold,DefaultFontName,battleFontSize))
			richText:pushBackElement(ccui.RichElementNewLine:create())
		end

		--获得道具
		--减调宝箱获得道具
		
		DeleteBoxItems(battleRequestData.items, battleRequestData.box_item)
		
		if battleRequestData.items ~= nil then
			for i=1,table.maxn(battleRequestData.items) do
				if battleRequestData.items[i].prop_id ~= PROP_ID_GOLD then
					local propData = GameData:getPropDataTable(battleRequestData.items[i].prop_id)
					if propData.ptype ~= 7 and battleRequestData.items[i].num > 0 then
						richText:pushBackElement(ccui.RichElementText:create(1, EQUIP_COLOR_ARR[propData.color], 255 ,MultiLan("lan_get")..MultiLan(propData.name)..": "..battleRequestData.items[i].num,DefaultFontName,battleFontSize))
						richText:pushBackElement(ccui.RichElementNewLine:create())
					end
				end
			end
		end
		
		--获得装备
		if battleRequestData.items ~= nil then
			for i=1,table.maxn(battleRequestData.items) do
				local propData = GameData:getPropDataTable(battleRequestData.items[i].prop_id) 
				if propData.ptype == 7 then
					richText:pushBackElement(ccui.RichElementText:create(1, COLOR_BLACK, 255 ,MultiLan("GBLa_battleResult_6"),DefaultFontName,battleFontSize))
					richText:pushBackElement(ccui.RichElementText:create(1, EquipHelper:getEquipColor(battleRequestData.items[i].obj), 255 ,"[Lv"..propData.level.." "..MultiLan(propData.name).."]",DefaultFontName,battleFontSize))
					richText:pushBackElement(ccui.RichElementNewLine:create())
				end
			end
		end

		if battleRequestData.sell ~= nil and battleRequestData.sell ~= CJSON_NULL then 
			local bSellEquip = false
			for i=1, 5 do
				if battleRequestData.sell[i] > 0 then
					bSellEquip = true
					richText:pushBackElement(ccui.RichElementText:create(1, COLOR_BLACK,255 ,MultiLan("GBLa_battleResult_7"),DefaultFontName,battleFontSize))
					richText:pushBackElement(ccui.RichElementText:create(1, EQUIP_COLOR_ARR[i],255 ,EQUIP_NAME_ARR[i],DefaultFontName,battleFontSize))
					richText:pushBackElement(ccui.RichElementNewLine:create())
				end
			end
			
			if battleRequestData.sellgold ~= nil and bSellEquip then
				richText:pushBackElement(ccui.RichElementText:create(1, goldColor,255 ,MultiLan("GBLa_battleResult_8")..battleRequestData.sellgold,DefaultFontName,battleFontSize))
				richText:pushBackElement(ccui.RichElementNewLine:create())
			end
		end
		
		BattleAddBoxDesc(battleRequestData, richText, battleFontSize)
	end
	
	AddDescContent(richText, richText:getTextMaxHeight())
	
	local width = 0
	richText = createBattleRichText()
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_BLACK,255 ,MultiLan("GBLa_battleResult_9"),DefaultFontName,battleFontSize))
	width = width + GetWidth(MultiLan("GBLa_battleResult_9"), battleFontSize)
	local re = CreateCommonLabel("("..BattleCountdown..")", nil, battleFontSize)
	re:setColor(COLOR_WHITE)
	re:disableEffect()
	registTimer(BattleCountdown, re, nil, true)
	
	AddDescContent(richText, richText:getTextMaxHeight())
	--AddDescContent(richText, richText:getContentSize().height)
	AddDescContent(re, width, true)
	BattleCountdown = 10
end

--等待服务器
local function BattleWaitForServer(waitTime)
	FightRest(waitTime)

	local richText = createBattleRichText()
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_BLACK,255 ,MultiLan("GBLa_battleResult_10"),DefaultFontName,FontSize2))
	local width = GetWidth(MultiLan("GBLa_battleResult_10"), FontSize2)
	local re = CreateCommonLabel("("..waitTime..")",nil,FontSize2)
	re:setColor(COLOR_WHITE)
	re:disableEffect()
	registTimer(waitTime, re, nil, true)

	AddDescContent(richText, richText:getTextMaxHeight())
	AddDescContent(re, width, true)
end

--每秒执行一次
function UpdateBattleTime()
	local newTime = os.time()
	local passTime = newTime - TimeBegin 
	
	local function delayLogout()
		DevicePlatform:getInstance():logout()
		gameEntrance()
	end
	--CommonNote(""..TimeBegin.." "..newTime)
	if passTime <= 0 then
		return
	elseif passTime > BACK_TO_LOGIN_WAIT then
		--CommonNote(""..passTime, COLOR_RED)
		local tmpSprite = cc.Sprite:createWithSpriteFrameName("pic_loading.png")
		tmpSprite:runAction(cc.RepeatForever:create(cc.RotateBy:create(2, -360)))
		CommonCreatePopup(tmpSprite)
		scheduler:unscheduleScriptEntry(EnergyTimeSchedulerEntry)
		CommonMapLayer:runAction(cc.Sequence:create(cc.DelayTime:create(1.2),cc.CallFunc:create(delayLogout)))
		return
	elseif passTime > RESET_FIGHT_WAIT then
		if BattleState == BATTLE_FIGHT then
			FightEnd()
			return
		end
	end
	TimeBegin = newTime
	--TimeBegin
	local deleteTable = {}
	for k, v in ipairs(CountdownTimerArr) do
		if v.leftTime > 0 then
			v.leftTime = v.leftTime - passTime

			if v.timeLabel ~= nil then
				if v.extra then
					v.timeLabel:setString("("..math.max(0, v.leftTime)..")")
				else
					v.timeLabel:setString(math.max(0, v.leftTime))
				end
			end
			
			if v.leftTime <=0 and (v.leftTime + passTime) > 0 and v.timeupCallBack ~= nil then
				v.timeupCallBack()
				table.insert(deleteTable,k)
				-- print("deleteTable",k)
			end
		end
	end
	
	local index = 0
	for i=1,table.maxn(deleteTable) do
		table.remove(CountdownTimerArr, deleteTable[i]-index)
		index = index + 1
	end
	--
	if BattleState == BATTLE_NONE then
		return
	end
	
	if BattleState == BATTLE_FIGHT then
		BattleCountdown = BattleCountdown - 1
		FightStep()
		
	elseif BattleState == BATTLE_REST then
		BattleRest()
		
		BattleState = BATTLE_NONE
	elseif BattleState == BATTLE_QUEST then
		local function pveFightCallback(jsonDataTable)
			-- print(pveFightCallback)
			if jsonDataTable.ret ~= 0 then
				-- cclog("take on equip failed %d", jsonDataTable.ret)
				return 
			end
			if jsonDataTable.data.newToken == 1 then
				setHeroTNote(true)
			end
			--前后端同步处理
			if jsonDataTable.data.sync ~= nil then
				if jsonDataTable.data.sync.feed ~= nil and jsonDataTable.data.sync.feed ~= CJSON_NULL then
					if jsonDataTable.data.sync.feed.mail == 1 then
						setMailNote(true)
					end
				end
				
				if jsonDataTable.data.sync.reset ~= nil and jsonDataTable.data.sync.reset ~= CJSON_NULL then
					local userinfo = UserInfo:getUserInfo().data.info
					for k,v in pairs(jsonDataTable.data.sync.reset) do
						if UserSelfInfo[k] ~= nil then
							UserSelfInfo[k] = v
						end
						
						if k == "hero_star" then
							HeroLayerInit()
						end
					end
				end
				
				if UserSelfInfo.regdays > 8 and ACT_TYPE_NEW ~= 0 and Activity_ActArr[ACT_TYPE_NEW] ~= nil then
					Activity_ActArr[ACT_TYPE_NEW] = nil
				end
					
				if jsonDataTable.data.sync.profit ~= nil and jsonDataTable.data.sync.profit ~= CJSON_NULL and UserActiveInfo.profit ~= nil then
					UserActiveInfo.profit = jsonDataTable.data.sync.profit
				end
				
				if jsonDataTable.data.sync.daily_pay ~= nil and jsonDataTable.data.sync.daily_pay ~= CJSON_NULL and ACT_TYPE_DAILY ~= 0 then
					Activity_ActArr[ACT_TYPE_DAILY].info.accpay = jsonDataTable.data.sync.daily_pay.accpay
					Activity_ActArr[ACT_TYPE_DAILY].canReward = IsDailyCanReward(Activity_ActArr[ACT_TYPE_DAILY].info)
					if Activity_ActArr[ACT_TYPE_DAILY].canReward == false and Activity_ActArr[ACT_TYPE_DAILY].noteNode ~= nil then
						removeSelf(Activity_ActArr[ACT_TYPE_DAILY].noteNode)
					end
				end
				
				
				if jsonDataTable.data.sync.daily_lottery ~= nil and jsonDataTable.data.sync.daily_lottery ~= CJSON_NULL and ACT_TYPE_DAILY ~= 0 then
					Activity_ActArr[ACT_TYPE_ZHUAN].info.left = jsonDataTable.data.sync.daily_lottery.left
					Activity_ActArr[ACT_TYPE_ZHUAN].canReward = IsDailyCanReward(Activity_ActArr[ACT_TYPE_ZHUAN].info)
					GameGuide:setActButtonNote()
				end
				
				if jsonDataTable.data.sync.accpay ~= nil and jsonDataTable.data.sync.accpay ~= CJSON_NULL and ACT_TYPE_PAY_TEMP ~= 0  then
					Activity_ActArr[ACT_TYPE_PAY_TEMP].info.countdown = jsonDataTable.data.sync.accpay.countdown
					Activity_ActArr[ACT_TYPE_PAY_TEMP].info.accpay = jsonDataTable.data.sync.accpay.accpay
					TimeDown:setTimeInfo(Activity_ActArr[ACT_TYPE_PAY_TEMP].timerId, Activity_ActArr[ACT_TYPE_PAY_TEMP].info.countdown)
				end
			end
			
			battleRequestBack = true
			NextFightLabel:setVisible(false)
			battleRequestData = jsonDataTable.data
			fightType = 1
			if jsonDataTable.data.wait > 0 then
				BattleWaitForServer(jsonDataTable.data.wait)
				BattleState = BATTLE_NONE
				if jsonDataTable.data.no_boss_num ~= nil then
					CommonNote(MultiLan("GBLa_noBossTime"))
					bFightWithBoss = 0
				end
			else
				local t = battleRequestData.status
				if bFightWithBoss == 0 then
					SetFightData({t.num, math.ceil(3600/t.num), t.wrate, t.erate, t.exp, t.gold})
				end
				if battleRequestData.offline ~= nil and battleRequestData.offline.items ~= nil then
					UserAttr:SetUserLevelInfo(battleRequestData.offline.expinfo)
					UserInfo:addProp(battleRequestData.offline.items)
					DeleteBattleKey(battleRequestData.offline.open_box_num)
					-- OutlinePopup("offlinereport", battleRequestData.offline, UserSelfInfo.last_passid)
					OutlinePopup(ZGMultiLan("offlinereport"), battleRequestData.offline, UserSelfInfo.last_passid)
				end
				
				-- print("pveFightCallback",battleRequestData.win)
				if battleRequestData.win > 0 then
					UserAttr:SetUserLevelInfo(battleRequestData.expinfo)
					if UserInfo:addProp(battleRequestData.items) then
						BagLayer:RefreshBagScrollLayer()
					end
					DeleteBattleKey(battleRequestData.open_box_num)
					if battleRequestData.new_pass ~= nil then
						UserPveInfo.id = battleRequestData.new_pass.id 
						NextPvepassId = UserPveInfo.id
						NextFightLabel:setVisible(false)
						BattleMapTitle:setString(MultiLan(GameData:getPass(NextPvepassId).name))
						setQuestByType(QUEST_TYPE_PASS)
					end
					if bFightWithBoss > 0 then
						UserSelfInfo.boss_num = UserSelfInfo.boss_num - 1
					end
				end
				bFightWithBoss = 0
				FightStepData = battleRequestData.log
				InitFightLayer()
				
				-- local sprite = CreateCommonSprite("battle_start.png", POS_FIGHT_MIDDLE)
				-- local sprite = CreateCommonFntLabel(ZGMultiLan("battle_value_start"), FntTypeUserTitle, POS_FIGHT_MIDDLE)
				local sprite = CreateCommonLabel(ZGMultiLan("battle_value_start"), POS_FIGHT_MIDDLE, FontSize4, COLOR_FNT_UserTilte)
				sprite:runAction(cc.Sequence:create(cc.ScaleTo:create(0.5,1.2), cc.DelayTime:create(0.5),cc.CallFunc:create(removeSelf)))
				FightLayer:addChild(sprite)
				
				BattleState = BATTLE_FIGHT
				if battleRequestData.status.num <= 0 then
					BattleCountdown = 30
				else
					BattleCountdown = math.ceil(3600/battleRequestData.status.num)
				end
				-- print("BattleCountdown2",BattleCountdown)
			end
		end
		
		local function pvpFightCallback(jsonDataTable)
			-- print(pvpFightCallback)
			if jsonDataTable.ret ~= 0 then
				-- cclog("pvpFightCallback failed %d", jsonDataTable.ret)
				return 
			end
			battleRequestBack = true
			
			if jsonDataTable.data.status == 1 then
				CommonNote(MultiLan("GBLa_EnemyNoChng"), COLOR_RED)
				ArnerFightId = 0
				NextFightLabel:setVisible(false)
				BattleState = BATTLE_NONE
				BattleWaitForServer(3)
				BattleCountdown = 10
				return
			end
			
			ArnerFightRank = 0
			ArnerFightId = 0
			UserArenaInfo.num = UserArenaInfo.num - 1
			NextFightLabel:setVisible(false)
			battleRequestData = jsonDataTable.data
			fightType = 2
			battleRequestData.exp = 0
			battleRequestData.gold = 0

			FightStepData = battleRequestData.log
			InitFightLayer()
				
			-- local sprite = CreateCommonSprite("battle_start.png", POS_FIGHT_MIDDLE)
			-- local sprite = CreateCommonFntLabel(ZGMultiLan("battle_value_start"), FntTypeUserTitle, POS_FIGHT_MIDDLE)
			local sprite = CreateCommonLabel(ZGMultiLan("battle_value_start"), POS_FIGHT_MIDDLE, FontSize4, COLOR_FNT_UserTilte)
			sprite:runAction(cc.Sequence:create(cc.ScaleTo:create(0.5,1.2), cc.DelayTime:create(0.5),cc.CallFunc:create(removeSelf)))
			FightLayer:addChild(sprite)
				
			BattleState = BATTLE_FIGHT
			BattleCountdown = 30
		end
		
		if NetWorkLock == false and battleRequestBack then
			battleRequestBack = false
			if ArnerFightId == 0 then
				if bFightWithBoss == 0 then
					HttpSend("pve/fight", {"id="..NextPvepassId,"boss="..bFightWithBoss}, pveFightCallback)
				else
					HttpSend("pve/fight", {"id="..bFightWithBoss,"boss=1"}, pveFightCallback)
				end
			else
				HttpSend("arena/fight", {"fuid="..ArnerFightId,"rank="..ArnerFightRank}, pvpFightCallback)
			end
		end
	end
end

--初始化战报文本区
function BattleDescInit()
	local layer = cc.Layer:create()
	layer:setContentSize(cc.size(585, 450))
	BattleDescLayer = layer
	CurrentPosition = 445
	CurrentSize     = 450
	
	BattleDescScrollView = CreateScrollViewByFather(XiaLayerOwner["mBattleDescScrollLayer"], layer, cc.p(0, 0),kScrollViewDirectionVertical)
	BattleDescScrollView:setTouchEnabled(false)
end

function CommonBattleLayerInit()
	if battleInited then
		return
	end
	battleInited = true
	cc.SpriteFrameCache:getInstance():addSpriteFrames("ccb/ccbResources/MonsterIcon.plist")
	cc.SpriteFrameCache:getInstance():addSpriteFrames("ccb/ccbResources/MapIcon.plist")
	
	--聊天按钮
	-- BattleTalkButton = CreateCommonButton("button_talkout.png", cc.p(590,566), cc.size(55,55), onMainTalk)
	-- XiaLayerOwner["mBattleDownLayer"]:addChild(BattleTalkButton)
	local mSpBtnTalkout = XiaLayerOwner["mSpBtnTalkout"]
	BattleTalkButton = CreateCommonButton("button_talkout.png", cc.p(mSpBtnTalkout:getPositionX(), mSpBtnTalkout:getPositionY()), mSpBtnTalkout:getContentSize(), onMainTalk)
	mSpBtnTalkout:getParent():addChild(BattleTalkButton)
	mSpBtnTalkout:removeFromParent()

	XiaLayerOwner["mBattleMapLabel"]:setString(MultiLan("GBLa_battleBttn_1"))
	-- XiaLayerOwner["mBattleMapButton"]:setTitleForState(MultiLan("GBLa_battleBttn_1"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mBattleCountLabel"]:setString(MultiLan("GBLa_battleBttn_2"))
	XiaLayerOwner["mBattleSetLabel"]:setString(MultiLan("GBLa_battleBttn_3"))
	XiaLayerOwner["mBattleQuickLabel"]:setString(MultiLan("GBLa_battleBttn_4"))
	CommonMoveLabelUnderBtn(XiaLayerOwner["mBattleMapButton"], XiaLayerOwner["mBattleMapLabel"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mBattleCountButton"], XiaLayerOwner["mBattleCountLabel"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mBattleSetButton"], XiaLayerOwner["mBattleSetLabel"])
	CommonMoveLabelUnderBtn(XiaLayerOwner["mBattleFastFightButton"], XiaLayerOwner["mBattleQuickLabel"])
	XiaLayerOwner["mFightDataLayer"]:setVisible(false)

	NextPvepassId = UserSelfInfo.last_passid
	--UserInfo:getUserInfo().data.pve.id
	-- print("NextPvepassId", NextPvepassId)

	FightLayer = XiaLayerOwner["mFightLayer"]

	--屏蔽层 屏蔽地图界面按钮
	local function onBattleSwallowTouch(touch, event)
		-- print("onBattleSwallowTouchEnded")
		return true
	end
	SetTouchEventForLayer(XiaLayerOwner["mBattleLayer"], onBattleSwallowTouch)
	
	--数据区
	XiaLayerOwner["mFightDesc1"]:setString(MultiLan("GBLa_fastBttl_1"))
	XiaLayerOwner["mFightDesc2"]:setString(MultiLan("GBLa_fastBttl_2"))
	XiaLayerOwner["mFightDesc3"]:setString(MultiLan("GBLa_fastBttl_3"))
	XiaLayerOwner["mFightDesc4"]:setString(MultiLan("GBLa_fastBttl_4"))
	XiaLayerOwner["mFightDesc5"]:setString(MultiLan("GBLa_fastBttl_5"))
	XiaLayerOwner["mFightDesc6"]:setString(MultiLan("GBLa_fastBttl_6"))

	--XiaLayerOwner["mFightDesc7"]:setSwallowTouch(false)
	local function onFightDataTouchEnded(touch, event)
		-- print("onFightDataTouchEnded")
		XiaLayerOwner["mFightDataLayer"]:setVisible(false)
		return true
	end
	SetTouchEventForLayer(XiaLayerOwner["mFightDataLayer"], onFightDataTouchEnded)
	SetFightData()

	
	BattleState = BATTLE_QUEST
	TimeBegin = os.time()
	if UserSelfInfo.name == "5001" or  UserSelfInfo.name == "5002" or  UserSelfInfo.name == "5003" then
		EnergyTimeSchedulerEntry = scheduler:scheduleScriptFunc(UpdateBattleTime, 1, false)
	else
		EnergyTimeSchedulerEntry = scheduler:scheduleScriptFunc(UpdateBattleTime, 1, false)
	end
	--OutlinePopup({exp=123,gold=123456,lnum=100,wnum=900,time=3321,expinfo={exp=1,level=12,levelup=1},equip_num={0,0,0,0,0},sell={1,2,3,4,5}})
	--创建战报文本区
	BattleDescInit()
	
	--副本标题
	BattleMapTitle = XiaLayerOwner["mBattleMapName"]
	BattleMapTitle:setString(MultiLan(GameData:getPass(NextPvepassId).name))
	
	--接下来挑战
	NextFightLabel = XiaLayerOwner["mNextFightLabel"]
	NextFightLabel:setColor(COLOR_RED)
	NextFightLabel:setString("")
	NextFightLabel:setPosition(cc.p(320, 740))
end

function BattleEnter()
	-- print("BattleEnter")
	CommonBattleLayerInit()
end

--地图按钮点击
function onBattleMap()
	-- print("onBattleMap")
	GameGuide:handStepClick(22, XiaLayerOwner["mBattleMapButton"])
	CommonBattleLayer:setVisible(false)
	CommonTitleLayer:setVisible(true)
	SetMapRichTextNote(true)
	UpdateMapInfo()
	
	GameGuide:GuideEnter(GUIDE_TYPE_MAP)
end

function getActivityDay()
	if UserSelfInfo.regdays > 8 and UserActiveInfo ~= nil and UserActiveInfo.profit ~= nil then
		return UserActiveInfo.profit
	else 
		return UserSelfInfo.regdays
	end
end

--设置战斗统计数据
function SetFightData(dataTable)
	local baseString = {MultiLan("GBLa_fastBttl_7"),MultiLan("GBLa_fastBttl_8"),MultiLan("GBLa_fastBttl_9"),MultiLan("GBLa_fastBttl_10"), MultiLan("GBLa_fastBttl_7"), MultiLan("GBLa_fastBttl_7")}
	local nowActDay = getActivityDay()
	if nowActDay == 1 or nowActDay == 2 then
		baseString[4] = MultiLan("GBLa_fastBttl_11")
	elseif nowActDay == 3 then
		baseString[6] = MultiLan("GBLa_fastBttl_12")
	elseif nowActDay == 4 then
		baseString[5] = MultiLan("GBLa_fastBttl_12")
	end
	
	local goodColor = COLOR_GREEN
	local badColor  = COLOR_RED
	local normalColor  = COLOR_WHITE
	
	if dataTable == nil then
		for i=1, 6 do
			XiaLayerOwner["mFightData"..i]:setString("--")
			XiaLayerOwner["mFightData"..i]:setColor(normalColor)
		end

		XiaLayerOwner["mFightDesc7"]:setString("")
		return
	end
	ExpPerHour = dataTable[5]
	for i=1, 6 do
		if ShowedFightData[i] == nil or ShowedFightData[i] == dataTable[i] then
			XiaLayerOwner["mFightData"..i]:setColor(normalColor)
		else
			if ShowedFightData[i] < dataTable[i] then
				if i == 2 then
					XiaLayerOwner["mFightData"..i]:setColor(badColor)
				else
					XiaLayerOwner["mFightData"..i]:setColor(goodColor)
				end
			else
				if i == 2 then
					XiaLayerOwner["mFightData"..i]:setColor(goodColor)
				else
					XiaLayerOwner["mFightData"..i]:setColor(badColor)
				end
			end
		end

		XiaLayerOwner["mFightData"..i]:setString(string.format(baseString[i], dataTable[i]))
		ShowedFightData[i] = dataTable[i]
	end
	
	local needExp = GameData:getGameDataTable()["exp"][UserSelfInfo.level].exp - UserSelfInfo.exp
	local hour = needExp/dataTable[5]
	local day = math.floor(hour/24)
	hour = hour - 24 * day
	local minute = math.floor((hour - math.floor(hour)) * 60)
	hour = math.floor(hour)
	if day == 0 and hour == 0 and minute == 0 then
		minute = 1 
	end
	
	local str = MultiLan("GBLa_remindTime_1")..(UserSelfInfo.level+1)..string.format(MultiLan("GBLa_remindTime_2"),tostring(needExp))
	if day>=1 then
		str = str..MultiLan("GBLa_remindTime_3")
	else
		str = str..MultiLan("GBLa_remindTime_4")
		if day ~= 0 then
			str = str..day.." "..MultiLan("lan_day") .. " "
		end
		if hour ~= 0 then
			str = str..hour.." "..MultiLan("lan_hour") .. " "
		end
		if minute ~= 0 then
			str = str..minute.." "..MultiLan("lan_minute") .. " "
		end
	end
	XiaLayerOwner["mFightDesc7"]:setScale(0.8)
	XiaLayerOwner["mFightDesc7"]:setColor(cc.c3b(150,230,221))
	XiaLayerOwner["mFightDesc7"]:setString(str)
end

function onBattleCount()
	XiaLayerOwner["mFightDataLayer"]:setVisible(not XiaLayerOwner["mFightDataLayer"]:isVisible())
end

--战斗设置 点击
function onBattleSetting()
	BattleSetting:BattleSettingEnter()
end

--快速战斗 点击
function onBattleQuick()
	local function quickFightCallback(jsonDataTable) 
		if jsonDataTable.ret ~= 0 then
			-- cclog("quickFightCallback failed %d", jsonDataTable.ret)
			return 
		end
		
		--扣除钻石 减少次数
		UserSelfInfo.cash = UserSelfInfo.cash - jsonDataTable.data.cash
		UseCash(jsonDataTable.data.cash)
		UserSelfInfo.fast_fight = jsonDataTable.data.fast_fight

		--经验
		UserAttr:SetUserLevelInfo(jsonDataTable.data.expinfo)

		--添加物品
		UserInfo:addProp(jsonDataTable.data.items)
		
		--快速战斗结果
		DeleteBattleKey(jsonDataTable.data.open_box_num)
		OutlinePopup("battlefast", jsonDataTable.data, NextPvepassId)
	end
		
	local cost = GameData:getGameDataTable().consume[UserSelfInfo.fast_fight+1].fast_fight
	local function sendQuickFight()
		if UserVipInfo.fast_fight <= UserSelfInfo.fast_fight then
			local richText = ccui.RichText:create()
			richText:ignoreContentAdaptWithSize(false)
			richText:setContentSize(cc.size(460,100))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GBLa_fastBttlCount_1"), DefaultFontName, FontSize2))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_YELLOW, 255 ,MultiLan("lan_vip")..UserSelfInfo.vip, DefaultFontName, FontSize2))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GBLa_fastBttlCount_2"), DefaultFontName, FontSize2))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 ,GameData:getGameDataTable().vip[UserVipInfo.level+1].fast_fight, DefaultFontName, FontSize2))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CP_offlineReport_5"), DefaultFontName, FontSize2))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GBLa_fastBttlCount_3"), DefaultFontName, FontSize2))
			richText:pushBackElement(ccui.RichElementNewLine:create())
			if UserVipInfo.level < VIP_LEVEL_MAX then
				richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GBLa_fastBttlCount_4"), DefaultFontName, FontSize2))
				richText:pushBackElement(ccui.RichElementText:create(1, COLOR_YELLOW, 255 ,MultiLan("lan_vip")..(UserSelfInfo.vip+1), DefaultFontName, FontSize2))
				richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GBLa_fastBttlCount_2"), DefaultFontName, FontSize2))
				richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 ,GameData:getGameDataTable().vip[UserVipInfo.level+2].fast_fight, DefaultFontName, FontSize2))
				richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("CP_offlineReport_5"), DefaultFontName, FontSize2))
			end
			if UserSelfInfo.vip ~= VIP_LEVEL_MAX then
				CreateSmallPopupWithPay("prompt", richText)
			else
				CommonNote("次数已用尽")
			end
		elseif UserSelfInfo.cash < cost then
			CommonCashNeed()
		else
			HttpSend("pve/fast", {"id="..NextPvepassId}, quickFightCallback)
		end	
	end
	
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setContentSize(cc.size(460,70))
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GBLa_fastBttlCount_6"), DefaultFontName, FontSize3))
	
	if nowActDay == 8 then
		richText:pushBackElement(ccui.RichElementText:create(1, EQUIP_COLOR_ARR[4], 255 , cost.."/2="..math.floor(cost/2), DefaultFontName, FontSize3))
		cost = math.floor(cost/2)
	else
		richText:pushBackElement(ccui.RichElementText:create(1, EQUIP_COLOR_ARR[4], 255 , cost, DefaultFontName, FontSize3))
	end
	if nowActDay == 5 then
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ," " .. MultiLan("prop_name_100001"), DefaultFontName, FontSize3))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GBLa_fastBttlCount_7"), DefaultFontName, FontSize3))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GBLa_fastBttlCount_8"), DefaultFontName, FontSize3))
	else
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ," " .. MultiLan("prop_name_100001")..MultiLan("GBLa_fastBttlCount_9"), DefaultFontName, FontSize3))
	end
	local color = COLOR_GREEN
	if UserVipInfo.fast_fight-UserSelfInfo.fast_fight <= 0 then
		color = COLOR_RED
	end
	richText:pushBackElement(ccui.RichElementText:create(1, color, 255 ,MultiLan("GBLa_fastBttlCount_10")..UserVipInfo.level..MultiLan("GBLa_fastBttlCount_11")..(UserVipInfo.fast_fight-UserSelfInfo.fast_fight)..MultiLan("CP_offlineReport_5")..MultiLan("GBLa_fastBttlCount_12"), DefaultFontName, FontSize4))
	CreateSmallPopupWithCancel("battlefast", richText, sendQuickFight)
	GameGuide:GuideEnter(GUIDE_TYPE_FASTFIGHT)
end

--切换挂机地图
function ChangeGuajiPass(passId)
	
end

--添加内容
function AddDescContent(content, height, bNotRichText)
	if table.maxn(ShowedRichTex) > 20 then
		for i=1, table.maxn(ShowedRichTex) - 20 do
			removeSelf(ShowedRichTex[1])
			table.remove(ShowedRichTex,1)
		end
	end

	content:setAnchorPoint(cc.p(0,1))
	content:setPositionY(CurrentPosition)
	BattleDescLayer:addChild(content)
	table.insert(ShowedRichTex, content)
	if bNotRichText then
		content:setAnchorPoint(cc.p(0,0.4))
		content:setPositionX(height)
	else
		CurrentPosition = CurrentPosition - height
		local CurrentSize     = 450 + math.max(0, 0 - CurrentPosition) 
		BattleDescLayer:setContentSize(585, CurrentSize)
		BattleDescScrollView:setContentOffset(cc.p(0, math.max(0, 0- CurrentPosition+20)))
	end
end

function createBattleRichText()
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setAnchorPoint(cc.p(0, 1))
    richText:setContentSize(cc.size(575, 25))
	richText:setPositionX(-285)
	
	return richText
end

--战斗倒计时
function FightRest(restTime)
	local label = cc.LabelBMFont:create(restTime, "ccb/ccbResources/countdown_number.fnt")
	label:setPosition(POS_FIGHT_MIDDLE)
	FightLayer:addChild(label)
	local search = CreateCommonLabel(ZGMultiLan("battle_value_search"), POS_FIGHT_DOWN, FontSize4, COLOR_FNT_UserTilte)
 	-- local search = CreateCommonFntLabel(ZGMultiLan("battle_value_search"), FntTypeUserTitle, POS_FIGHT_DOWN)
	FightLayer:addChild(search)
	local function timeup()
		removeSelf(label)
		removeSelf(search)
		BattleState = BATTLE_QUEST
		NextFightLabel:setVisible(false)
	end
	registTimer(restTime, label, timeup)
end