GameData = class("GameData")
GameData.__index = GameData

GameData.infoTable = nil

function GameData:setGameDataTable(infoTable)
	GameData.infoTable = infoTable
end

function GameData:getGameDataTable()
	return GameData.infoTable
end

function GameData:getPropDataTable(ID)
	if ID == nil then
		cclog("getPropDataTable id nil")
		return 
	end
	for i = 1, table.maxn(GameData.infoTable.prop) do
		if (GameData.infoTable.prop[i].id == ID) then
			--cclog("v id " .. GameData.infoTable.prop[i].id)
			return GameData.infoTable.prop[i]
		end
	end
	cclog("prop not found %d", ID)
	return nil
end

--副本数据
function GameData:getPass(id)
	return self.infoTable.pass[id-1000]
end

--怪物数据
function GameData:getMonster(id)
	return searchBinById(self.infoTable.monster, id)
end

--技能数据
function GameData:getSkill(skillId)
	return searchBinById(self.infoTable.skill, skillId)
end

--获取角色数据
function GameData:getRoleDataById(id)
	return FindFirstByKey(self.infoTable.hero, "id", id)
end

--获取玩家角色数据
function GameData:getUserRoleData(role)
	for i=1, table.maxn(self.infoTable.hero) do
		if self.infoTable.hero[i].htype == 1 and self.infoTable.hero[i].role == role then
			return self.infoTable.hero[i]
		end
	end
end

--获取护法角色数据
function GameData:getHeroRoleData(id)
	for i=1, table.maxn(self.infoTable.hero) do
		if self.infoTable.hero[i].htype == 2 and self.infoTable.hero[i].id  == id then
			return self.infoTable.hero[i]
		end
	end
end
--获取羽毛数据
function GameData:getWingsByLevelAndRole( level ,role )
	for i=1, table.maxn(self.infoTable.wings) do
		if self.infoTable.wings[i].lv == level and self.infoTable.wings[i].role == role then
			return self.infoTable.wings[i]
		end
	end
end
function GameData:getStoneUpGradeByLevel(stoneLevel)
	for i=1, table.maxn(self.infoTable.stone_upgrade) do
		if self.infoTable.stone_upgrade[i].level == stoneLevel then
			return self.infoTable.stone_upgrade[i]
		end
	end
end

function GameData:getPropDataTableByLevel(place,ptype,level)
	for i = 1, table.maxn(GameData.infoTable.prop) do
		if GameData.infoTable.prop[i].place == place  and GameData.infoTable.prop[i].ptype == ptype and GameData.infoTable.prop[i].level == level  then
			return GameData.infoTable.prop[i]
		end
	end
	return nil
end

function GameData:getHeroStarTable(role, level)
	return self.infoTable.hero_star["role_"..role]
end

function GameData:getQuest(id)
	return searchArrayById(self.infoTable.quest,id)
end

function GameData:getFamilyBoss(id)
	return searchBinById(self.infoTable.union_boss,id)
end

function GameData:getMailMsg(mailMsgKey)
    return nil
end

