EquipMeltLayer = class("EquipMeltLayer")
EquipMeltLayer.__index = EquipMeltLayer

EquipMeltLayer.topNode = nil

ccb["EquipMeltLayer"] = EquipMeltLayer
EquipMeltLayerOwner = EquipMeltLayerOwner or {}
ccb["EquipMeltLayerOwner"] = EquipMeltLayerOwner
EquipMeltLayer.meltItemTable = {}
EquipMeltLayer.meltEquipDataTable = {}
EquipMeltLayer.msgString  = "123"
MELTEQUIP_MAX = 6
--//////////////////////////////////////////////////////

function EquipMeltLayerAutoSelectItem()
    EquipMeltLayer:EquipMeltLayerClearItem()
    if NetWorkLock == true then
       return
    end
    local equipCount  = 0
    local equipDetailInfo = nil
	local bagEquipList = UserInfo:getBagEquip()
	table.sort(bagEquipList, sortByGradeAndScore)
	local index = table.maxn(bagEquipList)
	
    while index > 0 do
        equipDetailInfo = bagEquipList[index]
        if not EquipHelper:isRedEquip(equipDetailInfo) and (equipDetailInfo.stone == CJSON_NULL or table.maxn(equipDetailInfo.stone) == 0) and equipDetailInfo.locked == 0  then
           table.insert(EquipMeltLayer.meltEquipDataTable, equipDetailInfo)
           equipCount = equipCount +1 
           if equipCount >= MELTEQUIP_MAX then
              break
           end
        end  
        index = index - 1
    end
	if table.maxn(EquipMeltLayer.meltEquipDataTable) == 0 then
		CommonNote(MultiLan("GEML_noMeltEquip"))
	else
		EquipMeltLayer:EquipMeltLayerRefreshItem()
	end
end

function EquipMeltLayer:EquipMeltLayerClearItem()
	for i = 1, MELTEQUIP_MAX do
		EquipMeltLayer.meltItemTable[i]:setItemType(BAG_ITEM_TYPE_EMPTY_MELTEQUIP)
		EquipMeltLayer.meltItemTable[i]:setItemInfoTable({place=i})
	end
	
     EquipMeltLayer.meltEquipDataTable={}
end

function EquipMeltLayer:EquipMeltLayerRemoveItem(itemInfo)
	for i = 1, MELTEQUIP_MAX do
		if self.meltEquipDataTable[i] == itemInfo then
			self.meltEquipDataTable[i] = nil
		end
	end

	self:EquipMeltLayerRefreshItem()
end

function EquipMeltLayerCreatItem()
	for i = 1, MELTEQUIP_MAX do
		EquipMeltLayer.meltItemTable[i] = CreateBagItem()
		EquipMeltLayer.meltItemTable[i]:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
		EquipMeltLayer.meltItemTable[i]:setTag(i)
		tolua.cast(EquipMeltLayerOwner["mEquipMeltItemLayer" .. i], "cc.Node"):addChild(EquipMeltLayer.meltItemTable[i])
	end
    EquipMeltLayer:EquipMeltLayerClearItem()
end

function EquipMeltLayer:EquipMeltLayerRefreshItem()
	for i = 1, MELTEQUIP_MAX do
		if self.meltEquipDataTable[i] ~= nil then
			self.meltItemTable[i]:setItemType(BAG_ITEM_TYPE_MELTEQUIP)
			self.meltItemTable[i]:setItemInfoTable(self.meltEquipDataTable[i])
		else
			self.meltItemTable[i]:setItemType(BAG_ITEM_TYPE_EMPTY_MELTEQUIP)
			self.meltItemTable[i]:setItemInfoTable({place=i})
		end
	end
end

function EquipMeltLayer:refreshEquipMeltValue()
	tolua.cast(EquipMeltLayerOwner["mMeltValue"], "cc.Label"):setString(MultiLan("GEFL_currentForge")..UserInfo:getUserInfo().data.info.fusion)
end

function InitEquipMeltLayer()
	--swallowLaer
	local function onEquipMeltSwallowTouch(touch, event)
		EquipMeltLayer: EquipMeltLayerExit()
		return true
	end
	SetTouchEventForLayer(EquipMeltLayerOwner["mEquipMeltSwallowLayer"], onEquipMeltSwallowTouch)
	SetTouchEventForLayer(EquipMeltLayerOwner["mMeltBackLayer"], TouchSwallow)
	
    --MeltValue
	EquipMeltLayer:refreshEquipMeltValue()
end

function EquipMeltLayer:EquipMeltLayerExit()
	-- print("EquipMeltLayer:EquipMeltLayerExit")
	self.topNode:removeFromParent()
	self.topNode = nil
end

function EquipMeltLayer:EquipMeltLayerEnter()
    if self.topNode ~= nil then
        return
    end

	local proxy = cc.CCBProxy:create()
	self.topNode = CCBReaderLoad("ccb/EquipMeltLayer.ccbi",proxy,EquipMeltLayerOwner)
	if POPUP_LAYER ~= nil then
	    POPUP_LAYER:addChild(self.topNode)
		InitEquipMeltLayer()
		EquipMeltLayerCreatItem()
	end
	
	--ccb多语言
	EquipMeltLayerOwner["mButtonMakeNormal"]:setTitleForState(MultiLan("melt_make_normal"), 1)
	EquipMeltLayerOwner["mButtonMakeSpe"]:setTitleForState(MultiLan("melt_make_spe"), 1)
	EquipMeltLayerOwner["mButtonMelt"]:setTitleForState(MultiLan("melt_melt"), 1)
	EquipMeltLayerOwner["btnBatchMelt"]:setTitleForState(MultiLan("melt_melt1"), 1)
	EquipMeltLayerOwner["mButtonAuto"]:setTitleForState(MultiLan("melt_auto"), 1)
	EquipMeltLayerOwner["mTitleEquipMelt"]:setString(ZGMultiLan("equip_melt_title"))
	
	GameGuide:GuideEnter(GUIDE_TYPE_FORGE)
end

local function onNormalForgeBtnClick()
	local function equipForgeCallback(jsonDataTable)
        if  jsonDataTable == CJSON_NULL then
            return
        end
		
		if jsonDataTable.ret ~= 0 then
			-- cclog("take on equip failed %d", jsonDataTable.ret)
			return 
		end
 
		local shopid = jsonDataTable.data.info.id
        if shopid ~= 1 then
			return
		end

        if jsonDataTable.data.info.list ~= CJSON_NULL then
		   EquipForgeLayer:EquipForgeLayerEnter(jsonDataTable.data)
        end
	end
	
	HttpSend("shop/info", {"id=1"}, equipForgeCallback)
end

function onSpecialForgeBtnClick()

	local function specialForgeCallback(jsonDataTable)
        if jsonDataTable.data ~= CJSON_NULL then
		   SpecialForgeLayer:SpecialForgeLayerEnter(jsonDataTable.data)
        end
	end
	
	HttpSend("equip/makeinfo", {}, specialForgeCallback)
end

function onAutoSelectBtnClick()
	EquipMeltLayerAutoSelectItem()
end

function onEquipMeltBtnClick()
	local hasEquip = false
	for i=1,MELTEQUIP_MAX do
		if EquipMeltLayer.meltEquipDataTable[i] ~= nil then
			hasEquip = true 
			break
		end
	end
    if hasEquip == false then
	   CommonNote(MultiLan("GEML_selectMeltEquip"))
       return
	end

	local function equipMeltCallback(jsonDataTable)
        if  jsonDataTable == CJSON_NULL then
            return
        end
		if jsonDataTable.ret ~= 0 then
			-- cclog("take on equip failed %d", jsonDataTable.ret)
			return 
		end
		
		if jsonDataTable.data.fusion_ids ~= nil then
			for i=1,table.maxn(jsonDataTable.data.fusion_ids) do
				 UserInfo:removeEquipByIdAndObj(jsonDataTable.data.fusion_ids[i],0)
			end
		end

		local fusion = jsonDataTable.data.fusion
		if fusion > 0 then
			CommonNote(string.format(MultiLan("GEML_getFusion"),tostring(fusion)))
		end
        UserInfo:addMeltFusion(fusion)

		UserInfo:addProp(jsonDataTable.data.items)
		local noteArr = {}
		local colorArr = {}
        local propdetailInfo = nil
		local propDetailName = ""
        if jsonDataTable.data.items ~= CJSON_NULL then
            for i=1,table.maxn(jsonDataTable.data.items) do
                propdetailInfo = GameData:getPropDataTable(jsonDataTable.data.items[i].prop_id)
				propDetailName = MultiLan(propdetailInfo.name)
                if propdetailInfo.level > 0 then
					if EquipHelper:isRedEquip(jsonDataTable.data.items[i].obj) then 
						table.insert(noteArr, MultiLan("GEML_getNewArtifact")..propdetailInfo.level.."  ".. propDetailName)
						table.insert(colorArr, COLOR_RED)
					else
						table.insert(noteArr, MultiLan("GEML_getNewEquip")..propdetailInfo.level.."  ".. propDetailName)
						local color,grade = EquipHelper:getEquipColor(jsonDataTable.data.items[i].obj)
						table.insert(colorArr, color)
					end
                else
					table.insert(noteArr, MultiLan("GEML_return")..jsonDataTable.data.items[i].num.."  ".. propDetailName)
					table.insert(colorArr, COLOR_YELLOW)
                end
            end
        end
		CommonNote(noteArr, colorArr)
        EquipMeltLayer:EquipMeltLayerClearItem()
	    EquipMeltLayer:refreshEquipMeltValue()
	end


    local function sendEquipMelt()
        HttpSend("equip/fusion", {EquipMeltLayer.msgString}, equipMeltCallback)
    end


    local  equipQualitys = 0
    local needConfirmShow  = false
	local bFirst = true
	local color = nil
	EquipMeltLayer.msgString = "ids="

	for i=1,MELTEQUIP_MAX do 
		if EquipMeltLayer.meltEquipDataTable[i] ~= nil then
			if bFirst then
				bFirst = false
			else
				EquipMeltLayer.msgString  = EquipMeltLayer.msgString .. ","
			end
			EquipMeltLayer.msgString  = EquipMeltLayer.msgString  .. EquipMeltLayer.meltEquipDataTable[i].id
		    color,equipQualitys  = EquipHelper:getEquipColor(EquipMeltLayer.meltEquipDataTable[i]) 
		    UserAttr:compareAaEquipScore(EquipMeltLayer.meltEquipDataTable[i].id)
		    if equipQualitys >= 5 then
			    needConfirmShow = true
		    end
		end
	end
	
	if  needConfirmShow == true then
		local content = cc.Label:create(MultiLan("GEML_sureOfOrange"), DefaultFontName, FontSize3,cc.size(460,160),0,1)
		CreateSmallPopupWithCancel("smelt", content, sendEquipMelt)
	else
		sendEquipMelt()
	end
end

function onMeltHelpBtnClick()
	HelpPopup("melt")
end

function onBatchMeltBtnClick(  )
	-- EquipMeltLayer:EquipMeltLayerExit()
	local  batchlayer = EquipBatchFilterLayer:new()
    batchlayer:create()
    local layerNode = batchlayer.topNode
    if POPUP_LAYER == nil then
		POPUP_LAYER = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
		scene:addChild(POPUP_LAYER, POPUP_TAG, POPUP_TAG)
	end
	POPUP_LAYER:addChild(layerNode) 
end

function onCloseEquipMeltBtnClick()
	-- cclog("onCloseEquipMeltBtnClick")
	EquipMeltLayer:EquipMeltLayerExit()
end

--//////////////////////////////////
EquipMeltLayer["onNormalForgeBtnClick"] = onNormalForgeBtnClick
EquipMeltLayer["onSpecialForgeBtnClick"] = onSpecialForgeBtnClick
EquipMeltLayer["onAutoSelectBtnClick"] = onAutoSelectBtnClick
EquipMeltLayer["onEquipMeltBtnClick"] = onEquipMeltBtnClick
EquipMeltLayer["onMeltHelpBtnClick"] = onMeltHelpBtnClick
EquipMeltLayer["onCloseEquipMeltBtnClick"] = onCloseEquipMeltBtnClick
EquipMeltLayer["onBatchMeltBtnClick"] = onBatchMeltBtnClick




