
--主页
local bHomeInited = false
local HomeExpBar = nil
UserVipInfo = nil
UserLimitInfo = nil
UserSelfInfo = nil

--任务数据
UserQusetInfo = nil
QUEST_TYPE_MARK = 1
QUEST_TYPE_OPEN = 2
QUEST_TYPE_LEVEL= 3
QUEST_TYPE_PASS = 4
QUEST_TYPE_PAY  = 5
QUEST_TYPE_FIRST= 6

local questActTag = 1 --礼包界面显示的活动
local questActBack = nil
-- local questActTitle = nil

XiaLayer = XiaLayer or {}
ccb["XiaLayer"] = XiaLayer


--------------------------------------------------主页前后端同步机制-------------
function setMailNote(bNote)
	local bNeedNote = false
	if bNote ~= nil then
		bNeedNote = bNote
	else
		--根据邮件数据判断是否需要提醒
	end

	GameGuide:setButtonNote(XiaLayerOwner["mHomeMailButton"], bNeedNote,Pos(cc.size(100,100), 0.74, 0.76), 1)
end
function setHeroTNote(bNote)
	local bNeedNote = false
	if bNote ~= nil then
		bNeedNote = bNote
	else
		--根据邮件数据判断是否需要提醒
	end
	GameGuide:setButtonNote(XiaLayerOwner["mHomeHeroTokenButton"], bNeedNote,Pos(cc.size(100,100), 0.74, 0.76), 1)
end


--------------------------------------------------任务部分--------------------------------
local function setQuestNote()
	local bNeedNote = false
	for k,v in pairs(UserQusetInfo) do
		if v.bDone then
			bNeedNote = true 
			break
		end
	end

	GameGuide:setButtonNote(XiaLayerOwner["mHomeGiftButton"], bNeedNote, Pos(cc.size(100,100), 0.74,0.76), 1)
end

function SortQuest(a,b)
	if a.bDone and b.bDone == false then
		return true
	elseif a.bDone == false and b.bDone then
		return false
	else
		return a.staticData.id < b.staticData.id
	end
end

local function setQuestInfo(questInfo)
	-- print("setQuestInfo",questInfo.dynamicData.id)
	if questInfo.staticData == nil then
		questInfo.staticData = GameData:getQuest(questInfo.dynamicData.id)
	end

	questInfo.numMax = questInfo.staticData.condition
	if QUEST_TYPE_MARK == questInfo.staticData.qtype or QUEST_TYPE_OPEN == questInfo.staticData.qtype then
		questInfo.num = UserSelfInfo.logon_days
	elseif QUEST_TYPE_LEVEL == questInfo.staticData.qtype then
		questInfo.num = UserSelfInfo.level
	elseif QUEST_TYPE_PASS == questInfo.staticData.qtype then
		-- print("QUEST_TYPE_PASS",questInfo.numMax,UserInfo:getUserInfo().data.pve.id)
		questInfo.num = UserInfo:getUserInfo().data.pve.id - 1
	elseif QUEST_TYPE_PAY == questInfo.staticData.qtype then
		questInfo.num = UserSelfInfo.pay_cash_count
	elseif QUEST_TYPE_FIRST == questInfo.staticData.qtype then
		questInfo.numMax = 1
		questInfo.num = UserSelfInfo.pay_cash_count
	end
	if questInfo.num >= questInfo.numMax then	
		questInfo.bDone = true
		-- print(questInfo.bDone)
	else
		questInfo.bDone = false
	end
end

function setQuestByType(qtype)
	-- print("setQuestByType", qtype)
	local questInfo = nil 
	for i=1,table.maxn(UserQusetInfo) do
		if UserQusetInfo[i].staticData.qtype == qtype then
			questInfo = UserQusetInfo[i]
			break
		end
	end
	-- print(questInfo)
	if questInfo ~= nil then
		setQuestInfo(questInfo)
		setQuestNote()
	end
end

local function HomeInitQuest()
	if UserQusetInfo ~= nil then
		return
	end
	UserQusetInfo = {}
	-- print("HomeInitQuest", table.maxn(UserInfo:getUserInfo().data.quest))
	for i=1,table.maxn(UserInfo:getUserInfo().data.quest) do
		table.insert(UserQusetInfo,{dynamicData=UserInfo:getUserInfo().data.quest[i],staticData=nil,num=0,numMax=0,bDone=false}) 
		setQuestInfo(UserQusetInfo[table.maxn(UserQusetInfo)])
	end
	setQuestNote()
end
--------------------------------------------------任务部分结束--------------------------------

function HomeLocalizationInit()
	-- print("HomeLocalizationInit")
	if bHomeInited then
		return
	end
	bHomeInited = true
	--UserLimitInfo = UserInfo:getUserInfo().data.limit
	UserVipInfo = GameData:getGameDataTable().vip[UserSelfInfo.vip+1]
	HomeInitQuest()
	
	UserAttr:initAttrTable()
	UserAttr:CalUserAttr()

	XiaLayerOwner["mHomePayLabel"]:setString("")
end

function HomeEnter()
	-- print("HomeEnter")
	GameGuide:resetHandGuide()
	HomeLocalizationInit()
	XiaLayer:SetHomeUserInfo()
	GameGuide:refreshGuide(GUIDE_TYPE_FORGE)
	GameGuide:setActButtonNote()
	GameGuide:setGroupButtonNote()
	--BroadcastLayer:setVisible(true)
end

function HomeExit()
	
	--BroadcastLayer:setVisible(false)
end


function onMainGift()
	local popupContent = CreateLayer(POPUP_SIZE_BIG, 1, Pos(POPUP_SIZE_BIG, 0.5, 0.48))
	-- local bg = CommonCreateScale9Backgroud(cc.size(520, 700), Pos(POPUP_SIZE_BIG, 0.5, 0.505))
	-- popupContent:addChild(bg)
	-- local popupRoot = CommonCreatePopupBigWithoutBg("mypackage", popupContent, true)
	local popupRoot = CommonCreatePopupBig("mypackage", popupContent, true)
	table.sort(UserQusetInfo,SortQuest)
	
	local function onGiftReward(node)
		local tag = tolua.cast(node, "cc.Node"):getTag()
		if UserQusetInfo[tag].bDone == false then
			CommonNote(MultiLan("home_desc1"))
			return 
		end
		
		local function giftRewardCallback(jsonDataTable)
			if jsonDataTable.ret ~= 0 then
				-- cclog("giftRewardCallback failed %d", jsonDataTable.ret)
				return 
			end
			
			UserInfo:addProp(jsonDataTable.data.award)
			UserInfo:addPropNote(jsonDataTable.data.award)
			
			--删除任务
			removeFromTable(UserInfo:getUserInfo().data.quest, UserQusetInfo[tag].dynamicData)
			removeFromTable(UserQusetInfo, UserQusetInfo[tag])
			
			--添加新任务
			if jsonDataTable.data.new ~= nil then
				for i=1,table.maxn(jsonDataTable.data.new) do
					table.insert(UserInfo:getUserInfo().data.quest, jsonDataTable.data.new[i])
					table.insert(UserQusetInfo,{dynamicData=jsonDataTable.data.new[i],staticData=nil,num=0,numMax=0,bDone=false}) 
					setQuestInfo(UserQusetInfo[table.maxn(UserQusetInfo)])
				end
			end
			
			--刷新
			removeSelf(popupRoot)
			onMainGift()
			setQuestNote()
		end
		HttpSend("user/gift", {"id="..UserQusetInfo[tag].dynamicData.id}, giftRewardCallback)
	end
	--内容

	local height = 640
	local scrollLayer  = nil
	if table.maxn(Activity_ActArr) ~= 0 then
		height = 500
		scrollLayer = CreateLayer(cc.size(500,height), 1, Pos(POPUP_SIZE_BIG,0.5,0.42))
		
		local function setQuestAct(move) 
			-- print("setQuestAct", questActTag, move)
			questActTag = questActTag + move
			if questActTag > table.maxn(Activity_ActArr) then
				questActTag = questActTag % table.maxn(Activity_ActArr)
			end
			if questActTag <= 0 then
				questActTag = questActTag + table.maxn(Activity_ActArr)
			end
			if Activity_ActArr[questActTag] == nil then
				questActTag = 1
			end
			questActBack:setSpriteFrame(Activity_ActArr[questActTag].back)
			-- questActTitle:setSpriteFrame(Activity_ActArr[questActTag].title)
			-- questActTitle:setString(ZGMultiLan("act_title_" .. Activity_ActArr[questActTag].title))
		end
		
		local function clickAct()
			-- print("clickAct",questActTag)
			if Activity_ActArr[questActTag] ~= nil and Activity_ActArr[questActTag].callback ~= nil then
				removeSelf(popupRoot)
				JumpToActInit()
				GameActShowTag = questActTag 
				Activity_ActArr[questActTag].callback()
			end
		end
		local middlePos = Pos(POPUP_SIZE_BIG,0.5,0.8)
		-- print(1)
		local actButton = CreateLayer(cc.size(500*0.9,165*0.9),1, middlePos)
		-- print(2)
		popupContent:addChild(actButton)
		questActBack = CreateCommonSprite(Activity_ActArr[1].back, Pos(actButton:getContentSize()), 0.8)
		questActBack:setScaleX(0.9)
		questActBack:setScaleY(0.8)
		actButton:addChild(questActBack)
		-- actButton:addChild(CreateCommonSprite("board_actpic.png", Pos(actButton:getContentSize()), 0.9))
		
		-- questActTitle = CreateCommonSprite(Activity_ActArr[1].title, Pos(actButton:getContentSize()), 0.9)
		-- actButton:addChild(questActTitle)
		-- questActTitle = CreateCommonFntLabel(ZGMultiLan("act_title_" .. Activity_ActArr[1].title), FntTypeUserTitle, Pos(actButton:getContentSize()))
		-- questActTitle = CreateCommonLabel(ZGMultiLan("act_title_" .. Activity_ActArr[1].title), Pos(actButton:getContentSize(), 0.5, 0.48), FontSize4, COLOR_FNT_UserTilte)
		-- actButton:addChild(questActTitle)
		setQuestAct(0)
		
		local function changeAct()
			setQuestAct(1)
		end
		popupContent:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(4), cc.CallFunc:create(changeAct))))
		-- print(3)
		local function clickLeft() 
			setQuestAct(-1)
			popupContent:stopAllActions()
			popupContent:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(4), cc.CallFunc:create(changeAct))))
		end
		local function clickRight()
			setQuestAct(1) 
			popupContent:stopAllActions()
			popupContent:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(4), cc.CallFunc:create(changeAct))))
		end
		local leftButton = CreateCommonButton("pic_suiyiaaa.png", Pos(POPUP_SIZE_BIG,0.13,0.8), cc.size(120,130), clickLeft)
		local leftSprite = CreateCommonSprite("pic_waypre.png",Pos(leftButton:getContentSize()))
		leftSprite:setFlippedX(true)
		leftSprite:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.FadeOut:create(1.5), cc.FadeIn:create(1.5))))
		leftButton:addChild(leftSprite)
		popupContent:addChild(leftButton)
		-- print(4)
		local rightButton = CreateCommonButton("pic_suiyiaaa.png", Pos(POPUP_SIZE_BIG,0.87,0.8), cc.size(120,130), clickRight)
		local rightSprite = CreateCommonSprite("pic_waypre.png",Pos(rightButton:getContentSize()))
		rightSprite:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.FadeOut:create(1.5), cc.FadeIn:create(1.5))))
		rightButton:addChild(rightSprite)
		popupContent:addChild(rightButton)

		local beginx = 0
		local endx = 0
		local function onTouchBegan(touch, event)
			-- print("onTouchBegan")
			local locationInNode = actButton:convertToNodeSpace(touch:getLocation())
			beginx = locationInNode.x
			-- print("beginx",beginx)
			if locationInNode.y <= 0 or locationInNode.y >=  actButton:getContentSize().height or locationInNode.x <= 0 or locationInNode.x >=  actButton:getContentSize().width then
				return false
			end
			return true
		end
		
		local function onTouchEnded(touch, event)
			-- print("onTouchEnded",beginx)
			local locationInNode = actButton:convertToNodeSpace(touch:getLocation())
			endx = locationInNode.x
			-- print(endx, beginx)
			if locationInNode.y <=0 or locationInNode.y >=  actButton:getContentSize().height then
				return true
			end
			if endx - beginx > actButton:getContentSize().width/4 then
				clickRight()
			elseif beginx - endx > actButton:getContentSize().width/4 then
				clickLeft()
			else
				clickAct()
			end
			return true
		end
		
		local eventDispatcher = actButton:getEventDispatcher()
		local listener = cc.EventListenerTouchOneByOne:create()    
		listener:setSwallowTouches(false)
		listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN )
		listener:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED )
		eventDispatcher:addEventListenerWithSceneGraphPriority(listener, actButton)
		--pic_waypre
	else
		scrollLayer = CreateLayer(cc.size(500,height), 1, Pos(POPUP_SIZE_BIG,0.5,0.503))
	end
	
	--礼包内容
	local layer = cc.Layer:create()
	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0,0), kScrollViewDirectionVertical)
	local scrollWorldPos = scrollLayer:convertToWorldSpace(cc.p(scrollLayer:getPosition()))
	local scrollViewSize = scrolView:getViewSize()
	local count = table.maxn(UserQusetInfo)
	-- print("count", count)
	local scale = 0.85
	local y = count*140*scale-70
	local sprite = {"pic_gift01.png","pic_gift02.png","pic_gift03.png","pic_gift04.png","pic_gift05.png","pic_gift06.png"}
	for i=1, count do
		back = CreateCommonSprite("board_overmap.png", cc.p(250, y))
		back:setScale(scale)
		layer:addChild(back)
		-- print(i,UserQusetInfo,UserQusetInfo[i])
		-- print(UserQusetInfo[i].staticData)
		-- print(UserQusetInfo[i].dynamicData)
		
		layer:addChild(CreateCommonLabel(MultiLan(UserQusetInfo[i].staticData.name), cc.p(90, y+33),FontSize4,nil,cc.p(0,0.5)))
		local descBack = CreateCommonSprite("board_skill02.png", cc.p(240, y-13))
		descBack:setScaleX(0.91)
		layer:addChild(descBack)
		layer:addChild(CreateCommonLabel(MultiLan(UserQusetInfo[i].staticData.special_desc), cc.p(240, y-17),FontSize2,COLOR_WHITE,nil,cc.size(330*0.89,60)))	
		local iconTitle = CreateCommonSprite(sprite[UserQusetInfo[i].staticData.qtype], cc.p(45, y))
		iconTitle:setScale(0.7)
		layer:addChild(iconTitle)

		if UserQusetInfo[i].bDone then
			local rewardBtn = CreateCommonButton("button_reward.png", cc.p(450, y), SIZE_CONFIGS.button_reward, onGiftReward)
			rewardBtn:setScale(0.8)
			rewardBtn:setSwallowTouch(false)
			layer:addChild(rewardBtn, 0, i)
			-- local lb = CreateCommonFntLabel(ZGMultiLan("lbBtnReward"), FntTypeCommonYellow, cc.p(450, y ))
			local lb = CreateCommonLabel(ZGMultiLan("lbBtnReward"), cc.p(450, y - 20), FontSize4 + 5, COLOR_FNT_CommonYellow)
			lb:setScale(0.65)
			layer:addChild(lb)
		else
			layer:addChild(CreateCommonLabel(MultiLan("home_desc2"), cc.p(450, y),FontSize4))
		end
		y = y - 140*scale
	end
	
	
	popupContent:addChild(scrollLayer)
	layer:setContentSize(cc.size(600, math.max(height, 140*scale*count)))
	scrolView:setContentOffset(cc.p(0, height-(140*scale*count)))
	if 140*count*scale < height then
		scrolView:setTouchEnabled(false)
	end
	
	--说明
	local ruleBack = CreateCommonSprite("board_skill01.png", Pos(POPUP_SIZE_BIG,0.5,0.91))
	ruleBack:setScaleX(1.4)
	popupContent:addChild(ruleBack)
	popupContent:addChild(CreateCommonLabel(MultiLan("home_desc3"),Pos(POPUP_SIZE_BIG,0.5,0.91), FontSize4, COLOR_YELLOW))
	
	--兑换CD-key
	local function exchangeClick()
		local popupSmall = CreateLayer(POPUP_SIZE_SML, 1, Pos(POPUP_SIZE_SML)) 
		local popupRootSmall = CommonCreatePopupSmall("getcdkey", popupSmall, true)
        local userEditBox = cc.EditBox:create(cc.size(400, 60), cc.Scale9Sprite:createWithSpriteFrameName("board_account01.png"))
	    popupSmall:addChild(userEditBox)
		userEditBox:setAnchorPoint(cc.p(0.5,0.5))
		userEditBox:setReturnType(cc.KEYBOARD_RETURNTYPE_SEND)
		userEditBox:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
	    userEditBox:setPosition(cc.p(popupSmall:getContentSize().width / 2, popupSmall:getContentSize().height*0.58))
		userEditBox:setFontName(" ")
		userEditBox:setFontSize(FontSize3)
		userEditBox:setPlaceHolder(MultiLan("home_desc4"))
		
		local function exchangeCallback(jsonDataTable)
			if jsonDataTable.ret == 0 then
				--CommonNote("礼包奖励已发送到邮件中")
				UserInfo:addProp(jsonDataTable.data.item)
				UserInfo:addPropNote(jsonDataTable.data.item)
				removeSelf(popupRootSmall)
			end
		end
		
		local function sendExchange()
			local singature = tolua.cast(userEditBox,"cc.EditBox"):getText()
			singature = string.gsub(singature," ","")
			if string.match(singature, string.rep("[%a|%d]",string.len(singature))) == nil then
			--if string.match(singature, string.rep("[%a|%d]",10)) == nil or string.len(singature) ~= 10 then
				CommonNote(MultiLan("home_desc5"))
				return
			end
			
			HttpSend("activity/cdkey", {"cdkey="..singature}, exchangeCallback)
		end
		
		popupSmall:addChild(CreateCommonButton(("button_green.png"), Pos(POPUP_SIZE_SML,0.5,0.13), cc.size(144,50), sendExchange, {str=MultiLan("button_exchange"), size = FontSize6}))
	end
	local exchangeButton = CreateCommonButton("button_blue.png", Pos(POPUP_SIZE_BIG,0.3,0.07), cc.size(144,50), exchangeClick, {str=MultiLan("home_desc6"), size = FontSize6})
	popupContent:addChild(exchangeButton)
	
	
	--关闭
	local function closeFunc()
		removeSelf(popupRoot)
	end
	local closeButton = CreateCommonButton("button_red.png", Pos(POPUP_SIZE_BIG,0.7,0.07), cc.size(144,50), closeFunc, {str=MultiLan("button_close"), size = FontSize6})
	popupContent:addChild(closeButton)
	if IsInExamine() then
	--if TGAME_IN_EXAMINE and  IsTgamePlartform() then --
		exchangeButton:setVisible(false)
		closeButton:setPosition(Pos(POPUP_SIZE_BIG,0.5,0.05))
	end
end

function onUserDetailClick()
	PlayerInfoLayer:PlayerInfoLayerEnter()
end

--设置主页玩家数据
function XiaLayer:SetHomeUserInfo()
    if UserSelfInfo == nil then
       return
    end
	-- print("SetHomeUserInfo")
	--头像
	local head = SetMyHead(UserSelfInfo.role ,UserSelfInfo.sex , 1)
	-- cclog("aaaa--- "..UserSelfInfo.role.."....."..UserSelfInfo.sex)
	tolua.cast(XiaLayerOwner["mHomeUserHead"], "cc.Sprite"):setSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(head))
	
	--职业图标
	tolua.cast(XiaLayerOwner["mHomeUserType"], "cc.Sprite"):setSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame("school_icon_"..UserSelfInfo.role..".png"))
	
	--名字
	XiaLayerOwner["mHomeUserName"]:setString(UserSelfInfo.name)
	
	--等级
	XiaLayerOwner["mHomeUserLevel"]:setString("Lv:"..UserSelfInfo.level)
	
	--VIP
	XiaLayerOwner["mHomeVipLevel"]:setString(UserSelfInfo.vip)--UserSelfInfo.vipLevel
	
	--战斗力
	XiaLayerOwner["mHomeUserFightnum"]:setString(UserAttr:getFightNum())--
	
	--经验
	-- print("HomeExpBar",HomeExpBar)
	if HomeExpBar == nil then
		HomeExpBar = CreateCommonBar("exp_low.png",Pos(XiaLayerOwner["mHomeExpBack"]:getContentSize()))
		XiaLayerOwner["mHomeExpBack"]:addChild(HomeExpBar)
	end

	local maxExp = GameData:getGameDataTable()["exp"][UserSelfInfo.level].exp
	tolua.cast(HomeExpBar, "cc.ProgressTimer"):setPercentage(UserSelfInfo.exp * 100 / maxExp)
	XiaLayerOwner["mHomeUserExp"]:setString(UserSelfInfo.exp.."/"..maxExp)
	
	--银两
	XiaLayerOwner["mHomeUserSilver"]:setString(UserSelfInfo.gold)
	
	--元宝
	XiaLayerOwner["mHomeUserGold"]:setString(UserSelfInfo.cash)
end


function onMainTalk()
	if ChatLayer:getCanTalk() == false then
		CommonNote(MultiLan("chat_close"), COLOR_RED)
	end
	ChatLayer:ChatLayerEnter()
end

function onMainList()
	local function ranklistCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			GameListLayer:totleList(jsonDataTable.data)
		end
	end
	
	if UserSelfInfo.level < 10 then
		CommonNote(MultiLan("GG_open_6"))
	else
		HttpSend("rank/list",{},ranklistCallback)
	end
end

function onMainMore()
	local moreFuncArr = {onUserDetailClick, onLogoutBtnClick, onMainHelp,onMainNotice }
	local moreButtonSpriteArr = {"MainButton21.png","MainButton22.png", "MainButton11.png","MainButton9.png"}
	local moreButtonSizeArr = {cc.size(101, 101), cc.size(101, 101), cc.size(101, 101), cc.size(101, 101)}
	local moreButtonLabelArr = {"lbBtnMorePersonalInfo", "lbBtnMoreLogout", "lbBtnMoreHelp", "lbBtnMoreNotice"}

	local popupContent = CreateLayer(POPUP_SIZE_MID, 1, Pos(POPUP_SIZE_MID, 0.5, 0.45))
	CommonCreatePopupMid("moreduo", popupContent, true)
		
	local buttonArea = CreateLayer(cc.size(500,520), 1, Pos(POPUP_SIZE_MID,0.5,0.55))
	popupContent:addChild(buttonArea)
	
	local height = buttonArea:getContentSize().height
	local width = buttonArea:getContentSize().width
	local count = table.maxn(moreFuncArr)
	if TGAME_IN_EXAMINE ==  true then 
		count = 3
	end
	for i=1, count do
		local x = (math.mod((i-1),3)+0.5)*width/3
		local y = height - (math.floor((i-1)/3) + 0.5)*width/3
		-- local btn = CreateCommonButton(moreButtonSpriteArr[i], cc.p(x, y), cc.size(105, 117), moreFuncArr[i])
		local btn = CreateCommonButton(moreButtonSpriteArr[i], cc.p(x, y), moreButtonSizeArr[i], moreFuncArr[i])
		buttonArea:addChild(btn)
		-- btn:addChild(CreateCommonFntLabel(ZGMultiLan(moreButtonLabelArr[i]), FntTypeUserTitle, Pos(cc.size(126, 101), 0.423, 0.251)))
		btn:addChild(CreateCommonLabel(ZGMultiLan(moreButtonLabelArr[i]), Pos(cc.size(126, 101), 0.423, 0.251), FontSize4, COLOR_FNT_UserTilte))
	end
end
function onHomeCompensateClick()
	local function CompensateInfoCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			return 
		end
		-- setMailNote(false)
		UserCompensateInfo = jsonDataTable.data
		GameCompensateLayer:GameCompensateLayerEnter(UserCompensateInfo)
		GameGuide:setButtonNote(XiaLayerOwner["lyHomeCompensateBtn"], false)
	end
	HttpSend("indemnity/info", {}, CompensateInfoCallback)
end

XiaLayer["onMainGift"] = onMainGift
XiaLayer["onMainTalk"] = onMainTalk
XiaLayer["onMainList"] = onMainList
XiaLayer["onMainMore"] = onMainMore
XiaLayer["onHomeCompensateClick"]     = onHomeCompensateClick
XiaLayer["onUserDetailClick"] = onUserDetailClick