LoginRegisterLayer = class("LoginRegisterLayer")
LoginRegisterLayer.__index = LoginRegisterLayer

LoginRegisterLayer.topNode = nil
LoginRegisterLayer.editbox = nil
LoginRegisterLayer.selectedIndex = 0
LoginRegisterLayer.selectedSex = 0
LoginRegisterLayer.name = ""

ccb["LoginRegisterLayer"] = LoginRegisterLayer
LoginRegisterLayerOwner = LoginRegisterLayerOwner or {}
ccb["LoginRegisterLayerOwner"] = LoginRegisterLayerOwner

--[[Chinese
MAX_XING = 496
MAX_MING_MAN = 2300
MAX_MING_WOMAN = 4100
]]
--[[English]]
MAX_XING = 8
MAX_MING_MAN = 639
MAX_MING_WOMAN = 373
CHOOSE_SHOW_TAG = 3

function LoginRegisterLayer:LoginRegisterLayerEnter()
	GameEnteringLayer.topNode:setVisible(false)
	local proxy = cc.CCBProxy:create()
	self.topNode = CCBReaderLoad("ccb/LoginRegister.ccbi",proxy,LoginRegisterLayerOwner)
	scene:addChild(self.topNode)

	local lbInputYourNameHere = LoginRegisterLayerOwner["lbInputYourNameHere"]
	
	LoginRegisterLayerOwner["mLoginName"]:setString(MultiLan("login_desc6"))
	LoginRegisterLayerOwner["mTitleChooseRole"]:setString(ZGMultiLan("mTitleChooseRole"))
	SetTouchEventForLayer(LoginRegisterLayerOwner["mRegisterSwallow"], TouchSwallow)
	local editLayer = LoginRegisterLayerOwner["mLoginRegisterNameLayer"]
	self.editbox = cc.EditBox:create(lbInputYourNameHere:getContentSize(), cc.Scale9Sprite:createWithSpriteFrameName("pic_suiyiaaa.png"))
	editLayer:addChild(self.editbox)
	self.editbox:setText("")
	self.editbox:setPlaceHolder(MultiLan("register_desc1"))
	self.editbox:setPosition(lbInputYourNameHere:getPosition())
	self.editbox:setFontSize(25)
	self.editbox:setPlaceholderFontSize(25)

	lbInputYourNameHere:removeFromParent()		-- remove after used
	
	SetTouchEventForLayer(LoginRegisterLayerOwner["lybg"], TouchSwallow)

	CommonMoveLabelUnderBtn(LoginRegisterLayerOwner["mCreateActor"], LoginRegisterLayerOwner["lbBtnCreateActor"])
	LoginRegisterLayerOwner["lbBtnCreateActor"]:setString(ZGMultiLan("crate_btn_create_actor"))

	SetChooseUI()
end

function LoginRegisterLayer:LoginRegisterLayerExit()
end
function LoginRegisterLayer:playSpineAnimation( role )
	local spineFileNameArr = SPINE_CONFIGS.userFiles
	local s_pPathSpineBoyJson = "spine/" .. spineFileNameArr[role] .. ".json"
	local s_pPathSpineBoyAtlas = "spine/" .. spineFileNameArr[role] .. ".atlas"
	local spineboy = sp.SkeletonAnimation:create(s_pPathSpineBoyJson, s_pPathSpineBoyAtlas, 1)
	LoginRegisterLayerOwner["lyUserBg"]:addChild(spineboy)
	local width = LoginRegisterLayerOwner["lyUserBg"]:getContentSize().width * SPINE_CONFIGS.posLoginX[role]
	local height = LoginRegisterLayerOwner["lyUserBg"]:getContentSize().height * SPINE_CONFIGS.posLoginY[role] 
	spineboy:setPosition(cc.p(width, height))

  	spineboy:setScale(SPINE_CONFIGS.userFilesLoginScale[role])
	spineboy:setDebugBones(false)
	spineboy:setAnimation(0, "animation", true)
end
local function onLoginRegisterRandom()
	local nameXing = NameMultiLan("rnd_first_name_" .. (math.random(os.clock()*10^6)%MAX_XING + 1))
	local nameMing = ""
	if LoginRegisterLayer.selectedSex == 0 then
		nameMing = NameMultiLan("rnd_last_name_woman_" .. (math.random(os.clock()*10^6)%MAX_MING_WOMAN + 1))
	else
		nameMing = NameMultiLan("rnd_last_name_man_" .. (math.random(os.clock()*10^6)%MAX_MING_MAN + 1))
	end
	if SDK_PLATFORM == "SDK_TGAME_TH_IOS" or SDK_PLATFORM == "SDK_TGAME_TH_ANDROID" then
		LoginRegisterLayer.name = nameMing..nameXing 
	else
		LoginRegisterLayer.name = nameXing..nameMing
	end
	LoginRegisterLayer.editbox:setText(LoginRegisterLayer.name)
end

local function onLoginCheckName()
	local nameLen = GetUTF8LogicStrLen(LoginRegisterLayer.name)
	cclog("name len is %d", nameLen)
	local maxNameLen = 13
	local minNameLen = 4
	if SDK_PLATFORM == "SDK_TGAME_TH_IOS" or SDK_PLATFORM == "SDK_TGAME_TH_ANDROID" or SDK_PLATFORM == "SDK_TGAME_VN_IOS" or SDK_PLATFORM == "SDK_TGAME_VN_ANDROID"  then
		maxNameLen = 35
		minNameLen = 1
	end
	if nameLen < minNameLen or nameLen > maxNameLen then
		CreateSmallPopupWithCancel(nil, CreateCommonLabel(MultiLan("register_desc2"), nil, FontSize3), nil)
		return false
	end
	return true
end

local function onLoginRegisterCreateActor(node)
	LoginRegisterLayer.name = LoginRegisterLayer.editbox:getText()
	if onLoginCheckName() == false then
		cclog("check actor name failed %s", LoginRegisterLayer.name)
		return
	end
	local function onLoginRegisterCreateActorCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("login create actor name failed %d", jsonDataTable.ret)
			return 
		end
		tolua.cast(node, "cc.ControlButton"):setEnabled(false)
		UserInfo:getUserInfo().data.info.role = jsonDataTable.data.role
		UserInfo:getUserInfo().data.info.sex  = jsonDataTable.data.sex
		UserInfo:getUserInfo().data.info.name = jsonDataTable.data.name
		LoginRegisterLayer:LoginRegisterLayerExit()
		InitGameUi()
	end
	if 	SDK_PLATFORM == "SDK_TGAME_ANDROID" or SDK_PLATFORM == "SDK_TGAME_IOS" or SDK_PLATFORM == "SDK_JAGUAR_ANDROID" or SDK_PLATFORM == "SDK_JAGUAR_THIRD" then
		local tmpTable = {
						eventType = tostring(1),
						roleId = tostring(UserInfo:getUserInfo().data.info.uid),
						roleName = tostring(UserInfo:getUserInfo().data.info.name),
						serverId = tostring(LOGIN_SERVER_ID),
					}
					
		DevicePlatform:getInstance():sdkExtraFunction(tmpTable)
	end
	-- cclog("role is "..LoginRegisterLayer.selectedIndex)
	-- cclog("sex is "..(LoginRegisterLayer.selectedSex + 1))
	-- HttpSend("user/role", {"role=" .. LoginRegisterLayer.selectedIndex, "name=" .. LoginRegisterLayer.name}, onLoginRegisterCreateActorCallback)
	HttpSend("user/rolesex", {"role=" .. LoginRegisterLayer.selectedIndex, "sex=" .. (LoginRegisterLayer.selectedSex + 1), "name=" .. LoginRegisterLayer.name}, onLoginRegisterCreateActorCallback)
end
local function onClickLoginRegisterBtnAdd(node)
	-- cclog("onClickLoginRegisterBtnAdd")
	if CHOOSE_SHOW_TAG == 6 then
		CHOOSE_SHOW_TAG = 3
	elseif CHOOSE_SHOW_TAG == 2 then
		CHOOSE_SHOW_TAG = 5
	elseif CHOOSE_SHOW_TAG == 4 then
		CHOOSE_SHOW_TAG = 1
	else
		CHOOSE_SHOW_TAG = CHOOSE_SHOW_TAG + 1
	end
	SetChooseUI()
end
local function onClickLoginRegisterBtnJian(node)
	if CHOOSE_SHOW_TAG == 1 then
		CHOOSE_SHOW_TAG = 4
	elseif CHOOSE_SHOW_TAG == 3 then
		CHOOSE_SHOW_TAG = 6
	elseif CHOOSE_SHOW_TAG == 5 then
		CHOOSE_SHOW_TAG = 2
	else 
		CHOOSE_SHOW_TAG = CHOOSE_SHOW_TAG - 1
	end
	SetChooseUI()
end
local function onCLickLoginRegister( node )
	local tag = node:getTag()
	-- cclog("tag is "..tag)
	if tag == CHOOSE_SHOW_TAG then
		return
	end
	CHOOSE_SHOW_TAG = tag
	SetChooseUI()
end

function SetChooseUI(  )
	LoginRegisterLayerOwner["lyUserBg"]:removeAllChildren(true)
	for i =1 ,6 do
		if LoginRegisterLayerOwner["lyeffect"..i]:getChildByTag(1) ~= nil then
			LoginRegisterLayerOwner["lyeffect"..i]:removeChildByTag(1)
			LoginRegisterLayerOwner["lyeffect"..i]:removeChildByTag(2)
			local y = LoginRegisterLayerOwner["btLoginRegister"..i]:getPositionY()
			LoginRegisterLayerOwner["btLoginRegister"..i]:setPositionY(y - 40)
		end
	end
	LoginRegisterLayerOwner["ly_fire"]:removeAllChildren(true)
	if CHOOSE_SHOW_TAG == 3 then
		local p = cc.ParticleSystemQuad:create("ccbResources/particals/bodybg_2/fire.plist")
		p:setPosition(Pos(LoginRegisterLayerOwner["ly_fire"]:getContentSize()))
		p:setScale(0.25)
		LoginRegisterLayerOwner["ly_fire"]:addChild(p)
		-- ly_fire
	end
	
	local effect = CommonAddEffect("LR_eff_", 21, 0.1, 1)
	local fatherX = LoginRegisterLayerOwner["lyeffect"..CHOOSE_SHOW_TAG]:getContentSize().width
	local fatherY = LoginRegisterLayerOwner["lyeffect"..CHOOSE_SHOW_TAG]:getContentSize().height
	local childY = effect:getContentSize().height
	effect:setPosition(cc.p(fatherX / 2,fatherY / 2 + 20))
	LoginRegisterLayerOwner["lyeffect"..CHOOSE_SHOW_TAG]:addChild(effect,0,1)
	-- lyeffect1
	local effSprite = cc.Sprite:createWithSpriteFrameName("LR_effect.png")
	effSprite:setPosition(cc.p(fatherX / 2,fatherY / 2 + 20))
	LoginRegisterLayerOwner["lyeffect"..CHOOSE_SHOW_TAG]:addChild(effSprite,0,2)
	LoginRegisterLayerOwner["btLoginRegister"..CHOOSE_SHOW_TAG]:setPositionY(LoginRegisterLayerOwner["btLoginRegister"..CHOOSE_SHOW_TAG]:getPositionY() + 40)
	LoginRegisterLayer.selectedIndex = math.ceil(CHOOSE_SHOW_TAG / 2)
	LoginRegisterLayer.selectedSex = CHOOSE_SHOW_TAG % 2
	LoginRegisterLayerOwner["mLoginRegisterLabel"]:setString(MultiLan("career_desc_" .. LoginRegisterLayer.selectedIndex))
	LoginRegisterLayerOwner["imIcon"]:setSpriteFrame("school_icon_"..LoginRegisterLayer.selectedIndex..".png")
	LoginRegisterLayer:playSpineAnimation(CHOOSE_SHOW_TAG)
end
LoginRegisterLayer["onLoginRegisterRandom"] = onLoginRegisterRandom
LoginRegisterLayer["onClickLoginRegisterBtnAdd"] = onClickLoginRegisterBtnAdd
LoginRegisterLayer["onClickLoginRegisterBtnJian"] = onClickLoginRegisterBtnJian
LoginRegisterLayer["onCLickLoginRegister"] = onCLickLoginRegister
LoginRegisterLayer["onLoginRegisterCreateActor"] = onLoginRegisterCreateActor




