
PRIORITY_BATTLE = -100
PRIORITY_MAP    = 0
MapRichTextNote = nil
--地图界面 
local bMapInited = false
local mapScrollLayer = nil
local HandGuidePassButton = nil
UserPveInfo = nil

local LIMIT_BOSS_COUNT = 3

--副本选择
local function onPassChoosed(node)
	local passId = tolua.cast(node, "cc.Node"):getTag()
	-- print("onPassChoosed", passId)
	CommonBattleLayer:setVisible(true)
	CommonTitleLayer:setVisible(false)
	SetMapRichTextNote(false)
	bFightWithBoss = 0
	ArnerFightId = 0
	ArnerFightRank = 0
	--if NextPvepassId == nil or (NextPvepassId ~= nil and passId ~= NextPvepassId) then
		NextPvepassId = passId
			-- print("onPassChoosed",NextPvepassId)
		NextFightLabel:setVisible(false)
		BattleMapTitle:setString(MultiLan(GameData:getPass(passId).name))
	--end
end

--购买Boss次数小弹窗
local function BuyBossPopup()	
	local function buyBossCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			CommonNote(MultiLan("map_desc1"))
			local cashCost = GameData:getGameDataTable().consume[UserSelfInfo.buy_boss_num+1].boss
			UserSelfInfo.cash = UserSelfInfo.cash - cashCost
			UseCash(cashCost)
			UserSelfInfo.boss_num = jsonDataTable.data.boss_num
			UserSelfInfo.buy_boss_num = jsonDataTable.data.buy_boss_num
			XiaLayerOwner["mMapDesc3"]:setString(UserSelfInfo.boss_num)
			return 
		end
	end

	local function sendMapBuy()
		if UserSelfInfo.buy_boss_num >= UserVipInfo.boss then
			-- print(UserVipInfo.level, GameData:getGameDataTable().vip[UserVipInfo.level+1].buy_boss_num)
			local richText = ccui.RichText:create()
			richText:setScale(1)
			richText:ignoreContentAdaptWithSize(false)
			richText:setContentSize(cc.size(460,70))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 , MultiLan("map_buyboss1").." ", DefaultFontName, FontSize2))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_YELLOW, 255 , "VIP"..UserSelfInfo.vip, DefaultFontName, FontSize2))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("map_buyboss2").." ", DefaultFontName, FontSize2))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 ,GameData:getGameDataTable().vip[UserVipInfo.level+1].boss, DefaultFontName, FontSize2))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("map_buyboss3"), DefaultFontName, FontSize2))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("map_buyboss4"), DefaultFontName, FontSize2))
			richText:pushBackElement(ccui.RichElementNewLine:create())
			if UserVipInfo.level < VIP_LEVEL_MAX then
				richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("map_buyboss5").." ", DefaultFontName, FontSize2))
				richText:pushBackElement(ccui.RichElementText:create(1, COLOR_YELLOW, 255 ,"VIP"..(UserSelfInfo.vip+1), DefaultFontName, FontSize2))
				richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("map_buyboss2").." ", DefaultFontName, FontSize2))
				richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 ,GameData:getGameDataTable().vip[UserVipInfo.level+2].boss, DefaultFontName, FontSize2))
				richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("map_buyboss3"), DefaultFontName, FontSize2))
			end
		
			if UserSelfInfo.vip ~= VIP_LEVEL_MAX then
				CreateSmallPopupWithPay("prompt", richText)
			else
				CommonNote(MultiLan("map_desc2"))
			end
		elseif UserSelfInfo.cash < GameData:getGameDataTable().consume[UserSelfInfo.buy_boss_num+1].boss then
			CommonCashNeed()
		else
			HttpSend("shop/buybossnum", {}, buyBossCallback)
		end
	end

	
	local color = COLOR_GREEN
	if UserVipInfo.boss-UserSelfInfo.buy_boss_num <= 0 then
		color = COLOR_RED
	end
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setContentSize(cc.size(455, 70))
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,string.format(MultiLan("map_desc3"), (UserSelfInfo.buy_boss_num+1), GameData:getGameDataTable().consume[UserSelfInfo.buy_boss_num+1].boss),DefaultFontName, FontSize3))
	richText:pushBackElement(ccui.RichElementText:create(2, color, 255 ,string.format(MultiLan("map_desc4"), UserVipInfo.level, math.max(UserVipInfo.boss-UserSelfInfo.buy_boss_num,0)),DefaultFontName, FontSize2))
	
	CreateSmallPopupWithCancel("buytimes", richText, sendMapBuy)
end

--Boss挑战次数不足处理
local function BossNumNeed()
	local bossItem = FindFirstByKey(UserInfo:getUserInfo().data.bag_prop, "prop_id",PROP_ID_BOSS_NUM)
	if bossItem == nil or bossItem.amount <= 0 then
		if UserSelfInfo.buy_boss_num < UserVipInfo.boss then
			BuyBossPopup()
		else
			CommonNote(MultiLan("map_desc5"))
		end
		return
	end
	
	local function useBossCallback(jsonDataTable)
		-- print("useBossCallback")
		if jsonDataTable.ret == 0 then
			-- print("useBossCallback", jsonDataTable.data.id, PROP_ID_BOSS_NUM)
			local propUseInfo = jsonDataTable.data
			if propUseInfo.id == bossItem.id then
				BagLayer:removePropFromBag(jsonDataTable.data.id, propUseInfo.n)
				UserSelfInfo.boss_num = UserSelfInfo.boss_num + propUseInfo.n
				CommonNote(MultiLan("desc_use_success"))
				CommonNote(MultiLan("map_desc1"))
				XiaLayerOwner["mMapDesc3"]:setString(UserSelfInfo.boss_num)
			end
		end
	end
	
	local function sendUseBoss()
		-- print("sendUseBoss")
		HttpSend("item/use", {"id="..bossItem.id, "n=1"}, useBossCallback)
	end
	
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setContentSize(cc.size(460, 70))
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("map_desc7"),DefaultFontName, FontSize3))
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 , bossItem.amount,DefaultFontName, FontSize3))
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("map_desc8"),DefaultFontName, FontSize3))
	
	CreateSmallPopupWithCancel("buytimes", richText, sendUseBoss)
end

--Boss选择 挑战 
local function onBossChoosed(node)
	if UserSelfInfo.boss_num <= 0 then
		BossNumNeed()
		return
	end
	GameGuide:handStepClick(23, HandGuidePassButton)
	local passId = tolua.cast(node, "cc.Node"):getTag()
	CommonNote(MultiLan("map_desc9")..MultiLan(GameData:getMonster(GameData:getPass(passId).boss).name), COLOR_WHITE)
	local pass = GameData:getPass(passId)
	
	NextFightLabel:setString(MultiLan("map_desc9").." "..MultiLan(pass.name).." "..MultiLan("map_desc10"))
	NextFightLabel:setVisible(true)
	bFightWithBoss = passId
	
	CommonBattleLayer:setVisible(true)
	CommonTitleLayer:setVisible(false)
	SetMapRichTextNote(false)
end

--删除战斗中掉落的钥匙
function DeleteBattleKey(keyInfo)
	if keyInfo == nil or keyInfo == CJSON_NULL or type(keyInfo) ~= "table" or table.maxn(keyInfo) ~= 3 then
		return 
	end
	
	for i=1,3 do
		if keyInfo[i] > 0 then
			UserInfo:removepropByPropId(KEY_ID_ARR[i], keyInfo[i])
		end
	end
end

function DeleteBoxItems(addItems, boxItems)
	if addItems ~= nil and addItems ~= CJSON_NULL and boxItems ~= nil and boxItems ~= CJSON_NULL then
		for i=1, 3 do
			if boxItems[i] ~= CJSON_NULL then
				for j=1, table.maxn(boxItems[i]) do
					for k=1,table.maxn(addItems) do
						if boxItems[i][j].id == addItems[k].prop_id then
							addItems[k].num = addItems[k].num - boxItems[i][j].num
						end
					end
				end
			end
		end
	end
end

function BattleAddBoxDesc(serverInfo, richText, size)
	--发现battlekey
	if serverInfo.box_num ~= nil and serverInfo.box_num ~= CJSON_NULL and serverInfo.box_item ~= nil and serverInfo.box_item ~= CJSON_NULL then
		--发现
		for i=1, 3 do
			if serverInfo.box_item[i] ~= CJSON_NULL then
				for j=1, table.maxn(serverInfo.box_item[i]) do
					local propInfo = serverInfo.box_item[i][j]
					local propData = GameData:getPropDataTable(propInfo.id) 
					richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("map_desc11").." ",DefaultFontName,size))
					richText:pushBackElement(ccui.RichElementText:create(1, BOX_COLOR_ARR[i], 255 ,BOX_NAME_ARR[i],DefaultFontName,size))
					richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ," "..MultiLan("map_desc12").." ",DefaultFontName,size))
					richText:pushBackElement(ccui.RichElementText:create(1, BOX_COLOR_ARR[i], 255 ,KEY_NAME_ARR[i],DefaultFontName,size))
					richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ," "..MultiLan("lan_get").." ",DefaultFontName,size))
					richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 ,MultiLan(propData.name).."*"..propInfo.num,DefaultFontName,size))
					richText:pushBackElement(ccui.RichElementNewLine:create())
				end
			end
		end

		for i=1, 3 do
			local findNum = serverInfo.box_num[i]
			local openNum = serverInfo.open_box_num[i]
			local leftNum = findNum - openNum
			if leftNum > 0 then
				richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("map_desc11").." ",DefaultFontName,size))
				richText:pushBackElement(ccui.RichElementText:create(1, BOX_COLOR_ARR[i], 255 ,BOX_NAME_ARR[i].."*"..leftNum,DefaultFontName,size))
				richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ," "..MultiLan("map_desc13").." ",DefaultFontName,size))
				richText:pushBackElement(ccui.RichElementText:create(1, BOX_COLOR_ARR[i], 255 ,KEY_NAME_ARR[i],DefaultFontName,size))
				richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ," "..MultiLan("map_desc14"),DefaultFontName,size))
				richText:pushBackElement(ccui.RichElementNewLine:create())
			end
		end

		local haveBoxBlessingItems = false
		for i=1, 3 do
			if serverInfo.box_item_boxBlessing[i] ~= CJSON_NULL then
				haveBoxBlessingItems = true
			end
		end
		if haveBoxBlessingItems and UserActiveInfo ~= nil and UserActiveInfo.daily_boxBlessing ~= nil then
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255, MultiLan("map_desc18"), DefaultFontName, size))
			richText:pushBackElement(ccui.RichElementNewLine:create())
			local temStr = ""
			for i=1, 3 do
				if serverInfo.box_item_boxBlessing[i] ~= CJSON_NULL then
					for j= 1, table.maxn(serverInfo.box_item_boxBlessing[i]) do
						local propInfo = serverInfo.box_item_boxBlessing[i][j]
						local propData = GameData:getPropDataTable(propInfo.id)
						richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255, temStr .. MultiLan(propData.name) .. "*" .. propInfo.num , DefaultFontName,size))
						temStr = ", "
					end
				end
			end
			richText:pushBackElement(ccui.RichElementNewLine:create())
		end

	end

end
--扫荡
local function onFarmChoosed(node)
	if UserSelfInfo.boss_num <= 0 then
		BossNumNeed()
		return
	end

	local function farmBossCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			local farmBossInfo = jsonDataTable.data
			UserAttr:SetUserLevelInfo(farmBossInfo.expinfo)
			
			UserSelfInfo.boss_num = UserSelfInfo.boss_num - 1
			XiaLayerOwner["mMapDesc3"]:setString(UserSelfInfo.boss_num)
			
			--删除钥匙
			DeleteBattleKey(farmBossInfo.open_box_num)
			
			--添加道具
			UserInfo:addProp(farmBossInfo.items)
			
			--扫荡结果弹窗
			local richText = ccui.RichText:create()
			richText:ignoreContentAdaptWithSize(false)
			richText:setContentSize(cc.size(460, 360))
			richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GBLa_battleResult_4")..", ",DefaultFontName, FontSize4))

			if farmBossInfo.exp ~= nil then
				richText:pushBackElement(ccui.RichElementText:create(1, cc.c3b(210,64,0), 255 ,MultiLan("CP_offlineReport_8").." "..farmBossInfo.exp..", ", DefaultFontName, FontSize4))
			end

			if farmBossInfo.gold ~= nil then
				richText:pushBackElement(ccui.RichElementText:create(1, cc.c3b(210,64,0), 255 ,MultiLan("CP_offlineReport_11")..farmBossInfo.gold,DefaultFontName,FontSize4))
			end

			--获得道具
			DeleteBoxItems(farmBossInfo.items, farmBossInfo.box_item)
			if farmBossInfo.items ~= nil then
				for i=1,table.maxn(farmBossInfo.items) do
					-- print("get",farmBossInfo.items[i].prop_id)
					if farmBossInfo.items[i].prop_id ~= PROP_ID_GOLD then
						local propData = GameData:getPropDataTable(farmBossInfo.items[i].prop_id)
						if propData.ptype ~= 7 and farmBossInfo.items[i].num > 0 then
							richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,", ",DefaultFontName,FontSize4))
							-- print(EQUIP_COLOR_ARR[propData.color],MultiLan("lan_get")..MultiLan(propData.name)..": "..farmBossInfo.items[i].num)
							richText:pushBackElement(ccui.RichElementText:create(1, EQUIP_COLOR_ARR[propData.color], 255 ,MultiLan("lan_get")..MultiLan(propData.name)..": "..farmBossInfo.items[i].num,DefaultFontName,FontSize4))
						end
					end
				end
			end

			richText:pushBackElement(ccui.RichElementNewLine:create())
			--获得装备
			if farmBossInfo.items ~= nil then
				for i=1,table.maxn(farmBossInfo.items) do
					-- print(i,farmBossInfo.items[i].prop_id,farmBossInfo.items[i].obj,farmBossInfo.items[i].num)
					if farmBossInfo.items[i].obj ~= CJSON_NULL and farmBossInfo.items[i].obj.attr ~= nil and farmBossInfo.items[i].obj.attr ~= CJSON_NULL then
						local propData = GameData:getPropDataTable(farmBossInfo.items[i].prop_id) 
						-- print(farmBossInfo.items[i].obj.extra)
						local color,grade = EquipHelper:getEquipColor(farmBossInfo.items[i].obj)
						-- print(grade)
						richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GBLa_battleResult_6"),DefaultFontName,FontSize4))
						richText:pushBackElement(ccui.RichElementText:create(1, EquipHelper:getEquipColor(farmBossInfo.items[i].obj), 255 ," [Lv."..propData.level.." "..MultiLan(propData.name).."]",DefaultFontName,FontSize4))
						richText:pushBackElement(ccui.RichElementNewLine:create())
					end
				end
			end
			richText:setPosition(Pos(POPUP_SIZE_MID, 0.5, 0.55))
			BattleAddBoxDesc(farmBossInfo, richText, FontSize4)
			cclog("hdfsfasd")
			CommonCreatePopupMid("cleanboss", richText, true)
		end
	end
	
	HttpSend("pve/fastboss", {"id="..tolua.cast(node, "cc.Node"):getTag()}, farmBossCallback)
end
	
function UpdateMapInfo()
	XiaLayerOwner["mMapDesc3"]:setString(UserSelfInfo.boss_num)

	local layer = cc.Layer:create()
	local userPve = UserInfo:getPveInfo()
	local count = userPve.id - 1000  
	layer:setContentSize(cc.size(600, count*136+60))
	local passData = GameData:getGameDataTable().pass
	for i = 1, count do
		local y = (count + 0.5 - i)*136 + 60
		if i ~= count then
			layer:addChild(CreateCommonSprite("board_overmap.png", cc.p(300, y)))
		else
			layer:addChild(CreateCommonSprite("board_challengemap.png", cc.p(300, y)))
		end
		
		--普通怪物
		local passButton = CreateCommonButton("city_"..passData[i].id..".png", cc.p(225, y), cc.size(407, 101), onPassChoosed)
        passButton:setSwallowTouch(false)
        passButton:setZoomOnTouchDown(false)
		tolua.cast(passButton, "cc.Layer"):setSwallowsTouches(false)
		layer:addChild(passButton, 0, passData[i].id)

		--副本名字 等级
		layer:addChild(CreateCommonSprite("board_mapname.png", cc.p(125, y + 15)))
		layer:addChild(CreateCommonLabel(MultiLan(passData[i].name), cc.p(35, y + 25), FontSize2, nil ,cc.p(0,0.5)))
		layer:addChild(CreateCommonLabel("Lv."..passData[i].level, cc.p(120, y - 6), FontSize2))
		
		--挂机中 新地图
		-- print("UpdateMapInfo",NextPvepassId)
		if NextPvepassId == passData[i].id then
			-- layer:addChild(CreateCommonSprite("wordboard_fightingmap.png", cc.p(320,y-35)))
			-- layer:addChild(CreateCommonFntLabel(ZGMultiLan("lbMapBattleFightingMap"), FntTypeUserTitle, cc.p(320, y - 35)))
			layer:addChild(CreateCommonLabel(ZGMultiLan("lbMapBattleFightingMap"), cc.p(320, y - 35), FontSize4, COLOR_FNT_UserTilte))
		end
		if i == count and NextPvepassId ~= passData[i].id then
			-- layer:addChild(CreateCommonSprite("wordboard_newmap.png", cc.p(370,y-30)))
			-- layer:addChild(CreateCommonFntLabel(ZGMultiLan("lbMapBattleNewMap"), FntTypeUserTitle, cc.p(370, y - 30)))
			layer:addChild(CreateCommonLabel(ZGMultiLan("lbMapBattleNewMap"), cc.p(370, y - 30), FontSize4, COLOR_FNT_UserTilte))
		end
		
		--挑战 扫荡
		local bossButton = nil
		-- print(i,count)
		if UserSelfInfo.vip > 0 and i ~= count then
			-- 扫荡Boss
			bossButton = CreateCommonButton("button_saodang.png",  cc.p(515, y), SIZE_CONFIGS.button_saodang, onFarmChoosed)
			local bossButtonSize = bossButton:getContentSize()
			-- bossButton:addChild(CreateCommonFntLabel(ZGMultiLan("button_map_boss_saodao"), FntTypeUserTitle, cc.p(bossButtonSize.width / 2, bossButtonSize.height * 0.35)))
			bossButton:addChild(CreateCommonLabel(ZGMultiLan("button_map_boss_saodao"), cc.p(bossButtonSize.width / 2, bossButtonSize.height * 0.35), FontSize4, COLOR_FNT_UserTilte))
		else
			-- 挑战Boss
			bossButton = CreateCommonButton("button_killboss.png", cc.p(515, y), SIZE_CONFIGS.button_killboss, onBossChoosed)
			local bossButtonSize = bossButton:getContentSize()
			-- bossButton:addChild(CreateCommonFntLabel(ZGMultiLan("button_map_boss_challage"), FntTypeUserTitle, cc.p(bossButtonSize.width / 2, bossButtonSize.height * 0.35)))
			bossButton:addChild(CreateCommonLabel(ZGMultiLan("button_map_boss_challage"), cc.p(bossButtonSize.width / 2, bossButtonSize.height * 0.35), FontSize4, COLOR_FNT_UserTilte))
		end
        bossButton:setSwallowTouch(false)
		layer:addChild(bossButton, 0, passData[i].id)
		if i == count then
			GameGuide:setHandGuide(23, bossButton)
			HandGuidePassButton = bossButton
		end
	end
	
	layer:addChild(CreateCommonSprite("board_nextmap.png",cc.p(300,30)))
	layer:addChild(CreateCommonLabel(MultiLan("map_desc15"),cc.p(300,23), FontSize1))
	
	
	layer:setContentSize(cc.size(600, count*136+60))
	if mapScrollLayer:getContentSize().height > count*136+60 then
		local scrollView = CreateScrollViewByFather(mapScrollLayer, layer, cc.p(0, mapScrollLayer:getContentSize().height-count*136-60),kScrollViewDirectionVertical)
		scrollView:setTouchEnabled(false)
	else
		CreateScrollViewByFather(mapScrollLayer, layer, cc.p(0, 0),kScrollViewDirectionVertical)
	end
end
	
function SetMapRichTextNote(bNeed)
	if bNeed then
		if MapRichTextNote ~= nil then
			removeSelf(MapRichTextNote)
		end
	
		local richText = ccui.RichText:create()
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("map_open1"), DefaultFontName, FontSize2))
		richText:pushBackElement(ccui.RichElementText:create(2, COLOR_GREEN, 200 ,(UserPveInfo.id-1000)..MultiLan("map_open2"), DefaultFontName, FontSize2))
		richText:pushBackElement(ccui.RichElementText:create(3, COLOR_WHITE, 255 ,MultiLan("map_open3")..",", DefaultFontName, FontSize2))
		richText:pushBackElement(ccui.RichElementText:create(4, COLOR_BLUE,  235 ,table.maxn(GameData:getGameDataTable().pass) - UserPveInfo.id + 1000, DefaultFontName, FontSize2))
		richText:pushBackElement(ccui.RichElementText:create(5, COLOR_WHITE, 255 ,MultiLan("map_open4"), DefaultFontName, FontSize2))
		richText:pushBackElement(ccui.RichElementText:create(6, COLOR_ORANGE, 200 ,"VIP1", DefaultFontName, FontSize2))
		richText:pushBackElement(ccui.RichElementText:create(7, COLOR_WHITE, 255 ,MultiLan("map_open5"), DefaultFontName, FontSize2))
		richText:setPosition(cc.p(320,885))
		MapRichTextNote = richText
		CommonMapLayer:addChild(richText)
	else
		if MapRichTextNote ~= nil then
			MapRichTextNote:setVisible(false)
		end
	end

end
	
local function MapLayerInit()
	if bMapInited then
		return
	end
	bMapInited = true
	UserPveInfo = UserInfo:getPveInfo()
	mapScrollLayer = XiaLayerOwner["mMapBackScrollLayer"]
	
	--彩色说明
	SetMapRichTextNote(true)
	
	XiaLayerOwner["mMapDesc1"]:setString("")
	XiaLayerOwner["mMapDesc2"]:setString(MultiLan("map_desc16"))
	XiaLayerOwner["mMapDesc3"]:setString(UserSelfInfo.boss_num)
	XiaLayerOwner["mMapDesc3"]:setColor(COLOR_GREEN)
	
	XiaLayerOwner["mMapBuyLabel"]:setString(MultiLan("button_buy"))
end

function MapEnter()
	-- print("MapEnter")
	GameGuide:resetHandGuide()
	GameGuide:handStepClick(21, XiaLayerOwner["mMainButton2"])
	GameGuide:setHandGuide(22, XiaLayerOwner["mBattleMapButton"])
	MapLayerInit()
	--UpdateMapInfo()
	CommonBattleLayer:setVisible(true)
	CommonTitleLayer:setVisible(false)
	SetMapRichTextNote(false)

	--BattleEnter()
	GameGuide:GuideEnter(GUIDE_TYPE_BATTLE)
end

local function onMapBuy()
	if UserSelfInfo.boss_num >= LIMIT_BOSS_COUNT then
		CommonNote(MultiLan("map_desc17"))
	else
		BuyBossPopup()
	end
end


XiaLayer["onMapBuy"]  = onMapBuy