
local bMarketInited = false
local MarketPage = nil
local MarketFilter = {0, 0, 0, 0}
local MarketItems = {}
local SellingItems = nil

local MARKET_COUNT = 10


UserMarketInfo = nil

local function EquipStaticIcon(equipInfo)
	local equipIcon = CreateBagItem()
	equipIcon:setCanTouch(false)
	equipIcon:setItemType(BAG_ITEM_TYPE_EQUIP)
	equipIcon:setItemInfoTable(equipInfo)
	return equipIcon
end

--[[创建一个MxN的格子 默认每个对象的size大小是一样的,默认每个对象的anchorpoint是0.5
	shiftValue  table    有4个值表示左右空白 上下空白 
	staticSize  cc.size  表示固定位置 没有staticSize表示动态设置father的contentSize
	movePoint   cc.p     固定位置时所有内容的偏移 cc.p()
	]]
function CreateMxN(father, m, n, layerTable, shiftValue, staticSize, movePoint)
	father:removeAllChildren(true)
	if layerTable == nil or layerTable[1] == nil then
		return
	end
	
	local count = table.maxn(layerTable)
	local width,height = layerTable[1]:getContentSize().width*layerTable[1]:getScaleX(), layerTable[1]:getContentSize().height*layerTable[1]:getScaleY()
	local totleWidth,totleHeight = father:getContentSize().width, father:getContentSize().height
	local left,right,up,down = 0,0,0,0
	local moveX,moveY = 0,0
	if movePoint ~= nil then
		moveX,moveY = movePoint.x, movePoint.y
	end
	if staticSize ~= nil then
		totleWidth,totleHeight = staticSize.width, staticSize.height
	else
		if count >0 then
			n = math.ceil(count/m)
		end
		father:setContentSize(cc.size(width*m, height*n))
		totleWidth,totleHeight = father:getContentSize().width, father:getContentSize().height
	end

	if shiftValue ~= nil then
		left,right,up,down = shiftValue[1],shiftValue[2],shiftValue[3],shiftValue[4]
		if staticSize ~= nil then
			totleWidth = totleWidth - left - right
			totleHeight = totleHeight - up - down
		end
	end
	moveX = moveX + left
	moveY = moveY + down
	
	for i=1, n do
		for j=1, m do
			local num = (i-1)*m+j
			local x = (j-0.5)*(totleWidth/m)
			local y = totleHeight - (i-0.5)*(totleHeight/n)
			if layerTable[num] ~= nil then
				father:addChild(layerTable[num])
				layerTable[num]:setPosition(cc.p(x+moveX, y+moveY))
			end
		end
	end
end

--设置顶部货币栏
function SetMarketTopLayer()

    --tolua.cast(XiaLayerOwner["mMarket"],"cc.Label"):setString("Lv."..UserSelfInfo.level)
	XiaLayerOwner["mMarketCash"]:setString(UserSelfInfo.coupon)
	XiaLayerOwner["mMarketVip"]:setString(UserSelfInfo.vip)
end

--获取更多物品
function QusetMoreMarketItems()
	
end

--设置当前显示的商品
function SetMarketPage(move)
	if MarketPage == nil then
		MarketPage = 1
		XiaLayerOwner["mMarketPageLabel"]:setString(MarketPage)
		MarketUpdateList(MarketPage)
		return
	end
	if move ~= nil and MarketPage + move  > 0 then
		if MarketItems[MARKET_COUNT*(MarketPage + move)] ~= nil then
			MarketPage = MarketPage + move
			XiaLayerOwner["mMarketPageLabel"]:setString(MarketPage)
			MarketUpdateList(MarketPage)
		else
			local maxId = 0
			if table.maxn(MarketItems) > 0 then
				maxId = MarketItems[table.maxn(MarketItems)].id
			end
			
			local function moreItemCallback(jsonDataTable)
				if jsonDataTable.ret == 0 then
					if jsonDataTable.data.status == 1 then
						CommonNote(MultiLan("market_note7"))
					else
						for i=1, table.maxn(jsonDataTable.data.equip) do
							table.insert(MarketItems, jsonDataTable.data.equip[i])
						end
					end
					if MarketItems[MARKET_COUNT*(MarketPage + move-1)+1] ~= nil then
						MarketPage = MarketPage + move
						XiaLayerOwner["mMarketPageLabel"]:setString(MarketPage)
						MarketUpdateList(MarketPage)
					end
				end
			end
			
			HttpSend("market/info", {"idx="..maxId, "filter="..MarketFilter[1]..","..MarketFilter[2]..","..MarketFilter[3]..","..MarketFilter[4]}, moreItemCallback)
		end
	else
		XiaLayerOwner["mMarketPageLabel"]:setString(MarketPage)
		MarketUpdateList(MarketPage)
	end
end

--购买点击
local function onMarketItemBuy(node)
	local tag = node:getTag()
	
	local function marketBuyCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			--添加道具
			UserInfo:addProp(jsonDataTable.data.items)
			
			--减少银票
			UserSelfInfo.coupon = UserSelfInfo.coupon - jsonDataTable.data.use
			SetMarketTopLayer()
			
			--删除数据
			if MarketItems[tag] ~= nil then
				table.remove(MarketItems, tag)
			end
			
			--刷新界面
			CommonNote(MultiLan("GALa_buySucceed"))
			SetMarketPage()
		end
	end
	
	local function sendMarketBuy()
		if UserSelfInfo.coupon < MarketItems[tag].price then
			CommonCouponNeed()
			--CommonNote(MultiLan("market_note5"))
		else
			HttpSend("market/buy", {"id="..MarketItems[tag].id}, marketBuyCallback)
		end
	end
	
	if UserSelfInfo.coupon < MarketItems[tag].price then
		CommonCouponNeed()
		--CommonNote(MultiLan("market_note5"))
	else
		CreateSmallPopupWithCancel("prompt", CreateCommonLabel(string.format(MultiLan("market_desc4"), MarketItems[tag].price), nil,FontSize3, nil,nil,cc.size(455,100)), sendMarketBuy)
	end
end

--物品详情
local function onMarketItemClick(node)
	local tag = node:getTag()
	local midLayer = CreateLayer(POPUP_SIZE_MID, 1, Pos(POPUP_SIZE_MID, 0.5, 0.45))
	local root = CommonCreatePopupMid("sjwuxin", midLayer, true)
	local detailInfo = MarketItems[tag].obj

	local equip = EquipStaticIcon(detailInfo)
	equip:setPosition(cc.p(120, 550))
	midLayer:addChild(equip)

	local itemInfoRichText = EquipHelper:createItemInfoRichtext(detailInfo, nil,nil,bShowOthers)
	itemInfoRichText:setContentSize(cc.size(290, 500))
	itemInfoRichText:formatText()
	itemInfoRichText:ignoreAnchorPointForPosition(true)
	itemInfoRichText:setPosition(cc.p(180, 100))
	midLayer:addChild(itemInfoRichText)
	
	--价格
	local height1 = 0.28
	midLayer:addChild(CreateCommonLabel(MultiLan("market_desc1"), Pos(POPUP_SIZE_MID,0.34,height1), FontSize2, nil,cc.p(1,0.5)))
	midLayer:addChild(CreateCommonSprite("board_skill01.png", Pos(POPUP_SIZE_MID,0.5,height1),0.47,0.8,180))
	midLayer:addChild(CreateCommonSprite("icon_drafts.png", Pos(POPUP_SIZE_MID,0.4,height1)))
	midLayer:addChild(CreateCommonLabel(MarketItems[tag].price, Pos(POPUP_SIZE_MID,0.53,height1), FontSize2))
	
	--卖家
	local height2 = 0.21
	midLayer:addChild(CreateCommonSprite("board_skill01.png", Pos(POPUP_SIZE_MID,0.5,height2),1.1,0.8,180))
	midLayer:addChild(CreateCommonLabel(MultiLan("market_desc2")..MarketItems[tag].name, Pos(POPUP_SIZE_MID,0.18,height2), FontSize2, nil, cc.p(0, 0.5)))
	midLayer:addChild(CreateCommonLabel(MultiLan("market_desc3")..TurnSecendsToDay(MarketItems[tag].mtime, 2), Pos(POPUP_SIZE_MID,0.82,height2), FontSize2, COLOR_GREEN, cc.p(1, 0.5)))
	
	--购买
	local function onBuyClick(node)
		removeSelf(root)
		onMarketItemBuy(node)
	end
	midLayer:addChild(CreateCommonButton("button_green.png", Pos(POPUP_SIZE_MID,0.5,0.11),  cc.size(144,50), onBuyClick, {str=MultiLan("button_buy"),size=FontSize6}), 0, tag)
end

--刷新显示的商品列表列表
function MarketUpdateList()
	-- print("MarketUpdateList",MarketPage,table.maxn(MarketItems))
	local tt = {}
	
	for i=(MarketPage-1)*10+1, MarketPage*10 do
		-- print(i,MarketItems[i])
		if MarketItems[i] ~= nil then
			local back = CreateCommonSprite("board_sjwupin.png")
			local backSize = back:getContentSize()
			table.insert(tt, back)
			
			local button = CreateCommonButton("pic_suiyiaaa.png", Pos(backSize,0.2,0.5), cc.size(100,100), onMarketItemClick)
			back:addChild(button, 0, i)
			local buttonArea = CreateLayer(cc.size(100,100),1,Pos(backSize,0.15,0.5))
			back:addChild(buttonArea)
			local equip = EquipStaticIcon(MarketItems[i].obj)
			equip:setPosition(Pos(button:getContentSize()))
			buttonArea:addChild(equip)
			
			back:addChild(CreateCommonLabel(MultiLan("prop_name_"..MarketItems[i].obj.prop_id), Pos(backSize,0.62,0.7), FontSize2))
			back:addChild(CreateCommonSprite("icon_drafts.png", Pos(backSize,0.43,0.3)))
			back:addChild(CreateCommonLabel(MarketItems[i].price, Pos(backSize,0.62,0.3), FontSize2))
			
			local buyButton = CreateCommonButton("button_goumaiwp.png", Pos(backSize,0.91,0.5), cc.size(41,84), onMarketItemBuy)
			-- local buyButtonLabel = CreateCommonFntLabel(ZGMultiLan("button_market_buy"), FntTypeUserTitle, Pos(buyButton:getContentSize(), 0.5, 0.5))
			local buyButtonLabel = CreateCommonLabel(ZGMultiLan("button_market_buy"), Pos(buyButton:getContentSize(), 0.5, 0.5), FontSize4, COLOR_FNT_UserTilte)
			buyButtonLabel:setScale(0.8)
			buyButton:addChild(buyButtonLabel)
			back:addChild(buyButton, 0, i)
		end
	end
	-- print("table.maxn(tt)", table.maxn(tt))
	CreateMxN(XiaLayerOwner["mMarketScrollLayer"], 2, 5, tt, nil, XiaLayerOwner["mMarketScrollLayer"]:getContentSize())
end

local function MarketLayerInit()
	-- print("MarketLayerInit")
	if bMarketInited then
		return
	end

	bMarketInited = true
	--初始化左右翻页
	local swallowLayer = XiaLayerOwner["mMarketSwallowLayer"]
	local beginx = 0
	local endx = 0
	local function onTouchBegan(touch, event)
		if not XiaLayerOwner["mMarketLayer"]:isVisible() then
			return false
		end
		-- print("onTouchBegan")
		local locationInNode = swallowLayer:convertToNodeSpace(touch:getLocation())
		beginx = locationInNode.x
		-- print("beginx",beginx)
		if locationInNode.y <= 0 or locationInNode.y >=  swallowLayer:getContentSize().height or locationInNode.x <= 0 or locationInNode.x >=  swallowLayer:getContentSize().width then
			return false
		end
		return true
	end
	
	local function onTouchEnded(touch, event)
		-- print("onTouchEnded",beginx)
		local locationInNode = swallowLayer:convertToNodeSpace(touch:getLocation())
		endx = locationInNode.x
		-- print(endx, beginx)
		if locationInNode.y <=0 or locationInNode.y >=  swallowLayer:getContentSize().height then
			return true
		end
		if endx - beginx > swallowLayer:getContentSize().width/3 then
			onMarketLeft()
		elseif beginx - endx > swallowLayer:getContentSize().width/3 then
			onMarketRight()
		end
		return true
	end
		
	local eventDispatcher = swallowLayer:getEventDispatcher()
	local listener = cc.EventListenerTouchOneByOne:create()    
	listener:setSwallowTouches(false)
	listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN )
	listener:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED )
	eventDispatcher:addEventListenerWithSceneGraphPriority(listener, swallowLayer)
	
	--按钮
	XiaLayerOwner["mMarketTopLayer"]:setVisible(true)
	XiaLayerOwner["mMarketButtonFilter"]:setTitleForState(MultiLan("market_button1"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mMarketButtonSell"]:setTitleForState(MultiLan("market_button2"), cc.CONTROL_STATE_NORMAL)
end

function MarketEnter()
	for i=1, 100 do
		--MarketItems[i] = {prop_id=235032, price=1000, mtime = i*i, name="С"}
	end
	--UserSelfInfo.coupon = UserSelfInfo.cash

	SetMarketTopLayer()
	SellingItems = nil
	MarketLayerInit()
	SetMarketPage()
	GameGuide:GuideEnter(GUIDE_TYPE_MARKET)
end

function MarketExit()

end

--寄售物品弹窗
local function MarketSellPopup()
	local midLayer = CreateLayer(POPUP_SIZE_MAX, 1, Pos(POPUP_SIZE_MAX))
	local root = CommonCreatePopupMax("sjjishou", midLayer, true)
	
	--上架点击
	local chooseLayerCount = 0
	local function onItemUp(node)
		local pos = node:getTag()
		if chooseLayerCount > 0 then
			return
		end
		-- print("onItemUp")
		chooseLayerCount = chooseLayerCount + 1
		local chooseLayer = CreateLayer(POPUP_SIZE_MID, 1, Pos(POPUP_SIZE_MID))
		local choosePopup = CommonCreatePopupMid("sjxuanwp", chooseLayer)
		local chooseItem = false
		
		--描述
		chooseLayer:addChild(CreateCommonSprite("board_skill02.png", Pos(POPUP_SIZE_MID,0.5,0.89), 1.4, 1.2)) 
		local descBack = CreateLayer(cc.size(480,70), 1, Pos(POPUP_SIZE_MID, 0.5, 0.89))
		chooseLayer:addChild(descBack)
		CreateRichtextByFather(descBack, {{str=MultiLan("market_sell_desc4"), color=COLOR_RED, size=FontSize1}})
		
		local function onChooseUpItem(node)
			local choosedEquip = FindFirstByKey(UserInfo:getUserInfo().data.bag_equip, "id", node:getTag())
			if chooseItem or choosedEquip == nil then
				return 
			end
			chooseItem = true
			-- print("onChooseUpItem")
			
			local detailLayer = CreateLayer(POPUP_SIZE_MID, 1, Pos(POPUP_SIZE_MID))
			local function closeChaCha()
				chooseItem = false
			end
			local detailRoot = CommonCreatePopupMid("wupinjs", detailLayer, closeChaCha)

			local equip = EquipStaticIcon(choosedEquip)
			equip:setPosition(cc.p(120, 550))
			detailLayer:addChild(equip)

			local itemInfoRichText = EquipHelper:createItemInfoRichtext(choosedEquip, nil, nil, bShowOthers)
			itemInfoRichText:setContentSize(cc.size(290, 500))
			itemInfoRichText:formatText()
			itemInfoRichText:ignoreAnchorPointForPosition(true)
			itemInfoRichText:setPosition(cc.p(180, 100))
			detailLayer:addChild(itemInfoRichText)

			--描述
			local rate = 20
			local height1 = 0.36
			local priceValue = 100
			local costGold = 200*priceValue+2000
			detailLayer:addChild(CreateLayerBackSprite("board_skill02.png", cc.size(480, 100), Pos(POPUP_SIZE_MID, 0.5, 0.23)))
			local descLayer = CreateLayer(cc.size(460, 95), 1, Pos(POPUP_SIZE_MID, 0.5, 0.23))
			detailLayer:addChild(descLayer)
			local function refreshPriceDesc()
				local color = COLOR_WHITE
				costGold = 200*priceValue+2000
				if UserSelfInfo.gold < costGold then
					color = COLOR_RED
				end
				local coinId = PROP_ID_CASH
				if IsTgamePlartform() then
					coinId = PROP_ID_COUPON
				end
				local labelArr = {CreateCommonLabel(MultiLan("market_sell_desc7")..costGold..MultiLan("prop_name_"..PROP_ID_GOLD), nil, FontSize2, color),
								  CreateCommonLabel(MultiLan("market_sell_desc8")..rate.."%", nil, FontSize2),
								  CreateCommonLabel(MultiLan("market_sell_desc9")..math.ceil(priceValue*(100-rate)/100)..MultiLan("prop_name_"..coinId), nil, FontSize2, COLOR_GREEN)}
				CreateMultiTextByFather(descLayer,labelArr, true)
			end
			
			
			--价格
			--detailLayer:addChild(CreateCommonLabel(MultiLan("market_sell_desc6"), Pos(POPUP_SIZE_MID,0.5,height1+0.065), FontSize2, COLOR_GREEN))
			detailLayer:addChild(CreateCommonSprite("board_shoumaijg.png", Pos(POPUP_SIZE_MID, 0.5, height1)))
			detailLayer:addChild(CreateCommonLabel(MultiLan("market_sell_desc5"), Pos(POPUP_SIZE_MID,0.3,height1), FontSize2, nil, cc.p(1,0.5)))
			detailLayer:addChild(CreateCommonSprite("board_skill01.png", Pos(POPUP_SIZE_MID,0.53,height1),0.5,0.95,200))
			detailLayer:addChild(CreateCommonSprite("icon_drafts.png", Pos(POPUP_SIZE_MID,0.36,height1)))
			if EquipHelper:isRedEquip(choosedEquip) then
				priceValue = 1000
			else
				priceValue = 100
			end
			refreshPriceDesc()
			local priceLabel = CreateCommonLabel(priceValue, Pos(POPUP_SIZE_MID,0.5,height1), FontSize4)
			detailLayer:addChild(priceLabel)
			
			local function onSetPrice()
				local pupupSmall = CreateLayer(POPUP_SIZE_SML, 1)
				local priceBox = cc.EditBox:create(cc.size(240, 40), cc.Scale9Sprite:createWithSpriteFrameName("board_account01.png"))
				pupupSmall:addChild(priceBox)
				priceBox:setReturnType(cc.KEYBOARD_RETURNTYPE_SEND)
				priceBox:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
				priceBox:setText(tostring(priceValue))
				priceBox:setPosition(Pos(POPUP_SIZE_SML,0.5,0.4)) 
				pupupSmall:addChild(CreateCommonLabel(MultiLan("market_sell_desc6"), Pos(POPUP_SIZE_SML,0.5,0.55), FontSize2, COLOR_GREEN, nil, cc.size(480,60)))
				local function setPrice()
					local price = tolua.cast(priceBox,"cc.EditBox"):getText()
					local priceNumber = 0
					price = string.gsub(price," ","")
					if string.match(price, string.rep("[%a|%d]",string.len(price))) == nil then
						CommonNote(MultiLan("market_note4"))
						return
					end
					
					if price == nil then
						priceNumber = 0
					else
						priceNumber = tonumber(price)
					end
				
					if EquipHelper:isRedEquip(choosedEquip) then
						if priceNumber < 1000 or priceNumber > 10000 then
							CommonNote(MultiLan("market_note4"))
							return
						end
					else
						if priceNumber < 100 or priceNumber > 1000 then
							CommonNote(MultiLan("market_note4"))
							return
						end
					end
					
					priceValue = priceNumber
					priceLabel:setString(priceValue)
					refreshPriceDesc()
				end
				
				CreateSmallPopupWithCancel("wupinjs", pupupSmall, setPrice)
			end
			
			detailLayer:addChild(CreateCommonButton("button_sjsmjg.png", Pos(POPUP_SIZE_MID,0.8,height1),cc.size(93, 36), onSetPrice, {str=MultiLan("market_button_setprice"), size=FontSize2}))

			--上架
			local function onMarketPuton()
				if EquipHelper:isRedEquip(choosedEquip) then
					if priceValue < 1000 or priceValue > 10000 then
						CommonNote(MultiLan("market_note4"))
						return
					end
				else
					if priceValue < 100 or priceValue > 1000 then
						CommonNote(MultiLan("market_note4"))
						return
					end
				end
				
				if UserSelfInfo.gold < costGold then
					CommonGoldNeed()
					return
				end
				
				local function itemUpCallback(jsonDataTable)
					if jsonDataTable.ret == 0 then
						--数据
						UserSelfInfo.gold = UserSelfInfo.gold - jsonDataTable.data.use
						
						UserInfo:removeEquipByIdAndObj(jsonDataTable.data.id,0)
						if FindFirstByKey(SellingItems, "pos", jsonDataTable.data.equip.pos) == nil then
							table.insert(SellingItems, jsonDataTable.data.equip)
						end
						
						--显示
						CommonNote(MultiLan("market_note6"))
						removeSelf(choosePopup)
						removeSelf(detailRoot)
						removeSelf(root)
						MarketSellPopup()
					end
				end
				
				HttpSend("market/sell", {"id="..choosedEquip.id,"price="..priceValue,"pos="..pos}, itemUpCallback)
			end
			detailLayer:addChild(CreateCommonButton("button_green.png", Pos(POPUP_SIZE_MID,0.5,0.08),  cc.size(144,50), onMarketPuton, {str=MultiLan("market_button_puton"),size=FontSize6}))
		end
		
		local function canSell(equipInfo)
			-- print("canSell",equipInfo.id,equipInfo.prop_id, EquipHelper:getEquipGrade(equipInfo))
			if (equipInfo.strengthen > 0 or equipInfo.slots > 2 or (equipInfo.stone ~= CJSON_NULL and table.maxn(equipInfo.stone) > 0)
				or (EquipHelper:isMaster(equipInfo) and equipInfo.master_level > 1)
				or (EquipHelper:isGlyph(equipInfo) and equipInfo.glyph_level > 1)
				or EquipHelper:isBothMG(equipInfo)) then
				-- print("false1")
				return false
			elseif EquipHelper:getEquipGrade(equipInfo) >= 5 then 
				local minValue = 10000
				local maxValue = 0
				for k,v in pairs(equipInfo.extra) do
					minValue = math.min(minValue, v)
					maxValue = math.max(maxValue, v)
				end
				-- print("minValue",minValue,maxValue)
				if maxValue >= minValue*1.2 and maxValue - minValue >= 5 then
					-- print("false2", maxValue, maxValue)
					return false
				else
					return true
				end
			end
			
			return false
		end
		
		--滚动区域
		chooseLayer:addChild(CreateLayerBackSprite("board_equip.png", cc.size(480, 440), Pos(POPUP_SIZE_MID,0.5,0.49)))
		local scrollLayer  = CreateLayer(cc.size(480, 440), 1, Pos(POPUP_SIZE_MID,0.5,0.49))
		chooseLayer:addChild(scrollLayer)
		local layer = cc.Layer:create()
		local tt = {}
		local bagEquip = UserInfo:SortEquipBag()
		for i=1, table.maxn(bagEquip) do
			if canSell(bagEquip[i]) then
				local equip = EquipStaticIcon(bagEquip[i])
				local clickButton = CreateCommonButton("pic_suiyiaaa.png", Pos(equip:getContentSize()), cc.size(100,100), onChooseUpItem)
				clickButton:setSwallowTouch(false)
				equip:addChild(clickButton, 0, bagEquip[i].id)
				table.insert(tt, equip)
			end
		end
		local line = math.ceil(table.maxn(tt)/4)
		layer:setContentSize(cc.size(480, line*110))
		CreateMxN(layer, 4, line, tt,nil, cc.size(480, line*110))
		local scrollview = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, 440-line*110), kScrollViewDirectionVertical)
	
		--关闭
		local function onChooseClose()  
			removeSelf(choosePopup) 
			chooseLayerCount = chooseLayerCount - 1
		end
		chooseLayer:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_MID,0.5,0.08),  cc.size(144,50), onChooseClose, {str=MultiLan("button_close"),size=FontSize6}))
	end
	
	--下架点击
	local function onItemDown(node)
		local function itemDownCallback(jsonDataTable)
			if jsonDataTable.ret == 0 then
				RemoveFirstByKey(SellingItems, "pos", node:getTag())
				if jsonDataTable.data.status == 1 then
					CommonNote(MultiLan("market_note1"))
				else
					CommonNote(MultiLan("market_note2"))
					UserInfo:addProp(jsonDataTable.data.items)
				end
				
				removeSelf(root)
				MarketSellPopup()
			end
		end
		
		local function sendDown()
			HttpSend("market/off", {"pos="..node:getTag()}, itemDownCallback)
		end
		
		CreateSmallPopupWithCancel("prompt", CreateCommonLabel(MultiLan("market_note3"), nil,FontSize3, nil,nil,cc.size(455,100)), sendDown)
	end
	
	--寄售商品
	local sellVupLevel = {0,1,3,6,10,15} --VIP栏位
	local sellLayer = CreateLayer(cc.size(560, 480), 1, Pos(POPUP_SIZE_MAX,0.5,0.645))
	midLayer:addChild(sellLayer)
	sellLayer:removeAllChildren(true)
	local tt = {}
	for i=1, 6 do
		local back = CreateLayer(cc.size(190,210), 1)
		local backSize = back:getContentSize()
		local sprite = CreateCommonSprite("board_sjdaisjia.png", Pos(backSize,0.5,0.65))
		back:addChild(sprite)
		
		if UserSelfInfo.vip >= sellVupLevel[i] then
			local sellItemInfo = FindFirstByKey(SellingItems, "pos", i)
			if sellItemInfo ~= nil then
				sprite:addChild(CreateCommonSprite("board_sjsmwup.png", Pos(sprite:getContentSize(),0.5,0.2)))
				sprite:addChild(CreateCommonSprite("icon_drafts.png", Pos(sprite:getContentSize(),0.2,0.29)))
				sprite:addChild(CreateCommonLabel(sellItemInfo.price, Pos(sprite:getContentSize(),0.57,0.29), FontSize2))
				sprite:addChild(CreateCommonLabel(MultiLan("market_desc3")..TurnSecendsToDay(sellItemInfo.mtime, 2), Pos(sprite:getContentSize(),0.5,0.11), FontSize2))
			
				local equip = EquipStaticIcon(sellItemInfo.obj)
				equip:setPosition(Pos(sprite:getContentSize(),0.5,0.66))
				sprite:addChild(equip)
			
				local downButton = CreateCommonButton("button_red.png", Pos(backSize,0.5,0.09),  cc.size(144,50), onItemDown, {str=MultiLan("market_button_down"),size=FontSize6})
				downButton:setScale(0.75)
				back:addChild(downButton, 0 ,i)
			else
				sprite:addChild(CreateCommonButton("pic_suiyiaaa.png", Pos(sprite:getContentSize()), sprite:getContentSize(), onItemUp), 0 ,i)
				sprite:addChild(CreateCommonLabel(MultiLan("market_button_up"),Pos(sprite:getContentSize(),0.5,0.55), FontSize3))
				local upButton = CreateCommonButton("button_green.png", Pos(backSize,0.5,0.09),  cc.size(144,50), onItemUp, {str=MultiLan("market_button_up"),size=FontSize6})
				upButton:setScale(0.75)
				back:addChild(upButton, 0 ,i)
			end
		else
			sprite:setSpriteFrame("board_sjsmsuodi.png")
			--
			back:addChild(CreateCommonLabel(string.format(MultiLan("lan_need_vip_n"), sellVupLevel[i]), Pos(backSize,0.5,0.4),FontSize4))
		end
		table.insert(tt, back)
	end
	
	CreateMxN(sellLayer, 3, 2, tt, nil, sellLayer:getContentSize())

	
	--描述
	midLayer:addChild(CreateCommonSprite("board_skill02.png", Pos(POPUP_SIZE_MAX,0.5,0.21), 1.6, 2.85)) 
	local descBack = CreateLayer(cc.size(560,150), 1,Pos(POPUP_SIZE_MAX,0.5,0.12), cc.p(0.5, 0))
	midLayer:addChild(descBack)
	CreateRichtextByFather(descBack, {{str=MultiLan("market_sell_desc1"), size=FontSize4},{size=nil},
										{str=MultiLan("market_sell_desc2"), size=FontSize4},{size=nil},
										{str=MultiLan("market_sell_desc3"), size=FontSize4}
									 })

	--关闭
	local function closeSell() removeSelf(root) end
	midLayer:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_MAX,0.5,0.05),  cc.size(144,50), closeSell, {str=MultiLan("button_close"),size=FontSize6}))
end

--寄售
function onMarketSell()
	--CommonNote("onMarketSell")
	if SellingItems == nil then
		local function sellInfoCallback(jsonDataTable)
			if jsonDataTable.ret == 0 then
				SellingItems = jsonDataTable.data.equip
				MarketSellPopup()
			end
		end
		
		--SellingItems={{obj=UserInfo:getUserInfo().data.bag_equip[3],mtime=100,pos=2,price=1000 },{obj=UserInfo:getUserInfo().data.bag_equip[5],mtime=20000,pos=1,price=2000 }}
		--MarketSellPopup()
		HttpSend("market/sellinfo", {}, sellInfoCallback)
	else
		MarketSellPopup()
	end
end

--筛选物品
function onMarketFilter()
	--CommonNote("onMarketFilter")
	--MarketFilter
	local midLayer = CreateLayer(POPUP_SIZE_MID, 1, Pos(POPUP_SIZE_MID))
	local root = CommonCreatePopupMid("sjwpsxuan", midLayer, true)
	local tagArr = {}
	local tagMaxArr = {3,2,5,10}
	for i=1,table.maxn(MarketFilter) do
		tagArr[i] = MarketFilter[i]
	end
	
	--刷新打勾
	local function refreshHook()
		-- print("refreshHook",table.maxn(tagArr))
		for i=1, table.maxn(tagArr) do
			local balckLayer = midLayer:getChildByTag(i)
			-- print(i, tagMaxArr[i])
			for j=1, tagMaxArr[i] do
				local hook = balckLayer:getChildByTag(10*i+j):getChildByTag(1)
				if tagArr[i] == j then
					hook:setVisible(true)
				else
					hook:setVisible(false)
				end
			end
		end
	end
	
	--钩子点击
	local function onHookClick(node)
		local father = node:getParent()
		local tag = father:getTag()
		local t,v = 0,0
		if tag == 50 then
			t = 4
			v = 10
		else
			t = math.floor(tag/10)
			v = tag%10
		end
		
		if tagArr[t] == v then
			tagArr[t] = 0
		else
			tagArr[t] = v
		end
		refreshHook()
	end
	
	local function createSmalChoose(str, color, tag)
		local smallSize = cc.size(170, 60)
		local layer = CreateLayer(smallSize, 1)
		layer:setScale(0.7)
		layer:addChild(CreateCommonLabel(str, Pos(smallSize,0.6,0.5), FontSize4, color, cc.p(1,0.5)))
		local button = CreateCommonButton("board_skill03.png", Pos(smallSize,0.85,0.5), cc.size(66, 66), onHookClick)
		layer:addChild(button)	
		layer:addChild(CreateCommonSprite("pic_hook.png", Pos(smallSize,0.85,0.5)), 0, 1)
		layer:setTag(tag)
		
		return layer
	end
	
	--门派
	midLayer:addChild(CreateLayerBackSprite("board_equip.png", cc.size(480, 120), Pos(POPUP_SIZE_MID,0.5,0.85), 200))
	local blackLayer = CreateLayer(cc.size(500, 120), 1, Pos(POPUP_SIZE_MID,0.5,0.85))
	midLayer:addChild(blackLayer, 0, 1)
	layerTable = {createSmalChoose(MultiLan("market_filter_desc11"), COLOR_WHITE, 11),
					createSmalChoose(MultiLan("market_filter_desc12"), COLOR_WHITE, 12),
					createSmalChoose(MultiLan("market_filter_desc13"), COLOR_WHITE, 13)}
	CreateMxN(blackLayer, 3, 1, layerTable,nil, blackLayer:getContentSize())
	--装备类型
	midLayer:addChild(CreateLayerBackSprite("board_equip.png", cc.size(480, 60), Pos(POPUP_SIZE_MID,0.5,0.69), 200))
	blackLayer = CreateLayer(cc.size(500, 60), 1, Pos(POPUP_SIZE_MID,0.5,0.69))
	midLayer:addChild(blackLayer, 0, 2)
	layerTable = {createSmalChoose(MultiLan("market_filter_desc21"), EQUIP_COLOR_ARR[5], 21),
					createSmalChoose(MultiLan("market_filter_desc22"), COLOR_RED, 22)}
	CreateMxN(blackLayer, 3, 1, layerTable,nil, blackLayer:getContentSize())
	
	--等级
	midLayer:addChild(CreateLayerBackSprite("board_equip.png", cc.size(480, 120), Pos(POPUP_SIZE_MID,0.5,0.54), 200))
	blackLayer = CreateLayer(cc.size(500, 120), 1, Pos(POPUP_SIZE_MID,0.5,0.54))
	midLayer:addChild(blackLayer,0,3)
	layerTable = {createSmalChoose(MultiLan("market_filter_desc31"), COLOR_WHITE, 31),
					createSmalChoose(MultiLan("market_filter_desc32"), COLOR_WHITE, 32),
					createSmalChoose(MultiLan("market_filter_desc33"), COLOR_WHITE, 33),
					createSmalChoose(MultiLan("market_filter_desc34"), COLOR_WHITE, 34),
					createSmalChoose(MultiLan("market_filter_desc35"), COLOR_WHITE, 35)}
	CreateMxN(blackLayer, 3, 2, layerTable,nil, blackLayer:getContentSize())
	
	--部位
	midLayer:addChild(CreateLayerBackSprite("board_equip.png", cc.size(480, 180), Pos(POPUP_SIZE_MID,0.5,0.3), 200))
	blackLayer = CreateLayer(cc.size(500 , 180), 1, Pos(POPUP_SIZE_MID, 0.47, 0.3))
	midLayer:addChild(blackLayer, 0, 4)
	layerTable = {}
	for i=1, EQUIP_PLACE_MAX do
		table.insert(layerTable, createSmalChoose(MultiLan("equip_place_"..i), COLOR_WHITE, 40+i))
	end
	CreateMxN(blackLayer, 4, 3, layerTable,nil, blackLayer:getContentSize())
	
	refreshHook()
	
	--取消
	local function onFilterCancel()
		removeSelf(root)
	end
	midLayer:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_MID,0.3,0.08),  cc.size(144,50), onFilterCancel, {str=MultiLan("button_cancel"),size=FontSize6}))
	
	--确定
	local function onFilterSure()
		local function filterMarketCallback(jsonDataTable)
			if jsonDataTable.ret == 0 then
				if jsonDataTable.data.status == 1 then
					CommonNote(MultiLan("market_note7"))
					MarketItems = {}
				else
					MarketItems = jsonDataTable.data.equip
				end
				MarketPage = 1
				SetMarketPage()
			end
		end

		for i=1,table.maxn(MarketFilter) do
			MarketFilter[i] = tagArr[i]
		end
		removeSelf(root)
		
		HttpSend("market/info", {"idx=0", "filter="..MarketFilter[1]..","..MarketFilter[2]..","..MarketFilter[3]..","..MarketFilter[4]}, filterMarketCallback)
	end
	midLayer:addChild(CreateCommonButton("button_green.png", Pos(POPUP_SIZE_MID,0.7,0.08),  cc.size(144,50), onFilterSure, {str=MultiLan("button_ok"),size=FontSize6}))
	
end

--左翻
function onMarketLeft()
	--CommonNote("onMarketLeft")
	SetMarketPage(-1)
end

--右翻
function onMarketRight()
	--CommonNote("onMarketRight")
	SetMarketPage(1)
end

--主页 市集点击
function onHomeMarketClick()
	local function marketInfoCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			-- cclog("onHomeMarketClick failed %d", jsonDataTable.ret)
			return 
		end
		
		if jsonDataTable.data.status == 1 then
			CommonNote(MultiLan("market_note7"))
			MarketItems = {}
		else
			MarketItems = jsonDataTable.data.equip
		end
		

		local node = cc.Node:create()
		node:setTag(MarketLayerTag)
		ShowNew(node)
	end
	
	if CheckMarket() then
		HttpSend("market/info", {"idx=0", "filter="..MarketFilter[1]..","..MarketFilter[2]..","..MarketFilter[3]..","..MarketFilter[4]}, marketInfoCallback)
	else
		MarketNotOpen()
	end
end

XiaLayer["onMarketSell"]       = onMarketSell
XiaLayer["onMarketFilter"]      = onMarketFilter
XiaLayer["onMarketLeft"]      = onMarketLeft
XiaLayer["onMarketRight"]      = onMarketRight

XiaLayer["onHomeMarketClick"]      = onHomeMarketClick