MasterEquipEatLayer = class("MasterEquipEatLayer")
MasterEquipEatLayer.__index = MasterEquipEatLayer

MasterEquipEatLayer.topNode = nil

ccb["MasterEquipEatLayer"] = MasterEquipEatLayer
MasterEquipEatLayerOwner = MasterEquipEatLayerOwner or {}
ccb["MasterEquipEatLayerOwner"] = MasterEquipEatLayerOwner
MasterEquipEatLayer.eatItemTable = {}
MasterEquipEatLayer.eatSelectItem = {}
MasterEquipEatLayer.eatEquipDataTable = {}
MasterEquipEatLayer.eatEquipMasterDataTable = {}
MasterEquipEatLayer.selectEquipMaster = {}
MasterEquipEatLayer.MasterEatPer = nil
MasterEquipEatLayer.MasterEatCost = 0
EATEQUIP_MAX = 6
--//////////////////////////////////////////////////////

--清空
function MasterEquipEatLayer:MasterEquipEatLayerClearItem()
	for i = 1, EATEQUIP_MAX do
		MasterEquipEatLayer.eatItemTable[i]:setItemType(BAG_ITEM_TYPE_EMPTY_EATEQUIP)
		MasterEquipEatLayer.eatItemTable[i]:setItemInfoTable({place=i})
	end
	
	MasterEquipEatLayer.eatEquipDataTable = {}
end

--清空
function MasterEquipEatLayer:MasterEquipEatLayerRemoveItem(itemInfo)
	for i = 1, EATEQUIP_MAX do
		if self.eatEquipDataTable[i] == itemInfo then
			self.eatEquipDataTable[i] = nil
			break
		end
	end
	
	self:MasterEquipEatLayerRefreshItem()
end

--主装备
function MasterEquipEatLayer:MasterEquipEatLayerRefreshMasterItem()
    MasterEquipEatLayer.eatSelectItem:setItemType(BAG_ITEM_TYPE_EATEQUIP)
	MasterEquipEatLayer.eatSelectItem:setItemInfoTable(MasterEquipEatLayer.selectEquipMaster)
    MasterEquipEatLayer.eatSelectItem:setCanTouch(false)
end

--创建
local function MasterEquipEatLayerCreatItem(selectMasterEquip)
    MasterEquipEatLayer.selectEquipMaster = selectMasterEquip
	for i = 1, EATEQUIP_MAX do
		MasterEquipEatLayer.eatItemTable[i] = CreateBagItem()
		MasterEquipEatLayer.eatItemTable[i]:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
		MasterEquipEatLayer.eatItemTable[i]:setTag(i)
		tolua.cast(MasterEquipEatLayerOwner["mMasterEquipEatItemLayer" .. i], "cc.Node"):addChild(MasterEquipEatLayer.eatItemTable[i])
	end

    MasterEquipEatLayer.eatSelectItem = CreateBagItem()
	MasterEquipEatLayer.eatSelectItem:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
	MasterEquipEatLayer.eatSelectItem:setTag(0)
	tolua.cast(MasterEquipEatLayerOwner["mMasterEquipEatItemLayer0"], "cc.Node"):addChild(MasterEquipEatLayer.eatSelectItem)
    
   MasterEquipEatLayer:MasterEquipEatLayerRefreshMasterItem()

   MasterEquipEatLayer:MasterEquipEatLayerClearItem()
end

local function getMasterStarInfo(masterInfo)

	local infoText = ccui.RichText:create()
	infoText:setContentSize(cc.size(270, 500))
	infoText:ignoreContentAdaptWithSize(false)

	--神器属性
	if EquipHelper:isMaster(masterInfo) then
		for k, v in pairs(masterInfo.master) do
			if k == "arp" or  k == "prp" or  k == "mrp" then
				infoText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255, MASTER_ATTR_DESC[k] .. " +" .. v * masterInfo.master_level, DefaultFontName, 22))
			else
				infoText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255, MASTER_ATTR_DESC[k] .. " +" .. (v * masterInfo.master_level*100).."%", DefaultFontName, 22))
			end
			infoText:pushBackElement(ccui.RichElementNewLine:create())
		end
	end
	
	--雕文属性
	if EquipHelper:isGlyph(masterInfo) then
		for k, v in pairs(masterInfo.glyph) do
			if k == "arp" or  k == "prp" or  k == "mrp" then
				infoText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255, MASTER_ATTR_DESC[k] .. " +" .. v * masterInfo.glyph_level, DefaultFontName, 22))
			else
				infoText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255, MASTER_ATTR_DESC[k] .. " +" .. (v * masterInfo.glyph_level*100).."%", DefaultFontName, 22))
			end
			infoText:pushBackElement(ccui.RichElementNewLine:create())
		end
	end
	
	return infoText
end

local function refreshEquipEatValue(eatCost)
	if EquipHelper:isMaster(MasterEquipEatLayer.selectEquipMaster) then
		MasterEquipEatLayerOwner["mMasterEatLevel"]:setString(MultiLan("eat_desc1").."Lv"..MasterEquipEatLayer.selectEquipMaster.master_level)
		MasterEquipEatLayerOwner["mMasterEatExp"]:setString(MultiLan("eat_desc2")..MasterEquipEatLayer.selectEquipMaster.master_exp.."/"..(2*MasterEquipEatLayer.selectEquipMaster.master_level - 1))
		MasterEquipEatLayer.MasterEatPer:setPercentage(MasterEquipEatLayer.selectEquipMaster.master_exp / (2*MasterEquipEatLayer.selectEquipMaster.master_level - 1) * 100)	
		MasterEquipEatLayerOwner["mMasterEatLevel"]:setVisible(true)
		MasterEquipEatLayerOwner["mMasterEatExp"]:setVisible(true)
		MasterEquipEatLayerOwner["mMsterExpBar"]:setVisible(true)
   else
		MasterEquipEatLayerOwner["mMasterEatLevel"]:setVisible(false)
		MasterEquipEatLayerOwner["mMasterEatExp"]:setVisible(false)
		MasterEquipEatLayerOwner["mMsterExpBar"]:setVisible(false)
	end
    
	
	if EquipHelper:isGlyph(MasterEquipEatLayer.selectEquipMaster) then
		MasterEquipEatLayerOwner["mGlyphEatLevel"]:setString(MultiLan("eat_desc7").."Lv"..MasterEquipEatLayer.selectEquipMaster.glyph_level)
		tolua.cast(MasterEquipEatLayerOwner["mGlyphEatExp"], "cc.Label"):
			setString(MultiLan("eat_desc8")..MasterEquipEatLayer.selectEquipMaster.glyph_exp.."/"..(2*MasterEquipEatLayer.selectEquipMaster.glyph_level - 1))
		MasterEquipEatLayer.GlyphEatPer:setPercentage(MasterEquipEatLayer.selectEquipMaster.glyph_exp / (2*MasterEquipEatLayer.selectEquipMaster.glyph_level - 1) * 100)
		MasterEquipEatLayerOwner["mGlyphEatLevel"]:setVisible(true)
		MasterEquipEatLayerOwner["mGlyphEatExp"]:setVisible(true)
		MasterEquipEatLayerOwner["mGlyphExpBar"]:setVisible(true)
    else
		MasterEquipEatLayerOwner["mGlyphEatLevel"]:setVisible(false)
		MasterEquipEatLayerOwner["mGlyphEatExp"]:setVisible(false)
		MasterEquipEatLayerOwner["mGlyphExpBar"]:setVisible(false)
	end
	

	MasterEquipEatLayerOwner["mMasterEquipEatCost"]:setString(MultiLan("desc_need_gold")..eatCost.."("..MultiLan("desc_now_have")..UserSelfInfo.gold..")")
	if eatCost > UserSelfInfo.gold then
		MasterEquipEatLayerOwner["mMasterEquipEatCost"]:setColor(COLOR_RED)
	else
		MasterEquipEatLayerOwner["mMasterEquipEatCost"]:setColor(COLOR_WHITE)
	end
    MasterEquipEatLayer.topNode:removeChildByTag(111)
 	local masterStarInfo = getMasterStarInfo(MasterEquipEatLayer.selectEquipMaster)
	masterStarInfo:setContentSize(cc.size(270, 200))
	masterStarInfo:formatText()
	masterStarInfo:ignoreAnchorPointForPosition(true)
	masterStarInfo:setPosition(cc.p(240, masterStarInfo:getTextMaxHeight()-200 + 464))
    MasterEquipEatLayer.topNode:addChild(masterStarInfo, 111, 111)
end

--刷新
function MasterEquipEatLayer:MasterEquipEatLayerRefreshItem()
    self.MasterEatCost = 0
    local costExp = 0
    local masterstars = 0  
	for i = 1, EATEQUIP_MAX do
		if self.eatEquipDataTable[i] ~= nil then
			self.eatItemTable[i]:setItemType(BAG_ITEM_TYPE_EATEQUIP)
			self.eatItemTable[i]:setItemInfoTable(self.eatEquipDataTable[i])
			masterstars = self.eatEquipDataTable[i].master_level
			if EquipHelper:isMaster(MasterEquipEatLayer.selectEquipMaster) and EquipHelper:isMaster(self.eatEquipDataTable[i]) then
				costExp = costExp + (masterstars -1) * (masterstars - 1) + self.eatEquipDataTable[i].master_exp + 1
			end
			masterstars = self.eatEquipDataTable[i].glyph_level
			if EquipHelper:isGlyph(MasterEquipEatLayer.selectEquipMaster) and EquipHelper:isGlyph(self.eatEquipDataTable[i]) then
				costExp = costExp + (masterstars -1) * (masterstars - 1) + self.eatEquipDataTable[i].glyph_exp + 1
			end
		else
			MasterEquipEatLayer.eatItemTable[i]:setItemType(BAG_ITEM_TYPE_EMPTY_EATEQUIP)
			MasterEquipEatLayer.eatItemTable[i]:setItemInfoTable({place=i})
		end
	end

    masterLevel =  GameData:getPropDataTable(MasterEquipEatLayer.selectEquipMaster.prop_id).level
    self.MasterEatCost = self.MasterEatCost + masterLevel * masterLevel * costExp*100
    refreshEquipEatValue(self.MasterEatCost)
end

local function InitMasterEquipEatLayer()
	--swallowLaer
	local function onEquipEatSwallowTouch(touch, event)
		return true
	end
	SetTouchEventForLayer(MasterEquipEatLayerOwner["mMasterEquipEatSwallowLayer"], onEquipEatSwallowTouch)
    --EatValue

	
	MasterEquipEatLayer.MasterEatPer = CreateCommonBar("pic_equiptiao02.png", Pos(MasterEquipEatLayerOwner["mMsterExpBar"]:getContentSize()))
	MasterEquipEatLayerOwner["mMsterExpBar"]:addChild(MasterEquipEatLayer.MasterEatPer)
	
	MasterEquipEatLayer.GlyphEatPer = CreateCommonBar("pic_equiptiao03.png", Pos(MasterEquipEatLayerOwner["mGlyphExpBar"]:getContentSize()))
	MasterEquipEatLayerOwner["mGlyphExpBar"]:addChild(MasterEquipEatLayer.GlyphEatPer)

	refreshEquipEatValue(0)
end

function MasterEquipEatLayer: MasterEquipEatLayerExit()
	self.topNode:removeFromParent()
	self.topNode = nil
    MasterEquipEatLayer.MasterEatPer = nil
	MasterEquipEatLayer.GlyphEatPer = nil
end

function MasterEquipEatLayer:MasterEquipEatLayerEnter(selectMasterEquip)
    
    if self.topNode ~= nil then
        return
    end

	local proxy = cc.CCBProxy:create()
	self.topNode = CCBReaderLoad("ccb/MasterEquipEatLayer.ccbi",proxy,MasterEquipEatLayerOwner)
	
	MasterEquipEatLayerOwner["mDesc1"]:setString(MultiLan("eat_desc6"))
	MasterEquipEatLayerOwner["mButtonTunshi"]:setTitleForState(MultiLan("eat_button1"),1)
	MasterEquipEatLayerOwner["mButtonAuto"]:setTitleForState(MultiLan("eat_button2"),1)
	MasterEquipEatLayerOwner["mMasterEatLevel"]:setColor(COLOR_CYAN)
	MasterEquipEatLayerOwner["mGlyphEatLevel"]:setColor(COLOR_PURPLE)
	MasterEquipEatLayerOwner["mTitleEquipEat"]:setString(ZGMultiLan("mTitleEquipEat"))

	if POPUP_LAYER ~= nil then
	    POPUP_LAYER:addChild(self.topNode)
		MasterEquipEatLayerCreatItem(selectMasterEquip)
        InitMasterEquipEatLayer()
	end
end


local function onAutoSelectMasterBtnClick()
	MasterEquipEatLayer:MasterEquipEatLayerClearItem()
	
    local eatCount = 0
	local equipListOrign = UserInfo:getBagEquip()
	table.sort(equipListOrign, sortForBagFan)
    for k=1,table.maxn(equipListOrign) do
        equipDataInfo = equipListOrign[k]
		if equipDataInfo ~= MasterEquipEatLayer.selectEquipMaster and (equipDataInfo.stone == CJSON_NULL or table.maxn(equipDataInfo.stone) ==0) and equipDataInfo.locked == 0 then
			if (EquipHelper:isMaster(MasterEquipEatLayer.selectEquipMaster)  and  EquipHelper:isMaster(equipDataInfo)) or
				(EquipHelper:isGlyph(MasterEquipEatLayer.selectEquipMaster)  and  EquipHelper:isGlyph(equipDataInfo))  then
			
				table.insert(MasterEquipEatLayer.eatEquipDataTable,equipDataInfo)
				eatCount = eatCount + 1
				if eatCount >= 6 then
					break
				end
			end
		end
	end
	
	if eatCount == 0 then
		CommonNote(MultiLan("eat_desc3"))
	else
		MasterEquipEatLayer:MasterEquipEatLayerRefreshItem()
	end
end

local function onMasterEquipEatBtnClick()
	local eatCount = 0
	for i=1,EATEQUIP_MAX do
		if MasterEquipEatLayer.eatEquipDataTable[i] ~= nil then
			eatCount = eatCount + 1
		end
	end
    if eatCount == 0 then
	   CommonNote(MultiLan("eat_desc4"))
       return
	end
	
    if MasterEquipEatLayer.MasterEatCost > UserInfo:getUserInfo().data.info.gold then
	    CommonGoldNeed()
        return
    end

	local function equipEatCallback(jsonDataTable)
        if  jsonDataTable.data == CJSON_NULL  or jsonDataTable.ret ~= 0 then
            return
        end

        for i=1, table.maxn(jsonDataTable.data.swallow_equip) do
			UserInfo:setEquipByIdAndObj(jsonDataTable.data.swallow_equip[i])
        end

		local oldLevel1 = MasterEquipEatLayer.selectEquipMaster.master_level
		local oldLevel2 = MasterEquipEatLayer.selectEquipMaster.glyph_level
		MasterEquipEatLayer.selectEquipMaster = UserInfo:setEquipByIdAndObj(jsonDataTable.data.equip)

		if oldLevel1 ~= jsonDataTable.data.equip.master_level or oldLevel2 ~= jsonDataTable.data.equip.glyph_level then
			UserAttr:equipAttrChange(MasterEquipEatLayer.selectEquipMaster.obj, true)
		end

		MasterEquipEatLayer:MasterEquipEatLayerRefreshMasterItem()
		
		if MasterEquipEatLayer.MasterEatCost ~= jsonDataTable.data.gold then
			CommonNote(""..MasterEquipEatLayer.MasterEatCost.." "..jsonDataTable.data.gold)
		end
        UserInfo:setGold(UserInfo:getGold() - jsonDataTable.data.gold)
		
        MasterEquipEatLayer:MasterEquipEatLayerClearItem()
	    refreshEquipEatValue(0)
		BagLayer:setDirty(true)
        BagLayer:RefreshBagScrollLayer()
		CommonNote(MultiLan("eat_desc5"))
	end
	
	local bFirst = true
	local msgTable = {"id="..MasterEquipEatLayer.selectEquipMaster.id}
	local msgStr = "ids="
	for i=1,EATEQUIP_MAX do 
		if MasterEquipEatLayer.eatEquipDataTable[i] ~= nil then
			if bFirst then
				bFirst = false
			else
				msgStr  = msgStr .. ","
			end
			msgStr  = msgStr .. MasterEquipEatLayer.eatEquipDataTable[i].id
		end
	end
	table.insert(msgTable, msgStr)
	HttpSend("equip/swallow", msgTable, equipEatCallback)
end

local function onMasterEatHelpBtnClick()
	HelpPopup("equipswallow")
end

local function onCloseMasterEatBtnClick()
	MasterEquipEatLayer:MasterEquipEatLayerExit()
end

--//////////////////////////////////
MasterEquipEatLayer["onAutoSelectMasterBtnClick"] = onAutoSelectMasterBtnClick
MasterEquipEatLayer["onMasterEquipEatBtnClick"] = onMasterEquipEatBtnClick
MasterEquipEatLayer["onMasterEatHelpBtnClick"] = onMasterEatHelpBtnClick
MasterEquipEatLayer["onCloseMasterEatBtnClick"] = onCloseMasterEatBtnClick