MasterEquipInheritLayer = class("MasterEquipInheritLayer")
MasterEquipInheritLayer.__index = MasterEquipInheritLayer

MasterEquipInheritLayer.topNode = nil

ccb["MasterEquipInheritLayer"] = MasterEquipInheritLayer
MasterEquipInheritLayerOwner = MasterEquipInheritLayerOwner or {}
ccb["MasterEquipInheritLayerOwner"] = MasterEquipInheritLayerOwner
MasterEquipInheritLayer.inheritItem = {}
MasterEquipInheritLayer.inheritSelectItem = {}
MasterEquipInheritLayer.inheritEquipData = {}
MasterEquipInheritLayer.selectMasterEquipData = {}
MasterEquipInheritLayer.inheritCost = 0
MasterEquipInheritLayer.inheritDesc = nil
--//////////////////////////////////////////////////////
local function setMasterInheritInfo(mainEquip, chooseEquip)
	-- print("setMasterInheritInfo", MasterEquipInheritLayer.inheritDesc)
	-- print(table.maxn(MasterEquipInheritLayer.inheritDesc))
	if MasterEquipInheritLayer.inheritDesc ~= nil then
		-- print(table.maxn(MasterEquipInheritLayer.inheritDesc))
		for i= 1, table.maxn(MasterEquipInheritLayer.inheritDesc) do
			removeSelf(MasterEquipInheritLayer.inheritDesc[i])
		end
	end
	MasterEquipInheritLayer.inheritDesc = {}

	local infoText = ccui.RichText:create()
	table.insert(MasterEquipInheritLayer.inheritDesc, infoText)
	infoText:setContentSize(cc.size(270, 500))
	infoText:ignoreContentAdaptWithSize(false)

	local function addAttrDesc(richtext, attr,level)
		for k, v in pairs(attr) do
			if k == "arp" or  k == "prp" or  k == "mrp" then
				richtext:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255, MASTER_ATTR_DESC[k] .. " +" .. v * level, DefaultFontName, 22))
			else
				richtext:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255, MASTER_ATTR_DESC[k] .. " +" .. (v * level*100).."%", DefaultFontName, 22))
			end
			richtext:pushBackElement(ccui.RichElementNewLine:create())
		end
	end
	
	local function addRedEquipAttr(richtext, equipInfo)
		--神器属性
		if EquipHelper:isMaster(equipInfo) then
			addAttrDesc(richtext, equipInfo.master, equipInfo.master_level)
		end
		
		--雕文属性
		if EquipHelper:isGlyph(equipInfo) then
			addAttrDesc(richtext, equipInfo.glyph, equipInfo.glyph_level)
		end
	end
	if chooseEquip == nil then
		addRedEquipAttr(infoText, mainEquip)
	else
		if EquipHelper:isMaster(mainEquip) and not EquipHelper:isMaster(chooseEquip) then
			addAttrDesc(infoText, mainEquip.master, mainEquip.master_level)
		end
		if EquipHelper:isMaster(chooseEquip) then
			addAttrDesc(infoText, chooseEquip.master, chooseEquip.master_level)
		end
		
		if EquipHelper:isGlyph(mainEquip) and not EquipHelper:isGlyph(chooseEquip) then
			addAttrDesc(infoText, mainEquip.glyph, mainEquip.glyph_level)
		end
		if EquipHelper:isGlyph(chooseEquip) then
			addAttrDesc(infoText, chooseEquip.glyph, chooseEquip.glyph_level)
		end
	end
	
	--神器属性
	if EquipHelper:isMaster(mainEquip) and (chooseEquip == nil or not EquipHelper:isMaster(chooseEquip))  then
		--addAttrDesc(infoText, mainEquip.master, mainEquip.master_level)
	end
	
	--雕文属性
	if EquipHelper:isGlyph(mainEquip) and (chooseEquip == nil or not EquipHelper:isGlyph(chooseEquip)) then
		--addAttrDesc(infoText, mainEquip.glyph, mainEquip.glyph_level)
	end
	
	
	-- local mainText = ccui.RichText:create()
	-- table.insert(MasterEquipInheritLayer.inheritDesc, mainText)
	-- mainText:setContentSize(cc.size(270, 200))
	-- mainText:ignoreContentAdaptWithSize(false)
	-- addRedEquipAttr(mainText, mainEquip)
	-- mainText:formatText()
	-- mainText:ignoreAnchorPointForPosition(true)
	-- mainText:setPosition(cc.p(60, 260))
 --    MasterEquipInheritLayer.topNode:addChild(mainText)
	
	if chooseEquip ~= nil then
		local selectText = ccui.RichText:create()
		table.insert(MasterEquipInheritLayer.inheritDesc, selectText)
		selectText:setContentSize(cc.size(270, 200))
		selectText:ignoreContentAdaptWithSize(false)
		addRedEquipAttr(selectText, chooseEquip)
		selectText:formatText()
		selectText:ignoreAnchorPointForPosition(true)
		selectText:setPosition(cc.p(420, 240))
		MasterEquipInheritLayer.topNode:addChild(selectText)
	end
	 
	return infoText
end

function refreshEquipInheritValue(costMoney)
	-- print("refreshEquipInheritValue", costMoney)
	MasterEquipInheritLayerOwner["mMasterInheritCost"]:setString(MultiLan("desc_need_gold")..costMoney.."("..MultiLan("desc_now_have")..UserSelfInfo.gold..")")
	if costMoney > UserSelfInfo.gold then
		MasterEquipInheritLayerOwner["mMasterInheritCost"]:setColor(COLOR_RED)
	else
		MasterEquipInheritLayerOwner["mMasterInheritCost"]:setColor(COLOR_WHITE)
	end

 	local masterStarInfo = setMasterInheritInfo(MasterEquipInheritLayer.selectMasterEquipData, MasterEquipInheritLayer.inheritEquipData[1])
	masterStarInfo:setContentSize(cc.size(270, 180))
	masterStarInfo:formatText()
	masterStarInfo:ignoreAnchorPointForPosition(true)
	masterStarInfo:setPosition(cc.p(240, masterStarInfo:getTextMaxHeight()-200 + 400))
    MasterEquipInheritLayer.topNode:addChild(masterStarInfo,111,111)
end

function MasterEquipInheritLayer:MasterEquipInheritLayerClearItem()
	
	MasterEquipInheritLayer.inheritItem:setItemType(BAG_ITEM_TYPE_EMPTY_INHERITEQUIP)
	MasterEquipInheritLayer.inheritItem:setItemInfoTable({place=i})
        
   while  table.maxn(self.inheritEquipData) > 0 do
      table.remove(self.inheritEquipData)
   end
   refreshEquipInheritValue(0)
end

function MasterEquipInheritLayerCreatItem(selectMasterEquip)
	
   MasterEquipInheritLayer.selectMasterEquipData = selectMasterEquip
   MasterEquipInheritLayer.inheritItem = CreateBagItem()
   MasterEquipInheritLayer.inheritItem:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
   MasterEquipInheritLayer.inheritItem:setTag(1)
   tolua.cast(MasterEquipInheritLayerOwner["mMasterEquipInheritItemLayer1"], "cc.Node"):addChild(MasterEquipInheritLayer.inheritItem)

   MasterEquipInheritLayer.inheritSelectItem = CreateBagItem()
   MasterEquipInheritLayer.inheritSelectItem:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
   MasterEquipInheritLayer.inheritSelectItem:setTag(0)
   tolua.cast(MasterEquipInheritLayerOwner["mMasterEquipInheritItemLayer0"], "cc.Node"):addChild(MasterEquipInheritLayer.inheritSelectItem)
   MasterEquipInheritLayer.inheritSelectItem:setItemType(BAG_ITEM_TYPE_INHERITEQUIP)
   MasterEquipInheritLayer.inheritSelectItem:setItemInfoTable(MasterEquipInheritLayer.selectMasterEquipData)
   MasterEquipInheritLayer.inheritSelectItem:setCanTouch(false)

   MasterEquipInheritLayer:MasterEquipInheritLayerClearItem()

end

function MasterEquipInheritLayer:MasterEquipInheritLayerRefreshItem()

    self.inheritCost = 0
    if  table.maxn(self.inheritEquipData) > 0 then

	    self.inheritItem:setItemType(BAG_ITEM_TYPE_INHERITEQUIP)
	    self.inheritItem:setItemInfoTable(self.inheritEquipData[1])

        local lv1 = EquipHelper:getStaticData(self.selectMasterEquipData).level   
        local lv2 = EquipHelper:getStaticData(self.inheritEquipData[1]).level
        if  lv2 > lv1 then 
            local starlevel = self.selectMasterEquipData.master_level
			-- print("starlevel",starlevel)
			local glyphlevel = self.selectMasterEquipData.glyph_level
			-- print("glyphlevel",glyphlevel)
            local adjust = lv2-5
        
            if adjust < 1 then
                adjust = 1
            end
			
			self.inheritCost = 0
			if EquipHelper:isMaster(self.selectMasterEquipData) and not  EquipHelper:isMaster(self.inheritEquipData[1]) then
				self.inheritCost = self.inheritCost + ((1000 * (lv1 + adjust)/2+2500)*starlevel*starlevel+10000)*math.ceil((lv2-lv1)/5.00)
			end
			if EquipHelper:isGlyph(self.selectMasterEquipData) and not  EquipHelper:isGlyph(self.inheritEquipData[1]) then
				self.inheritCost = self.inheritCost + ((1000 * (lv1 + adjust)/2+2500)*glyphlevel*glyphlevel+10000)*math.ceil((lv2-lv1)/5.00)
			end
        else
			if EquipHelper:isMaster(self.selectMasterEquipData) and not  EquipHelper:isMaster(self.inheritEquipData[1]) then
				self.inheritCost = self.inheritCost + 10000
			end
			if EquipHelper:isGlyph(self.selectMasterEquipData) and not  EquipHelper:isGlyph(self.inheritEquipData[1]) then
				self.inheritCost = self.inheritCost + 10000
			end
		end
    end
    refreshEquipInheritValue(self.inheritCost)
end

function InitMasterEquipInheritLayer()
	--swallowLaer
	local function onEquipInheritSwallowTouch(touch, event)
		return true
	end
	SetTouchEventForLayer(MasterEquipInheritLayerOwner["mMasterEquipInheritSwallowLayer"], onEquipInheritSwallowTouch)
    --InheritValue
	refreshEquipInheritValue(0)
end

function MasterEquipInheritLayer: MasterEquipInheritLayerExit()
	self.topNode:removeFromParent()
	self.topNode = nil
	MasterEquipInheritLayer.inheritDesc = nil
    
end

function MasterEquipInheritLayer:MasterEquipInheritLayerEnter(selectMasterEquip)
    
    if self.topNode ~= nil then
        return
    end

	local proxy = cc.CCBProxy:create()
	self.topNode = CCBReaderLoad("ccb/MasterEquipInheritLayer.ccbi",proxy,MasterEquipInheritLayerOwner)
	
	MasterEquipInheritLayerOwner["mInheritDesc"]:setString(MultiLan("inherit_desc3"))
	MasterEquipInheritLayerOwner["mButtonTunshi"]:setTitleForState(MultiLan("eat_button3"),1)
	MasterEquipInheritLayerOwner["mTitleEquipInherit"]:setString(ZGMultiLan("mTitleEquipInherit"))
	MasterEquipInheritLayer.inheritDesc = nil
	if POPUP_LAYER ~= nil then
	    POPUP_LAYER:addChild(self.topNode)
		MasterEquipInheritLayerCreatItem(selectMasterEquip)
        InitMasterEquipInheritLayer()
	end
end

function onMasterEquipInheritBtnClick()

    if  table.maxn(MasterEquipInheritLayer.inheritEquipData) < 1 then
	    CommonNote(MultiLan("inherit_desc1"))
       return
	end

    if MasterEquipInheritLayer.inheritCost > UserInfo:getUserInfo().data.info.gold then
		CommonGoldNeed()
        return
    end

	local function equipInheritCallback(jsonDataTable)
		-- print("equipInheritCallback")
        if  jsonDataTable == CJSON_NULL  or jsonDataTable.ret ~= 0 then
            return
        end

       -- MasterEquipInheritLayer.inheritEquipData[1].master = MasterEquipInheritLayer.selectMasterEquipData.master
        --MasterEquipInheritLayer.inheritEquipData[1].master_level = MasterEquipInheritLayer.selectMasterEquipData.master_level
        --MasterEquipInheritLayer.inheritEquipData[1].master_exp = MasterEquipInheritLayer.selectMasterEquipData.master_exp
		MasterEquipInheritLayer.inheritEquipData[1] = UserInfo:setEquipByIdAndObj(jsonDataTable.data.obj_equip)
		UserAttr:equipAttrChange(MasterEquipInheritLayer.inheritEquipData[1].obj)
		BagLayer:UpdateItem(MasterEquipInheritLayer.inheritEquipData[1])
		

        --MasterEquipInheritLayer.selectMasterEquipData.master = CJSON_NULL
        --MasterEquipInheritLayer.selectMasterEquipData.master_level = 1
        --MasterEquipInheritLayer.selectMasterEquipData.master_exp = 0
		MasterEquipInheritLayer.selectMasterEquipData = UserInfo:setEquipByIdAndObj(jsonDataTable.data.equip)
		UserAttr:equipAttrChange(MasterEquipInheritLayer.selectMasterEquipData.obj)
		BagLayer:UpdateItem(MasterEquipInheritLayer.selectMasterEquipData)
		
		if MasterEquipInheritLayer.inheritCost ~= jsonDataTable.data.gold then
			CommonNote(""..MasterEquipInheritLayer.inheritCost..jsonDataTable.data.gold)
		end
        UserInfo:setGold(UserInfo:getGold() - jsonDataTable.data.gold)

		if MasterEquipInheritLayer.inheritEquipData[1].obj == 0 or MasterEquipInheritLayer.selectMasterEquipData.obj == 0 then
			BagLayer:RefreshBagScrollLayer()
		end

        MasterEquipInheritLayer:MasterEquipInheritLayerExit()
		CommonNote(MultiLan("inherit_desc2"))
	end

    local msgStrTable = {"id="..MasterEquipInheritLayer.selectMasterEquipData.id, "obj_id=".. MasterEquipInheritLayer.inheritEquipData[1].id}
	HttpSend("equip/inherit", msgStrTable, equipInheritCallback)

end

function onMasterInheritHelpBtnClick()
	HelpPopup("equipinherit")
end

function onCloseMasterInheritBtnClick()
	-- cclog("onCloseMasterInheritBtnClick")
	MasterEquipInheritLayer:MasterEquipInheritLayerExit()
end

--//////////////////////////////////
MasterEquipInheritLayer["onMasterEquipInheritBtnClick"] = onMasterEquipInheritBtnClick
MasterEquipInheritLayer["onMasterInheritHelpBtnClick"] = onMasterInheritHelpBtnClick
MasterEquipInheritLayer["onCloseMasterInheritBtnClick"] = onCloseMasterInheritBtnClick