ItemDetail = class("ItemDetail")
ItemDetail.__index = ItemDetail

ItemDetail.isCreated = false
ItemDetail.topNode = nil
ItemDetail.icon = nil
ItemDetail.slotLayer = nil
ItemDetail.itemInfo = nil

ccb["ItemDetail"] = ItemDetail
ItemDetailOwner = ItemDetailOwner or {}
ccb["ItemDetailOwner"] = ItemDetailOwner

function ItemDetail:ItemDetailEnter(detailInfo, bOnlyShow, bShowOthers)
	if self.topNode ~= nil then
		return
	end

	local proxy = cc.CCBProxy:create()
	self.topNode = CommonCreatePopup(CCBReaderLoad("ccb/ItemDetail.ccbi",proxy,ItemDetailOwner))
	--ccb多语言
	--ItemDetailOwner["mMailDesc"]:setString(MultiLan("mail_desc5"))
	ItemDetailOwner["mItemDetailXiangqian"]:setTitleForState(MultiLan("button_xiangqian"), 1)
	ItemDetailOwner["mItemDetailTunshi"]:setTitleForState(MultiLan("button_tunshi"), 1)
	ItemDetailOwner["mItemDetailChuancheng"]:setTitleForState(MultiLan("button_chuancheng"), 1)
	ItemDetailOwner["mItemDetailQianghua"]:setTitleForState(MultiLan("button_strengthen"), 1)
	ItemDetailOwner["mItemDetailXilian"]:setTitleForState(MultiLan("button_refine"), 1)
	ItemDetailOwner["mItemDetailTakeoff"]:setTitleForState(MultiLan("button_takeoff"), 1)
	ItemDetailOwner["mItemDetailChange"]:setTitleForState(MultiLan("button_change"), 1)
	ItemDetailOwner["mItemDetailSell"]:setTitleForState(MultiLan("button_equip_sell"), 1)
	ItemDetailOwner["mTitleItemDetail"]:setString(ZGMultiLan("mTitleItemDetail"))
	
	self.icon = CreateBagItem()
	self.icon:setCanTouch(false)
	local x, y = ItemDetailOwner["sp_board_empty"]:getPosition()
	self.icon:setPosition(cc.p(x, y))
	ItemDetailOwner["sp_board_empty"]:removeFromParent()
	self.icon:setItemType(BAG_ITEM_TYPE_EQUIP)
	ItemDetailOwner["mItemDetailBgLayer"]:addChild(self.icon)

	self.icon:setItemInfoTable(detailInfo)
	self:setItemDetail(detailInfo, bOnlyShow)

	-- ItemDetailOwner["mItemDetailDesc"]:removeAllChildren()

	if detailInfo.locked == 0 then
		ItemDetailOwner["mItemDetailSuoding"]:setTitleForState(ZGMultiLan("mItemDetailSuoding1"),1)
	elseif detailInfo.locked == 1 then
		ItemDetailOwner["mItemDetailSuoding"]:setTitleForState(ZGMultiLan("mItemDetailSuoding2"),1)
	end

	local layer = cc.Layer:create()
    

	local itemInfoRichText = EquipHelper:createItemInfoRichtext(detailInfo, nil,nil,bShowOthers)
	itemInfoRichText:setContentSize(cc.size(270, 500))
	itemInfoRichText:formatText()
	itemInfoRichText:ignoreAnchorPointForPosition(true)

	layer:setContentSize(cc.size(270, itemInfoRichText:getTextMaxHeight() + 60))

	itemInfoRichText:setPosition(cc.p(0, layer:getContentSize().height - 500))
	layer:addChild(itemInfoRichText)
	
	self.slotLayer = cc.Layer:create()
	self.slotLayer:ignoreAnchorPointForPosition(false)
	self.slotLayer:setAnchorPoint(0, 1)
	self.slotLayer:setContentSize(cc.size(200, 45))
	self.slotLayer:setPosition(cc.p(0, 45))
	layer:addChild(self.slotLayer)
--添加滑动条
	local scrollLayer = ItemDetailOwner["mItemDetailDesc"]
	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, scrollLayer:getContentSize().height - layer:getContentSize().height), kScrollViewDirectionVertical)
	
	if self.itemInfo.slots ~= 0 then
		for i = 1, self.itemInfo.slots do
			local spriteBg = cc.Sprite:createWithSpriteFrameName("board_baseboard.png")
			spriteBg:setScale(0.5)
			spriteBg:setPosition(cc.p((i - 1) * 50 + 22.5, 22))
			self.slotLayer:addChild(spriteBg)
		end
	end
	if self.itemInfo.stone ~= nil and self.itemInfo.stone ~= CJSON_NULL then
		for i = 1, table.maxn(self.itemInfo.stone) do
			local spriteStone = cc.Sprite:createWithSpriteFrameName("prop_" .. self.itemInfo.stone[i] .. ".png")
			spriteStone:setScale(0.5)
			spriteStone:setPosition(cc.p((i - 1) * 50 + 22.5, 22))
			self.slotLayer:addChild(spriteStone)
		end
	end
end

function ItemDetail:ItemDetailExit()
	removeSelf(self.topNode)
	self.topNode = nil
end

function ItemDetail:hideAllButton()
	ItemDetailOwner["mItemDetailTakeoff"]:setVisible(false)
	ItemDetailOwner["mItemDetailChange"]:setVisible(false)
	ItemDetailOwner["mItemDetailSell"]:setVisible(false)
	ItemDetailOwner["mItemDetailTunshi"]:setVisible(false)
	ItemDetailOwner["mItemDetailChuancheng"]:setVisible(false)
	ItemDetailOwner["mItemDetailXiangqian"]:setVisible(false)
	ItemDetailOwner["mItemDetailXilian"]:setVisible(false)
	ItemDetailOwner["mItemDetailQianghua"]:setVisible(false)
	ItemDetailOwner["mItemDetailSuoding"]:setVisible(false)
	
	
	local detailLabel = tolua.cast(ItemDetailOwner["mItemDetailName"], "cc.Label")
	detailLabel:setColor(COLOR_ORANGE)
	detailLabel:setString(MultiLan("equip_place_" .. EquipHelper:getStaticData(self.itemInfo).place))
end

function ItemDetail:refreshAllButton()
	if self.itemInfo.obj == 0 then
		ItemDetailOwner["mItemDetailTakeoff"]:setVisible(false)
		ItemDetailOwner["mItemDetailChange"]:setVisible(false)
		ItemDetailOwner["mItemDetailSell"]:setVisible(true)
	else
		ItemDetailOwner["mItemDetailTakeoff"]:setVisible(true)
		ItemDetailOwner["mItemDetailChange"]:setVisible(true)
		ItemDetailOwner["mItemDetailSell"]:setVisible(false)
	end
	if EquipHelper:isRedEquip(self.itemInfo) then
		ItemDetailOwner["mItemDetailTunshi"]:setVisible(true)
		ItemDetailOwner["mItemDetailChuancheng"]:setVisible(true)
	else
		ItemDetailOwner["mItemDetailTunshi"]:setVisible(false)
		ItemDetailOwner["mItemDetailChuancheng"]:setVisible(false)
	end
	local propInfoTable = GameData:getPropDataTable(self.itemInfo.prop_id)
	if propInfoTable.level >= 10  and EquipHelper:getEquipGrade(self.itemInfo)> 2 then
		ItemDetailOwner["mItemDetailXilian"]:setVisible(true)
	else
		ItemDetailOwner["mItemDetailXilian"]:setVisible(false)
	end

	local detailLabel = tolua.cast(ItemDetailOwner["mItemDetailName"], "cc.Label")
	detailLabel:setColor(COLOR_ORANGE)
	detailLabel:setString(MultiLan("equip_place_" .. propInfoTable.place))
end

function ItemDetail:setItemDetail(detailInfo, bOnlyShow)
	self.itemInfo = detailInfo
	if bOnlyShow then
		--如果是纯显示 则隐藏所有按钮
		self:hideAllButton()
	else
		self:refreshAllButton()
	end
	self.icon:setItemSprite("prop_" .. detailInfo.prop_id .. ".png")
end

local function onItemDetailClose()
	ItemDetail:ItemDetailExit()
end

local function onItemDetailXiangqian()
	onItemDetailClose()
	EquipStoneSet:EquipStoneSetEnter(ItemDetail.itemInfo)
end

local function onItemDetailTunshi()
    if EquipHelper:isRedEquip(ItemDetail.itemInfo) then
        MasterEquipEatLayer:MasterEquipEatLayerEnter(ItemDetail.itemInfo)
        onItemDetailClose()
    end
end

local function onItemDetailChuancheng()
    if  EquipHelper:isRedEquip(ItemDetail.itemInfo) then
        MasterEquipInheritLayer:MasterEquipInheritLayerEnter(ItemDetail.itemInfo)
        onItemDetailClose()
    end
end

local function onItemDetailQianghua()
	onItemDetailClose()
	EquipStrengthen:EquipStrengthenEnter(ItemDetail.itemInfo, EQUIP_STRENGTHEN)
end

local function onItemDetailXilian()
	onItemDetailClose()
	if VERSION_REFIND then
		local refinelayer = RefineLayer:new()
	    refinelayer:create({
	    	itemInfo = ItemDetail.itemInfo,
	    	})
	    local layerNode = refinelayer.topNode 
	    if POPUP_LAYER == nil then
			POPUP_LAYER = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
			scene:addChild(POPUP_LAYER, POPUP_TAG, POPUP_TAG)
		end
		POPUP_LAYER:addChild(layerNode)
	else
		EquipStrengthen:EquipStrengthenEnter(ItemDetail.itemInfo, EQUIP_REFINE)
	end
end

local function onItemDetailTakeoffCallback(jsonDataTable)
	if jsonDataTable.ret ~= 0 then
		-- cclog("take off equip failed %d", jsonDataTable.ret)
		return 
	end
	local takeoffId = jsonDataTable.data.id
	-- print("takeoffId id is %d", takeoffId, jsonDataTable.data.obj)
	local takeoffEquipTable = UserInfo:removeEquipByIdAndObj(takeoffId, jsonDataTable.data.obj)
	UserInfo:addEquipByObj(takeoffEquipTable, 0)
	-- ccdump(jsonDataTable,"jsonDataTable")
	UserAttr:equipAttrChange(jsonDataTable.data.obj, true)
	if jsonDataTable.data.obj == 1 then
		UserAttr:compareAllyEquipScore(takeoffEquipTable)
	else
		UserAttr:compareEquipScore(takeoffEquipTable)
		UserAttr:compareAllyEquipScore(takeoffEquipTable,jsonDataTable.data.obj)
	end
end

local function onItemDetailTakeoff()
	HttpSend("equip/unload", {"id=" .. ItemDetail.itemInfo.id}, onItemDetailTakeoffCallback)
	onItemDetailClose()
end

local function onItemDetailChange()
	EquipFilterChange:EquipFilterChangeEnter(ItemDetail.itemInfo)
	onItemDetailClose()
end

local function onItemDetailSell()

	if EquipHelper:isRedEquip(ItemDetail.itemInfo) then
       CommonNote(MultiLan("itemDetail_desc1"))
       onItemDetailClose()
       return
	end
	-- ccdump(ItemDetail,"ItemDetail")
	if ItemDetail.itemInfo.locked == 1 then
		CommonNote(MultiLan("itemDetail_desc_lock"))
		onItemDetailClose()
		return
	end
	

   if ItemDetail.itemInfo.stone ~= nil and ItemDetail.itemInfo.stone ~= CJSON_NULL and table.maxn(ItemDetail.itemInfo.stone) > 0 then
       CommonNote(MultiLan("itemDetail_desc2"))
       onItemDetailClose()
       return
   end


	local function itemDetailSellCallback(jsonDataTable)
        if  jsonDataTable == CJSON_NULL  or jsonDataTable.ret ~= 0 then
            return
        end

        if jsonDataTable.data ~= CJSON_NULL then
            UserInfo:addProp(jsonDataTable.data.prop, true)

            if jsonDataTable.data.prop ~= CJSON_NULL then
                for i=1,table.maxn(jsonDataTable.data.prop) do
                    if jsonDataTable.data.prop[i].prop_id == 100003 then
						CommonNote(MultiLan("GEML_return")..jsonDataTable.data.prop[i].num.." "..MultiLan("prop_name_"..jsonDataTable.data.prop[i].prop_id),COLOR_YELLOW)
                    end
                end
            end
            UserAttr:compareAaEquipScore(ItemDetail.itemInfo.id)
            UserInfo:removeEquipByIdAndObj(jsonDataTable.data.sell, 0)
        end
        BagLayer:RefreshBagScrollLayer()
        onItemDetailClose()
	end


    local function sendItemSell()
        HttpSend("item/sell", {"id="..ItemDetail.itemInfo.id, "num=1"}, itemDetailSellCallback)
    end
     local color,equipQualitys  = EquipHelper:getEquipColor(ItemDetail.itemInfo) 
    if equipQualitys >= 5 then
        local content = cc.Label:create(MultiLan("itemDetail_desc3"), DefaultFontName, FontSize3,cc.size(460,160),0,1)
	    CreateSmallPopupWithCancel("selleq",content, sendItemSell)
    else
        sendItemSell()
    end
 
end
local function onItemDetailSuoding(  )
	-- cclog("onItemDetailSuoding")
	local function LockCallback( jsonDataTable )
		-- ccdump(jsonDataTable,"jsonDataTable")
		-- cclog("jsonDataTable is "..jsonDataTable.data.prop.locked)
		-- ccdump(ItemDetail.itemInfo,"2")
		if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
			-- UserInfo:setEquipByIdAndObj(jsonDataTable.data.prop)

			local equipInfo = UserInfo:setEquipByIdAndObj(jsonDataTable.data.prop)
			if equipInfo ~= nil then
				UserAttr:setEquipGradeAndScore(equipInfo)
			end
			UserAttr:equipAttrChange(jsonDataTable.data.prop.obj)
		end
		-- cclog("New ItemDetail.itemInfo.locked is "..ItemDetail.itemInfo.locked)
		ccdump(ItemDetail.itemInfo,"3")
	end
	-- cclog("old ItemDetail.itemInfo.locked is "..ItemDetail.itemInfo.locked )
	if ItemDetail.itemInfo.locked == 0 then
		-- cclog("locked")
		HttpSend("equip/lock", {"id="..ItemDetail.itemInfo.id}, LockCallback)
	elseif ItemDetail.itemInfo.locked == 1 then
		-- cclog("unlock")
		HttpSend("equip/unlock", {"id="..ItemDetail.itemInfo.id}, LockCallback)
	end
	onItemDetailClose()
end

ItemDetail["onItemDetailClose"] = onItemDetailClose
ItemDetail["onItemDetailXiangqian"] = onItemDetailXiangqian
ItemDetail["onItemDetailTunshi"] = onItemDetailTunshi
ItemDetail["onItemDetailChuancheng"] = onItemDetailChuancheng
ItemDetail["onItemDetailQianghua"] = onItemDetailQianghua
ItemDetail["onItemDetailXilian"] = onItemDetailXilian
ItemDetail["onItemDetailSuoding"] = onItemDetailSuoding
ItemDetail["onItemDetailTakeoff"] = onItemDetailTakeoff
ItemDetail["onItemDetailChange"] = onItemDetailChange
ItemDetail["onItemDetailSell"] = onItemDetailSell