Localization = class("Localization")
Localization.__index = Localization
Localization.stringTable = nil
Localization.stringTableZG = nil

function Localization:loadString()

	-- local currentLan = "ENGLISH"
	-- local currentLan = "CHINESE"
	local projectType = GameConfig:GetProjectType()
	local language = GameConfig:GetLanguage()
	local lanFileName = string.format("localization/LAN_%s_%s.json", projectType, language)
	local nameFileName = string.format("localization/LAN_NAME_%s_%s.json", projectType, language)
	local zgFileName = string.format("localization/LAN_ZG_%s_%s.json", projectType, language)

	self.stringTable = {}
	local jsonString = cc.FileUtils:getInstance():getStringFromFile(lanFileName)
	local cjson = require "cjson"
	self.stringTable = cjson.decode(jsonString)

	self.stringTableZG = {}
	local jsonStringZG = cc.FileUtils:getInstance():getStringFromFile(zgFileName)
	self.stringTableZG = cjson.decode(jsonStringZG)

	self.stringTableName = {}
	local jsonStringName = cc.FileUtils:getInstance():getStringFromFile(nameFileName)
	self.stringTableName = cjson.decode(jsonStringName)

	-- print("setLocalization")
	--table.foreach(self.stringTable,function(i, v) print (i, v) end)
end

function MultiLan(keyVal)
	--print("MultiLan", keyVal, Localization.stringTable)
	return Localization:getValueByKey(keyVal)
end

function NameMultiLan( keyVal )
	return Localization:getValueByKeyName(keyVal)
end

function ZGMultiLan( keyVal )
	return Localization:getValueByKeyZG(keyVal)
end

function Localization:getValueByKey(keyVal)
	for i, v in pairs(self.stringTable) do
		if keyVal == i then
			return v
		end
	end
	--cclog("invalid key is %s", keyVal)
	-- return self.stringTable["invalid"]
	return keyVal
end

function Localization:getValueByKeyZG( keyVal )
	for i, v in pairs(self.stringTableZG) do
		if keyVal == i then
			return v
		end
	end
	-- print("ZGMultiLan not found: " .. keyVal)
	return keyVal
end

function Localization:getValueByKeyName( keyVal )
	for i, v in pairs(self.stringTableName) do
		if keyVal == i then
			return v
		end
	end
	-- print("NameMultiLan not found: " .. keyVal)
	return keyVal
end
Localization:loadString()