PropDetail = class("PropDetail")
PropDetail.__index = PropDetail

PropDetail.topNode = nil
PropDetail.icon = nil
PropDetail.itemInfo = nil


ccb["PropDetail"] = PropDetail
PropDetailOwner = PropDetailOwner or {}
ccb["PropDetailOwner"] = PropDetailOwner

local function onPropDetailClose()
	PropDetail:PropDetailExit()
end

local function onPropDetailSingleUse()
  
	local propInfo = GameData:getPropDataTable(PropDetail.itemInfo.prop_id)
    if propInfo.ptype == 10 or propInfo.ptype == 11 then
       --singleuse master
       PillMergePopup(PropDetail.itemInfo.prop_id)
	   onPropDetailClose()
    elseif propInfo.ptype == 9 then
       --singleuse master
       PropDetail:doMasterPiecesUse(10)
    elseif propInfo.ptype == 4 or propInfo.ptype == 14 then 
      --singleuse boss
      PropDetail:doPropUse(1)
	elseif propInfo.ptype == 16 then
		local staticData = EquipHelper:getStaticData(PropDetail.itemInfo)
		if staticData.role ~= UserSelfInfo.role then
			CommonNote(MultiLan("skill_desc44"))
			return
		elseif staticData.level <= GetSkillMaster(staticData.attr_value) then
			CommonNote(MultiLan("skill_desc45"))
			return
		end
		
		PropDetail:doPropUse(1)
    elseif propInfo.ptype == 6 then
      --singleuse stone
	    if propInfo.level < STONE_LEVEL_MAX then
		    StoneUpGradeLayer:StoneUpGradeLayerEnter(PropDetail.itemInfo)
		    onPropDetailClose()
		else
			CommonNote(MultiLan("stoneup_desc1"))
		end
    end

end

local function onPropDetailOpen1()
    PropDetail:doPropUse(1)
end

local function onPropDetailOpen10()
	PropDetail:doPropUse(math.min(PropDetail.itemInfo.amount, 10))
end

local function initPropDetaile(propInfo, bInShop)
    --swallowLaer
	local function onPropDetailSwallowTouch(touch, event)
        onPropDetailClose()
		return true
	end
	SetTouchEventForLayer(PropDetailOwner["mPropDetailSwallowLayer"], onPropDetailSwallowTouch)

	local propDetailInfo = GameData:getPropDataTable(propInfo.prop_id)
    tolua.cast(PropDetailOwner["mPropDetailName"], "cc.Label"):setString(MultiLan(propDetailInfo.name))
    tolua.cast(PropDetailOwner["mPropDetailDesc"], "cc.Label"):setString(MultiLan(propDetailInfo.desc))
	
	if bInShop then
		return
	end

    local propType = propDetailInfo.ptype
	-- print("propType",propType)
    if propType == 1  or propType == 2 or propType == 3 then
       -- close
       PropDetailOwner["mPropDetailUserClose"]:setVisible(true)
    elseif propType == 4  or propType == 14 or propType == 16 then
      --singleuse boss
      PropDetailOwner["mPropDetailSingleUse"]:setVisible(true)
      tolua.cast(PropDetailOwner["mPropDetailSingleUse"], "cc.ControlButton"):setTitleForState(MultiLan("propdetail_button1"),1)
    elseif propType == 5 then
        --use10
        PropDetailOwner["mPropDetailOpen1"]:setVisible(true)
        PropDetailOwner["mPropDetailOpen10"]:setVisible(true)
	    if propInfo.amount > 10 then
			tolua.cast(PropDetailOwner["mPropDetailSingleUse"], "cc.ControlButton"):setTitleForState(MultiLan("propdetail_button3"),1)
			PropDetailOwner["mPropDetailOpen10"]:setTitleForState(MultiLan("propdetail_button3"), cc.CONTROL_STATE_NORMAL)
	    else
			tolua.cast(PropDetailOwner["mPropDetailSingleUse"], "cc.ControlButton"):setTitleForState(MultiLan("propdetail_button4"),1)
			PropDetailOwner["mPropDetailOpen10"]:setTitleForState(MultiLan("propdetail_button4"), cc.CONTROL_STATE_NORMAL)
	    end
    elseif propType == 6 then
      --singleuse stone
      PropDetailOwner["mPropDetailSingleUse"]:setVisible(true)
      tolua.cast(PropDetailOwner["mPropDetailSingleUse"], "cc.ControlButton"):setTitleForState(MultiLan("stoneup_button1"),1)
    elseif propType == 9 then
      --singleuse master
      PropDetailOwner["mPropDetailSingleUse"]:setVisible(true)
      tolua.cast(PropDetailOwner["mPropDetailSingleUse"], "cc.ControlButton"):setTitleForState(MultiLan("propdetail_button5"),1)
    elseif propType == 10 or propType == 11 then
      --singleuse master
      PropDetailOwner["mPropDetailSingleUse"]:setVisible(true)
      tolua.cast(PropDetailOwner["mPropDetailSingleUse"], "cc.ControlButton"):setTitleForState(MultiLan("propdetail_button5"),1)
    end


end

function PropDetail:RefreshPropDetail(propInfo)
    if self.icon ~= nil then
        self.icon:setItemInfoTable(propInfo)
		initPropDetaile(propInfo)
    end
	
end
function PropDetail:PropDetailEnter(propInfo, bInShop)
    
    if self.topNode ~= nil then
        return
    end

	local proxy = cc.CCBProxy:create()
	self.topNode = CCBReaderLoad("ccb/PropDetail.ccbi",proxy,PropDetailOwner)
	POPUP_LAYER:addChild(self.topNode)

	PropDetailOwner["mPropDetailUserClose"]:setTitleForState(MultiLan("button_close"), cc.CONTROL_STATE_NORMAL)
	PropDetailOwner["mPropDetailSingleUse"]:setTitleForState(MultiLan("propdetail_button1"), cc.CONTROL_STATE_NORMAL)
	PropDetailOwner["mPropDetailOpen1"]:setTitleForState(MultiLan("propdetail_button2"), cc.CONTROL_STATE_NORMAL) 
	
	PropDetailOwner["mTitlePropDetail"]:setString(ZGMultiLan("mTitlePropDetail"))
		
    initPropDetaile(propInfo, bInShop)

	self.icon = CreateBagItem()
	self.icon:setCanTouch(false)
	self.icon:setPosition(cc.p(100, 220))
	self.icon:setItemType(BAG_ITEM_TYPE_THING)
	PropDetailOwner["mPropDetailBgLayer"]:addChild(self.icon)

	self.icon:setItemInfoTable(propInfo)
	self:setPropDetail(propInfo)
    self.icon.itemName:setVisible(false)
end

function PropDetail:PropDetailExit()
	self.topNode:removeFromParent()
	self.topNode = nil
end

function PropDetail:setPropDetail(propInfo)
	self.itemInfo = propInfo
	self.icon:setItemSprite("prop_" .. propInfo.prop_id .. ".png")
end


function PropDetail:doPropUse(useNum)
    if self.itemInfo.amount < useNum then
        CommonNote(MultiLan("desc_count_need"))
        return
    end

    local function doPropUseCallback(jsonDataTable)
        if  jsonDataTable == CJSON_NULL or jsonDataTable.ret ~= 0  then
            return
        end
		CommonNote(MultiLan("desc_use_success"))
        local propUseInfo = jsonDataTable.data
        if propUseInfo.id == self.itemInfo.id then
			local bUseOut = false
            if self.itemInfo.amount - propUseInfo.n < 1 then
				bUseOut = true
			end

			UserInfo:removepropByPropId(self.itemInfo.prop_id, propUseInfo.n)

            if propUseInfo.t == 5 or propUseInfo.t == 14 then
                if propUseInfo.items ~= nil then
                    UserInfo:addProp(propUseInfo.items)
					UserInfo:addPropNote(propUseInfo.items)
                end
			elseif propUseInfo.t == 16 then
				local searchTable = UserInfo:getUserInfo().data.skill
				local bFind = false
				for i=1, table.maxn(searchTable) do
					if searchTable[i].id ==  jsonDataTable.data.skill.id then
						bFind = true
						searchTable[i].master = jsonDataTable.data.skill.master
					end
				end
				if bFind == false then
					table.insert(UserInfo:getUserInfo().data.skill, jsonDataTable.data.skill)
				end
            elseif propUseInfo.t == 4 then
                UserInfo:getUserInfo().data.info.boss_num = UserInfo:getUserInfo().data.info.boss_num + 1
            end
			BagLayer:RefreshBagScrollLayer()
            -----------
			if bUseOut then
                PropDetail:PropDetailExit()
            else
                PropDetail:RefreshPropDetail(self.itemInfo)
            end
        end
	end

	HttpSend("item/use", {"id="..self.itemInfo.id, "n="..useNum}, doPropUseCallback)

end

function PropDetail:doMasterPiecesUse(useNum)

    if self.itemInfo.amount < useNum then
        CommonNote(MultiLan("desc_count_need"))
        return
    end

    local function doMasterPiecesUseCallback(jsonDataTable)
        if  jsonDataTable == CJSON_NULL or jsonDataTable.ret ~= 0  then
            return
        end
	
        local propUseInfo = jsonDataTable.data
        if propUseInfo.id == self.itemInfo.id then
			local bUseOut = false
            if self.itemInfo.amount - propUseInfo.n < 1 then
				bUseOut = true
			end
			BagLayer:removePropFromBag(propUseInfo.id, propUseInfo.n)

            if propUseInfo.items ~= nil then
				UserInfo:addProp(propUseInfo.items)
				
				ItemDetail:ItemDetailEnter(propUseInfo.items[1].obj)
			    local propdetailInfo = nil
				propdetailInfo = GameData:getPropDataTable(propUseInfo.items[1].prop_id)
				CommonNote(MultiLan("speForge_desc4").." Lv "..propdetailInfo.level.."  ".. MultiLan(propdetailInfo.name), COLOR_RED)
            end

            ----------
			BagLayer:RefreshBagScrollLayer()

			PropDetail:PropDetailExit()
        end
	end

	HttpSend("item/synthesismaster", {"id="..self.itemInfo.id}, doMasterPiecesUseCallback)

end

PropDetail["onPropDetailClose"] = onPropDetailClose
PropDetail["onPropDetailSingleUse"] = onPropDetailSingleUse
PropDetail["onPropDetailOpen1"] = onPropDetailOpen1
PropDetail["onPropDetailOpen10"] = onPropDetailOpen10