RefineLayer = class("RefineLayer")

function RefineLayer.getCellSize(  )
	return cc.size(640, 960)
end

--new
function RefineLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function RefineLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["RefineLayer"] = self
	ccb["RefineLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/RefineLayer.ccbi", proxy, self)
	self.data = data

	-- set button onlick
	self.btClose.owner = self
	self.btHelp.owner = self
	self.btChoose1.owner = self
	self.btChoose2.owner = self
	self.btChoose3.owner = self
	self.btChoose4.owner = self
	self.mEquipRefine.owner = self
	self.mEquipHighRefine.owner = self
	self:initUI()
	return self
end
function RefineLayer:initUI(  )
	SetTouchEventForLayer(self.swallowLayer, TouchSwallow)
	self.mTitleEquipRefine:setString(ZGMultiLan("equip_refine_title"))
	self.mEquipRefine:setTitleForState(MultiLan("button_refine"), 1)
	self.mEquipHighRefine:setTitleForState(MultiLan("button_advrefine"), 1)
	self.mEquipStrengthenPercent:setString(MultiLan("Refine_desc_5"))
	self.mEquipStrengthenDesc1:setString(MultiLan("Refine_desc_1"))
	self.mEquipStrengthenDesc4:setString(MultiLan("Refine_desc_4"))
	self:RefreshLbGold()

	self.itemIcon = CreateBagItem()
	self.itemIcon:setCanTouch(false)
	local x, y = self.sp_board_empty:getPosition()
	self.itemIcon:setPosition(cc.p(x, y))
	self.sp_board_empty:getParent():addChild(self.itemIcon)
	self.sp_board_empty:removeFromParent()
	self.itemIcon:setItemType(BAG_ITEM_TYPE_EQUIP)	
	self.itemIcon:setItemInfoTable(self.data.itemInfo)
    self.itemIcon:setCanTouch(false)
	local y = self.lyDesc:getContentSize().height
	local propInfoTable = EquipHelper:getStaticData(self.data.itemInfo)
	local strengthenStr = ""
	y = y - 20
	if propInfoTable.strengthen  ~= nil and propInfoTable.strengthen > 0 then
		strengthenStr = " +" .. propInfoTable.strengthen
	end
	self.lbName:setString("Lv" .. propInfoTable.level .. " " .. MultiLan(propInfoTable.name) .. strengthenStr)
	self.lbName:setPositionY(y)
	y = y - 30

	if propInfoTable.role ~= 0 then
		self.lbClass:setString(string.format(MultiLan("EH_equipCarrer"), MultiLan("role_career_" .. propInfoTable.role)))
		self.lbClass:setPositionY(y)
		y = y - 30
	else
		self.lbClass:setVisible(false)
	end
	self.lbGrade:setString(MultiLan("EH_equipScore")..EquipHelper:getEquipScore(self.data.itemInfo))
	self.lbGrade:setPositionY(y)
	self.myextra = {}
	local extraTable = {"str", "int", "agi", "sta"}
	if self.data.itemInfo.extra ~= nil and self.data.itemInfo.extra ~= CJSON_NULL then
		for i=1, table.maxn(MAIN_ATTR_DESC) do
			if self.data.itemInfo.extra[extraTable[i]] ~= nil and self.data.itemInfo.extra[extraTable[i]] ~= CJSON_NULL then
				local atable = {
							   name = "",
							   num = 1,
							  }
				atable.name = extraTable[i]
				atable.num = self.data.itemInfo.extra[extraTable[i]]
				table.insert(self.myextra,atable)
			end
		end
	end
	self.lyBattleTable = {self.lyBattle1, self.lyBattle2, self.lyBattle3, self.lyBattle4,}
	self.lbBattleTable = {self.lbBattle1, self.lbBattle2, self.lbBattle3, self.lbBattle4,}
	self.imChooseTable = {self.imChoose1, self.imChoose2, self.imChoose3, self.imChoose4,}
	self.iconUpTable = {self.icon_up_1, self.icon_up_2, self.icon_up_3,self.icon_up_4,}
	self.iconDownTable = {self.icon_down_1, self.icon_down_2, self.icon_down_3, self.icon_down_4,}
	local myextranum = table.maxn(self.myextra)
	self.extranum = myextranum
	for i = 1, 4 do
		if i <= myextranum then
			self.lbBattleTable[i]:setString(ATTR_DESC[self.myextra[i].name]..": "..tostring(self.myextra[i].num))
		else
			self.lyBattleTable[i]:setVisible(false)
		end
		self.imChooseTable[i]:setVisible(false)
		self.iconUpTable[i]:setVisible(false)
		self.iconDownTable[i]:setVisible(false)
	end
	self:RefreshLbCash(table.maxn(self.myextra))
end
function RefineLayer:onClickClose(sender)
	removeSelf(self.owner.topNode)
end
function RefineLayer:onClickHelp(sender)
	HelpPopup("equiprefine")
end
function RefineLayer:onClickChoose1(sender)
	if self.owner.imChooseTable[1]:isVisible() then
		self.owner.extranum = self.owner.extranum + 1
		self.owner.imChooseTable[1]:setVisible(false)
	else
		if self.owner.extranum > 2 then
			self.owner.imChooseTable[1]:setVisible(true)
			self.owner.extranum = self.owner.extranum - 1
		end
	end
	self.owner:RefreshLbCash(self.owner.extranum)
end
function RefineLayer:onClickChoose2(sender)
	if self.owner.imChooseTable[2]:isVisible() then
		self.owner.extranum = self.owner.extranum + 1
		self.owner.imChooseTable[2]:setVisible(false)
	else
		if self.owner.extranum > 2 then
			self.owner.imChooseTable[2]:setVisible(true)
			self.owner.extranum = self.owner.extranum - 1
		end
	end
	self.owner:RefreshLbCash(self.owner.extranum)
end
function RefineLayer:onClickChoose3(sender)
	if self.owner.imChooseTable[3]:isVisible() then
		self.owner.extranum = self.owner.extranum + 1
		self.owner.imChooseTable[3]:setVisible(false)
	else
		if self.owner.extranum > 2 then
			self.owner.imChooseTable[3]:setVisible(true)
			self.owner.extranum = self.owner.extranum - 1
		end
	end
	self.owner:RefreshLbCash(self.owner.extranum)
end
function RefineLayer:onClickChoose4(sender)
	if self.owner.imChooseTable[4]:isVisible() then
		self.owner.extranum = self.owner.extranum + 1
		self.owner.imChooseTable[4]:setVisible(false)
	else
		if self.owner.extranum > 2 then
			self.owner.imChooseTable[4]:setVisible(true)
			self.owner.extranum = self.owner.extranum - 1
		end
	end
	self.owner:RefreshLbCash(self.owner.extranum)
end
function RefineLayer:onEquipRefine(sender)
	local isCanRefine = true
	for i = 1 ,table.maxn(self.owner.myextra) do
		if self.owner.imChooseTable[i]:isVisible() then
			isCanRefine = false
		end
		self.owner.iconUpTable[i]:setVisible(false)
		self.owner.iconDownTable[i]:setVisible(false)
	end
	if not isCanRefine then
		for i = 1 ,table.maxn(self.owner.myextra) do
			self.owner.imChooseTable[i]:setVisible(false)
		end
		self.owner.extranum = table.maxn(self.owner.myextra)
		self.owner:RefreshLbCash(self.owner.extranum)
		return
	end

	local equipLevel = EquipHelper:getStaticData(self.owner.data.itemInfo).level
	local needGold = 4500 + 500 * equipLevel
	if UserInfo:getUserInfo().data.info.gold < needGold then
        CommonNote(MultiLan("ES_washFail"))
        return
    end
	local function equipRefineCallback(jsonDataTable)
		ccdump(jsonDataTable,"jsonDataTable")
		if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
			UserInfo:setGold(UserInfo:getGold() - needGold)
			for i =1 ,table.maxn(self.owner.myextra) do
				local number = jsonDataTable.data.extra[self.owner.myextra[i].name]
				if number < self.owner.myextra[i].num then
					self.owner.iconDownTable[i]:setVisible(true)
				end
				if number > self.owner.myextra[i].num then
					self.owner.iconUpTable[i]:setVisible(true)
				end
				self.owner.myextra[i].num = number
				self.owner.lbBattleTable[i]:setString(ATTR_DESC[self.owner.myextra[i].name]..": "..tostring(self.owner.myextra[i].num))
			end
			self.owner:RefreshLbGold()
		end
		local equipInfo = UserInfo:setEquipByIdAndObj(jsonDataTable.data)
		if equipInfo ~= nil then
			UserAttr:setEquipGradeAndScore(equipInfo)
		end
		UserAttr:equipAttrChange(jsonDataTable.data.obj)
    end
	HttpSend("equip/refine", {"id=" .. self.owner.data.itemInfo.id}, equipRefineCallback)
end
function RefineLayer:onEquipHighRefine(sender)
	local lockstr = ""
	local bFirst = true
	for i = 1 ,table.maxn(self.owner.myextra) do
		if self.owner.imChooseTable[i]:isVisible() then
			if bFirst then
				bFirst = false
			else
				lockstr  = lockstr .. ","
			end
			lockstr = lockstr .. self.owner.myextra[i].name
		end
		self.owner.iconUpTable[i]:setVisible(false)
		self.owner.iconDownTable[i]:setVisible(false)
	end
	needCash = 10 + (table.maxn(self.owner.myextra) - self.owner.extranum) * 5
	if UserSelfInfo.cash < needCash then
        CommonCashNeed()
        return
    end
	local function equipRefineCallback(jsonDataTable)
		if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
			UserSelfInfo.cash = UserSelfInfo.cash - jsonDataTable.data.cost_cash
			for i =1 ,table.maxn(self.owner.myextra) do
				local number = jsonDataTable.data.equip.extra[self.owner.myextra[i].name]
				if number < self.owner.myextra[i].num then
					self.owner.iconDownTable[i]:setVisible(true)
				end
				if number > self.owner.myextra[i].num then
					self.owner.iconUpTable[i]:setVisible(true)
				end
				self.owner.myextra[i].num = number
				self.owner.lbBattleTable[i]:setString(ATTR_DESC[self.owner.myextra[i].name]..": "..tostring(self.owner.myextra[i].num))
			end
			self.owner:RefreshLbCash(self.owner.extranum)

			local equipInfo = UserInfo:setEquipByIdAndObj(jsonDataTable.data.equip)
			if equipInfo ~= nil then
				UserAttr:setEquipGradeAndScore(equipInfo)
			end
			UserAttr:equipAttrChange(jsonDataTable.data.equip.obj)
		end
	end
	-- cclog("lockstr="..lockstr)
	HttpSend("equip/advrefine", {"idx="..self.owner.data.itemInfo.id,"lockstr="..lockstr}, equipRefineCallback)
end
function RefineLayer:RefreshLbGold()
	local equipLevel = EquipHelper:getStaticData(self.data.itemInfo).level
	local needGold = 4500 + 500 * equipLevel
	self.mEquipStrengthenDesc2:setString(string.format(MultiLan("Refine_desc_2"),needGold,UserInfo:getUserInfo().data.info.gold))
	if UserInfo:getUserInfo().data.info.gold < needGold then
		self.mEquipStrengthenDesc2:setColor(COLOR_RED)
	else
		self.mEquipStrengthenDesc2:setColor(COLOR_WHITE)
	end
end
function RefineLayer:RefreshLbCash(num)
	local need = (table.maxn(self.myextra) - num) * 5 + 10
	self.mEquipStrengthenDesc3:setString(string.format(MultiLan("Refine_desc_3"),need,UserSelfInfo.cash))
	if UserSelfInfo.cash < need then
		self.mEquipStrengthenDesc3:setColor(COLOR_RED)
	else
		self.mEquipStrengthenDesc3:setColor(COLOR_WHITE)
	end
end


