function SkillMasteryLayer:buyInit()

	self.mButtonBuy:setEnabled(false)
	self.mButtonMerger:setEnabled(true)
	self.mButtonExchange:setEnabled(true)
	self.buySkillLayer:setVisible(true)
	self.mergerSkillLayer:setVisible(false)
	self.exchangeSkilLayer:setVisible(false)
	self.bookLayer:setVisible(false)
	
	self.btCancel.owner = self
	self.btOk.owner = self

	local picTable = {{"prop_121005.png","prop_121004.png","prop_121003.png","prop_121002.png","prop_121001.png"},
					  {"prop_122005.png","prop_122004.png","prop_122003.png","prop_122002.png","prop_122001.png"},
					  {"prop_123005.png","prop_123004.png","prop_123003.png","prop_123002.png","prop_123001.png"}}
	tolua.cast(self.static1, "cc.Sprite"):setSpriteFrame(picTable[UserSelfInfo.role][1])
	tolua.cast(self.static2, "cc.Sprite"):setSpriteFrame(picTable[UserSelfInfo.role][2])
	tolua.cast(self.static3, "cc.Sprite"):setSpriteFrame(picTable[UserSelfInfo.role][3])
	tolua.cast(self.static4, "cc.Sprite"):setSpriteFrame(picTable[UserSelfInfo.role][4])
	tolua.cast(self.static5, "cc.Sprite"):setSpriteFrame(picTable[UserSelfInfo.role][5])
	self.lbTitle:setString(ZGMultiLan("title_prompt"))
	self.btCancel:setTitleForState(MultiLan("button_cancel"),1)
	self.btOk:setTitleForState(MultiLan("button_ok"),1)
	SetTouchEventForLayer(self.swallowLayerSmall, TouchSwallow)
	self.price1 = 280
	self.price2 = 2500
	local rate = 0.6
	if UserSelfInfo.free_book == 0 then
		self.price1 = 0
	end
	if UserSelfInfo.skill_book == 0 then
		self.price2 = 2500*rate
	end
	self.staticLayer:setVisible(true)
	self.lbLeft:setString(MultiLan("skill_desc18"))
	self.lbMoneyNumLeft:setString(self.price1)
	if UserSelfInfo.free_book == 0 then
		self.btLeft:setTitleForState(MultiLan("skill_desc20"),1)
		GameGuide:setButtonNote(self.btLeft, true)
	else
		self.btLeft:setTitleForState(MultiLan("skill_desc19"),1)
	end
	self.lbRight:setString(MultiLan("skill_desc21"))
	self.lbMoneyNumRight:setString(self.price2)
	self.btRight:setTitleForState(MultiLan("skill_desc22"),1)
end
function SkillMasteryLayer:onClickBtLeft( sender )
	self.owner.tag = 1
	if UserSelfInfo.free_book == 0 then
		self.owner.staticLayer:setVisible(false)
    	self.owner.bookLayer:setVisible(true)
    	self.owner.effectLayer:setVisible(false)
    	self.owner.lb_bookLayer:setString(MultiLan("skill_desc28"))
    	self.owner.showBookLayer:removeAllChildren(true)
		self.owner.tanLayer:setVisible(false)
		self.owner:onBookGetClick(self.owner.tag)
	else
		self.owner.tanLayer:setVisible(true)
		self.owner.desc = string.format(MultiLan("skill_desc24"), self.owner.price1)
		self.owner.lbDesc:setString(self.owner.desc)
	end	
end
function SkillMasteryLayer:onClickBtRight( sender )
	self.owner.tanLayer:setVisible(true)
	self.owner.tag = 2
	if UserSelfInfo.skill_book == 0 then
		self.owner.desc = string.format(MultiLan("skill_desc24"), self.owner.price2)..MultiLan("skill_desc25")
	else
		self.owner.desc = string.format(MultiLan("skill_desc24"),self.owner.price2)
	end	
	self.owner.lbDesc:setString(self.owner.desc)
end
function SkillMasteryLayer:onClickCancel( sender )
	self.owner.tanLayer:setVisible(false)
end
function SkillMasteryLayer:onClickOk( sender )
	if self.owner.tag == 1 then
		self.owner.cost = self.owner.price1
	elseif self.owner.tag == 2 then
		self.owner.cost = self.owner.price2
	end
    if UserSelfInfo.cash < self.owner.cost then
		CommonCashNeed()
	else
    	self.owner.staticLayer:setVisible(false)
    	self.owner.bookLayer:setVisible(true)
    	self.owner.effectLayer:setVisible(false)
    	self.owner.lb_bookLayer:setString(MultiLan("skill_desc28"))
    	self.owner.showBookLayer:removeAllChildren(true)
		self.owner.tanLayer:setVisible(false)
		self.owner:onBookGetClick(self.owner.tag)
	end
end
function SkillMasteryLayer:onBookGetClick(tag)
	local function showBookEffect(count, bookInfo)
		local layerTable = {}
		for i=1, count do
			local sprite = CreateCommonSprite("prop_"..bookInfo[i].prop_id..".png")
			sprite:setVisible(false)
			local sprite_name = CreateCommonLabel(MultiLan(GameData:getPropDataTable(bookInfo[i].prop_id).name), Pos(sprite:getContentSize(),0.5,-0.35), FontSize1,nil , nil , cc.size(112,70))
			sprite_name:setAlignment(cc.TEXT_ALIGNMENT_CENTER)
			sprite:addChild(sprite_name)
			table.insert(layerTable, sprite)
		end
		
		if count == 1 then
			CreateMxN(self.showBookLayer,1, 1, layerTable, nil, self.showBookLayer:getContentSize())
		else
			CreateMxN(self.showBookLayer,5, 2, layerTable, nil, self.showBookLayer:getContentSize())
		end
		-- print(1)
		local t =0.15
		for i=1, count do
			if count ~= i then
				layerTable[i]:runAction(cc.Sequence:create(cc.DelayTime:create((i-1)*t), cc.CallFunc:create(GaiEffect)))
			else
				local function resetState(node)
					getBookLock = false
					GaiEffect(node)
				end
				layerTable[i]:runAction(cc.Sequence:create(cc.DelayTime:create((i-1)*t), cc.CallFunc:create(resetState)))
			end
		end
		if count == 10 and bookInfo[11] ~= nil then
			local staticData = GameData:getPropDataTable(bookInfo[11].prop_id)
				-- print("staticData", staticData.id)
			if staticData ~= nil then
				local function delayNote()
					self.effectLayer:setVisible(true)
					self.lbEffectTitle:setString(MultiLan("skill_desc35"))
					tolua.cast(self.imEffectIco, "cc.Sprite"):setSpriteFrame("prop_"..bookInfo[11].prop_id..".png")   
					self.lbEffectName:setString(MultiLan(staticData.name))
					self.effectLayer:setScale(1.2)
					local that = self
					self.effectLayer:runAction(cc.Sequence:create(cc.ScaleTo:create(0.15, 1), cc.DelayTime:create(2), cc.CallFunc:create(function ()
																																		that.effectLayer:setVisible(false)
																																	end)))
				end
				self.effectLayer:runAction(cc.Sequence:create(cc.DelayTime:create(10*t), cc.CallFunc:create(delayNote)))
			end
		end
	end
	function getBookCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			return 
		end
		getBookLock = true
		--消耗
		UserSelfInfo[jsonDataTable.data.use_type] = UserSelfInfo[jsonDataTable.data.use_type] - jsonDataTable.data.use_num
		
		--获得
		UserInfo:addProp(jsonDataTable.data.item)
		
		--数据
		UserSelfInfo.free_book = UserSelfInfo.free_book + 1
		UserSelfInfo.skill_book = UserSelfInfo.skill_book + 1
		
		--界面变化
		GameGuide:setButtonNote(self.btLeft, false)
		if tag == 1 then
			self.price1 = 280
			self.lbMoneyNumLeft:setString(self.price1)
			self.btLeft:setTitleForState(MultiLan("skill_desc19"),1)
		elseif tag == 2 then
			self.price2 = 2500
			self.lbMoneyNumRight:setString(self.price2)
		end
		
		--特效
		if tag == 1 then
			showBookEffect(1, jsonDataTable.data.display)
		elseif tag == 2 then
			showBookEffect(10, jsonDataTable.data.display)
		end
	end
	HttpSend("skill/lottery", {"type="..tag}, getBookCallback)
end






