SpecialForgeLayer = class("SpecialForgeLayer")
SpecialForgeLayer.__index = SpecialForgeLayer

SpecialForgeLayer.topNode = nil
SpecialForgeLayer.filterScroll = nil
SpecialForgeLayer.specialForgeInfoList = {}
SpecialForgeLayer.selectForgeInfo = {}

SpecialForgeLayer.COST_PRESTIGE = 1000
SpecialForgeLayer.COST_FUSION = 8000

ccb["SpecialForgeLayer"] = SpecialForgeLayer
SpecialForgeLayerOwner = SpecialForgeLayerOwner or {}
ccb["SpecialForgeLayerOwner"] = SpecialForgeLayerOwner

function SpecialForgeLayer:SpecialForgeLayerEnter(specialForgeInfos)
    
    if self.topNode ~= nil then
        return
    end

	local proxy = cc.CCBProxy:create()
	self.topNode = CCBReaderLoad("ccb/SpecialForgeLayer.ccbi",proxy,SpecialForgeLayerOwner)
	POPUP_LAYER:addChild(self.topNode)
	
	SpecialForgeLayerOwner["mDesc"]:setString(MultiLan("speforge_desc7"))
	SpecialForgeLayerOwner["mButtonClose"]:setTitleForState(MultiLan("button_close"), cc.CONTROL_STATE_NORMAL)
	SpecialForgeLayerOwner["mTitleSepcialForge"]:setString(ZGMultiLan("mTitleSepcialForge"))
		
	self:SpecialForgeLayerCreate()
	self:SpecialForgeLayerRefresh(specialForgeInfos)
	
end

function onSpecialForgeLayerClose()
	SpecialForgeLayer:SpecialForgeLayerExit()
end

function SpecialForgeLayer:SpecialForgeLayerExit()
	self.topNode:removeFromParent()
	self.topNode = nil
end

function SpecialForgeLayer:refreshPrestige()
    tolua.cast(SpecialForgeLayerOwner["mSpecialForgePrestige"], "cc.Label"):setString(MultiLan("speForge_desc1")..UserInfo:getUserInfo().data.info.prestige)
end

function SpecialForgeLayer:SpecialForgeLayerCreate()
	local filterLayer = SpecialForgeLayerOwner["mSpecialForgeChoose"]
	self.filterScroll = cc.ScrollView:create()
	filterLayer:addChild(self.filterScroll)
	self.filterScroll:setViewSize(cc.size(filterLayer:getContentSize().width, filterLayer:getContentSize().height))
	self.filterScroll:setPosition(cc.p(0,0))
	self.filterScroll:ignoreAnchorPointForPosition(true)
	self.filterScroll:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
	self.filterScroll:setClippingToBounds(true)
	self.filterScroll:setBounceable(true)
	self.filterScroll:setDelegate()
	self.filterScroll:setVisible(true)

    --swallowLaer
	local function onSpecialForgeSwallowTouch(touch, event)
		return true
	end
	SetTouchEventForLayer(SpecialForgeLayerOwner["mSpecialForgeSwallowLayer"], onSpecialForgeSwallowTouch)
end

function SpecialForgeLayer:SpecialForgeLayerRefresh(specialForgeInfos)

    self.specialForgeInfoList = specialForgeInfos
	SpecialForgeLayer:refreshPrestige()

	local scrollLayer = cc.Layer:create()
	scrollLayer:ignoreAnchorPointForPosition(true)
	self.filterScroll:setContainer(scrollLayer)
	local scrollWorldPos = self.filterScroll:getParent():convertToWorldSpace(cc.p(self.filterScroll:getPosition()))
	local scrollViewSize = self.filterScroll:getViewSize()
	local curPosY = 0
    local i = table.maxn(specialForgeInfos)


    local function getMasterStar(masterInfo)
       local starCount = 0
       for k, v in pairs(masterInfo) do
          starCount = starCount +1
	   end
       return starCount
    end

	while i > 0 do

		local propId =specialForgeInfos[i].prop_id
		local propInfoTable = GameData:getPropDataTable(propId)
		
		local itemLayer = cc.Layer:create()
		itemLayer:ignoreAnchorPointForPosition(true)
			
		local itemBgSprite = cc.Sprite:createWithSpriteFrameName("board_equipchoose.png")
		itemBgSprite:setAnchorPoint(cc.p(0, 0))
		itemLayer:addChild(itemBgSprite)
			
		local itemRichInfo = EquipHelper:doCreateItemInfoRichtext(specialForgeInfos[i], EQUIP_COLOR_ARR[5])
		itemRichInfo:setContentSize(cc.size(270, 500))
		itemRichInfo:formatText()
		itemRichInfo:ignoreAnchorPointForPosition(true)
		itemRichInfo:setPosition(cc.p(115, itemRichInfo:getTextMaxHeight()-500 + 30/2))
		itemLayer:setContentSize(496, itemRichInfo:getTextMaxHeight() + 30)
		itemLayer:addChild(itemRichInfo)
		itemLayer:setPosition(cc.p(0, curPosY))
		curPosY = curPosY + itemLayer:getContentSize().height
			
		itemBgSprite:setScaleY(itemLayer:getContentSize().height / itemBgSprite:getSpriteFrame():getRect().height)
			
		local bagItem = CreateBagItem()
		bagItem:setCanTouch(false)
        bagItem:setItemType(BAG_ITEM_TYPE_EQUIP)
		bagItem:setItemInfoTable(specialForgeInfos[i])
		bagItem:setPosition(cc.p(56, itemLayer:getContentSize().height - 52))
        bagItem:setEquipOutLine(5)
		itemLayer:addChild(bagItem)
		
        local equipPlace = cc.Label:create(MultiLan( "equip_place_"..propInfoTable.place), DefaultFontName, FontSize1)
        equipPlace:setPosition(cc.p(440, itemLayer:getContentSize().height * 0.85))
        equipPlace:setColor(COLOR_YELLOW)
        itemLayer:addChild(equipPlace)	

			local function specialForgeCallback(jsonDataTable)
				if jsonDataTable.ret ~= 0 then
				    CommonNote(MultiLan("speForge_desc2"))
                else
                    CommonNote(MultiLan("speForge_desc3"))
              
                    if jsonDataTable.data ~= nil then
                        UserInfo:addProp(jsonDataTable.data)
                        BagLayer:setDirty(true)
                        ItemDetail:ItemDetailEnter(jsonDataTable.data[1].obj)

                        local propdetailInfo = nil
                        propdetailInfo = GameData:getPropDataTable(jsonDataTable.data[1].prop_id)
		                CommonNote(MultiLan("speForge_desc4").." Lv "..propdetailInfo.level.."  ".. MultiLan(propdetailInfo.name), COLOR_RED)
                    end

                    if getMasterStar(self.selectForgeInfo.glyph) > 1 then
                        UserInfo:getUserInfo().data.info.prestige = UserInfo:getUserInfo().data.info.prestige - SpecialForgeLayer.COST_PRESTIGE
                        UserInfo:getUserInfo().data.info.fusion = UserInfo:getUserInfo().data.info.fusion - SpecialForgeLayer.COST_FUSION
                    else
                        UserInfo:getUserInfo().data.info.prestige = UserInfo:getUserInfo().data.info.prestige - SpecialForgeLayer.COST_PRESTIGE
                        UserInfo:getUserInfo().data.info.fusion = UserInfo:getUserInfo().data.info.fusion - SpecialForgeLayer.COST_FUSION
                    end
                    SpecialForgeLayer:refreshPrestige()
				
				end

                onSpecialForgeLayerClose()
                EquipMeltLayer: EquipMeltLayerExit()
			end

			local function sendSpecialForge()
                local  canForge = 0

                if  UserInfo:getUserInfo().data.info.fusion < SpecialForgeLayer.COST_FUSION then
                    canForge = 1
                else
                    if getMasterStar(self.selectForgeInfo.glyph) > 1 then
                        if UserInfo:getUserInfo().data.info.prestige < SpecialForgeLayer.COST_PRESTIGE then
                            canForge = 2
                        end
                    else
                        if UserInfo:getUserInfo().data.info.prestige < SpecialForgeLayer.COST_PRESTIGE  then
                            canForge = 2
                        end
                    end
                end

             
                if canForge == 0 then
                   HttpSend("equip/make", {"id=" ..self.selectForgeInfo.id, "prop_id="..self.selectForgeInfo.prop_id}, specialForgeCallback)
                elseif canForge == 1  then
                   CommonMeltpointNeed()
                elseif   canForge == 2  then
                   CommonPrestigeNeed()
                end


            end

			local function onTouchSpecialForge(node)
               
                self.selectForgeInfo = self.specialForgeInfoList[node:getTag()]

                local content = nil
                if getMasterStar(self.selectForgeInfo.glyph)  > 1 then
                  content = cc.Label:create(MultiLan("speForge_desc5"),DefaultFontName, FontSize3,CCSize(460,160),0,1)
                else
                  content = cc.Label:create(MultiLan("speForge_desc6"),DefaultFontName, FontSize3,CCSize(460,160),0,1)
                end

	            CreateSmallPopupWithCancel("equipnew",content, sendSpecialForge)
				
			end

			local pBackgroundButton = cc.Scale9Sprite:createWithSpriteFrameName("button_blue.png")
			local pTitle = cc.Label:create(MultiLan("speForge_make"), DefaultFontName, 30)
			local takeonButton = cc.ControlButton:create(pTitle, pBackgroundButton)
			takeonButton:setTag(i)
			takeonButton:registerControlEventHandler(onTouchSpecialForge,cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE)
			takeonButton:setPosition(cc.p(430, itemLayer:getContentSize().height * 0.4))
			takeonButton:setPreferredSize(cc.size(144, 50))
			takeonButton:setScrollViewRect(cc.rect(scrollWorldPos.x, scrollWorldPos.y, scrollViewSize.width, scrollViewSize.height))
			itemLayer:addChild(takeonButton)
			takeonButton:setScale(0.6)
			scrollLayer:addChild(itemLayer)
		i = i-1	
	end
	local filterLayer = SpecialForgeLayerOwner["mSpecialForgeChoose"]
	if scrollLayer:getContentSize().height <= filterLayer:getContentSize().height then
		scrollLayer:setContentSize(cc.size(filterLayer:getContentSize().width, filterLayer:getContentSize().height))
		self.filterScroll:setContentOffset(cc.p(0, 0), false)
	else
		scrollLayer:setContentSize(cc.size(filterLayer:getContentSize().width, curPosY))
		self.filterScroll:setContentOffset(cc.p(0, -scrollLayer:getContentSize().height + filterLayer:getContentSize().height), false)
	end
	self.filterScroll:updateInset()
end


SpecialForgeLayer["onSpecialForgeLayerClose"] = onSpecialForgeLayerClose