GuildWarZhanTanLayer = class("GuildWarZhanTanLayer")

--new
function GuildWarZhanTanLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function GuildWarZhanTanLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["GuildWarZhanTanLayer"] = self
	ccb["GuildWarZhanTanLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/tanchuang/zhandoubaogao.ccbi", proxy, self)
	self.data = data

    
    SetTouchEventForLayer(self.swallowLayerSmall, TouchSwallow)
	-- set button onlick
 	self.btClose.owner = self
 	self.btChakan1.owner = self 
 	self.btChakan2.owner = self 
 	self.btChakan3.owner = self 
	self:initUI()
	return self
end
function GuildWarZhanTanLayer:initUI(  )
	self.title_zhandoubaogao:setString(ZGMultiLan("title_zhandoubaogao"))
	self.lbGuild1Name:setString(self.data.info.name1)
	self.lbGuild2Name:setString(self.data.info.name2)
	if self.data.info.win_id == self.data.info.id1 then
		self.imGuild1:setSpriteFrame("banghui_3.png")
		self.imGuild2:setSpriteFrame("banghui_4.png")
	else
		self.imGuild1:setSpriteFrame("banghui_4.png")
		self.imGuild2:setSpriteFrame("banghui_3.png")
	end
	self.LbZhanbaoDesc:setString(MultiLan("guild_war_zhanbao_3"))
	local battledata = self.data.info.blog
	local guild1 = {self.lbGuild1Group1 , self.lbGuild1Group2 ,self.lbGuild1Group3}
	local guild2 = {self.lbGuild2Group1 , self.lbGuild2Group2 ,self.lbGuild2Group3}
	local btTable = {self.btChakan1 , self.btChakan2 , self.btChakan3}
	self.btClose:setTitleForState(MultiLan("button_close"),1)
	ccdump(self.data,"data")
	for i = 1,3 do
		btTable[i]:setTitleForState(MultiLan("guild_war_zhanbao_button"),1) 
		if battledata[i].status == 1 then
			guild1[i]:setString(MultiLan("guild_war_zhanbao_1"))
			guild2[i]:setString(MultiLan("guild_war_zhanbao_2"))
			guild1[i]:setColor(cc.c3b(0,255,0))
			guild2[i]:setColor(cc.c3b(255,0,0))
		elseif battledata[i].status == 0 then
			guild1[i]:setString(MultiLan("guild_war_zhanbao_2"))
			guild2[i]:setString(MultiLan("guild_war_zhanbao_1"))
			guild1[i]:setColor(cc.c3b(255,0,0))
			guild2[i]:setColor(cc.c3b(0,255,0))
		else
			guild1[i]:setString("--")
			guild2[i]:setString("--")
			guild1[i]:setColor(cc.c3b(100,100,100))
			guild2[i]:setColor(cc.c3b(100,100,100))
		end
	end
end
function GuildWarZhanTanLayer:onCilckClose( sender )
	removeSelf(self.owner.topNode)
end
function GuildWarZhanTanLayer:onClickChakan( sender )
	tag = self:getTag()
	local battlelog = self.owner.data.info.blog[tag]
	self.owner:ShowGuildGroupFight(battlelog )
end
function GuildWarZhanTanLayer:ShowGuildGroupFight(fightInfo, bTeamFight)
	if fightInfo.status == nil or fightInfo.status == 2 then
		return
	end
	local team = {fightInfo.self_log, fightInfo.vs_log}
	local function sortTeam(a,b)
		if a.kill > b.kill then
			return true
		elseif a.kill < b.kill then
			return false
		else
			return a.score > b.score 
		end
	end
	table.sort(team[1], sortTeam)
	table.sort(team[2], sortTeam)
	--查看战报
	local popupContent = CreateLayer(POPUP_SIZE_MAX, 1, Pos(POPUP_SIZE_MAX))
	local scrollLayer  = CreateLayer(cc.size(580,640), 1, Pos(POPUP_SIZE_MAX,0.5,0.495))
	popupContent:addChild(scrollLayer)
	
	popupContent:addChild(CreateCommonSprite("board_guildthings.png", Pos(POPUP_SIZE_MAX,0.5,0.905)))
	popupContent:addChild(CreateCommonSprite("pic_vspic.png", Pos(POPUP_SIZE_MAX,0.5,0.905)))
	popupContent:addChild(CreateCommonLabel(string.format(MultiLan("GGL_team"),self.data.info.name1), Pos(POPUP_SIZE_MAX,0.3,0.905),FontSize2))
	popupContent:addChild(CreateCommonLabel(string.format(MultiLan("GGL_team"),self.data.info.name2), Pos(POPUP_SIZE_MAX,0.7,0.905),FontSize2))
	if fightInfo.status == 1 then
		popupContent:addChild(CreateCommonLabel(ZGMultiLan("game_war_result_win"), Pos(POPUP_SIZE_MAX, 0.11, 0.905), FontSize4, COLOR_FNT_CommonYellow))
		popupContent:addChild(CreateCommonLabel(ZGMultiLan("game_war_result_lose"), Pos(POPUP_SIZE_MAX, 0.89, 0.905), FontSize4, COLOR_FNT_CommonDisableGray))
	elseif fightInfo.status == 0 then
		popupContent:addChild(CreateCommonLabel(ZGMultiLan("game_war_result_win"), Pos(POPUP_SIZE_MAX, 0.89, 0.905), FontSize4, COLOR_FNT_CommonYellow))
		popupContent:addChild(CreateCommonLabel(ZGMultiLan("game_war_result_lose"), Pos(POPUP_SIZE_MAX, 0.11, 0.905), FontSize4, COLOR_FNT_CommonDisableGray))
	end

	local height = 80
	local width = 280
	local count = math.max(table.maxn(team[1]),table.maxn(team[2]))
	local y = (count - 0.5)*height
	local x = width/2
	local layer = cc.Layer:create()
	local backArr = {"board_dbteammb.png", "board_dbenemymb.png"}
	if fightInfo.status == 0 then
		backArr = {"board_dbenemymb.png", "board_dbteammb.png"}
	end
	for i=1, 2 do
		y = math.max(640-0.5*height,(count - 0.5)*height)
		for j=1,count do
			
			local player = team[i][j]
			-- print(i,j,player)
			if player ~= nil then
				local back = CreateCommonSprite(backArr[i], cc.p(x,y))
				if player.uid ~= nil and player.uid ~= 0 then
					
					local clickButton = CreateCommonButton("pic_suiyiaaa.png", Pos(back:getContentSize()), cc.size(272,76) , onPlayerDetailClick)
					clickButton:setSwallowTouch(false)
					back:addChild(clickButton, 0, player.uid)
					clickButton:setName(player.uid)
					if bTeamFight ~= nil then
						clickButton:setEnable(false)
					end
				end
				
				-- print(backArr[i])
				back:addChild(CreateCommonLabel(MultiLan("GGL_score")..player.score, Pos(back:getContentSize(),0.02,0.28),FontSize5, COLOR_GREEN,cc.p(0,0.5)))
				back:addChild(CreateCommonLabel(MultiLan("GGL_kill")..player.kill, Pos(back:getContentSize(),0.6,0.72),FontSize5, COLOR_RED,cc.p(0,0.5)))
				-- print(i, j, player.name, player.uid)
				local name = nil
				if player.uid ~= nil and player.uid == 0 then
					name = CreateCommonLabel(MultiLan(player.name), Pos(back:getContentSize(),0.02,0.72),FontSize5, nil,cc.p(0,0.5))
				else
					name = CreateCommonLabel(player.name, Pos(back:getContentSize(),0.02,0.72),FontSize5, nil,cc.p(0,0.5))
				end
				back:addChild(name)
				if player.name == UserSelfInfo.name then
					back:setOpacity(128)
					name:setColor(COLOR_YELLOW)
				end
				layer:addChild(back)
			end
			
			y = y - height
		end
		x = x + width
	end

	
	layer:setContentSize(cc.size(580, math.max(640, count*height)))
	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, math.min(0,640-count*height)), kScrollViewDirectionVertical)
	
	local root1 = CommonCreatePopupMax("checkresult", popupContent, true)
	
	local function closeFunc()
		removeSelf(root1)
	end
	popupContent:addChild(CreateCommonButton("button_red.png",Pos(POPUP_SIZE_MAX,0.5,0.05), cc.size(144,50), closeFunc, {str=MultiLan("button_close"),size=FontSize3}))
end