HeroAuraLayer = class("HeroAuraLayer")

--new
function HeroAuraLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function HeroAuraLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["HeroAuraLayer"] = self
	ccb["HeroAuraLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/tanchuang/HeroAuraLayer.ccbi", proxy, self)
	self.data = data
    
    SetTouchEventForLayer(self.swallowLayerSmall, TouchSwallow)
	-- set button onlick
	self.btClose.owner = self
	self.btHelp.owner = self
	self.button1.owner = self
	self.button2.owner = self
	self.button3.owner = self
	self.btActivation.owner = self
	self.icon = {self.imIco1,self.imIco2,self.imIco3}
	self.showHeroAuraTag = 1
	self:initUI()
	return self
end
function HeroAuraLayer:initUI()
	ccdump(HeroInfoTable[self.data.showedHeroTag].dynamicData.aura)
	self.title_hero_aura:setString(ZGMultiLan("title_hero_aura"))
	self.imIco1:setSpriteFrame("icon_hero_aura_"..self.data.showedHeroTag.."01.png")
	self.imIco2:setSpriteFrame("icon_hero_aura_"..self.data.showedHeroTag.."02.png")
	self.imIco3:setSpriteFrame("icon_hero_aura_"..self.data.showedHeroTag.."03.png")
	self.lbName1:setString(MultiLan("name_hero_aura_"..self.data.showedHeroTag.."01"))
	self.lbName2:setString(MultiLan("name_hero_aura_"..self.data.showedHeroTag.."02"))
	self.lbName3:setString(MultiLan("name_hero_aura_"..self.data.showedHeroTag.."03"))
	self.lb_aura_effect:setString(MultiLan("hero_aura_desc_1"))
	self.lb_requires:setString(MultiLan("hero_aura_desc_2"))
	self.imIco1:addChild(CreateCommonSprite("effect_selected01.png", Pos(self.imIco1:getContentSize())),0,1)
	self:SetAuraLb()
end
function HeroAuraLayer:onClickHelp()
	HelpPopup("heroaura")
end
function HeroAuraLayer:onClickClose()
	removeSelf(self.owner.topNode)
	UpdateHeroInfo()
end
function HeroAuraLayer:onclickButton1(sender)
	self.owner.showHeroAuraTag = 1
	self.owner:SetAuraLb()
end
function HeroAuraLayer:onclickButton2(sender)
	self.owner.showHeroAuraTag = 2
	for i=1,3 do
		if self.owner.icon[i]:getChildByTag(1) ~= nil then
			self.owner.icon[i]:removeChildByTag(1)
		end
	end
	self.owner.imIco2:addChild(CreateCommonSprite("effect_selected01.png", Pos(self.owner.imIco2:getContentSize())),0,1)
	self.owner:SetAuraLb()
end
function HeroAuraLayer:onclickButton3(sender)
	self.owner.showHeroAuraTag = 3
	for i=1,3 do
		if self.owner.icon[i]:getChildByTag(1) ~= nil then
			self.owner.icon[i]:removeChildByTag(1)
		end
	end
	self.owner.imIco3:addChild(CreateCommonSprite("effect_selected01.png", Pos(self.owner.imIco3:getContentSize())),0,1)
	self.owner:SetAuraLb()
end
function HeroAuraLayer:onClickActivation(sender)
	if self.showHeroAuraTag == 1 then
		if UserInfo:getGold() < 200000 then
			CommonNote(MultiLan("ES_AuraFail"))
			return
		end
	elseif self.showHeroAuraTag == 2 then
		if UserInfo:getGold() < 500000 then
			CommonNote(MultiLan("ES_AuraFail"))
			return
		end
	elseif self.showHeroAuraTag == 3 then
		if UserInfo:getGold() < 1500000 then
			CommonNote(MultiLan("ES_AuraFail"))
			return
		end
	end
	local function AuraActiveCallback( jsonDataTable )
		if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
			self.owner.btActivation:setEnabled(false)
			self.owner.btActivation:setTitleForState(MultiLan("hero_aura_button_3"),4)
			UserInfo:setGold(UserInfo:getGold() - jsonDataTable.data.cost_gold)
			HeroInfoTable[self.owner.data.showedHeroTag].dynamicData.aura[self.owner.showHeroAuraTag] = 1
			UserAttr:equipAttrChange(1, true,true)
			UserAttr:equipAttrChange(HeroInfoTable[self.owner.data.showedHeroTag].dynamicData.id, true,true)
		end
	end
	HttpSend("hire/auraActive", {"hid="..HeroInfoTable[self.owner.data.showedHeroTag].dynamicData.id, "auraIndex="..self.owner.showHeroAuraTag - 1}, AuraActiveCallback)
end
function HeroAuraLayer:SetAuraLb()
	self.lb_aura_effect_desc:setString(MultiLan("hero_aura_desc_"..self.data.showedHeroTag.."0"..self.showHeroAuraTag))
	local iconTable = {self.imIco1, self.imIco2, self.imIco3 }
	for i=1,3 do
		if HeroInfoTable[self.data.showedHeroTag].dynamicData.aura[i] == 1 then
			AddAllyAuraEffect(iconTable[i],Pos(iconTable[i]:getContentSize()))
		end
		if self.icon[i]:getChildByTag(1) ~= nil then
			self.icon[i]:removeChildByTag(1)
		end
	end
	self.icon[self.showHeroAuraTag]:addChild(CreateCommonSprite("effect_selected01.png", Pos(self.icon[self.showHeroAuraTag]:getContentSize())),0,1)
	if self.showHeroAuraTag == 1 then
		self:SetActivationButton(3)
		self.lb_requires_desc_1:setString(string.format(MultiLan("hero_aura_desc_3"),3))
		self.lb_requires_desc_2:setString(string.format(MultiLan("hero_aura_desc_4"),200000))
	elseif self.showHeroAuraTag == 2 then
		self:SetActivationButton(6)
		self.lb_requires_desc_1:setString(string.format(MultiLan("hero_aura_desc_3"),6))
		self.lb_requires_desc_2:setString(string.format(MultiLan("hero_aura_desc_4"),500000))
	elseif self.showHeroAuraTag == 3 then
		self:SetActivationButton(10)
		self.lb_requires_desc_1:setString(string.format(MultiLan("hero_aura_desc_3"),10))
		self.lb_requires_desc_2:setString(string.format(MultiLan("hero_aura_desc_4"),1500000))
	end
end
function HeroAuraLayer:SetActivationButton(a)
	if self.data.star_level >= a then
		self.lb_requires_desc_1:setColor(cc.c3b(255,255,255))
		if HeroInfoTable[self.data.showedHeroTag].dynamicData.aura[self.showHeroAuraTag] == 1 then
			self.btActivation:setEnabled(false)
			self.btActivation:setTitleForState(MultiLan("hero_aura_button_3"),4)
		else
			self.btActivation:setEnabled(true)
			self.btActivation:setTitleForState(MultiLan("hero_aura_button_2"),1)
		end
	else
		self.lb_requires_desc_1:setColor(cc.c3b(255,0,0))
		self.btActivation:setEnabled(false)
		self.btActivation:setTitleForState(MultiLan("hero_aura_button_1"),4)
	end
end

