
UserDetailLayer = class("UserDetailLayer")
UserDetailLayer.__index = UserDetailLayer
UserDetailLayer.isCreated = false
UserDetailLayer.topNode = nil
UserDetailLayer.equipItems = {}

UserDetail = UserDetail or {}
ccb["UserDetail"] = UserDetail
UserDetailOwner = UserDetailOwner or {}
ccb["UserDetailOwner"] = UserDetailOwner

function UserDetailLayer:Exit()
	self.topNode:setVisible(false)
end

function UserDetailLayer:Enter(playerInfo)
    if playerInfo == nil or (self.isCreated and self.topNode:isVisible()) then
        return nil
    end

	if self.isCreated then
		self.topNode:setVisible(true)
	else
		local proxy = cc.CCBProxy:create()
		self.topNode = CCBReaderLoad("ccb/UserDetail.ccbi",proxy,UserDetailOwner)
		SetTouchEventForLayer(UserDetailOwner["mUserDetailSwallow"], TouchSwallow)
		UserDetailOwner["mUserDetailClose"]:setTitleForState(MultiLan("button_close"), 1)
		if POPUP_LAYER ~= nil then
			POPUP_LAYER:addChild(self.topNode)
			for i = 1, EQUIP_MAX do
				local equip = CreateBagItem()
				equip:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
				equip:setTag(i)
				equip:setItemType(BAG_ITEM_TYPE_EMPTY_EQUIP)
				equip:setItemInfoTable({place=i})
				equip:setCanTouch(false)
				self.equipItems[i] = equip
				tolua.cast(UserDetailOwner["mEquipItemLayer" .. i], "cc.Node"):addChild(self.equipItems[i])
			end
		else
			return nil
		end
	end

	return self:InitUserDetail(playerInfo)
end

function UserDetailLayer:playSpineAnimation( role ,sex , level)
	-- local spineFileNameArr = {"Soldier_man", "Magician_woman", "hunter_woman"}
	local seetag = role * 2 - sex +1
	local spineFileNameArr = SPINE_CONFIGS.userFiles
	local s_pPathSpineBoyJson = "spine/" .. spineFileNameArr[seetag] .. ".json"
	local s_pPathSpineBoyAtlas = "spine/" .. spineFileNameArr[seetag] .. ".atlas"
	local spineboy = sp.SkeletonAnimation:create(s_pPathSpineBoyJson, s_pPathSpineBoyAtlas, 1)
	UserDetailOwner["lyUserBg"]:addChild(spineboy)
	spineboy:setPosition(Pos(UserDetailOwner["lyUserBg"]:getContentSize(), 0.5, 0.05))

  	spineboy:setScale(SPINE_CONFIGS.userFilesScale[seetag])
	spineboy:setDebugBones(false)
	spineboy:setAnimation(0, "animation", true)
	if level >= 40 then
		spineboy:setAnimation(0, "wind", true)
	end
end

function UserDetailLayer:setupBodyBg( role ,sex )
	if GameConfig:GetProjectType() == "HY" then
		UserDetail["mAnimationManager"]:setRootNode(UserDetailOwner["ly_anim"])
		UserDetailOwner["ly_anim_fire"]:removeAllChildren()
		if role == 1 then
			local p = cc.ParticleSystemQuad:create("ccbResources/particals/bodybg_1/fire.plist")
			p:setPosition(Pos(UserDetailOwner["ly_anim_fire"]:getContentSize()))
			p:setScale(0.25)
			UserDetailOwner["ly_anim_fire"]:addChild(p)
			UserDetail["mAnimationManager"]:runAnimationsForSequenceNamed("fire")
		end
	end
	if GameConfig:GetProjectType() == "WOW" then
		UserDetail["mAnimationManager"]:setRootNode(UserDetailOwner["ly_anim"])
		UserDetailOwner["ly_anim_fire"]:removeAllChildren()
		if role == 2 and sex == 2 then
			local p = cc.ParticleSystemQuad:create("ccbResources/particals/bodybg_2/fire.plist")
			p:setPosition(Pos(UserDetailOwner["ly_anim_fire"]:getContentSize()))
			p:setScale(0.25)
			UserDetailOwner["ly_anim_fire"]:addChild(p)
			UserDetail["mAnimationManager"]:runAnimationsForSequenceNamed("fire")
		end
	end

	for i = 1, 3 do
		UserDetailOwner["lyBodyPartical_" .. i]:setVisible((i == role))
	end
	UserDetailOwner["im_class_icon"]:setSpriteFrame("school_icon_"..role..".png")
	if role == 1 then
		for i = 1, #PARTICLE_CONFIGS.user.fire do
			local sp = UserDetailOwner["lyBodyPartical_1"]:getChildByTag(i)
			local p = cc.ParticleSystemQuad:create("ccbResources/particals/bodybg_1/" .. PARTICLE_CONFIGS.user.fire[i] .. ".plist")
			local x, y = sp:getPosition()
			p:setPosition(cc.p(x, y))
			p:setScale(sp:getScale())
			sp:getParent():addChild(p)
			sp:removeFromParent()	
		end
	end
	if role == 2 then
		for i = 1, #PARTICLE_CONFIGS.user.water do
			local sp = UserDetailOwner["lyBodyPartical_2"]:getChildByTag(i)
			local p = cc.ParticleSystemQuad:create("ccbResources/particals/bodybg_2/" .. PARTICLE_CONFIGS.user.water[i] .. ".plist")
			local x, y = sp:getPosition()
			p:setPosition(cc.p(x, y))
			p:setScale(sp:getScale())
			sp:getParent():addChild(p)
			sp:removeFromParent()	
		end
	end
	if role == 3 then
		for i = 1, #PARTICLE_CONFIGS.user.wind do
			local sp = UserDetailOwner["lyBodyPartical_3"]:getChildByTag(i)
			local p = cc.ParticleSystemQuad:create("ccbResources/particals/bodybg_3/" .. PARTICLE_CONFIGS.user.wind[i] .. ".plist")
			local x, y = sp:getPosition()
			p:setPosition(cc.p(x, y))
			p:setScale(sp:getScale())
			sp:getParent():addChild(p)
			sp:removeFromParent()	
		end
	end
end

--初始化界面
function UserDetailLayer:InitUserDetail(playerInfo)
	-- print("UserDetailLayer:InitUserDetail")
	-- ccdump(playerInfo,"+++++++++++++++playerInfo++++++++++++++++++")
	local attr, power,alllevel = UserAttr:CalFinalAttr(playerInfo.role, playerInfo.level, playerInfo.equip,playerInfo.hero,playerInfo.wing.lv)
	--等级 
	UserDetailOwner["mEquipActorName"]:setColor(COLOR_CYAN)
	if playerInfo.union == nil then
		UserDetailOwner["mEquipActorName"]:setVisible(false)
	else
		tolua.cast(UserDetailOwner["mEquipActorName"], "cc.Label"):setString(MultiLan("lan_union").."：" .. playerInfo.union)
	end
	
	tolua.cast(UserDetailOwner["mDetailName"], "cc.Label"):setString("Lv." .. playerInfo.level .. " " .. playerInfo.name)
	--tolua.cast(UserDetailOwner["mEquipBattleValue"], "cc.Label"):setColor(COLOR_ORANGE)
	tolua.cast(UserDetailOwner["mEquipBattleValue"], "cc.Label"):setString(power)
	if playerInfo.title == 0 then
		-- UserDetailOwner["mEquipUserTitle"]:setVisible(false)
		UserDetailOwner["mEquipHonor"]:setVisible(false)
	else
		-- UserDetailOwner["mEquipUserTitle"]:setVisible(true)
		-- tolua.cast(UserDetailOwner["mEquipUserTitle"], "cc.Sprite"):setSpriteFrame("honor_"..playerInfo.title..".png")
		UserDetailOwner["mEquipHonor"]:setString(ZGMultiLan("honor_" .. playerInfo.title))
	end
	
	local attrTable = {"str","agi","int","sta","damage","armor","mr","hit","crit","dodge","tough"}
	for i=1, 11 do
		tolua.cast(UserDetailOwner["mEquipProperty"..i], "cc.Label"):setString(MultiLan( "attr_role_"..attrTable[i])..":")
		-- tolua.cast(UserDetailOwner["mEquipProperty"..i], "cc.Label"):setColor(COLOR_ORANGE)
	end

	tolua.cast(UserDetailOwner["mEquipValue1"], "cc.Label"):setString(attr.str)
	tolua.cast(UserDetailOwner["mEquipValue2"], "cc.Label"):setString(attr.agi)
	tolua.cast(UserDetailOwner["mEquipValue3"], "cc.Label"):setString(attr.int)
	tolua.cast(UserDetailOwner["mEquipValue4"], "cc.Label"):setString(attr.sta)
	tolua.cast(UserDetailOwner["mEquipValue5"], "cc.Label"):setString(math.ceil(attr.damage/2).." - "..attr.damage)
	tolua.cast(UserDetailOwner["mEquipValue6"], "cc.Label"):setString(attr.armor)
	tolua.cast(UserDetailOwner["mEquipValue7"], "cc.Label"):setString(attr.mr)
	tolua.cast(UserDetailOwner["mEquipValue8"], "cc.Label"):setString(attr.hit)
	tolua.cast(UserDetailOwner["mEquipValue9"], "cc.Label"):setString(attr.crit)
	tolua.cast(UserDetailOwner["mEquipValue10"], "cc.Label"):setString(attr.dodge)
	tolua.cast(UserDetailOwner["mEquipValue11"], "cc.Label"):setString(attr.tough)
	UserDetailOwner["mEquipValue5"]:setColor(COLOR_GREEN)
	-- print("InitUserDetail", playerInfo.role)
	UserDetailOwner["mEquipLayerHp"]:setString(attr.hp)
	UserDetailOwner["mEquipLayerMp"]:setString(attr.mp)
	-- UserDetailOwner["mEquipLayerBody"]:setSpriteFrame("body_icon_"..playerInfo.role..".png")
	UserDetailOwner["mEquipBattleValueTitle"]:setString(ZGMultiLan("equip_battle_value_title"))
	-- UserDetailOwner["lbBasePropertiesTitle"]:setString(ZGMultiLan("lbBasePropertiesTitle"))

	-- 设置背景，播放粒子动画
	self:setupBodyBg(playerInfo.role , playerInfo.sex)
	-- play spine
	self:playSpineAnimation(playerInfo.role , playerInfo.sex, playerInfo.level)
	
	--装备
	local equipItems = {}
	for i = 1, EQUIP_MAX do
		self.equipItems[i]:setItemType(BAG_ITEM_TYPE_EMPTY_EQUIP)
		self.equipItems[i]:setItemInfoTable({place=i})
	end
	
	if playerInfo.equip ~= nil and table.maxn(playerInfo.equip) > 0 then
		for i = 1, table.maxn(playerInfo.equip) do
			local propId = playerInfo.equip[i].prop_id
			local propInfoTable = GameData:getPropDataTable(propId)
			-- cclog("place is %d", propInfoTable.place)
			playerInfo.equip[i].alllevel = alllevel
			self.equipItems[propInfoTable.place]:setItemType(BAG_ITEM_TYPE_EQUIP_DETAIL)
			self.equipItems[propInfoTable.place]:setItemInfoTable(playerInfo.equip[i])
			self.equipItems[propInfoTable.place]:setCanTouch(true)
		end
	end
end

function userDetailCallback(jsonDataTable)
	if jsonDataTable.ret == 0 then
		UserDetailLayer:Enter(jsonDataTable.data)
	end
end

function onPlayerDetailClick(node)
	--local uid = tolua.cast(node, "cc.Node"):getTag()
	local uid = tolua.cast(node, "cc.Node"):getName()
	HttpSend("user/equip", {"fuid="..uid}, userDetailCallback)
end

function CreateDetailButton(role, sex , uid, callback)
	local function onPlayerHeadClick(node)
		-- local uid = tolua.cast(node, "cc.Node"):getTag()
		local uid = tolua.cast(node, "cc.Node"):getName()
		local function userDetailCallback(jsonDataTable)
			-- ccdump(jsonDataTable,"------jsonDataTable")
			if jsonDataTable.ret == 0 then
				local ret = UserDetailLayer:Enter(jsonDataTable.data)
				if callback ~= nil then
					callback(ret)
				end
			end
		end
		
		HttpSend("user/equip", {"fuid="..uid}, userDetailCallback)
	end
	local head = SetMyHead(role,sex,2)
	local headButton = CreateCommonButton(head, nil, cc.size(95,95), onPlayerHeadClick)
	headButton:setTag(uid)
	headButton:setName(uid)
	return headButton
end

function onUserDetailClose()
	cclog("onUserDetailClose")
	UserDetailLayer:Exit()
end

UserDetail["onUserDetailClose"] = onUserDetailClose
