UserInfo = class("UserInfo")
UserInfo.__index = UserInfo

UserInfo.UserInfoTable = {}

function UserInfo:getUserInfo()
	return self.UserInfoTable
end

function UserInfo:setUserInfo(infoTable)
	UserInfo.UserInfoTable = infoTable
	-- ccdump(infoTable.data.hero, "infoTable.data.hero")
	-- ccdump(infoTable.data.testHeros, "infoTable.data.testHeros")
	-- ccdump(infoTable.data.testHeros3, "infoTable.data.testHeros3")
	if self.UserInfoTable.data.equip.hero_1 == nil then
		self.UserInfoTable.data.equip.hero_1 = {}
	end
    local bagEquip = self.UserInfoTable.data.bag_equip
	for i=1,table.maxn(bagEquip) do
		UserAttr:setEquipGradeAndScore(bagEquip[i])
	end
	
	for k,v in pairs(self.UserInfoTable.data.equip) do
		for i=1,table.maxn(v) do
			UserAttr:setEquipGradeAndScore(v[i])
		end
	end
end

function UserInfo:setGold(goldNum)
	self.UserInfoTable.data.info.gold = goldNum
end

function UserInfo:getGold()
	return self.UserInfoTable.data.info.gold
end

function UserInfo:setLevel(levelNum)
	self.UserInfoTable.data.info.level = levelNum
end

function UserInfo:getLevel()
	return self.UserInfoTable.data.info.level
end

function UserInfo:setExp(expNum)
	self.UserInfoTable.data.info.exp = expNum
end

function UserInfo:getExp()
	return self.UserInfoTable.data.info.exp
end

function UserInfo:setCash(cashNum)
	self.UserInfoTable.data.info.cash = cashNum
end

function UserInfo:getCash()
	return self.UserInfoTable.data.info.cash
end

function UserInfo:getPveInfo()
	return self.UserInfoTable.data.pve
end
function UserInfo:addMeltFusion(fusionValue)
	self.UserInfoTable.data.info.fusion = UserInfo:getUserInfo().data.info.fusion + fusionValue
end

function UserInfo:getBagEquip()
	 return self.UserInfoTable.data.bag_equip
end

function GetSomethingStr(propid, num)
	return MultiLan("lan_get").." "..num.." "..MultiLan("prop_name_"..propid)
end

--根据服务器返回的数据添加道具
function UserInfo:addProp(items, bNeedGoldNote)
	-- print("UserInfo:addProp")
    if items == CJSON_NULL then
        return
    end
	
	local bAddNewEquip = false
	local userItems = self.UserInfoTable.data.bag_prop
	for i=1,table.maxn(items) do
		-- print(i,items[i].prop_id)
		if items[i].prop_id == PROP_ID_CASH then     --元宝
			self.UserInfoTable.data.info.cash = self.UserInfoTable.data.info.cash + items[i].num
            XiaLayer:SetHomeUserInfo()
		elseif items[i].prop_id == PROP_ID_GOLD  then --银两
			self.UserInfoTable.data.info.gold = self.UserInfoTable.data.info.gold + items[i].num
            XiaLayer:SetHomeUserInfo()
			if bNeedGoldNote then
				CommonNote(GetSomethingStr(PROP_ID_GOLD, items[i].num))
			end
		elseif items[i].prop_id == PROP_ID_HONOR  then --荣誉
			self.UserInfoTable.data.info.honor = self.UserInfoTable.data.info.honor + items[i].num
        elseif items[i].prop_id == PROP_ID_FUSION  then --熔炼值
			self.UserInfoTable.data.info.fusion = self.UserInfoTable.data.info.fusion + items[i].num
        elseif items[i].prop_id == PROP_ID_PRESTIGE  then --声望
			self.UserInfoTable.data.info.prestige = self.UserInfoTable.data.info.prestige + items[i].num
        elseif items[i].prop_id == PROP_ID_COUPON  then --银票
			self.UserInfoTable.data.info.coupon = self.UserInfoTable.data.info.coupon + items[i].num
        else
			if items[i].obj.attr == nil or items[i].obj.attr == CJSON_NULL then  --普通道具
				local bFind = false
				for j=1,table.maxn(userItems) do
					if userItems[j].prop_id == items[i].prop_id then
						items[i].obj.bagBtn = userItems[j].bagBtn
						userItems[j] = items[i].obj
						BagLayer:UpdateItem(userItems[j])
						bFind = true
						break
					end
				end
				-- print("bFind",bFind)
				--没找到则添加
				if bFind == false then
					table.insert(userItems, items[i].obj)
					BagLayer:AddNewItem(items[i].obj)
				end
			else
				table.insert(self.UserInfoTable.data.bag_equip, items[i].obj)
				UserAttr:setEquipGradeAndScore(items[i].obj)
				UserAttr:compareEquipScore(items[i].obj)
				UserAttr:compareAllyEquipScore(items[i].obj)
				BagLayer:AddNewItem(items[i].obj)
				bAddNewEquip = true
			end
		end
	end
	
	GameGuide:SetBagFullEffect()
	
	return bAddNewEquip
end

--根据服务器返回的数据飘字
function UserInfo:addPropNote(items)
	-- print("UserInfo:addProp", table.maxn(items))
    if items == CJSON_NULL then
        return
    end
	local userItems = self.UserInfoTable.data.bag_prop
	local noteArr = {}
	local colorArr = {}
	for i=1,table.maxn(items) do
		if items[i].prop_id == PROP_ID_CASH then     --元宝
			table.insert(noteArr, GetSomethingStr(items[i].prop_id, items[i].num))
			table.insert(colorArr, COLOR_GREEN)
		elseif items[i].prop_id == PROP_ID_GOLD  then --银两
			table.insert(noteArr, GetSomethingStr(items[i].prop_id, items[i].num))
			table.insert(colorArr, COLOR_GREEN)
		elseif items[i].prop_id == PROP_ID_HONOR  then --荣誉
			table.insert(noteArr, GetSomethingStr(items[i].prop_id, items[i].num))
			table.insert(colorArr, COLOR_GREEN)
        elseif items[i].prop_id == PROP_ID_FUSION  then --熔炼值
			table.insert(noteArr, GetSomethingStr(items[i].prop_id, items[i].num))
			table.insert(colorArr, COLOR_GREEN)
        elseif items[i].prop_id == PROP_ID_PRESTIGE  then --声望
			table.insert(noteArr, GetSomethingStr(items[i].prop_id, items[i].num))
			table.insert(colorArr, COLOR_GREEN)
        elseif items[i].prop_id == PROP_ID_COUPON  then --银票
			table.insert(noteArr, GetSomethingStr(items[i].prop_id, items[i].num))
			table.insert(colorArr, COLOR_GREEN)
        else
			local propInfo = GameData:getPropDataTable(items[i].prop_id)
			if items[i].obj.attr == nil or items[i].obj.attr == CJSON_NULL then  --普通道具
				table.insert(noteArr, MultiLan("lan_get").." "..MultiLan(propInfo.name).."*"..items[i].num)
				table.insert(colorArr, COLOR_GREEN)
			else
				local color,grade = EquipHelper:getEquipColor(items[i].obj)
				table.insert(noteArr, MultiLan("lan_get").." Lv"..propInfo.level..MultiLan(propInfo.name))
				table.insert(colorArr, color)
			end
		end
	end
	
	CommonNote(noteArr, colorArr)
end

--获取护法动态数据
function UserInfo:getHero(heroId)
	local DynamicData = self.UserInfoTable.data.hero
	for j=1, table.maxn(DynamicData) do
		if DynamicData[j].id == heroId then
			return DynamicData[j]
		end
	end
end

--根据服务器返回的数据添加装备 bNew表示获得新装备
function UserInfo:addEquipByObj(equipdata, obj, bNew)
	if equipdata == nil then
		return
	end
	
	if bNew then
		UserAttr:setEquipGradeAndScore(equipdata)
		UserAttr:compareEquipScore(equipdata)
		UserAttr:compareAllyEquipScore(equipdata)
    end
	-- print("UserInfo:addEquip", obj)
	equipdata.obj = obj
	if obj == 0 then
		BagLayer:AddNewItem(equipdata)
		table.insert(self.UserInfoTable.data.bag_equip, equipdata)
	elseif obj == 1 then
		table.insert(self.UserInfoTable.data.equip.hero_1, equipdata)
	else
		local heroData = GameData:getGameDataTable().hero
		local obj = equipdata.obj
		for i=1, table.maxn(heroData) do
			if heroData[i].htype == 2 and heroData[i].id == obj and self.UserInfoTable.data.equip["hero_"..obj] ~= nil then
				table.insert(self.UserInfoTable.data.equip["hero_"..obj], equipdata)
			end
		end
	end
	
	GameGuide:SetBagFullEffect()
	

end

--获取装备数据
function UserInfo:getEquipByIdAndObj(id, obj)
	if obj == 0 then
		return searchArrayById(self.UserInfoTable.data.bag_equip, id)
	elseif obj == 1 then
		return searchArrayById(self.UserInfoTable.data.equip.hero_1, id)
	else
		local heroData = GameData:getGameDataTable().hero
		for i=1, table.maxn(heroData) do
			if heroData[i].htype == 2 and self.UserInfoTable.data.equip["hero_"..obj] ~= nil then
				return searchArrayById(self.UserInfoTable.data.equip["hero_"..obj], id)
			end
		end
	end
end

--替换装备数据
function UserInfo:setEquipByIdAndObj(equipInfo)
	local searchTable = nil
	if equipInfo.obj == 0 then
		BagLayer:setDirty(true)
		searchTable = self.UserInfoTable.data.bag_equip
	elseif equipInfo.obj == 1 then
		searchTable = self.UserInfoTable.data.equip.hero_1
	else
		local heroData = GameData:getGameDataTable().hero
		for i=1, table.maxn(heroData) do
			if heroData[i].htype == 2 and heroData[i].id == equipInfo.obj and self.UserInfoTable.data.equip["hero_"..equipInfo.obj] ~= nil then
				searchTable = self.UserInfoTable.data.equip["hero_"..equipInfo.obj]
			end
		end
	end

	if searchTable ~= nil then
		for i=1, table.maxn(searchTable) do
			if searchTable[i].id == equipInfo.id then
				equipInfo.bagBtn = searchTable[i].bagBtn
				searchTable[i] = equipInfo
				BagLayer:UpdateItem(searchTable[i])
				UserAttr:setEquipGradeAndScore(searchTable[i])
				return searchTable[i]
			end
		end
	end
	
	return nil
end

--删除装备
function UserInfo:removeEquipByIdAndObj(id,obj)
	if obj == 0 then
		local ret = removeArrayById(self.UserInfoTable.data.bag_equip, id)
		BagLayer:RemoveItem(ret)
		GameGuide:SetBagFullEffect()
		return ret
	elseif obj == 1 then
		return removeArrayById(self.UserInfoTable.data.equip.hero_1, id)
	else
		local heroData = GameData:getGameDataTable().hero
		for i=1, table.maxn(heroData) do
			if heroData[i].htype == 2 and self.UserInfoTable.data.equip["hero_"..obj] ~= nil then
				return removeArrayById(self.UserInfoTable.data.equip["hero_"..obj], id)
			end
		end
	end
	return nil
end

--根据道具id获取道具数据
function UserInfo:getPropByPropid(id)
	return FindFirstByKey(self.UserInfoTable.data.bag_prop, "prop_id",id)
end

function sortForBag(a,b)
	if EquipHelper:isRedEquip(a) and not EquipHelper:isRedEquip(b) then
		return true
	elseif not EquipHelper:isRedEquip(a) and EquipHelper:isRedEquip(b) then
		return false
	else
		if a.grade > b.grade then
			return true
		elseif a.grade < b.grade then
			return false
		else
			local equipA = EquipHelper:getStaticData(a)
			local equipB = EquipHelper:getStaticData(b)
			if equipA.level > equipB.level then
				return true
			elseif equipA.level < equipB.level then
				return false
			else
				if equipA.place < equipB.place then
					return true
				elseif equipA.place > equipB.place then
					return false
				else
					if equipA.id > equipB.id then
						return true
					elseif equipA.id < equipB.id then
						return false
					else
						return a.id < b.id
					end
				end
			end
		end
	end
end

function sortByGradeAndScore(a,b)
	if EquipHelper:isRedEquip(a) and not EquipHelper:isRedEquip(b) then
		return true
	elseif not EquipHelper:isRedEquip(a) and EquipHelper:isRedEquip(b) then
		return false
	else
		if a.grade > b.grade then
			return true
		elseif a.grade < b.grade then
			return false
		else
			if a.score > b.score then
				return true
			elseif a.score < b.score then
				return false
			else
				return a.prop_id > b.prop_id
			end
		end
	end
end


function sortForBagFan(a,b)
	if EquipHelper:isRedEquip(a) and not EquipHelper:isRedEquip(b) then
		return false
	elseif not EquipHelper:isRedEquip(a) and EquipHelper:isRedEquip(b) then
		return true
	else
		if a.grade > b.grade then
			return false
		elseif a.grade < b.grade then
			return true
		else
			if a.score > b.score then
				return false
			elseif a.score < b.score then
				return true
			else
				return a.prop_id < b.prop_id
			end
		end
	end
end

--背包排序
function UserInfo:SortEquipBag()
	table.sort(self.UserInfoTable.data.bag_equip, sortByGradeAndScore)
	return self.UserInfoTable.data.bag_equip
end  

function sortByScore(a,b)
	if a.score >  b.score then
		return true
	elseif a.score < b.score  then
		return false
	else
		if a.grade > b.grade then
			return true
		elseif a.grade < b.grade then
			return false
		else
			return a.prop_id > b.prop_id
		end
	end
end

--用于装备筛选 穿装备换装备
function UserInfo:sortBagEquipByScore(place, role)
	local sortTable = {}
	local bagEquip = self.UserInfoTable.data.bag_equip
	if place ~= nil and role ~= nil then
		for i=1,table.maxn(bagEquip) do
			local equipData = EquipHelper:getStaticData(bagEquip[i])
			if equipData.place == place and (equipData.role == 0 or equipData.role == role) then
				table.insert(sortTable, bagEquip[i])
			end
		end		
	else
		sortTable = bagEquip
	end
	

	table.sort(sortTable, sortByScore)
    return sortTable
end

function UserInfo:sortPropById()
    local function sortById(a,b)
		if a.prop_id >  b.prop_id then
			return true
		elseif a.prop_id < b.prop_id  then
			return false
		else
			return a.id > b.id
		end
	end
	table.sort(self.UserInfoTable.data.bag_prop, sortById)
    return self.UserInfoTable.data.bag_prop
end

--根据prop_id减少道具数量
function UserInfo:removepropByPropId(propId,num)
    local propItem = {}
	for i=1,table.maxn(self.UserInfoTable.data.bag_prop) do
		propItem = self.UserInfoTable.data.bag_prop[i]
		if propItem.prop_id == propId then
			propItem.amount = propItem.amount - num
			if propItem.amount <= 0 then
				BagLayer:RemoveItem(propItem)
				table.remove(self.UserInfoTable.data.bag_prop, i)
			else
				BagLayer:UpdateItem(propItem)
			end
			break
		end
	end
end

function UserInfo:getBookList(level)
    local propItem = {}
	local bagInfo = self.UserInfoTable.data.bag_prop
	for i=1,table.maxn(bagInfo) do
		local staticInfo = EquipHelper:getStaticData(bagInfo[i])
		if staticInfo.ptype == 16 and staticInfo.level == level then
			table.insert(propItem, bagInfo[i])
		end
	end
	
	return propItem
end
