AllyBattleCell = class("AllyBattleCell")

function AllyBattleCell.getCellSize(  )
	return cc.size(582, 136)
end

--new
function AllyBattleCell:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function AllyBattleCell:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["AllyBattleCell"] = self
	ccb["AllyBattleCellOwner"] = self
	self.topNode = CCBReaderLoad("ccb/cells/AllyBattleCell.ccbi", proxy, self, AllyBattleCell:getCellSize())
	self.data = data

	-- set button onlick
	-- self.mButtonClose.owner = self

	self:initUI()
	return self
end

function AllyBattleCell:initUI()
	local enemyInfo = self.data.enemyInfo
	local roleData = GameData:getRoleDataById(enemyInfo.id)
	
	if not self.data.isAlly then	-- 人物
		self.lyStateAlly:setVisible(false)
		-- 头像
		self.spHead:setSpriteFrame("actor_icon_" .. roleData.role .. ".png")
		-- 名字
		self.lbUserName:setString(enemyInfo.name)
		-- 鼓舞
		if self.data.inspire > 0 then
			-- 需要鼓舞
			self.lyStateInspire:setVisible(true)
			self.lbInspireTitle:setString(MultiLan("GFL_unionBoss_4") .. ":")
			self.lbInspireValue:setString(self.data.inspire .. "%")
		else
			self.lyStateInspire:setVisible(false)
		end
	else	-- 宝宝
		self.spBg:setSpriteFrame("board_overmap.png")
		self.lyStateInspire:setVisible(false)
		self.lyStateAlly:setVisible(true)
		-- set head
		self.spHead:setSpriteFrame("hero_icon_" .. roleData.role .. ".png")
		-- 名字
		self.lbUserName:setString(MultiLan(enemyInfo.name))
	end

	-- 设置角色角标
	self.spSchool:setSpriteFrame("school_icon_" .. roleData.role .. ".png")
	-- 等级
	self.lbLevel:setString(enemyInfo.level)
	-- 战力
	self.lbPowerValue:setString(MultiLan("GFL_unionMember_8") .. ":" .. enemyInfo.power)
	-- 技能
	if enemyInfo.skill ~= nil and enemyInfo.skill ~= CJSON_NULL then
		for j = 1, 4 do
			if enemyInfo.skill[j] ~= nil then
				self["spSkill_" .. j]:setSpriteFrame("skill_" .. enemyInfo.skill[j].id .. ".png")
				-- skillBack:addChild(CreateCommonSprite("skill_"..enemyInfo.skill[j].id..".png", cc.p(-20+70*j, 30), 0.5))
			else
				self["spSkill_" .. j]:removeFromParent()
			end
		end
	end
end