CompensateCell = class("CompensateCell")

function CompensateCell.getCellSize(  )
	return cc.size(499, 120)
end

--new
function CompensateCell:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function CompensateCell:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["CompensateCell"] = self
	ccb["CompensateCellOwner"] = self
	self.topNode = CCBReaderLoad("ccb/cells/CompensateCell.ccbi", proxy, self, CompensateCell.getCellSize())
	self.data = data
	self.btGetCompen.owner = self
	self:initUI()
	

	return self
end
function CompensateCell:initUI(  )
	self.btGetCompen:setTitleForState(MultiLan("compensate_button"), cc.CONTROL_STATE_NORMAL)

	if self.data.mytype == 1 then
		self.lbDescTime:setString(MultiLan("compensate_desc_3")..self.data.compensatecellInfo.createTime)
		self.lbDescCompen:setString(MultiLan("compensate_desc_4")..MultiLan("compensate_desc_5")..self.data.compensatecellInfo.cash.."  "..MultiLan("compensate_desc_6")..self.data.compensatecellInfo.gold)
	else
		local pays = self.data.compensatecellInfo[self.data.tag]
		local showtime = os.date("%Y-%m-%d %H:%M:%S", pays.pay_time)
		-- local showtime = ""..temp.year.."/"..temp.month.."/"..temp.day.." "..temp.hour..":"..temp.min..":"..temp.sec
		self.lbDescTime:setString(MultiLan("compensate_desc_1")..showtime)
		self.lbDescCompen:setString(MultiLan("compensate_desc_2").."$"..pays.price.." x2")	
	end
end
function CompensateCell:onClickGetCompen( sender )
	-- cclog("onClickGetCompen")
	local function getCompensateUserCallback( jsonDataTable )
		if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
			self.owner.data.UserCompensateInfo.user = nil
			UserInfo:addProp(jsonDataTable.data.items)
			UserInfo:addPropNote(jsonDataTable.data.items)
			GameCompensateLayer:GameCompensateLayerRefresh(self.owner.data.UserCompensateInfo)
		end
	end
	local function getCompensatePayCallback( jsonDataTable )
		if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
			table.remove(self.owner.data.compensatecellInfo,self.owner.data.tag) 
			sendRefreshCash()
			GameCompensateLayer:GameCompensateLayerRefresh(self.owner.data.UserCompensateInfo)
		end
	end
	if self.owner.data.mytype == 1 then
		HttpSend("indemnity/getuser", {}, getCompensateUserCallback)
	else
		local info = self.owner.data.compensatecellInfo[self.owner.data.tag]
		HttpSend("indemnity/getpay", {"openId="..info.open_id, "payTime="..info.pay_time, "itemId="..info.item_id}, getCompensatePayCallback)
	end
end


