Rankcell = class("Rankcell")

function Rankcell.getCellSize(  )
	return cc.size(570, 140)
end

--new
function Rankcell:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function Rankcell:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["Rankcell"] = self
	ccb["RankcellOwner"] = self
	self.topNode = CCBReaderLoad("ccb/cells/Rankcell.ccbi", proxy, self, Rankcell.getCellSize())
	self.data = data
	self:initUI()
	self.clickButton.owner = self
	return self
end
function Rankcell:initUI()
	local speNums = {"pic_pvpfirst.png", "pic_pvpsecond.png", "pic_pvpthird.png"}
	if self.data.rank <= 3 then
        tolua.cast(self.imPVPnum, "cc.Sprite"):setSpriteFrame(speNums[self.data.rank])
        -- self.lbPVPnum:setVisible(false)
        tolua.cast(self.mBgSprite, "cc.Sprite"):setSpriteFrame("board_challengemap.png")
	end
	self.lbFamily:setVisible(false)
	self.lbName:setString(self.data.name)
	if self.data.family ~= nil and self.data.family ~= "" then
	    self.lbFamily:setVisible(true)
		self.lbFamily:setString("["..self.data.family.."]")
		self.lbFamily:setPositionX(7+self.lbName:getContentSize().width)
	end
	self.sign:setVisible(true)
	self.guild:setVisible(false)
	if self.data.isGuildRank then
		self.sign:setVisible(false)
		self.guild:setVisible(true)
		self.guildLeaderName:setString(self.data.sign)
		self.lbFamily:setVisible(false)
		self.Leader:setString(MultiLan("union_battle_12"))
		self.lbPower:setString(MultiLan("union_battle_13"))
	else
		self.lbPower:setString(MultiLan("GALa_rank_2"))
	end
	local head = SetMyHead(self.data.head,self.data.sex,2)
	tolua.cast(self.imHead, "cc.Sprite"):setSpriteFrame(head)
	self.clickButton:setSwallowTouch(false)
	tolua.cast(self.imSchoolIcon, "cc.Sprite"):setSpriteFrame("school_icon_"..self.data.head..".png")
	self.lbRank:setString(MultiLan("GALa_rank_1"))
	self.lbRankNum:setString(self.data.ranks)
	
	self.lbPowerNum:setString(self.data.power)
	self.lbQianM:setString(self.data.sign)
	self.lbLevle:setString("Lv."..self.data.leavel)
	self.lbPVPnum:setString(self.data.ranks)	

	-- setup button name
	self.clickButton:setName(self.data.uid)
end

function Rankcell:onClickBtn( sender )
	onPlayerDetailClick(self.owner.clickButton)
end