SkillExchangeCell = class("SkillExchangeCell")

function SkillExchangeCell.getCellSize(  )
	return cc.size(570, 140)
end

--new
function SkillExchangeCell:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function SkillExchangeCell:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["SkillExchangeCell"] = self
	ccb["SkillExchangeCellOwner"] = self
	self.topNode = CCBReaderLoad("ccb/cells/skillExChangeCell.ccbi", proxy, self, SkillExchangeCell.getCellSize())
	self.data = data
	self.btExchange.owner = self
	self:initUI()
	return self
end
function SkillExchangeCell:initUI()
	tolua.cast(self.inSkillHead, "cc.Sprite"):setSpriteFrame("prop_"..self.data.skillData.id..".png")
	self.lbName:setString(MultiLan(self.data.skillData.name))
	self.btExchange:setTitleForState(MultiLan("skill_desc40"),1)
	local num = FindFirstByKey(GameData:getGameDataTable().skill_master,"prop_id",self.data.skillData.id).compose_num
	self.lbNum:setString(string.format(MultiLan("skill_desc41"),tostring(num)))
	self.lbDesc:setString(string.format(MultiLan("skill_desc42"), MultiLan(self.data.skillData.name)))	
end
function SkillExchangeCell:onClickExchange( sender )
	local count = UserInfo:getPropByPropid(110005).amount
	local num = FindFirstByKey(GameData:getGameDataTable().skill_master,"prop_id",self.owner.data.skillData.id).compose_num
	if count < num then
		CommonNote(MultiLan("skill_desc43"))
		return 
	end
	local function bookMakeCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			--增加
			UserInfo:addProp(jsonDataTable.data.item)
			UserInfo:addPropNote(jsonDataTable.data.item)
			--消耗
			for i=1,table.maxn(jsonDataTable.data.use_prop) do
				UserInfo:removepropByPropId(jsonDataTable.data.use_prop[i].prop_id, jsonDataTable.data.use_prop[i].num)
			end
			
			self.owner.data.setBookDesc()
		end
	end
	HttpSend("skill/exchange", {"id="..self.owner.data.skillData.id}, bookMakeCallback)
end