UserTitleChooseCell = class("UserTitleChooseCell")

function UserTitleChooseCell.getCellSize(  )
	return cc.size(490, 110)
end

-- new 
function UserTitleChooseCell:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function UserTitleChooseCell:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["UserTitleChooseCell"] = self
	ccb["UserTitleChooseCellOwner"] = self
	self.topNode = CCBReaderLoad("ccb/cells/UserTitleChooseCell.ccbi", proxy, self, UserTitleChooseCell.getCellSize())
	self.data = data
	self:initUI()
	return self
end

function UserTitleChooseCell:initUI(  )
	self.lbLocked:setString(MultiLan("usetitle_desc"))
	self.lbUserTitle:setString(ZGMultiLan("honor_" .. self.data.titleId))
	self.lbHowToGet:setString(MultiLan("description_con_" .. self.data.titleId))
	self.btnStageChange.owner = self;
end

function UserTitleChooseCell:setAllInvisible(  )
	self.btnStageChange:setEnabled(false)
	self.btnStageChange:setVisible(false)
	self.spDisable:setVisible(false)
	self.lbLocked:setVisible(false)
	self.spChoosed:setVisible(false)
end


-- 未选中状态
function UserTitleChooseCell:setUnChoosed(  )
	self:setAllInvisible()
	self.btnStageChange:setVisible(true)
	self.btnStageChange:setEnabled(true)
end

-- 选中状态
function UserTitleChooseCell:setChoosed(  )
	self:setAllInvisible()
	self.spChoosed:setVisible(true)	
	self.btnStageChange:setVisible(true)
	self.btnStageChange:setEnabled(true)
end

-- 不可选择状态
function UserTitleChooseCell:setDisabled(  )
	self:setAllInvisible()
	self.spDisable:setVisible(true)
	self.btnStageChange:setVisible(true)
end

-- 未解锁状态
function UserTitleChooseCell:setLocked(  )
	self:setAllInvisible()
	self.lbLocked:setVisible(true)	
end


-- buttons on click
function UserTitleChooseCell:onTitleStateChange( sender, eventType )
	self.owner.data.cb_setTitleState(self.owner.data.titleId)
end