GuildWarLayer = class("GuildWarLayer")

--new
function GuildWarLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function GuildWarLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["GuildWarLayer"] = self
	ccb["GuildWarLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/Family/GuildWarLayer.ccbi", proxy, self)
	self.data = data
	self.mGoBackGuid.owner = self
	self.mGuidWarHelp.owner = self
	self.btStandings.owner = self
	self.btLastStandings.owner = self
	self.btRewardb.owner = self
	self.mBtnGroup.owner = self
	self.btChooseGroup1.owner = self
	self.btChooseGroup2.owner = self
	self.btChooseGroup3.owner = self
	self.btShangjieZhanbao.owner = self
	self.mCloseGuildWarGroupsManager.owner = self
	self.mGoBackToGuid.owner = self
	self.btGuWu.owner = self
	self.showGroupTag = 1
	self:initUI()
	return self
end

function GuildWarLayer:initUI(  )
	self.mGuildWarLayer:setVisible(true)
	self.LastbattlefieldLayer:setVisible(false)
	self.mGuildWarGroupManagerLayer:setVisible(false)
	--上届战报
	self.lbTitleGuildWar02:setString(ZGMultiLan("title_shangjiezhanbao"))
	self.btShangjieZhanbao:setTitleForState(MultiLan("guild_war_shanjie_zhanbao_button"),1)
	self.mNextWarTime11:setString(MultiLan("guild_war_shanjie_zhanbao_desc"))
	--阵型UI
	self.lbTitleGuildWarTeamManage:setString(ZGMultiLan("lbTitleTeamSettting"))
	self.btChooseGroup1:setTitleForState(MultiLan("guild_war_zhenxing_1"),1)
	self.btChooseGroup2:setTitleForState(MultiLan("guild_war_zhenxing_2"),1)
	self.btChooseGroup3:setTitleForState(MultiLan("guild_war_zhenxing_3"),1)
	self.btGuWu:setTitleForState(MultiLan("guild_war_zhenxing_4"),1)
	--主页UI
	self.lbTitleGuildWar:setString(ZGMultiLan("lbTitleGuildWar"))
	self.btStandings:setTitleForState(MultiLan("guild_war_zhuye_button1"),1)
	self.btLastStandings:setTitleForState(MultiLan("guild_war_zhuye_button2"),1)
	self.btRewardb:setTitleForState(MultiLan("guild_war_zhuye_button3"),1)
	self.mBtnGroup:setTitleForState(MultiLan("guild_war_zhuye_button4"),1)
	self.lbGuildHomeRank:setString(MultiLan("guild_war_zhuye_desc6"))
	self.lbGuildHomeName:setString(MultiLan("guild_war_zhuye_desc7"))
	self.lbGuildHomePower:setString(MultiLan("guild_war_zhuye_desc8"))
	self.mCostDes:setString(MultiLan("guild_war_zhuye_desc9")..self.data.jsonDataTable.data.my_union.total_power)
	if self.data.jsonDataTable.data.is_in_battle == 0 then
		self.mMyExtandDes:setVisible(false)
	else
		self.mMyExtandDes:setString(MultiLan("guild_war_zhuye_desc10")..self.data.jsonDataTable.data.enemy_union.total_power)
	end
	if self.data.jsonDataTable.data.info.current_battle == 0 then
		self.layer_paiming_title:setVisible(true)
		local unionList = self.data.jsonDataTable.data.unionList
		local count = #unionList
		local scrollLayer = self.scrollLayer 
	    local layer = cc.Layer:create()
	    local y = count * GuildWarCell.getCellSize().height
	    layer:setContentSize(cc.size(scrollLayer:getContentSize().width, y))
		local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, scrollLayer:getContentSize().height - y), kScrollViewDirectionVertical)
		y = y - GuildWarCell.getCellSize().height
		for i =1 ,count do
			local gulidwarcell = GuildWarCell:new()
			local lastPos = self.data.jsonDataTable.data.info.last_pos[tostring(unionList[i].id)]
			if lastPos == nil then
				lastPos = 0
			end
			gulidwarcell:create({
				rank = i,
				name = tostring(unionList[i].name),
				power = tostring(unionList[i].total_power),
				lastPos = lastPos,
			})
			local cellNode = gulidwarcell.topNode
			cellNode:setPositionY(y)
			layer:addChild(cellNode)
			y = y - GuildWarCell.getCellSize().height
		end
	else
		self.layer_paiming_title:setVisible(false)
		local scrollLayer = self.scrollLayer 
	    local layer = cc.Layer:create()
	    local y = 624
	    layer:setContentSize(cc.size(scrollLayer:getContentSize().width, y))
	    -- layer.setContentSize(BattleListLayer.getCellSize())
		local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, scrollLayer:getContentSize().height - y), kScrollViewDirectionVertical)
		local battlelistlayer = BattleListLayer:new()
		battlelistlayer:create({MatrixPre = self.data.jsonDataTable.data.info.matrix,})
		local cellNode = battlelistlayer.topNode
		cellNode:setPositionY(0)
		layer:addChild(cellNode)
	end

	local next_date = self.data.jsonDataTable.data.info.next_date
	-- cclog("next_date is "..next_date)
	local function getTime( time )
		t = os.date("%m-%d %H:%M:%S", time)
		return t
	end
	local function setserverTimeZone(str)
		local year = tonumber(string.sub(str, 1, 4))
		local month = tonumber(string.sub(str, 6, 7))
		local day = tonumber(string.sub(str, 9, 10))
		local hour = tonumber(string.sub(str, 12, 13))
		local min = tonumber(string.sub(str, 15, 16))
		local sec = tonumber(string.sub(str, 18, 19))
		local ret = os.time({year = year, month = month, day = day, hour = hour, min = min, sec = sec})
		return ret
	end
	local function TurnSecendsToDay(t)
		-- cclog("aaaaa"..t)
		if t <= 0 then
			t = 0
		end
		local day = math.floor(t/24/3600)
		local hour = math.floor((t - 24*3600*day)/3600)
		local minute = math.floor((t - 24*3600*day - 3600*hour)/60)
		local sec = t - 24*3600*day - 3600*hour - 60*minute
		-- cclog("sec is "..sec)
		local str = ""
		str = str..day.." "..MultiLan("lan_day").." "
		str = str..hour.." "..MultiLan("lan_hour").." "
		str = str..minute.." "..MultiLan("lan_minute").." "
		str = str..sec.." "..MultiLan("lan_second")
		-- cclog("str 111 is "..str)
		return str

	end
	local function UpdateTime(  )
		local time = setserverTimeZone(next_date)
		local shengtime = time - TimeDown.serverTimeZone
		local str = TurnSecendsToDay(shengtime)
		-- cclog("time is "..time)
		-- cclog("TimeDown.serverTimeZone "..shengtime)
		-- cclog("  "..str)
		if self.mNextWarShengTime ~= nil then
			self.mNextWarShengTime:setString(MultiLan("guild_war_zhuye_desc11")..str)
		end
	end
	UpdateTime()
	self.daojishi = scheduler:scheduleScriptFunc(UpdateTime, 1, false)
	self.mNextWarTime:setString(MultiLan("guild_war_zhuye_desc"..self.data.jsonDataTable.data.info.current_battle).. getTime(setserverTimeZone(next_date)))
	local num = 0
	if not table_is_empty(self.data.jsonDataTable.data.info.inspires) then
		if self.data.jsonDataTable.data.info.inspires[tostring(UserFamilyInfo.info.id)] ~= nil then
			num = self.data.jsonDataTable.data.info.inspires[tostring(UserFamilyInfo.info.id)]
		end
	end
	self.lbGuHit:setString(MultiLan("guilg_war_guwu_desc1")..tostring(num * 10 ).. "%")
	self.lbGuHp:setString(MultiLan("guilg_war_guwu_desc2")..tostring(num * 20 ).. "%")
	self.lbGuNum:setString(MultiLan("guilg_war_guwu_desc3")..tostring(num).." "..MultiLan("guilg_war_guwu_desc5")..(num * 10 + 50))
end
function GuildWarLayer:onClickCloseGuildWar(sender)
	scheduler:unscheduleScriptEntry(self.owner.daojishi)
	onCloseGuildWar()
end
function GuildWarLayer:onClickGuidWarHelp(sender)
	HelpPopup("guildwar")
end
--本届战报
function GuildWarLayer:onCilckStandings(sender)
	if self.owner.data.jsonDataTable.data.info.current_battle == 0 then
		CommonNote(MultiLan("guild_war_desc3"))
		return
	end
	local layer = self.owner:setStandingLayer(self.owner.data.jsonDataTable.data.info.matrix)
	
	local guildwartan = GuildWarTanLayer:new()
	guildwartan:create({
		title = MultiLan("guild_war_zhanbao_title"),
		desc = MultiLan("guild_war_zhanbao_desc"),
		layer = layer,
		size = layer:getContentSize(),
		})
	local layerNode = guildwartan.topNode
	if POPUP_LAYER == nil then
		POPUP_LAYER = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
		scene:addChild(POPUP_LAYER, POPUP_TAG, POPUP_TAG)
	end
	POPUP_LAYER:addChild(layerNode) 
	
end
function GuildWarLayer:setStandingLayer(info)
	local layer = cc.Layer:create()
	local count = 0
	local flag2 = false
	local flag4 = false
	local flag8 = false
	local flag16 = false
	local flag32 = false
	if info["201"] ~= nil then
		if info["201"].win_id ~= 0 then
			count = count + 2
			flag2 = true
		end
	end
	if info["401"] ~= nil then
		for i =1 ,2 do
			if info[tostring(400+i)].win_id ~= 0 then
				flag4 = true
				count = count + 1
			end
		end
		if flag4 then
			count = count + 1
		end
	end
	if info["801"] ~= nil then
		for i =1 ,4 do
			if info[tostring(800+i)].win_id ~= 0 then
				flag8 = true
				count = count + 1
			end
		end
		if flag8 then
			count = count + 1
		end
	end
	if info["1601"] ~= nil then
		for i =1 ,8 do
			if info[tostring(1600+i)].win_id ~= 0 then
				flag16 = true
				count = count + 1
			end
		end
		if flag16 then
			count = count + 1
		end
	end
	for i = 1,16 do
		if info[tostring(3200+i)].win_id ~= 0 then
			flag32 = true
			count = count + 1
		end
	end
	if flag32 then
		count = count + 1
	end


	local height = GuildWarListCell.getCellSize().height
	local y = height * count
	layer:setContentSize(cc.size(GuildWarListCell.getCellSize().width, y ))
	--决赛
	if flag2 then
		local guildWarListCell = GuildWarListCell:new()
		guildWarListCell:create({
			atype = 1,
			atag = 5,
			})
		local cellNode = guildWarListCell.topNode
		y = y - height
		cellNode:setPositionY(y)
		layer:addChild(cellNode)
		local guildWarListCell = GuildWarListCell:new()
		guildWarListCell:create({
			atype = 2,
			info = info["201"],
			})
		local cellNode = guildWarListCell.topNode
		y = y - height
		cellNode:setPositionY(y)
		layer:addChild(cellNode)
	end
	--半决赛
	if flag4 then
		local guildWarListCell = GuildWarListCell:new()
		guildWarListCell:create({
			atype = 1,
			atag = 4,
			})
		local cellNode = guildWarListCell.topNode
		y = y - height
		cellNode:setPositionY(y)
		layer:addChild(cellNode)
		for i = 1 ,2 do
			if info[tostring(400+i)].win_id ~= 0 then
				local guildWarListCell = GuildWarListCell:new()
				guildWarListCell:create({
					atype = 2,
					info = info[tostring(400 + i)],
					})
				local cellNode = guildWarListCell.topNode
				y = y - height
				cellNode:setPositionY(y)
				layer:addChild(cellNode)
			end
		end
	end
	--四强赛
	if flag8 then
		local guildWarListCell = GuildWarListCell:new()
		guildWarListCell:create({
			atype = 1,
			atag = 3,
			})
		local cellNode = guildWarListCell.topNode
		y = y - height
		cellNode:setPositionY(y)
		layer:addChild(cellNode)
		for i = 1 ,4 do
			if info[tostring(800+i)].win_id ~= 0 then
				local guildWarListCell = GuildWarListCell:new()
				guildWarListCell:create({
					atype = 2,
					info = info[tostring(800 + i)],
					})
				local cellNode = guildWarListCell.topNode
				y = y - height
				cellNode:setPositionY(y)
				layer:addChild(cellNode)
			end
		end
	end
	--八强赛
	if flag16 then
		local guildWarListCell = GuildWarListCell:new()
		guildWarListCell:create({
			atype = 1,
			atag = 2,
			})
		local cellNode = guildWarListCell.topNode
		y = y - height
		cellNode:setPositionY(y)
		layer:addChild(cellNode)
		for i = 1 ,8 do
			if info[tostring(1600+i)].win_id ~= 0 then
				local guildWarListCell = GuildWarListCell:new()
				guildWarListCell:create({
					atype = 2,
					info = info[tostring(1600 + i)],
					})
				local cellNode = guildWarListCell.topNode
				y = y - height
				cellNode:setPositionY(y)
				layer:addChild(cellNode)
			end
		end
	end
	--16强赛
	if flag32 then
		local guildWarListCell = GuildWarListCell:new()
		guildWarListCell:create({
			atype = 1,
			atag = 1,
			})
		local cellNode = guildWarListCell.topNode
		y = y - height
		cellNode:setPositionY(y)
		layer:addChild(cellNode)
		for i = 1 ,16 do
			if info[tostring(3200+i)].win_id ~= 0 then
				local guildWarListCell = GuildWarListCell:new()
				guildWarListCell:create({
					atype = 2,
					info = info[tostring(3200 + i)],
					})
				local cellNode = guildWarListCell.topNode
				y = y - height
				cellNode:setPositionY(y)
				layer:addChild(cellNode)
			end
		end
	end
	return layer
end
------------------------------------------------------------
-- 上届战报
function GuildWarLayer:onClickLastStandings(sender)
	local MatrixPre = self.owner.data.jsonDataTable.data.info.matrix_pre
	-- ccdump(self.owner.data.jsonDataTable.data.info,"MatrixPre")
	if MatrixPre == CJSON_NULL then
		CommonNote(MultiLan("guild_war_desc2"))
		return
	end
	self.owner.mGuildWarLayer:setVisible(false)
	self.owner.LastbattlefieldLayer:setVisible(true)
	for k,v in pairs(MatrixPre) do

	end
	local scrollLayer = self.owner.scrollLayerLast 
    local layer = cc.Layer:create()
    local y = 624
    layer:setContentSize(cc.size(scrollLayer:getContentSize().width, y))
	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, scrollLayer:getContentSize().height - y), kScrollViewDirectionVertical)

	local battlelistlayer = BattleListLayer:new()
	battlelistlayer:create({MatrixPre = MatrixPre,})
	local cellNode = battlelistlayer.topNode
	cellNode:setPositionY(0)
	layer:addChild(cellNode)
end
function GuildWarLayer:onClickLastZhanbao(sender)
	local layer = self.owner:setStandingLayer(self.owner.data.jsonDataTable.data.info.matrix_pre)
	
	local guildwartan = GuildWarTanLayer:new()
	guildwartan:create({
		title = MultiLan("guild_war_zhanbao_title"),
		desc = MultiLan("guild_war_zhanbao_desc"),
		layer = layer,
		size = layer:getContentSize(),
		})
	local layerNode = guildwartan.topNode
	if POPUP_LAYER == nil then
		POPUP_LAYER = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
		scene:addChild(POPUP_LAYER, POPUP_TAG, POPUP_TAG)
	end
	POPUP_LAYER:addChild(layerNode) 
end
function GuildWarLayer:onClickGoBackToGuid(sender)
	self.owner.scrollLayerLast:removeAllChildren(true)
	self.owner.mGuildWarLayer:setVisible(true)
	self.owner.LastbattlefieldLayer:setVisible(false)
end
----------------------------------------------------------
-- 奖励列表
function GuildWarLayer:onClickRewardb(sender)
	local function RewardbCallback( jsonDataTable )
		if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
			-- ccdump(jsonDataTable,"jsonDataTable")
			local layer = cc.Layer:create()
			layer:setContentSize(cc.size(RewardListLayer.getCellSize().width, RewardListLayer.getCellSize().height * 7))
			local y = RewardListLayer.getCellSize().height * 6
			for i = 1, 7 do
				local rewardlistlayer = RewardListLayer:new()
				rewardlistlayer:create({
					awards = jsonDataTable.data.awards[i],
					tag = i,
					})
				local cellNode = rewardlistlayer.topNode
				cellNode:setPositionY(y)
				y = y - RewardListLayer.getCellSize().height
				layer:addChild(cellNode)
			end
			


			local guildwartan = GuildWarTanLayer:new()
			guildwartan:create({
				title = MultiLan("familyrewarddesc3"),
				desc = MultiLan("familyrewarddesc4"),
				layer = layer,
				size = layer:getContentSize(),
				})
			local layerNode = guildwartan.topNode
			if POPUP_LAYER == nil then
				POPUP_LAYER = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
				scene:addChild(POPUP_LAYER, POPUP_TAG, POPUP_TAG)
			end
			POPUP_LAYER:addChild(layerNode)
		end
	end
	HttpSend("union/zgubaward", {}, RewardbCallback)
end
function GuildWarLayer:onGuildTeamGroup(sender)
	self.owner.mGuildWarLayer:setVisible(false)
	self.owner.mGuildWarGroupManagerLayer:setVisible(true)
	self.owner:ChooseGroup(1)
end
function GuildWarLayer:onCloseGuildWarGroupManagerLayer(sender)
	self.owner.mWarTeamLayer:removeAllChildren(true)
	self.owner.mGuildWarLayer:setVisible(true)
	self.owner.mGuildWarGroupManagerLayer:setVisible(false)
	
end
function GuildWarLayer:onCloseGuildWarReport(sender)
	
end


---------------------------------------------------------
--选择分组 阵型
function GuildWarLayer:onCilckChooseGroup(sender)
	tag = self:getTag()
	self.owner.showGroupTag = tag
	self.owner:ChooseGroup(tag)
end
function GuildWarLayer:ChooseGroup(tag)
	local buttontable = {self.btChooseGroup1,self.btChooseGroup2,self.btChooseGroup3}
	for i =1 ,3 do
		buttontable[i]:setEnabled(true)
	end
	buttontable[tag]:setEnabled(false)
	local teams = self:getGuildTeams()
	self:showGroupManagerLayer(tag, teams[tag])
end

function GuildWarLayer:getGuildTeams()
	-- body
	local teams = {}
	teams[#teams+1] = {}
	teams[#teams+1] = {}
	teams[#teams+1] = {}
	if UserFamilyInfo == nil then
		return nil
	end
	for i=1, table.maxn(UserFamilyInfo.member) do
		local memberdata = UserFamilyInfo.member[i]
		if memberdata.union_battle_team ~= 0 then
			local team = teams[memberdata.union_battle_team]
			table.insert(team,memberdata)
		end
	end
	return teams
end

function GuildWarLayer:showGroupManagerLayer(index, team)
	local function mygotoTeamOne( node )
		self:gotoTeamOne(node)
	end
	local function mygotoTeamTwo( node )
		self:gotoTeamTwo(node)
	end
	local function mygotoTeamThree( node )
		self:gotoTeamThree(node)
	end
	self.gotofuns = {}
	self.gotofuns[1] = {[1] =mygotoTeamTwo ,[2] = mygotoTeamThree, [3] = "union_battle_10", [4] = "union_battle_11"}
	self.gotofuns[2] = {[1] =mygotoTeamOne ,[2] = mygotoTeamThree, [3] = "union_battle_9", [4] = "union_battle_11"}
	self.gotofuns[3] = {[1] =mygotoTeamOne ,[2] = mygotoTeamTwo,   [3] = "union_battle_9", [4] = "union_battle_10"}
	local mydata = getMyMemberInfo()
	local count = #team--table.maxn(famillyListInfo)
	local height = 530 
	local datalayer = cc.Layer:create()
	local popupContent = self.mWarTeamLayer
	popupContent:removeAllChildren(true)
	local gofuncs = self.gotofuns[index]
	local totalpower = 0
	local y = count*140 + 10
	datalayer:setContentSize(cc.size(600, math.max(530, y)))
	local scrolView = CreateScrollViewByFather(popupContent, datalayer, cc.p(0, height - y ), kScrollViewDirectionVertical)
	y = y - 70
	for i=1, count do
		local playerInfo = team[i]
		local back = CreateCommonSprite("board_challengemap.png", cc.p(300, y))
		datalayer:addChild(back)
		if playerInfo ~= nil then
			local nameLayer = CreateCommonSprite("board_skill01.png", cc.p(291, 96))
			back:addChild(nameLayer)
			setNameAndFamily(nameLayer, playerInfo.name)
			local head = SetMyHead(playerInfo.role,playerInfo.sex,2)
			local powerButton = CreateCommonButton(head, cc.p(60, 64), cc.size(95, 95), onPlayerDetailClick)
			powerButton:setName(playerInfo.uid)
			powerButton:setTag(index)
			back:addChild(powerButton,0,playerInfo.uid)
			local listLayer = CreateCommonSprite("board_skill02.png", cc.p(291, 41))
			back:addChild(listLayer)
			back:addChild(CreateCommonSprite("school_icon_"..playerInfo.role..".png", cc.p(30, 110)))
			if playerInfo.union_battle_inspire == 1 then
				back:addChild(CreateCommonSprite("pic_guwuaa.png", cc.p(100, 110)))
			end
			back:addChild(CreateCommonLabel("Lv."..playerInfo.level, cc.p(70, 18), FontSize2))
			back:addChild(CreateCommonSprite("wordboard_power.png", cc.p(240, 41)))
			back:addChild(CreateCommonLabel(playerInfo.power, cc.p(184, 44),FontSize4,COLOR_YELLOW,cc.p(0,0.5)))
			totalpower = totalpower + playerInfo.power
			for j=1,2 do
				local fun = gofuncs[j]
				local buttname = gofuncs[j+2]
				local reportButton = CreateCommonButton("button_blue.png", cc.p(520, 90-(j-1)*50), cc.size(144, 50), fun, {str=MultiLan(buttname), size = FontSize6})
				reportButton.owner = self
				SetCommonButtonDisabledSprite(reportButton, "button_gray.png")
				reportButton:setTag(index)
				reportButton:setScale(0.6)
				reportButton:setName(playerInfo.uid)
				if mydata.position ~= 0 then
					reportButton:setEnabled(false)
				end
				back:addChild(reportButton)
			end
		end	
		y = y - 140
	end
	if 140*count < height then
	 	scrolView:setTouchEnabled(false)
	end
	self.mGuildTeamNameTitle:setString(MultiLan("GFL_unionInfo_3")..#team.."    "..MultiLan("GGL_declare_5")..totalpower)
end
function GuildWarLayer:gotoTeamOne(node)
	-- body
	--local function reportClick(node)
	local function changeWarTeama( jsonDataTable )
		self:changeWarTeam(jsonDataTable)
	end
	local uid = tolua.cast(node, "cc.Node"):getName()
	local tag = tolua.cast(node, "cc.Node"):getTag()

	HttpSend("union/battleteam", {"pid="..uid, "team=1"}, changeWarTeama)
end

function GuildWarLayer:gotoTeamTwo(node)
	-- body
	--local function reportClick(node)
	local function changeWarTeama( jsonDataTable )
		ccdump(jsonDataTable,"jsonDataTable")
		self:changeWarTeam(jsonDataTable)
	end
	local uid = tolua.cast(node, "cc.Node"):getName()
	local tag = tolua.cast(node, "cc.Node"):getTag()


	HttpSend("union/battleteam", {"pid="..uid, "team=2"}, changeWarTeama)

end

function GuildWarLayer:gotoTeamThree(node)
	-- body
	--local function reportClick(node)
	local function changeWarTeama( jsonDataTable )
		self:changeWarTeam(jsonDataTable)
	end
	local uid = tolua.cast(node, "cc.Node"):getName()
	local tag = tolua.cast(node, "cc.Node"):getTag()
	HttpSend("union/battleteam", {"pid="..uid, "team=3"}, changeWarTeama)
end

function GuildWarLayer:getGuildTeams( ... )
	-- body
	local teams = {}
	teams[#teams+1] = {}
	teams[#teams+1] = {}
	teams[#teams+1] = {}
	if UserFamilyInfo == nil then
		return nil
	end
	for i=1, table.maxn(UserFamilyInfo.member) do
		local memberdata = UserFamilyInfo.member[i]
		if memberdata.union_battle_team ~= 0 then
			local team = teams[memberdata.union_battle_team]
			table.insert(team,memberdata)
		end
	end
	return teams
end

function GuildWarLayer:changeWarTeam(jsonDataTable)
	-- body
	-- cclog("changeWarTeam")
	local function gotoMainCallBack( ... )
		-- body
		local node = cc.Node:create()
		node:setTag(1)
		ShowNew(node)
	end
	if jsonDataTable.ret == 0 then
		if jsonDataTable.data.status == 1 then
			commonCreatePopupSmallWithOneButtonCallback(nil, CreateCommonLabel(MultiLan("union_battle_22"), nil, FontSize3), MultiLan("button_ok"), gotoMainCallBack)
			return
		end
		WarTeamChange = true
		local data = jsonDataTable.data
		local team = self:teamChange(data)
		self:showGroupManagerLayer(jsonDataTable.data.from, team)
	end
end
function GuildWarLayer:teamChange(data)
	local index  = data.from
	-- print("-----------teamChange"..tostring(index))
	local team = {}
	for i=1, table.maxn(UserFamilyInfo.member) do
		local memberdata = UserFamilyInfo.member[i]
		if data.pid == memberdata.uid then
			memberdata.union_battle_team = data.team	
		end
		if memberdata.union_battle_team == index then
			table.insert(team,memberdata)
		end
	end
	return team
end
---------------------------鼓舞----------------------------
function GuildWarLayer:onClickGuwu()
	local function GuWuCallback( jsonDataTable )
		if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
			self.owner.data.jsonDataTable.data.info.inspires[tostring(UserFamilyInfo.info.id)] = jsonDataTable.data.inspire
			local num = jsonDataTable.data.inspire
			self.owner.lbGuHit:setString(MultiLan("guilg_war_guwu_desc1")..num * 10 .. "%")
			self.owner.lbGuHp:setString(MultiLan("guilg_war_guwu_desc2")..num * 20 .. "%")
			self.owner.lbGuNum:setString(MultiLan("guilg_war_guwu_desc3")..num.." "..MultiLan("guilg_war_guwu_desc5")..(num * 10 + 50))
			UserInfo:setCash(UserInfo:getCash() - jsonDataTable.data.use_num )
		end
	end

	if getMyMemberInfo().position > 10 then
		CommonNote(MultiLan("GFL_openBoss_1"))
		return
	end
	if self.owner.data.jsonDataTable.data.is_in_battle == 0 then
		CommonNote(MultiLan("guilg_war_guwu_desc4"))
		return
	end
	if self.owner.data.jsonDataTable.data.info.inspires ~= nil and
		 not table_is_empty(self.owner.data.jsonDataTable.data.info.inspires) and
		 self.owner.data.jsonDataTable.data.info.inspires[tostring(UserFamilyInfo.info.id)] ~= nil
	then
		if self.owner.data.jsonDataTable.data.info.inspires[tostring(UserFamilyInfo.info.id)] >= 5 then
			CommonNote(MultiLan("GFL_inspire_3"))
			return
		end
	end
	HttpSend("union/zgubinspire", {}, GuWuCallback)
end





