RewardListLayer = class("RewardListLayer")

function RewardListLayer.getCellSize(  )
	return cc.size(494, 320)
end
--new
function RewardListLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end
 
-- create
function RewardListLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["RewardListLayer"] = self
	ccb["RewardListLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/Family/RewardListLayer.ccbi", proxy, self)
	self.data = data
	self:initUI()
	return self
end
function RewardListLayer:initUI(  )
	local awardA = {self.imaward_1_1, self.imaward_1_2, self.imaward_1_3}
	local awardB = {self.imaward_2_1, self.imaward_2_2, self.imaward_2_3}
	self.lbdesc1:setString(MultiLan("familyrewarddesc1"))
	self.lbdesc2:setString(MultiLan("familyrewarddesc2"))
	self.lbTitle:setString(MultiLan("familyrewardtitle_"..self.data.tag))
	for i = 1 ,3 do
		if self.data.awards.leader_items[i] ~= nil then
			local bagItem = CreateBagItem()
			bagItem:setItemType(BAG_ITEM_TYPE_GET_AWARD)
			bagItem:setItemInfoTable(self.data.awards.leader_items[i])
			bagItem:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
			awardA[i]:addChild(bagItem)
		else
			awardA[i]:setVisible(false)
		end
	end
	for i = 1 ,3 do
		if self.data.awards.member_items[i] ~= nil then
			local bagItem = CreateBagItem()
			bagItem:setItemType(BAG_ITEM_TYPE_GET_AWARD)
			bagItem:setItemInfoTable(self.data.awards.member_items[i])
			bagItem:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
			awardB[i]:addChild(bagItem)
		else
			awardB[i]:setVisible(false)
		end
	end
end