HeroTokenLayer = class("HeroTokenLayer")

--new
function HeroTokenLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function HeroTokenLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["HeroTokenLayer"] = self
	ccb["HeroTokenLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/wing/yingxionglingrenwu.ccbi", proxy, self)
	self.data = data
    
    SetTouchEventForLayer(self.swallowLayer, TouchSwallow)
    SetTouchEventForLayer(self.swallowLayer1, TouchSwallow)

	-- set button onlick
    self.btSell.owner = self
    self.btAdd.owner = self
    self.btGet.owner = self
    self.btnClose.owner = self
    self.btCloseTan.owner = self
    self.btTanSell.owner = self

	self:initUI()
	return self
end
function HeroTokenLayer:initUI()
    self.layerTan:setVisible(false)
    self.lbAims:setString(MultiLan("wing_aims"))
    -- ccdump(self.data.info)
    self.lbAimsDesc:setString(string.format(MultiLan("wing_aims_desc"),40,self.data.info.sData.monster_num))
    self.lbReward:setString(MultiLan("wing_reward"))
    self.lbRewardDesc:setString(MultiLan("wing_reward_desc")..self.data.info.sData.wing)
    self.lbRemind:setString(MultiLan("wing_remind"))
    self.lbRemindDesc:setString(string.format(MultiLan("wing_remind_desc"),UserInfo.UserInfoTable.data.wing.day_limit,5))
    self.btSell:setTitleForState(MultiLan("wing_button_sell"),1)
    self.btAdd:setTitleForState(MultiLan("wing_button_merge"),1)
    self.btGet:setTitleForState(MultiLan("wing_button_use"),1)
    self.hero_token_title:setString(MultiLan("hero_token_title"))
    self.lb_token_desc:setString(MultiLan("wing_token_desc"))
    self.lb_token_name:setString(MultiLan("prop_name_"..self.data.info.prop_id))
    -- if self.data.info.prop_id == 100701 then

    if self.data.info.prop_id == 100701 then
        self.im_token_biankuang:setSpriteFrame("frame_grey.png")
    elseif self.data.info.prop_id == 100702 then
        self.im_token_biankuang:setSpriteFrame("frame_green.png")
    elseif self.data.info.prop_id == 100703 then
        self.im_token_biankuang:setSpriteFrame("frame_blue.png")
    elseif self.data.info.prop_id == 100704 then
        self.im_token_biankuang:setSpriteFrame("frame_violet.png")
    elseif self.data.info.prop_id == 100705 then
        self.im_token_biankuang:setSpriteFrame("frame_yellow.png")
    end
    --出售小弹窗
    self.lb_wing_sell_desc:setString(MultiLan("wing_sell_desc"))
    self.lb_wing_sell_title:setString(MultiLan("wing_button_sell"))
    self.btCloseTan:setTitleForState(MultiLan("button_cancel"),1)
    self.btTanSell:setTitleForState(MultiLan("button_ok"),1)
    -- string.format()
end
function HeroTokenLayer:onClickSell()
    self.owner.layerTan:setVisible(true)
end
function HeroTokenLayer:onCilckAdd(sender)
    local heroTokenMergeLayer = HeroTokenMergeLayer:new()
    heroTokenMergeLayer:create()
    local layerNode = heroTokenMergeLayer.topNode
    if POPUP_LAYER == nil then
        POPUP_LAYER = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
        scene:addChild(POPUP_LAYER, POPUP_TAG, POPUP_TAG)
    end
    POPUP_LAYER:addChild(layerNode) 
    removeSelf(self.owner.topNode)
end
function HeroTokenLayer:onCilckGet(sender)
    local function useCallback( jsonDataTable )
        if jsonDataTable.ret ~= 0 then
            return
        end
        UserInfo:removepropByPropId(self.owner.data.info.prop_id, 1)
        UserInfo.UserInfoTable.data.wing.day_limit = UserInfo.UserInfoTable.data.wing.day_limit + 1
        BagLayer:RefreshBagScrollLayer()
        CommonNote(MultiLan("wings_desc_tishi_7"))
        removeSelf(self.owner.topNode)
    end
    if UserInfo.UserInfoTable.data.wing.day_limit >= 5 then
        CommonNote(MultiLan("wings_desc_tishi_8"))
        return
    end
    HttpSend("wing/tokenuse",{"propId="..self.owner.data.info.prop_id},useCallback)
end
function HeroTokenLayer:onClickClose(sender)
    removeSelf(self.owner.topNode)
end
function HeroTokenLayer:onClickCloseTan(sender)
    self.owner.layerTan:setVisible(false)
end
function HeroTokenLayer:onClickTanSell(sender)
    local function sellCallback( jsonDataTable )
        if jsonDataTable.ret ~= 0 then
            return
        end
        UserInfo:removepropByPropId(self.owner.data.info.prop_id, 1)
        UserInfo:setGold(UserInfo:getGold() + jsonDataTable.data.got_gold)
        BagLayer:RefreshBagScrollLayer()
        CommonNote(MultiLan("wing_sell_desc_2"))
        removeSelf(self.owner.topNode)
    end
    HttpSend("wing/tokensell",{"pid="..self.owner.data.info.id},sellCallback)
end