HeroTokenMergeLayer = class("HeroTokenMergeLayer")

--new
function HeroTokenMergeLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function HeroTokenMergeLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["HeroTokenMergeLayer"] = self
	ccb["HeroTokenMergeLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/wing/yingxionglinghecheng.ccbi", proxy, self)
	self.data = data
    
    SetTouchEventForLayer(self.swallowLayer, TouchSwallow)


	-- set button onlick
    self.btnClose.owner = self
    self.btMerge.owner = self
    self.btToken1.owner = self
    self.btToken2.owner = self
    self.btToken3.owner = self
    self.btToken4.owner = self
    self.btToken5.owner = self
    self.showtag = 1
    self.TokenTabll = {0,0,0,0,0}
    self.needCash = 0
	self:initUI()
	return self
end
function HeroTokenMergeLayer:initUI()
	for i = 1, table.maxn(UserInfo:getUserInfo().data.bag_prop) do
		if UserInfo:getUserInfo().data.bag_prop[i].sData.ptype == 21 then
			if UserInfo:getUserInfo().data.bag_prop[i].sData.color == 1 then
				self.TokenTabll[1] = UserInfo:getUserInfo().data.bag_prop[i].amount
			elseif UserInfo:getUserInfo().data.bag_prop[i].sData.color == 2 then
				self.TokenTabll[2] = UserInfo:getUserInfo().data.bag_prop[i].amount
			elseif UserInfo:getUserInfo().data.bag_prop[i].sData.color == 3 then
				self.TokenTabll[3] = UserInfo:getUserInfo().data.bag_prop[i].amount
			elseif UserInfo:getUserInfo().data.bag_prop[i].sData.color == 4 then
				self.TokenTabll[4] = UserInfo:getUserInfo().data.bag_prop[i].amount
			elseif UserInfo:getUserInfo().data.bag_prop[i].sData.color == 5 then
				self.TokenTabll[5] = UserInfo:getUserInfo().data.bag_prop[i].amount
			end
			
		end
	end
	self.btMerge:setTitleForState(MultiLan("wing_button_merge"),1)
	self.token_name1:setString(MultiLan("prop_name_100701"))
	self.token_name2:setString(MultiLan("prop_name_100702"))
	self.token_name3:setString(MultiLan("prop_name_100703"))
	self.token_name4:setString(MultiLan("prop_name_100704"))
	self.token_name5:setString(MultiLan("prop_name_100705"))
	self.lb_token_title:setString(MultiLan("lb_token_title"))
	self:setUI(1)
end
function HeroTokenMergeLayer:onClickMerge(sender)
	if self.owner.needCash > UserInfo:getCash() then
		CommonCashNeed()
		return
	end
	if 4 > self.owner.TokenTabll[self.owner.showtag] then
		CommonNote(MultiLan("wings_desc_tishi_6"))
		return
	end
	local function mergeCallback( jsonDataTable )
		if jsonDataTable.ret ~= 0 then
			return
		end
		UserInfo:addProp(jsonDataTable.data.newToken)
		UserInfo:addPropNote(jsonDataTable.data.newToken)
		UserInfo:removepropByPropId(100700 + self.owner.showtag, 4)
		UserInfo:setCash(UserInfo:getCash() - jsonDataTable.data.cost_cash)
		self.owner.TokenTabll[self.owner.showtag] = jsonDataTable.data.remine
		self.owner.TokenTabll[self.owner.showtag + 1] = self.owner.TokenTabll[self.owner.showtag + 1] + 1
		BagLayer:RefreshBagScrollLayer()
		self.owner:setUI(self.owner.showtag)
	end

	HttpSend("wing/tokenmerge",{"propId="..(100700 + self.owner.showtag)},mergeCallback)
end
function HeroTokenMergeLayer:onClickClose(sender)
	if self.owner.data ~= nil then
		if self.owner.data.tag == "task" then
			-- cclog("---"..self.owner.data.showtag)
			self.owner.data.layer:refreshUI( self.owner.data.showtag )
		end
	end
	removeSelf(self.owner.topNode)
end
function HeroTokenMergeLayer:onClickToken(sender)
	tag = self:getTag()
	self.owner.showtag = tag
	self.owner:setUI(tag)
	-- cclog("tag is "..tag)
end
function HeroTokenMergeLayer:setUI(tag)
	local token_num = {self.lb_token_num_1, self.lb_token_num_2, self.lb_token_num_3, self.lb_token_num_4, self.lb_token_num_5,}
	local buttontable = {self.btToken1, self.btToken2, self.btToken3, self.btToken4, self.btToken5}
	for i =1 ,5 do
		token_num[i]:setString("x"..self.TokenTabll[i])
		if buttontable[i]:getChildByTag(1) ~= nil then
			buttontable[i]:removeChildByTag(1)
		end
	end
	buttontable[tag]:addChild(CreateCommonSprite("effect_selected01.png", Pos(buttontable[tag]:getContentSize()),0.93),0,1)
	-- local eff = effect_selected01.png
	self.showtag = tag
	local propId = 100700+tag
	local propInfoTable = GameData:getPropDataTable(propId)
	self.needCash = propInfoTable.upgrade
	if tag == 5 then
		self.lb_token_desc8:setVisible(true)
		self.layerLbDesc:setVisible(false)
		self.lb_token_desc8:setString(MultiLan("wing_merge_desc_6"))
		self.btMerge:setEnabled(false)

	else
		self.lb_token_desc8:setVisible(false)
		self.layerLbDesc:setVisible(true)
		self.btMerge:setEnabled(true)
		self.lb_token_desc1:setString(MultiLan("wing_merge_desc_1"))
		self.lb_token_desc2:setString(MultiLan("wing_merge_desc_2"))
		self.lb_token_desc3:setString(""..propInfoTable.upgrade.." ( "..MultiLan("wing_merge_desc_3")..UserInfo:getCash().." )")
		self.lb_token_desc4:setString(MultiLan("hero_token_title"))
		self.lb_token_desc4:setColor(EQUIP_COLOR_ARR[tag])
		local wingNum = self.TokenTabll[tag]
		self.lb_token_desc5:setString("4 ( "..MultiLan("wing_merge_desc_3")..wingNum.." )")
		self.lb_token_desc6:setString(MultiLan("wing_merge_desc_4"))
		self.lb_token_desc7:setString(MultiLan("wing_merge_desc_5")..propInfoTable.wing)
	end

end





