HeroTokenTaskLayer = class("HeroTokenTaskLayer")

--new
function HeroTokenTaskLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function HeroTokenTaskLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["HeroTokenTaskLayer"] = self
	ccb["HeroTokenTaskLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/wing/HeroTokenTaskLayer.ccbi", proxy, self)
	self.data = data
    self.btToken1.owner = self
    self.btToken2.owner = self
    self.btToken3.owner = self
    self.btToken4.owner = self
    self.btToken5.owner = self
    self.mHelpIcon.owner = self
    self.btMerge.owner = self 
    self.btAct.owner = self
    self.TokenTabll = {0,0,0,0,0}
    SetTouchEventForLayer(self.swallowLayer, TouchSwallow)
    self.showtag = 1

	-- set button onlick
    self.btnClose.owner = self
	self:initUI()
	return self
end
function HeroTokenTaskLayer:initUI()
	self:refreshUI(1)
	self:refreshScrol( )
	self.token_name1:setString(MultiLan("prop_name_100701"))
	self.token_name2:setString(MultiLan("prop_name_100702"))
	self.token_name3:setString(MultiLan("prop_name_100703"))
	self.token_name4:setString(MultiLan("prop_name_100704"))
	self.token_name5:setString(MultiLan("prop_name_100705"))
	self.hero_token_task_title:setString(MultiLan("hero_token_task_title"))
	self.btMerge:setTitleForState(MultiLan("wing_button_merge"),1)
    self.btAct:setTitleForState(MultiLan("wing_button_use"),1)
end
function HeroTokenTaskLayer:refreshScrol1( info )
	self.ScrollLayer:removeAllChildren(true)
	local scrollLayer = self.ScrollLayer
	local layer = cc.Layer:create()
	local count = 0
	if info ~= CJSON_NULL then
		count = table.maxn(info)
	end
	local cellSize = HeroTokenTaskCell.getCellSize()
	local y = count * cellSize.height
	layer:setContentSize(cc.size(cellSize.width, y))
	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, scrollLayer:getContentSize().height - y), kScrollViewDirectionVertical)
	for i = 1, count do
		local rankcell = HeroTokenTaskCell:new()
		rankcell:create({
			info = info[i],
			layer = self,
			})
		local cellNode = rankcell.topNode 
		cellNode:setPositionY(y - i * cellSize.height)   
		layer:addChild(cellNode)
	end
end
function HeroTokenTaskLayer:refreshScrol( )
	local function taskCallback( jsonDataTable )
		if jsonDataTable.ret ~= 0 then
			return
		end
		self:refreshScrol1( jsonDataTable.data.token_infos )
	end
	HttpSend("wing/info",{},taskCallback)
end
function HeroTokenTaskLayer:refreshUI( tag )
	for i = 1, table.maxn(UserInfo:getUserInfo().data.bag_prop) do
		if UserInfo:getUserInfo().data.bag_prop[i].sData.ptype == 21 then
			if UserInfo:getUserInfo().data.bag_prop[i].sData.color == 1 then
				self.TokenTabll[1] = UserInfo:getUserInfo().data.bag_prop[i].amount
			elseif UserInfo:getUserInfo().data.bag_prop[i].sData.color == 2 then
				self.TokenTabll[2] = UserInfo:getUserInfo().data.bag_prop[i].amount
			elseif UserInfo:getUserInfo().data.bag_prop[i].sData.color == 3 then
				self.TokenTabll[3] = UserInfo:getUserInfo().data.bag_prop[i].amount
			elseif UserInfo:getUserInfo().data.bag_prop[i].sData.color == 4 then
				self.TokenTabll[4] = UserInfo:getUserInfo().data.bag_prop[i].amount
			elseif UserInfo:getUserInfo().data.bag_prop[i].sData.color == 5 then
				self.TokenTabll[5] = UserInfo:getUserInfo().data.bag_prop[i].amount
			end
		end
	end
	local token_num = {self.lb_token_num_1, self.lb_token_num_2, self.lb_token_num_3, self.lb_token_num_4, self.lb_token_num_5,}
	local buttontable = {self.btToken1, self.btToken2, self.btToken3, self.btToken4, self.btToken5}
	self.lb_desc:setString(string.format(MultiLan("wing_task_desc"),UserInfo.UserInfoTable.data.wing.day_limit,5))
	for i =1 ,5 do
		token_num[i]:setString("x"..self.TokenTabll[i])
		if buttontable[i]:getChildByTag(1) ~= nil then
			buttontable[i]:removeChildByTag(1)
		end
	end
	buttontable[tag]:addChild(CreateCommonSprite("effect_selected01.png", Pos(buttontable[tag]:getContentSize()),0.93),0,1)
end
function HeroTokenTaskLayer:onClickToken( sender )
	tag = self:getTag()
	self.owner.showtag = tag
	self.owner:refreshUI(tag)
end
function HeroTokenTaskLayer:onClickClose(sender)
	setHeroTNote(false)
	removeSelf(self.owner.topNode)
end
function HeroTokenTaskLayer:onUpHelpClick(sender)
	HelpPopup("wingshelp")
end
function HeroTokenTaskLayer:onClickMerge(sender)
-- cclog("++++"..self.owner.showtag)
	local heroTokenMergeLayer = HeroTokenMergeLayer:new()
    heroTokenMergeLayer:create({
    	tag = "task",
    	layer = self.owner,
    	showtag = self.owner.showtag,
    	})
    local layerNode = heroTokenMergeLayer.topNode
    if POPUP_LAYER == nil then
        POPUP_LAYER = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
        scene:addChild(POPUP_LAYER, POPUP_TAG, POPUP_TAG)
    end
    POPUP_LAYER:addChild(layerNode) 
end
function HeroTokenTaskLayer:onClickAct(sender)
	local function useCallback( jsonDataTable )
        if jsonDataTable.ret ~= 0 then
            return
        end
        UserInfo:removepropByPropId(100700 + self.owner.showtag, 1)
        UserInfo.UserInfoTable.data.wing.day_limit = UserInfo.UserInfoTable.data.wing.day_limit + 1
        self.owner.TokenTabll[self.owner.showtag] = self.owner.TokenTabll[self.owner.showtag] - 1
        self.owner:refreshUI(self.owner.showtag)
        self.owner:refreshScrol( )
        CommonNote(MultiLan("wings_desc_tishi_7"))
    end
    if UserInfo.UserInfoTable.data.wing.day_limit >= 5 then
        CommonNote(MultiLan("wings_desc_tishi_8"))
        return
    end
    if self.owner.TokenTabll[self.owner.showtag] <= 0 then
    	CommonNote(MultiLan("wings_desc_tishi_9"))
    	return
    end
    HttpSend("wing/tokenuse",{"propId="..(100700 + self.owner.showtag)},useCallback)
end
local function onMainHeroToken()
	if UserSelfInfo.level < 40 then
		CommonNote(MultiLan("lb_wing_tishi"))
		return
	end
	setHeroTNote(false)
	local heroTokenTaskLayer = HeroTokenTaskLayer:new()
	heroTokenTaskLayer:create()
	local layerNode = heroTokenTaskLayer.topNode
	if POPUP_LAYER == nil then
	    POPUP_LAYER = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
	    scene:addChild(POPUP_LAYER, POPUP_TAG, POPUP_TAG)
	end
	POPUP_LAYER:addChild(layerNode) 
end
XiaLayer["onMainHeroToken"] = onMainHeroToken




