WingLayer = class("WingLayer")

--new
function WingLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function WingLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["WingLayer"] = self
	ccb["WingLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/wing/WingLayer.ccbi", proxy, self)
	self.data = data
    
    SetTouchEventForLayer(self.swallowLayer1, TouchSwallow)
    SetTouchEventForLayer(self.swallowLayer2, TouchSwallow)
	-- set button onlick
    self.mActPayBack.owner = self
    self.btMore.owner = self
    self.btTan.owner = self
    self.btUpdateAll.owner = self
    self.btUpdate.owner = self
    self.btTanClose.owner = self
    self.btPic.owner = self
    self.btRank.owner = self
    self.mHelpIcon.owner = self
    self.btPicWings1.owner = self
    self.btPicWings2.owner = self
    self.btPicWings3.owner = self
    self.btPicWings4.owner = self
    self.btPicWings5.owner = self

	self:initUI()
	return self
end
function WingLayer:initUI()
	-- ccdump(self,"self")
	XiaLayerOwner["mBigTitleLayer"]:setVisible(false)
	self.btMore:setTitleForState(ZGMultiLan("btn_equip_more_proporties"),1)
    self.btTan:setTitleForState(MultiLan("wings_desc_button_1"),1)
    self.btUpdateAll:setTitleForState(MultiLan("wings_desc_button_2"),1)
    self.btUpdate:setTitleForState(MultiLan("wings_desc_button_3"),1)
    self.btTanClose:setTitleForState(MultiLan("button_close"),1)
    self.btPic:setTitleForState(MultiLan("wings_desc_button_1"),1)
    self.btRank:setTitleForState(MultiLan("wings_desc_button_4"),1)

    self.lb_wing_layer_title:setString(MultiLan("lb_wing_layer_title"))
    self.lb_wing_tan_title:setString(MultiLan("lb_wing_tan_title"))
	self.layerWing:setVisible(true)
	self.layerTan:setVisible(false)
	self.lb_wing_tan_title:setString(MultiLan("lb_wing_tan_title"))
	self.lbRole:setString(MultiLan("role_career_"..UserSelfInfo.role))
	self.icoRole:setSpriteFrame("school_icon_"..UserSelfInfo.role..".png")
	self.UserWingTable = UserInfo.UserInfoTable.data.wing
	self:setWingHome()
	-- ccdump(wings , "wings")
end
function WingLayer:onActPayBack( sender )
	XiaLayerOwner["mBigTitleLayer"]:setVisible(true)
	removeSelf(self.owner.topNode)
end

function WingLayer:onClickUpdateAll( sender )
	local upNum = 0
	local function updata(  )
		local function updateCallback(jsonDataTable)
			if jsonDataTable.ret ~= 0 then
				return
			end
			if jsonDataTable.data.isSuccess == 0 then
				CommonNote(MultiLan("wings_desc_tishi_1"))
				CommonNote(MultiLan("wings_desc_tishi_2").."+"..(jsonDataTable.data.luck - self.owner.UserWingTable.luck))
				self.owner.UserWingTable.luck = jsonDataTable.data.luck
				self.owner.UserWingTable.lv = jsonDataTable.data.lv
			else
				CommonNote(MultiLan("wings_desc_tishi_3"))
				self.owner.UserWingTable.lv = jsonDataTable.data.lv
				self.owner.UserWingTable.luck = jsonDataTable.data.luck
				UserAttr:equipAttrChange(1, true)
			end
			if jsonDataTable.data.ctype == 1 then
				CommonNote(MultiLan("wings_desc_tishi_4")..jsonDataTable.data.cvalue)
				UserInfo:setGold(UserInfo:getGold() - jsonDataTable.data.cvalue)
			else
				CommonNote(MultiLan("wings_desc_tishi_5")..jsonDataTable.data.cvalue)
				UserSelfInfo.cash = UserSelfInfo.cash - jsonDataTable.data.cvalue
			end
			UserInfo:removepropByPropId(100700, jsonDataTable.data.wing)
			for i = 1, table.maxn(UserInfo:getUserInfo().data.bag_prop) do
				local propId = UserInfo:getUserInfo().data.bag_prop[i].prop_id
				if propId == 100700 then
					self.owner.wingNum = UserInfo:getUserInfo().data.bag_prop[i].amount
				end
			end
			self.owner:setWingHome()
			upNum = upNum + 1
			local wings = GameData:getWingsByLevelAndRole( self.owner.UserWingTable.lv ,UserSelfInfo.role )
			if wings.ctype == 1 then
				if wings.cvalue > UserInfo:getGold() or wings.wing > self.owner.wingNum then
					CommonNote(MultiLan("wings_desc_tishi_6"))
				end
				if wings.cvalue <= UserInfo:getGold() and wings.wing <= self.owner.wingNum and upNum < 10 and self.owner.UserWingTable.lv < 50 then
					updata()
				end
			else
				if wings.cvalue > UserSelfInfo.cash or wings.wing > self.owner.wingNum then
					CommonNote(MultiLan("wings_desc_tishi_6"))
				end
				if wings.cvalue <= UserSelfInfo.cash and wings.wing <= self.owner.wingNum and upNum < 10 and self.owner.UserWingTable.lv < 50 then
					updata()	
				end
			end
		end
		HttpSend("wing/upgrade",{},updateCallback)
	end
	local wings = GameData:getWingsByLevelAndRole( self.owner.UserWingTable.lv ,UserSelfInfo.role )
	if wings.ctype == 1 then
		if wings.cvalue <= UserInfo:getGold() and wings.wing <= self.owner.wingNum then
			updata()
		else
			CommonNote(MultiLan("wings_desc_tishi_6"))
		end
	else
		if wings.cvalue <= UserSelfInfo.cash and wings.wing <= self.owner.wingNum then
			updata()
		else
			CommonNote(MultiLan("wings_desc_tishi_6"))
		end
	end
end
function WingLayer:onClickUpdate( sender )
	local function updateCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			return
		end
		if jsonDataTable.data.isSuccess == 0 then
			CommonNote(MultiLan("wings_desc_tishi_1"))
			CommonNote(MultiLan("wings_desc_tishi_2").."+"..(jsonDataTable.data.luck - self.owner.UserWingTable.luck))
			self.owner.UserWingTable.luck = jsonDataTable.data.luck
			self.owner.UserWingTable.lv = jsonDataTable.data.lv
		else
			CommonNote(MultiLan("wings_desc_tishi_3"))
			self.owner.UserWingTable.lv = jsonDataTable.data.lv
			self.owner.UserWingTable.luck = jsonDataTable.data.luck
			UserAttr:equipAttrChange(1, true)
		end
		if jsonDataTable.data.ctype == 1 then
			CommonNote(MultiLan("wings_desc_tishi_4")..jsonDataTable.data.cvalue)
			UserInfo:setGold(UserInfo:getGold() - jsonDataTable.data.cvalue)
		else
			CommonNote(MultiLan("wings_desc_tishi_5")..jsonDataTable.data.cvalue)
			UserSelfInfo.cash = UserSelfInfo.cash - jsonDataTable.data.cvalue
		end
		UserInfo:removepropByPropId(100700, jsonDataTable.data.wing)
		self.owner:setWingHome()
	end
	local wings = GameData:getWingsByLevelAndRole( self.owner.UserWingTable.lv ,UserSelfInfo.role )
	if wings.ctype == 1 then
		if wings.cvalue <= UserInfo:getGold() and wings.wing <= self.owner.wingNum then
			HttpSend("wing/upgrade",{},updateCallback)
		else
			CommonNote(MultiLan("wings_desc_tishi_6"))
		end
	else
		if wings.cvalue <= UserSelfInfo.cash and wings.wing <= self.owner.wingNum then
			HttpSend("wing/upgrade",{},updateCallback)
		else
			CommonNote(MultiLan("wings_desc_tishi_6"))
		end
	end
	
end
function WingLayer:onClickMore( sender )
	MorepertyPopup(UserAttr:getAttrTable(),UserAttr:getFightNum(),UserSelfInfo.name,UserSelfInfo.level,UserSelfInfo.role)
end
function WingLayer:onUpHelpClick( sender )
	HelpPopup("wingshelp")
end

function WingLayer:setWingHome()
	local userAttr = UserAttr:getAttrTable()
	self.lbBattlePower:setString(ZGMultiLan( "equip_battle_value_title")..":")
	self.lbBattlePownerNum:setString(UserAttr:getFightNum())
	self.lbPower:setString(MultiLan( "attr_role_str")..":")
	self.lbPowerNum:setString(userAttr.str)
	self.lbInt:setString(MultiLan( "attr_role_int")..":")
	self.lbIntNum:setString(userAttr.int)
	self.lbHit:setString(MultiLan( "attr_role_damage")..":")
	self.lbHitNum:setString(math.ceil(userAttr.damage/2).." - "..userAttr.damage)
	self.lbLife:setString(MultiLan( "attr_role_hp")..":")
	self.lbLifeNum:setString(userAttr.hp)
	self.lbVit:setString(MultiLan( "attr_role_sta")..":")
	self.lbVitNum:setString(userAttr.sta)
	self.lbAgi:setString(MultiLan( "attr_role_agi")..":")
	self.lbAgiNum:setString(userAttr.agi)
	self.lbMp:setString(MultiLan( "attr_role_mp")..":")
	self.lbMpNum:setString(userAttr.mp)
    local wings = GameData:getWingsByLevelAndRole( self.UserWingTable.lv ,UserSelfInfo.role )
    self.lbAddHp:setString(MultiLan( "attr_role_hp"))
	self.lbAddHpNum:setString(""..wings.hp)
	self.lbAddDamageMin:setString(MultiLan( "attr_role_damage_min"))
	self.lbAddDamageMinNum:setString(""..math.ceil(wings.damage/2))
	self.lbAddDamage:setString(MultiLan( "attr_role_damage_max"))
	self.lbAddDamageNum:setString(""..wings.damage)
    if self.UserWingTable.lv < 50 then
	    local nextlvwings = GameData:getWingsByLevelAndRole( self.UserWingTable.lv + 1 ,UserSelfInfo.role )
	    self.lbAddHpNum2:setString("+"..(nextlvwings.hp - wings.hp))
	    self.lbAddDamageMinNum2:setString("+"..math.ceil((nextlvwings.damage - wings.damage)/2))
	    self.lbAddDamageNum2:setString("+"..(nextlvwings.damage - wings.damage))
	    if wings.prp ~=0 or nextlvwings.prp ~= 0 then
		    self.lbAddPrp:setString(MultiLan( "attr_artifact_prp"))
		    self.lbAddPrpNum:setString(""..wings.prp)
		    self.lbAddPrpNum2:setString("+"..(nextlvwings.prp - wings.prp))
		elseif wings.mrp ~=0 or nextlvwings.mrp ~= 0 then
		    self.lbAddPrp:setString(MultiLan( "attr_artifact_mrp"))
		    self.lbAddPrpNum:setString(""..wings.mrp)
		    self.lbAddPrpNum2:setString("+"..(nextlvwings.mrp - wings.mrp))
		else
			self.lbAddPrp:setVisible(false)
		    self.lbAddPrpNum:setVisible(false)
		    self.lbAddPrpNum2:setVisible(false)
		end
	else
		if wings.prp ~=0 then
		    self.lbAddPrp:setString(MultiLan( "attr_artifact_prp"))
		    self.lbAddPrpNum:setString(""..wings.prp)
		elseif wings.mrp ~=0  then
		    self.lbAddPrp:setString(MultiLan( "attr_artifact_mrp"))
		    self.lbAddPrpNum:setString(""..wings.mrp)
		end
		self.lbAddHpNum2:setVisible(false)
		self.lbAddDamageMinNum2:setVisible(false)
		self.lbAddDamageNum2:setVisible(false)
		self.lbAddPrpNum2:setVisible(false)
		self.btUpdateAll:setEnabled(false)
   		self.btUpdate:setEnabled(false)

	end
	self.wingNum = 0
	for i = 1, table.maxn(UserInfo:getUserInfo().data.bag_prop) do
		local propId = UserInfo:getUserInfo().data.bag_prop[i].prop_id
		if propId == 100700 then
			self.wingNum = UserInfo:getUserInfo().data.bag_prop[i].amount
		end
	end
	if self.wingNum < wings.wing then
		self.lbWingNum:setColor(COLOR_RED)
	else
		self.lbWingNum:setColor(COLOR_WHITE)
	end
	self.lbWingNum:setString(tostring(self.wingNum).."/"..wings.wing)
	if wings.ctype == 1 then
		self.iconGold:setSpriteFrame("icon_silver.png")
		self.lbCashNum:setString(""..UserSelfInfo.gold.."/"..wings.cvalue)
		if UserSelfInfo.gold < wings.cvalue then
			self.lbCashNum:setColor(COLOR_RED)
		else
			self.lbCashNum:setColor(COLOR_WHITE)
		end
	else
		self.iconGold:setSpriteFrame("icon_gold.png")
		self.lbCashNum:setString(""..UserSelfInfo.cash.."/"..wings.cvalue)
		if UserSelfInfo.cash < wings.cvalue then
			self.lbCashNum:setColor(COLOR_RED)
		else
			self.lbCashNum:setColor(COLOR_WHITE)
		end
	end
	if self.progressBar == nil then
		local x,y = self.imLucyBar:getPosition()
		local Parent = self.imLucyBar:getParent()
	    self.imLucyBar:removeFromParent(true)
		self.progressBar = cc.ProgressTimer:create(cc.Sprite:createWithSpriteFrameName("tianyu_jindutiao_g.png"))
		self.progressBar:setPosition(cc.p(x,y))
		self.progressBar:setType(cc.PROGRESS_TIMER_TYPE_BAR)
		self.progressBar:setMidpoint(cc.p(0, 0))
		self.progressBar:setBarChangeRate(cc.p(1, 0))
		Parent:addChild(self.progressBar)
	end
	local startTable = {self.imStart01 , self.imStart02 , self.imStart03 , self.imStart04 , self.imStart05 , self.imStart06 , self.imStart07 , self.imStart08 , self.imStart09 , self.imStart10}
	local count = 0
	if self.UserWingTable.lv == 0 then
		count =0
	else
		if self.UserWingTable.lv % 10 == 0 then
			count = 10
		else
			count = self.UserWingTable.lv % 10
		end
	end
	for i = 1, 10 do
		if startTable[i]:getChildByTag(1) ~= nil then
			startTable[i]:removeChildByTag(1)
		end
	end
	for i =1 ,count do
		local star = CreateCommonSprite("pic_shstar.png",Pos(startTable[i]:getContentSize()))
		startTable[i]:addChild(star,0,1)
	end
	self.lbLuckNum:setString(MultiLan("wings_desc_1")..self.UserWingTable.luck)
	if self.UserWingTable.lv == 0 then
		self.im_wing_wings:setSpriteFrame("tianyu_cb_1.png")
	else
		self.im_wing_wings:setSpriteFrame("tianyu_cb_".. math.ceil(self.UserWingTable.lv / 10)..".png")
	end
	self.progressBar:setPercentage(self.UserWingTable.luck)
end
--弹窗内容
function WingLayer:onClickTan( sender )
	self.owner.layerWing:setVisible(false)
	self.owner.layerTan:setVisible(true)
	self.owner.layerPic:setVisible(true)
	self.owner.layerRank:setVisible(false)
	self.owner.btPic:setEnabled(false)
	self.owner.btRank:setEnabled(true)
	self.owner:setPicLayerUI(1)
end
function WingLayer:onClickTanClose( sender )
	self.owner.layerWing:setVisible(true)
	self.owner.layerTan:setVisible(false)

end
function WingLayer:onClickPic( sender )
	self.owner.layerPic:setVisible(true)
	self.owner.layerRank:setVisible(false)
	self.owner.btPic:setEnabled(false)
	self.owner.btRank:setEnabled(true)
end
function WingLayer:onClickRank( sender )
	local function RankCallback( jsonDataTable )
		if jsonDataTable.ret ~= 0 then
			return
		end
		if jsonDataTable.data.rank == CJSON_NULL then
			return
		end
		self.owner.layerPic:setVisible(false)
		self.owner.layerRank:setVisible(true)
		self.owner.btPic:setEnabled(true)
		self.owner.btRank:setEnabled(false)
		local scrollLayer = self.owner.layerWingRankScroll
	    local layer = cc.Layer:create()
	    local count = table.maxn(jsonDataTable.data.rank)
	    local cellSize = WingRankcell.getCellSize()
	    local y = count * cellSize.height
	    layer:setContentSize(cc.size(cellSize.width, y))
		local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, scrollLayer:getContentSize().height - y), kScrollViewDirectionVertical)
	    for i = 1, count do
	    		local rankcell = WingRankcell:new()
	            rankcell:create({
	            	info = jsonDataTable.data.rank[i],
	            	rank = i,
	            	})
	            local cellNode = rankcell.topNode 
	            cellNode:setPositionY(y - i * cellSize.height)   
		        layer:addChild(cellNode)
	    end
	end

	HttpSend("wing/rank",{},RankCallback)
	-- wing/rank
end
function WingLayer:onClickPicWings( sender )
	tag = self:getTag()
	-- cclog("tag is "..tag)
	self.owner:setPicLayerUI(tag)
end
function WingLayer:setPicLayerUI( tag )
	local buttontable = {self.btPicWings1, self.btPicWings2, self.btPicWings3, self.btPicWings4, self.btPicWings5}
	for i =1 ,5 do
		if buttontable[i]:getChildByTag(1) ~= nil then
			buttontable[i]:removeChildByTag(1)
		end
	end
	buttontable[tag]:addChild(CreateCommonSprite("effect_selected01.png", Pos(buttontable[tag]:getContentSize()),0.8),0,1)
	local wings = GameData:getWingsByLevelAndRole( tag * 10 ,UserSelfInfo.role )
	self.lbPicHp:setString(MultiLan("attr_role_hp"))
	self.lbPicHpNum:setString(""..wings.hp)
	self.lbPicDamage:setString(MultiLan("attr_role_damage_max"))
	self.lbPicDamageNum:setString(""..wings.damage)
	self.lbPicDamageMin:setString(MultiLan("attr_role_damage_min"))
	self.lbPicDamageMinNum:setString(""..math.ceil(wings.damage / 2))
	self.im_tan_wings:setSpriteFrame("tianyu_cb_"..tag ..".png")
	-- ccdump(wings)
	if wings.prp ~= 0 then
		self.lbPicPrp:setVisible(true)
		self.lbPicPrpNum:setVisible(true)
		self.lbPicPrp:setString(MultiLan("attr_artifact_prp"))
		self.lbPicPrpNum:setString(""..wings.prp)
	elseif wings.mrp ~= 0 then
		self.lbPicPrp:setVisible(true)
		self.lbPicPrpNum:setVisible(true)
		self.lbPicPrp:setString(MultiLan("attr_artifact_mrp"))
		self.lbPicPrpNum:setString(""..wings.mrp)
	else
		self.lbPicPrp:setVisible(false)
		self.lbPicPrpNum:setVisible(false)
	end
end






